# 2019-09-04 sokol@insa-toulouse.fr

# adapt tests to new dir structure
# replace symlinks on ftbl's by a real copy
find -type l \( -name '*'.ftbl -o -name '*'.txt -o -name '*'.R \) | while read f; do
   ref=$(readlink "$f")
   fref=$(readlink -e "$f")
   if [ "x$fref" == "x" ]; then
      # the link points to nothing => add "../" in front of it
      if [ -e "../$ref" -a "x$(readlink -e ../$ref)" != "x" ]; then
         echo "cp '../$ref' '$f'" | tee >> ftbl_origin.txt
         rm -f "$f" && cp "../$ref" "$f" 
      else
         echo 1>&2 "could not unref '../$ref' for '$f'"
      fi
   else
      echo "cp '$fref' '$f'" | tee >> ftbl_origin.txt
      rm -f "$f" && cp "$fref" "$f"
   fi
done

# 2019-09-10 sokol@insa-toulouse.fr
# make hard links for e_coli.ftbl (and other repeated files) for concurrent running

# in python3
import csv, os
fd=csv.reader(open("cases_influx_si-v4.4.4.tab"), delimiter="\t")
for l in fd: #print(l[2] if len(l)>2 else "")
   if len(l) < 3:
      continue
   fn=l[2].split()[-1]
   if not fn.endswith(".ftbl"):
      fn += ".ftbl"
   if not os.path.exists(fn):
      continue
   # hard link fn by adding 1,2,.... before ftbl
   i = 1
   while True:
      ft = fn[:-5]+"_%d_.ftbl"%i
      if not os.path.exists(ft):
         break
      i += 1
   # we have fond free name slot
   print("linking '%s' (source) -> '%s' (dest)"%(fn,ft))
   os.link(fn, ft)

# 2022-05-25 sokol@insa-toulouse.fr

MTF files for single labeling experiment
----------------------------------------
 * mtf/e_coli -- real-world example on central carbon metabolism of E.coli (original e_coli.ftbl authored by P. Millard)
    run with: influx_s --prefix e_coli
 * mtf/e_coli_growth.* -- same as e_coli but with growth fluxes modeled as -µ*[specie_concentration]
    run with: influx_s --prefix e_coli_growth
 * mtf/e_coli_i -- instationary labeling in E.coli on synthetic data.
    run with: influx_i --prefix e_coli_i
 * mtf/e_coli_iv -- instationary labeling in E.coli with input labeling in a form of periodic rectangular pulses (no fitting, only simulation)
    run with: influx_i --prefix e_coli_iv
 * mtf/ex_i_2box_var -- instationary labeling in a linear metabolic chain of 2 metabolites with label input in an exponential form (no fitting, only simulation)
    run with: influx_i --prefix ex_i_2box_var

MTF files for parallel labeling experiments
-------------------------------------------
 * prl_exp/mtf/e_coli_glc1-6n.ftbl -- 6 parallel experiments, each having as label input a Glucose molecule labeled in corresponding atom. 
    run with: influx_s --prefix prl_exp/mtf/e_coli_glc1-6n
 * prl_exp/mtf/e_coli_GX_prl -- 2 parallel experiments with instationary labeling
    run with: influx_i --prefix prl_exp/e_coli_GX_prl

Helper files
------------
 * README.txt -- this file
 * mtf/e_coli_iv_funlab.R - helper for e_coli_iv.*, defines some variables referenced in .linp R expressions
 * prl_exp/mtf/e_coli_glc2n.*, prl_exp/mtf/e_coli_glc3n.*, prl_exp/mtf/e_coli_glc4n.*, prl_exp/mtf/e_coli_glc5n.*, prl_exp/mtf/e_coli_glc6n.* -- auxiliary .miso nad .linp files for parallel experiments referenced from prl_exp/mtf/e_coli_glc1-6n.opt
 * prl_exp/mtf/e_coli_GX_X.* -- auxiliary .miso, .linp and .opt files for parallel experiment referenced from prl_exp/mtf/e_coli_GX_prl.opt
 * ok/* -- results of all cited MTF files, to be used as reference in comparison with user's results

suppressPackageStartupMessages(library(nlsic)); # for non negative least square
#suppressPackageStartupMessages(library(Matrix, warn=F, verbose=F)); # for sparse matrices
#options(Matrix.quiet=TRUE)
suppressPackageStartupMessages(library(slam)); # for quick sparse matrices
suppressPackageStartupMessages(library(parallel))
#use_magma=suppressWarnings(suppressPackageStartupMessages(require(magma, quietly=T)))
#use_magma=F
##suppressPackageStartupMessages(library(Rcpp))
suppressPackageStartupMessages(library(RcppArmadillo))
suppressPackageStartupMessages(library(bitops))
suppressPackageStartupMessages(library(arrApply)) # for fast apply() on arrays
suppressMessages(suppressPackageStartupMessages(library(rmumps)))
suppressMessages(suppressPackageStartupMessages(library(multbxxc))) # auxiliary C++ routines
suppressPackageStartupMessages(library(kvh));
compiler::enableJIT(0)
#suppressPackageStartupMessages(library(Rdsm)); # for shared memory on cluster
# get some common tools
source(file.path(dirr, "tools_ssg.R"), echo=FALSE)
source(file.path(dirr, "psoptim_ic.R"), echo=FALSE)
if (case_i)
    source(file.path(dirr, "funlab.R"), echo=FALSE)

# CRAN packages required for influx_si
options(error=function(e) q("no"))
preq=c("nnls", "rmumps", "arrApply", "slam", "limSolve", "multbxxc", "kvh", "nlsic", "bitops", "glue")
# check what is already installed
iinst=sapply(preq, requireNamespace, quietly = TRUE)
repos=getOption("repos")
repos=if (!length(repos) || repos == "@CRAN@") "https://cloud.r-project.org/" else repos
# install lacking packages
plack=preq[!iinst]
if (length(plack)) {
   #print(interactive())
   #cat("installing: ", plack, "\n")
   install.packages(plack, repos=repos)
}
# update already present
pold=preq[iinst]
if (length(pold)) {
   #cat("updating: ", pold, "\n")
   update.packages(oldPkgs=pold, repos=repos, ask=FALSE)
}
q("no")

#' prepare data and calculate fluxes in influx_si package.
#'
#' @param fkvh file name from which input data are read
#' @param e environment in which variables will be created
#' @return None All resulting content is stored in e
#options(error=function() traceback(3))
options(error = function() {
  calls <- sys.calls()
  if (length(calls) >= 2L) {
    sink(stderr())
    on.exit(sink(NULL))
    cat("Backtrace:\n")
    calls <- rev(calls[-length(calls)])
    for (i in seq_along(calls)) {
      cat(i, ": ", deparse(calls[[i]], nlines = 1L), "\n", sep = "")
    }
  }
  if (!interactive()) {
    q(status = 1)
  }
})

prep=function(fkvh, e) {
    # read basic input values
    l=kvh::kvh_read(fkvh, comment_str="#", skip_blank=TRUE, split_str="\t")
    list2env(l, envir=e)
    e$il=l
    e$labargs=e
    e$case_i=as.logical(e$case_i)
    # create log/err
    if (nchar(e$dirres)) {
        e$write_res=TRUE
        e$fcerr=file(file.path(e$dirres, sprintf("%s.err", e$baseshort)), "ab")
        e$fclog=file(file.path(e$dirres, sprintf("%s.log", e$baseshort)), "ab")
        #on.exit(close(e$fcerr), add=TRUE)
        #on.exit(close(e$fclog), add=TRUE)
    } else {
        e$write_res=FALSE
        e$fcerr=base::stderr()
        e$fclog=base::stdout()
    }
    if (options()$warn == 0L)
        options(warn=1L)
    options(digits.secs=2L)
    source(file.path(e$dirr, "libs.R"), echo=FALSE, local=e)
    # define matprod for simple_triplet_matrix
    .GlobalEnv$`%stm%` = slam::matprod_simple_triplet_matrix
    # default options
    with(e, {
        version=FALSE
        noopt=FALSE
        noscale=FALSE
        meth="nlsic"
        fullsys=FALSE
        emu=FALSE
        irand=FALSE
        sens=""
        cupx=0.999
        cupn=1.e3
        cupp=1.e5
        clownr=0.
        cinout=0.
        clowp=1.e-8
        np=0L
        ln=FALSE
        tikhreg=FALSE
        sln=FALSE
        lim=FALSE
        zc=-.Machine$double.xmax
        ffguess=FALSE
        addnoise=FALSE
        fseries=""
        iseries=""
        seed=-.Machine$integer.max
        excl_outliers=FALSE
        TIMEIT=FALSE
        prof=FALSE
        tstart=0.
        time_order="1"
        wkvh=FALSE
        tol=1.e-10
        DEBUG=FALSE
    })
    
    # evaluate r options
    if (length(e$ropts))
        for (o in strsplit(e$ropts, "\n", fixed=TRUE)[[1L]])
            eval(parse(text=o), env=e)
    with(e, {
    top_chrono("init", file=fclog)
    # update nbsys
    if (!fullsys)
       nbsys$label_variables$full=NULL
    if (emu) {
       x=s2i(nbsys$label_variables$reduced_cumomers)
       nbsys$label_variables$reduced_cumomers=NULL
       nbsys$label_variables$emu=paste(x, "*", seq_len(length(x)), "=", x*seq_len(length(x)))
        suppressWarnings(rm(x))
    }
    })
    # store nm_<smth> into nml$<smth> as 'name list'
    nme=names(e)
    nms=nme[startsWith(nme, "nm_")]
    e$nml=setNames(lapply(nms, function(nm) {it=e[[nm]]; if (identical(nchar(it), 0L)) character(0L) else it}), substring(nms, 4L))
    suppressWarnings(rm(list="nm_" %s+% names(e$nml), envir=e))
    # add nml$exp
    e$nml$exp=names(e$meas)
    e$nbl$exp=length(e$nml$exp)
    
    # store nb_<smth> into nbl$<smth> as 'number list'
    nms=nme[startsWith(nme, "nb_")]
    e$nbl=setNames(lapply(nms, function(nm) {it=e[[nm]]; if (identical(nchar(it), 0L)) character(0L) else s2i(it)}), substring(nms, 4L))
    # cumulated rcumos
    e$nbl$crcumos=c(0, cumsum(e$nbl$rcumos))
#browser()
    suppressWarnings(rm(list="nb_" %s+% names(e$nbl), envir=e))
    
    # integer values
    lapply(c("clen"), function(nm) e[[nm]]=s2i(e[[nm]]))
    # double float values
    lapply(c("ffn", "ffx", "fcn", "fcx", "fln", "flx", "fgr", "fmn", "fmndev", "poolf", "poolc", "poolm", "poolmdev"),
        function(nm) e[[nm]]=s2d(e[[nm]]))
    e$xi[]=lapply(e$xi, s2i)
    
    # composite vectors
    with(e, {
    nml$ff=c(nml$ffn, nml$ffx)
    nml$fc=c(nml$fcn, nml$fcx)
    nml$fl=c(nml$fln, nml$flx)
    nml$fallnx=c(nml$fln, nml$ffn, nml$fcn, nml$fgr, nml$flx, nml$ffx, nml$fcx, sub(".n.", ".x.", nml$fgr, fixed=TRUE))
    nml$incu=c("one", nml$xi, nml$rcumo)
    nml$ineq=c(nml$inn, nml$inx)
    # complete nbl$<smth> for numbers from nml
    nbl=c(nbl, setNames(as.list(lengths(nml)), names(nml)))
    })
    # set names to vectors of the same length that names
    lapply(names(e$nml), function(nm) if (!is.null(e[[nm]]) && (length(e[[nm]]) == e$nbl[[nm]])) e[[nm]]=setNames(e[[nm]], e$nml[[nm]]) else NULL)
    # basic setup
    with(e, {
    # synonymous
    myver=version
    optimize=!noopt
    methods=trimws(strsplit(meth, ",")[[1L]])
    sensitive=sens
    least_norm=ln
    initrand=irand

    # sanity check for command line parameters
    if (TRUE) {
        if (substring(sensitive, 1L, 3L)=="mc=") {
           # read the mc iteration number
           nmc=as.integer(substring(sensitive, 4L))
           sensitive="mc"
        } else if (sensitive=="mc") {
           nmc=10L
        } else if (nchar(sensitive) > 0L) {
           stop_mes("Option '--sens SENS' got unknown argument SENS '", sensitive,"'\n",
              "Expected 'mc[=N]' where optional N is a number of Monter-Carlo iterations", file=fcerr)
        }
        # cupx==0 means no upper limit => cupx=1
        cupx=ifelse(cupx, cupx, 1.)
        if (cupx < 0. || cupx > 1.) {
           stop_mes("Option '--cupx N' must have N in the interval [0,1L]\n",
              "Instead, the value ", cupx, " is given.", file=fcerr)
        }
        if (cinout < 0.) {
           stop_mes("Option '--cinout N' must have N non negative\n",
              "Instead, the value ", cinout, " is given.", file=fcerr)
        }
        # minimization method
        validmethods=c("BFGS", "Nelder-Mead", "SANN", "ipopt", "nlsic", "pso")
        if (! all(igood <- (methods %in% validmethods))) {
           cat(paste("***Warning: optimization methods ", paste0(methods[!igood], collapse=", "), " are not implemented. 'nlsic' is used instead."), "\n", sep="", file=fclog)
           methods[!igood]="nlsic"
        }
        if ("ipopt" %in% methods) {
           installed=suppressPackageStartupMessages(library(ipoptr, logical.return=TRUE))
           if (!installed) {
              stop_mes("An optimization method ipopt is requested but not available in this R installation", file=fcerr)
           }
        }
        if (least_norm && sln) {
           stop_mes("Options --ln and --sln cannot be activated simultaniously.", file=fcerr)
        }

        avaco=try(detectCores(), silent=TRUE)
        if (inherits(avaco, "try-error")) {
           avaco=NULL
        }
        if (np > 0L && np < 1L) {
           np=round(avaco*np)
        } else if (np >= 1L) {
           np=round(np)
        } else {
           np=avaco
        }
        if (is.null(np) || np <= 0L) {
           np=1L
        }
        if (sensitive=="mc") {
           np=min(np, nmc)
        }
        options(mc.cores=np)

        if (least_norm+tikhreg+lim > 1L) {
           stop_mes("Options --ln, --lim and --tikhreg cannot be activated simultaneously. Use only one of them at a time.", file=fcerr)
        }
        lsi_fun=lsi
        if (least_norm || sln) {
           lsi_fun=lsi_ln
        } else if (tikhreg) {
           lsi_fun=lsi_reg
        } else if (lim) {
           suppressPackageStartupMessages(library(limSolve));
           lsi_fun=lsi_lim
        }
        if (zc==-.Machine$double.xmax) {
           # no zero scrossing to apply
           zerocross=FALSE
        } else {
           if (zc < 0.) {
              stop_mes("Zero crossing value ZC must be non negative, instead ", zc, " is given.", file=fcerr)
           }
           zerocross=TRUE
        }
        if (seed==-.Machine$integer.max) {
           # no seed to apply
           set_seed=FALSE
        } else {
           set_seed=TRUE
           set.seed(seed)
        }
        if (prof) {
           Rprof(sprintf("%s.Rprof", baseshort))
        }
    }
    # get some cumomer tools
    source(file.path(dirr, "opt_cumo_tools_kvh.R"), echo=FALSE, local=e)
    if (case_i) {
        time_order=gsub("\\\\s", "", time_order) # remove spaces if any
        if (!(time_order %in% c("1", "2", "1,2"))) {
           stop_mes("time_order must be '1', '2' or '1,2'. Instead got '", time_order, "'", file=fcerr)
        }
        source(file.path(dirr, "opt_icumo_tools_kvh.R"), echo=FALSE, local=e)
        lab_resid=icumo_resid
        lab_sim=param2fl_usm_rich
        names(funlabli)=nml$exp
    }
    lab_resid=cumo_resid
    lab_sim=param2fl_x
    jx_f=new.env()
    if (emu) {
        nbl$emus=nbl$rcumos*(seq_len(nbl$rw)+1L)
        nml$x=nml$emu
        nbl$x=nbl$emu
        xiemu=lapply(xiemu, setNames, nml$xiemu)
        nml$inp=nml$xiemu
        xi=xiemu
        nml$inemu=c("one", nml$xiemu, nml$emu)
        nml$inlab=nml$inemu
    } else
        nml$x=nml$rcumo
        nbl$x=nbl$rcumos
    }) # end with()
    # prepare mat vec
    with(e, {
    top_chrono("stoichiom", file=fclog)
    # initialize the linear system Afl*flnx=bfl (0-weight cumomers)
    # prepare free fluxes and all pools
    ff=c(ffn, ffx)
    fc=c(fcn, fcx)
    ff=c(ffn, ffx)
    # set pool names as plain metabs (i.e. omit "pc:" and "pf:" prefixes)
    if (!is.null(nml$poolf))
        names(nml$poolf)=substring(nml$poolf, 4L)
    if (!is.null(nml$poolc))
        names(nml$poolc)=substring(nml$poolc, 4L)
    nml$poolall=c(nml$poolf, nml$poolc)
    poolall=setNames(c(poolf, poolc), nml$poolall)
    pool=poolall
    nbl$poolall=length(nml$poolall)
    if (case_i) {
       # check the coherence of metabolites/cumomers
       met_net=strsplitlim(nml$rcumo, ":", fixed=TRUE, lim=3L, mat=TRUE)[,1L]
       net_pool=sort(setdiff(met_net, names(nml$poolall)))
       if (length(net_pool) > 0L) {
          stop_mes("The following metabolites are internal in NETWORK section but not in METABOLITE_POOLS one:\\n", paste(net_pool, collapse="\n"), file=fcerr)
       }
       suppressWarnings(rm(met_net, net_pool))
    }

    # flux matrix
    Afl=simple_triplet_matrix(s2i(Afl$i), s2i(Afl$j), s2d(Afl$v), dimnames=list(nml$rows, nml$fl))
    # prepare pcgc2bfl matrix such that pcgc2bfl%*%c(c(ff,fc,fgr,1)) -> bfl
    nml$pcgc=c(nml$ff, nml$fc, nml$fgr, "")
    pcgc2bfl=simple_triplet_matrix(s2i(fl2bfl$i), match(fl2bfl$j, nml$pcgc), s2d(fl2bfl$v), nrow=nbl$rows, ncol=length(nml$pcgc), dimnames=list(nml$rows, nml$pcgc))
    param=ff # start building param: ff, scales, poolf

    if (ffguess) {
        top_chrono("ffguess", file=fclog)
        # make an automatic guess for free/dependent flux partition
        afd=as.matrix(cbind(Afl, -pcgc2bfl[,seq_len(nbl$ff), drop=FALSE]))
        qafd=qr(afd, LAPACK=TRUE)
        d=abs(diag(qafd$qr))
        rank=sum(d >= d[1L]*tol)
        qrow=qr(t(afd))
        rankr=qrow$rank
        if (rank != rankr)
           stop_mes("Weird error: column and row ranks of augmented Afl are not equal.", file=fcerr)
        
        irows=qrow$pivot[seq_len(rankr)]
        if (rank==0)
           stop_mes("Error: No free/dependent flux partition could be made. Stoichiometric matrix has rank=0.", file=fcerr)
        Afl=afd[irows, qafd$pivot[1L:rank], drop=FALSE]
        ka=kappa(Afl)
        if (ka > 1.e7) {
           mes=sprintf("Error: No working free/dependent flux partition could be proposed. Stoichiometric matrix has condition number %g.\\n", ka)
           stop_mes(mes, file=fcerr)
        }
        pcgc2bfl=cbind(-as.simple_triplet_matrix(afd[irows, qafd$pivot[-seq_len(rank)], drop=FALSE]), pcgc2bfl[irows,-seq_len(nbl$ff), drop=FALSE])
        
        # replace names
        nml$fl=paste("d", substring(colnames(Afl), 2L), sep="")
        colnames(Afl)=nml$fl # both net and xch
        nml$fln=sort(nml$fl[startsWith(nml$fl, "d.n")])
        nml$flx=sort(nml$fl[startsWith(nml$fl, "d.x")])
        nml$fl=c(nml$fln, nml$flx)
        Afl=Afl[, nml$fl, drop=FALSE]
        
        nbl$ff=ncol(afd)-rank
        nml$ff=paste("f", substring(nml$pcgc[seq_len(nbl$ff)], 2L), sep="")# both net and xch
        nml$pcgc[seq_len(nbl$ff)]=nml$ff
        colnames(pcgc2bfl)=nml$pcgc
        nml$ffn=sort(nml$ff[startsWith(nml$ff, "f.n")])
        nml$ffx=sort(nml$ff[startsWith(nml$ff, "f.x")])
        nml$ff=c(nml$ffn, nml$ffx)
        pcgc2bfl[,seq_len(nbl$ff)]=pcgc2bfl[, nml$ff, drop=FALSE]
        
        # redo fallnx
        nml$fallnx=c(nml$fln, nml$ffn, nml$fcn, nml$fgr, nml$flx, nml$ffx, nml$fcx, sub(".n.", ".x.", nml$fgr, fixed=TRUE))

        # redo param vector
        param=setNames(runif(nbl$ff), nml$ff)
        nml$param=nml$ff
        # redo lengths
        nms=c("ffn", "ffx", "fln", "flx", "ff", "fl", "param")
        nbl[nms]=lengths(nml[nms])
        suppressWarnings(rm(afd, qafd, rank, rankr, irows, ka))
    }
    # translation from all n-x to fw-rv
    sh_fwrv=substring(nml$fwrv[1:(nbl$fwrv/2L)], 5L)
    sh_nx=substring(nml$fallnx, 2L)
    nbl$inet2ifwrv=match(paste(".n.", sh_fwrv, sep=""), sh_nx)
    nbl$ixch2ifwrv=match(paste(".x.", sh_fwrv, sep=""), sh_nx)
    suppressWarnings(rm(sh_fwrv, sh_nx))
    
    # normalize inout and notrev flux names (add "d.n.", "f.n." etc)
    nml$inout=nml$fallnx[match(nml$inout, substring(nml$fallnx, 5L))]
    nml$notrev=nml$fallnx[match(nml$notrev, substring(nml$fallnx, 5L))]
    
    # QR Afl
    qrAfl=qr(Afl, LAPACK=TRUE)
    d=abs(diag(qrAfl$qr))
    qrAfl$rank=sum(d > d[1L]*1.e-10)
    rank=qrAfl$rank
    aful=as.matrix(cbind(Afl, -pcgc2bfl[,startsWith(nml$pcgc, c("f", "c")),drop=FALSE]))
    qrow=qr(t(aful))
    rankr=qrow$rank
    # first check the presence of lindep rows
    if (nrow(Afl) > rankr) {
       # find list of independent metabs for dependent ones
       idep=qrow$pivot[(rankr+1):nrow(Afl)]
       dcoef=qr.solve(t(aful[-idep,,drop=FALSE]), t(aful[idep,,drop=FALSE]))
       lidep=apply(dcoef, 2L, function(v) names(which(abs(v) >= 1.e-10)), simplify=FALSE)
       prop=sprintf("***Warning: Among %d equations (rows), %d are redundant.\nThe dependencies are:\n\t", nrow(Afl), nrow(Afl)-rankr)
       prop=paste0(prop, paste0(lapply(names(lidep), function(nm) paste0(nm, ": ", paste0(lidep[[nm]], collapse=", "))), collapse="\n\t"), "\nThe redundant balances for species '", paste0(names(lidep), collapse="', '"), "' will be ignored.\n")
       cat(prop, file=fclog)
       Afl=Afl[-idep,,drop=FALSE]
       rankr=nrow(Afl)
       qrAfl=qr(Afl, LAPACK=TRUE)
       d=abs(diag(qrAfl$qr))
       qrAfl$rank=sum(d > d[1L]*1.e-10)
       rank=qrAfl$rank
       pcgc2bfl=pcgc2bfl[-idep,,drop=FALSE]
    }
    pcgc2bfl=as.simple_triplet_matrix(pcgc2bfl)
    if (nrow(Afl) != rank || nrow(Afl) != ncol(Afl)) {
       mes=NULL
       if (nrow(Afl) <= rank) {
          mes=paste("Candidate(s) for free or constrained flux(es):\n",
             paste(colnames(Afl)[-qrAfl$pivot[1L:nrow(Afl)]], collapse="\n"),
             "\nFor this choice, condition number of stoichiometric matrix will be ",
             kappa(Afl[,qrAfl$pivot[1L:nrow(Afl)],drop=FALSE]), "\n", sep="")
       } else if (nrow(Afl) > rank) {
          nextra=nrow(Afl)-rank
          comb=combn(c(nml$ffn, colnames(Afl)[-qrAfl$pivot[1L:rank]]), nextra)
          aextra=cbind(Afl[,-qrAfl$pivot[1L:rank],drop=FALSE], -pcgc2bfl[, startsWith(nml$pcgc, "f"), drop=FALSE])
          ara=Afl[,qrAfl$pivot[1L:rank],drop=FALSE]
          i=which.min(apply(comb, 2L, function(i) kappa(cbind(ara, aextra[,i]))))[1L]
          nmtmp=comb[,i]
          ka=kappa(cbind(ara, aextra[,nmtmp]))
          if (ka < 1.e7) {
             prop=paste("Proposal to declare dependent flux(es) is:\n",
                paste(nmtmp, collapse="\n"), "\n", sep="")
             if (rank < ncol(Afl)) {
                prop=prop%s+%"While the following dependent flux(es) should be declared free or constrained:\n"%s+%join("\n", colnames(Afl)[-qrAfl$pivot[1L:rank]])%s+%"\n"
             }
             prop=paste(prop, "For this choice, condition number of stoichiometric matrix will be ", ka, "\n", sep="")
          } else {
             aextended=aful
             qae=qr(aextended, LAPACK=TRUE)
             d=abs(diag(qae$qr))
             ranke=sum(d > d[1L]*1.e-10)
             if (ranke == nrow(Afl)) {
                prop=paste("Proposal to declare dependent flux(es) is:\n",
                join("\n", colnames(aextended)[qae$pivot[1L:ranke]]), "\n",
                "while free and constrained fluxes should be:\n",
                join("\n", colnames(aextended)[-qae$pivot[1L:ranke]]), "\n",
                sep="")
                ka=kappa(aextended[,qae$pivot[1L:ranke]])
                prop=paste(prop, "For this choice, condition number of stoichiometric matrix will be ", ka, "\n", sep="")
             } else {
                prop="No proposal for partition dependent/free fluxes could be made.\n"
             }
          }
          mes=paste("There is (are) probably ", nextra,
             " extra free flux(es) among the following:\n",
             paste(nml$ffn, collapse="\n"), "\n",
             prop,
             sep="")
       }
       stop_mes("Flux matrix is not square or is singular: (", nrow(Afl), "eq x ",
          ncol(Afl), "unk)\n", "You have to change your choice of free fluxes in the '", baseshort, "' file.\n", mes, file=fcerr)
    }

    # make sure that free params choice leads to not singular matrix
    if (qrAfl$rank != nbl$fl) {
       # make a suggestion of new free fluxes
       ifc=which(startsWithv(nml$pcgc, c("f", "c")))
       A=cbind(Afl, -pcgc2bfl[,ifc, drop=FALSE])
       qa=qr(A, LAPACK=TRUE)
       d=diag(qa$qr)
       qa$rank=sum(abs(d)>=abs(d[1L]*1.e-10))
       
       mes=paste("Error: Dependent flux matrix is singular.\n",
          "Change your partition on free/dependent/constrained fluxes in the '%(n_ftbl)s' file.\n",
          "Can not resolve dependent fluxe(s):\n",
          paste(colnames(Afl)[-qrAfl$pivot[(1:qrAfl$rank)]], collapse="\n"),
          sep="")
       if (qa$rank==nbl$fl) {
          mes=paste(mes,
          "\n\nSuggested dependent fluxes:\n",
          paste(colnames(A)[qa$pivot[(1:qa$rank)]], collapse="\n"),
          "\n\nWhich would give the following free and constrained fluxes:\n",
          paste(colnames(A)[-qa$pivot[(1:qa$rank)]], collapse="\n"), "\n",
          sep="")
       } else {
          mes=paste(mes, "\nNo suggested free fluxes could be found", sep="")
       }
       stop_mes(mes, file=fcerr)
    }

    # inverse flux matrix
    invAfl=solve(qrAfl)
    invAfl[abs(invAfl) <= tol]=0.
    # intermediate jacobians
    top_chrono("dfl_dffg", file=fclog)
    nbl$dfl_dffg=invAfl %stm% pcgc2bfl[,startsWithv(nml$pcgc, c("f", "g"))]
    nbl$dfl_dffg[abs(nbl$dfl_dffg) < 1.e-14]=0.

    # prepare ifdcg2all
    # such that  c(ff, fc, fg, fl, 0)[ifcgd2all] -> fallnx
    ifcgd2all=match(nml$fallnx, c(nml$ff, nml$fc, nml$fgr, nml$fl))
    ifcgd2all[is.na(ifcgd2all)]=nbl$ff + nbl$fc + nbl$fg + nbl$fl + 1L
    # prepare spAbr
    top_chrono("cumosys", file=fclog)
    }) # end with()

    e$spa=prep_spAbr(e$spAbr, e$emu, e)

    if (e$fullsys)
        e$spaf=prep_spAbr(e$spAbr_f, emu=FALSE, e)
    # measurements
    with(e, {
    top_chrono("measurem", file=fclog)
    jx_f=new.env()
    
    sc=nbl$sc=nml$meas=nml$measmat=nbl$measmat=nbl$meas=vector("list", nbl$exp)
    measmat=memaone=measvec=measdev=vector("list", nbl$exp)
    pwe=ipwe=ip2ipwe=ipf2ipwe=pool_factor=dpw_dpf=ijpwef=vector("list", nbl$exp)
    if (case_i) {
        measvecti=ti=tifull=tifull2=vector("list", nbl$exp)
        nbl$ti=nbl$tifu=nbl$tifu2=integer(nbl$exp)
        nsubdiv_dt=pmax(1L, s2i(nsubdiv_dt))
        nbl$ipf2ircumo=nbl$ipf2ircumo2=list()
    }
    nmpf=if (!is.null(nml$poolf)) names(nml$poolf)
    for (iexp in seq_along(meas)) {
        m=meas[[iexp]]
        # labeled measurements
        nml$meas[[iexp]]=m$nmmeas
        nml$measmat[[iexp]]=m$nmmeas_np
        nbl$meas[[iexp]]=length(m$nmmeas)
        if (nbl$meas[[iexp]] == 0L)
            stop_mes("At least one label measurement is required in '", nml$exp[[iexp]], "'")
        nbl$measmat[[iexp]]=length(m$nmmeas_np)
        measmat[[iexp]]=simple_triplet_matrix(s2i(m$mmat$i)+1L, s2i(m$mmat$j)+1L, s2d(m$mmat$v), nrow=nbl$measmat[[iexp]], ncol=length(nml$x), dimnames=list(m$nmmeas_np, nml$x))
        memaone[[iexp]]=s2d(m$memaone)
        measdev[[iexp]]=s2d(m$measdev)
        measvec[[iexp]]=s2d(m$measvec, na.rm=FALSE)
        if (!noscale) {
            # scaling factors
            sc[[iexp]]=Filter(length, n_lapply(m$sc_name, function(nm, v) {
                iv=match(v, m$nmmeas) # todo: remove extra scales for case_i
                if (anyNA(iv))
                    stop_mes("Incoherent measurement names in scales '", nm, "' and nmmeas in input kvh.", file=fcerr)
                ivv=iv[!is.na(measvec[[iexp]][iv])]
                if (length(ivv) < 2L)
                    stop_mes("Not enough valid (non NA) measurements for scale'", nm, "'", file=fcerr)
                # remove scaling when MS with complete fragment summing to 1.
                if (all(startsWith(m$nmmeas[ivv], "m"))) {
                    met=strsplitlim(m$nmmeas[ivv], ":", fixed=TRUE, lim=4L, mat=TRUE)
                    lenfrag=ncol(strsplitlim(met[,3L], ",", fixed=TRUE, lim=NA, mat=TRUE))
                    met=trimws(strsplitlim(met[,2L], "+", fixed=TRUE, lim=NA, mat=TRUE)[,1L])
                    if (lenfrag == 0L)
                        lenfrag=clen[met[1L]]
                    s <- sum(measvec[[iexp]][ivv])
                    if (lenfrag+1L == length(ivv) && abs(s - 1.) <= tol) {
                        NULL
                    } else {
                        bop(measvec[[iexp]], as.matrix(ivv), "*=", 1./s) # mv /= sum
                        ivv # todo: update sd
                    }
                } else {
                    ivv
                }
            }))
            nbl$sc[[iexp]]=length(sc[[iexp]])
        }
        # pooled measurements
        # they are calculated as: mv=meas2sum[[iexp]] %stm% (pwe[[iexp]]*mx)
        # where pwe is pwe[[iexp]][ipwe[[iexp]]]=pool[ip2ipwe[[iexp]]]
        # spwe=tapply(pwe[[iexp]], pool_factor[[iexp]], sum) # sum of pooled concentrations
        # spwe=1./spwe[nml$measmat[[iexp]]]
        # pwe[[iexp]]=c(pwe[[iexp]]*spwe)
        m$ipooled=Filter(length, lapply(m$ipooled, function(v) s2i(v)+1L))
        
        if (length(m$ipooled)) {
            ipwe[[iexp]]=unlist(m$ipooled) # where in meas, the weight is
            pool_factor[[iexp]]=as.factor(m$nmmeas_np)
            pwe[[iexp]]=rep(1., nbl$measmat)
            mets_in_res=strsplitlim(names(m$ipooled), ":", fixed=TRUE, lim=3L, mat=TRUE)[, 2L]
            names(mets_in_res)=names(m$ipooled)
            metsp=lapply(strsplit(mets_in_res, "+", fixed=TRUE), trimws)
            ip2ipwe[[iexp]]=lapply(metsp, function(v) which(names(nml$poolall) %in% v))
            # first 2 col for d(mx)/d(pf), the 3d for j in dpw_dpf
            ipf2ipwe[[iexp]]=Filter(length, n_lapply(ip2ipwe[[iexp]], function(nm, iv) {ii=which(iv <= nbl$poolf); if (length(ii)) cbind(imnp=m$ipooled[[nm]][ii], im=match(nm, nml$meas[[iexp]]), ipf=iv[ii]) else NULL}))
            ipf2ipwe[iexp]=list(Reduce(rbind, ipf2ipwe[[iexp]]))
            # dpw_dpf - matrix for derivation of pool weights by free pools
            if (nbl$poolf > 0L && length(ipf2ipwe[[iexp]]) > 0L) {
                dpw_dpf[[iexp]]=simple_triplet_zero_matrix(nbl$meas[[iexp]], nbl$poolf)
                dpw_dpf[[iexp]][ipf2ipwe[[iexp]][,c("im", "ipf"),drop=FALSE]]=1.
            }
            ip2ipwe[[iexp]]=unlist(ip2ipwe[[iexp]])
            ijpwef[iexp]=list(Reduce(rbind, i_lapply(metsp, function(i, mets) {
                ip=na.omit(pmatch(mets, names(nml$poolf)))
                cbind(rep(m$ipooled[i], length(ip)), rep(ip, each=length(m$ipooled[i]))) # where free pools matter
            })))
        }
        # variables for isotopomer kinetics
        if (case_i) {
            # read measvecti from file(s) specified in ftbl(s)
            nmim=nml$poolall[strsplitlim(nml$rcumo, ":", fixed=TRUE, lim=3L, mat=TRUE)[,1L]]
            if (fullsys)
                nmimf=nml$poolall[strsplitlim(nml$cumo, ":", fixed=TRUE, lim=3L, mat=TRUE)[,1L]]
            if (tmax[iexp] < 0)
                stop_mes(sprintf("The parameter tmax must not be negative (tmax=%g in '%s.ftbl')", tmax[iexp], nml$exp[iexp]), file=fcerr)
            if (dt[iexp] <= 0)
                stop_mes(sprintf("The parameter dt must be positive (dt=%g in '%s.ftbl')", dt[iexp], nml$exp[iexp]), file=fcerr)
            if (nchar(flabcin[iexp])) {
                if (substr(flabcin[iexp], 1L, 1L) == "/") {
                    flabcin[iexp]=file.path(flabcin[iexp])
                } else
                    flabcin[iexp]=file.path(dirw, flabcin[iexp])
                measvecti[[iexp]]=try(as.matrix(read.table(flabcin[iexp], header=TRUE, row.names=1, sep="\t", check=FALSE, comment="#", strip.white=TRUE)), silent=TRUE)
                if (inherits(measvecti[[iexp]], "try-error")) {
                    # try with comment '//'
                    tmp=try(kvh::kvh_read(flabcin[iexp], comment_str = "//", strip_white = FALSE, skip_blank = TRUE, split_str = "\t", follow_url = FALSE), silent=TRUE)
                    if (inherits(tmp, "try-error"))
                        stop_mes("Error while reading '", flabcin[iexp], "' from '", nml$exp[iexp], "':\n", tmp, file=fcerr)
                    nbcol=lengths(tmp)
                    if (any(ibad <- nbcol != nbcol[1L]))
                        stop_mes("Column number varies in '", flabcin[iexp], "'. First row has ", nbcol[1L], " columns while the following rows differ:\n\t", paste(c("row", which(ibad)), c("col_nb", nbcol[ibad]), sep="\t", collapse="\n\t"))

                    tmp=do.call(rbind, tmp)
                    tmp=structure(tmp[-1L,, drop=FALSE], dimnames=list(rownames(tmp)[-1L], tmp[1L,]))
                    suppressWarnings(storage.mode(tmp) <- "double")
                    measvecti[[iexp]]=tmp
                }
                nmrow=rownames(measvecti[[iexp]])
                # put in the same row order as simulated measurements
                # check if nmmeas are all in rownames
                if (all(m$nmmeas %in% nmrow)) {
                    measvecti[[iexp]]=measvecti[[iexp]][m$nmmeas,,drop=FALSE]
                } else {
                    # try to strip row number from measure id
                    nmstrip=sapply(strsplit(m$nmmeas, ":", fixed=TRUE), function(v)
                        paste(c(v[-length(v)], ""), sep="", collapse=":")
                    )
                    im=pmatch(nmstrip, nmrow)
                    if (any(ina <- is.na(im))) {
                        mes=paste("Cannot match the following measurement(s) in the file '", flabcin[iexp], "':\n", paste(m$nmmeas[ina], sep="", collapse="\n"), "\n", sep="", collapse="")
                        stop_mes(mes, file=fcerr)
                    }
                    measvecti[[iexp]]=measvecti[[iexp]][im,,drop=FALSE]
                    if (typeof(measvecti[[iexp]]) != "double") {
                        # check for weird  entries
                        tmp=measvecti[[iexp]]
                        suppressWarnings(storage.mode(tmp) <- "double")
                        if (any(ibad <- is.na(tmp) & !is.na(measvecti[[iexp]]))) {
                            ibad=which(ibad)[1L]
                            stop_mes("This entry '", measvecti[[iexp]][ibad], "' could not be converted to real number (", flabcin[iexp], ")", file=fcerr)
                        } else if (!noopt)
                            stop_mes("Entries in file '", flabcin[iexp], "' could not be converted to real numbers", file=fcerr)
                    }
                    if (!noopt && all(is.na(measvecti[[iexp]])))
                        stop_mes("All entries in file '", flabcin[iexp], "' are NA (non available).", file=fcerr)
                }
                ti[[iexp]]=as.double(colnames(measvecti[[iexp]]))
                if (any(is.na(ti[[iexp]]))) {
                    mes=sprintf("Some time moments (in column names) could not be converted to real numbers in the file '%s'\nConverted times:\n%s", flabcin[[iexp]], join("\n", ti[[iexp]]))
                    stop_mes(mes, file=fcerr)
                }
                if (length(ti[[iexp]]) < 1L) {
                    mes=sprintf("No column found in the file '%s'", flabcin[[iexp]])
                    stop_mes(mes, file=fcerr)
                }
                if (!all(diff(ti[[iexp]]) > 0.)) {
                    mes=sprintf("Time moments (in column names) are not monotonously increasing in the file '%s'", flabcin[[iexp]])
                    stop_mes(mes, file=fcerr)
                }
                if (ti[[iexp]][1L] <= 0.) {
                    mes=sprintf("The first time moment cannot be negative or 0 in the file '%s'", flabcin[[iexp]])
                    stop_mes(mes, file=fcerr)
                }
                if (ti[[iexp]][1L] != 0.)
                    ti[[iexp]]=c(tstart, ti[[iexp]])
                i=which(ti[[iexp]]<=tmax[[iexp]])
                ti[[iexp]]=ti[[iexp]][i]
                if (tmax[[iexp]] == Inf)
                    tmax[[iexp]]=max(ti[[iexp]])
                measvecti[[iexp]]=measvecti[[iexp]][,i[-1L]-1L,drop=FALSE]
            } else {
                if (tmax[[iexp]] == Inf)
                    stop_mes(sprintf("Maximal value for time is Inf (probably 'tmax' field is not set in OPTIONS section: '%%s.ftbl')", nml$exp[[iexp]]), file=fcerr)
                ti[[iexp]]=seq(tstart, tmax[[iexp]], by=dt[iexp])
                if (optimize) {
                    cat(sprintf("***Warning: a fitting is requested but no file with label data is provided by 'file_labcin' option in '%%s.ftbl' file.
	The fitting is ignored as if '--noopt' option were set.\\n", nml$exp[[iexp]]), file=fclog)
                    optimize=FALSE
                }
            }
            if (length(ti[[iexp]]) < 2L) {
               mes=sprintf("After filtering by tmax, only %d time moments are kept for experiment '%s'. It is not sufficient.", length(ti[[iexp]], nml$exp[[iexp]]))
               stop_mes(mes, file=fcerr)
            }
            nbl$ti[[iexp]]=length(ti[[iexp]])
            # recalculate nbl$meas from measvecti
            nbl$meas[[iexp]]=NROW(measvecti[[iexp]])
            # divide each time interval by nsubdiv_dt
            tifull[[iexp]]=ti[[iexp]]
            dt=diff(tifull[[iexp]])
            dt=rep(dt/nsubdiv_dt[iexp], each=nsubdiv_dt[iexp])
            tifull[[iexp]]=c(tifull[[iexp]][1L], cumsum(dt))
            nbl$tifu[iexp]=length(tifull[[iexp]])
            
            tifull2[[iexp]]=c(tifull[[iexp]][1L], tifull[[iexp]][1L]+cumsum(rep(diff(tifull[[iexp]])/2., each=2L)))
            nbl$tifu2[iexp]=length(tifull2[[iexp]])
            
            if (length(ijpwef[[iexp]])) {
                # vector index for many time points
                ijpwef[[iexp]]=cbind(ijpwef[[iexp]][,1L], rep(seq_len(nbl$ti[[iexp]]-1L), each=nrow(ijpwef[[iexp]])), ijpwef[[iexp]][,2L])
                dp_ones[[iexp]]=matrix(aperm(array(dp_ones[[iexp]], c(dim(dp_ones[[iexp]]), nbl$ti[[iexp]]-1L)), c(1L, 3L, 2L)), ncol=nbl$poolf)
            }
        }
    }
    suppressWarnings(rm(mets_in_res, metsp, nmpf, dt))
    nbl$sc_tot=sum(unlist(nbl$sc))
    # pool measurements, poolm is ready from kvh
    # inverse of variance for pool measurements
    names(poolmdev)=nml$poolm
    # simulated metabolite measurements are calculated as
    # measmatpool %stm% poolall -> poolm
    i=s2i(mmatp$i)
    measmatpool=simple_triplet_matrix(i=i, j=s2i(mmatp$j), v=rep(1., length(i)), nrow=nbl$poolm, ncol=nbl$poolall, dimnames=list(nml$poolm, nml$poolall))
    # flux measurements
    fmndev=setNames(fmndev, nml$fmn)
    ifmn=match(paste(".n.", nml$fmn, collapse="", sep=""), substring(nml$fallnx, 2L))
    # gather all measurement information
    measurements=list(
        vec=list(labeled=measvec, flux=fmn, pool=poolm, kin=if (case_i) measvecti else NULL),
        dev=list(labeled=measdev, flux=fmndev, pool=poolmdev, kin=if (case_i) i_lapply(measdev, function(i, v) {nbc=if (is.null(measvecti[[i]])) 0 else ncol(measvecti[[i]]); suppressWarnings(matrix(v, nrow=length(v), ncol=nbc))}) else NULL),
        mat=list(labeled=measmat, flux=ifmn, pool=measmatpool),
        one=list(labeled=memaone)
    )
    measurements$dev$all_inv=with(measurements$dev, 1./c(unlist(if (case_i) kin else labeled), flux, pool))
    nml$resid=c(if (case_i) unlist(i_lapply(measvecti, function(iexp, mti) {m=outer(rownames(mti), colnames(mti), paste, sep=", t="); if (length(m) > 0L) paste(iexp, m, sep=":", recycle0=TRUE) else character(0L)})) else unlist(i_lapply(nml$meas, function(iexp, v) paste(iexp, v, sep=":"))), nml$fmn, nml$poolm)
    nbl$resid=length(nml$resid)
    
    # finalize param (after defining scale factors in measurements)
    param=c(param, poolf)
    nml$param=names(param)
    nbl$param=length(param)
    }) # end with()
    
    # inequalities
    with(e, {
    top_chrono("inequal", file=fclog)

    # prepare mi matrix and li vector
    # such that mi*fallnx>=li corresponds
    # to the inequalities given in ftbl file
    li=s2d(mi$li)
    mi=simple_triplet_matrix(s2i(mi$i), na.omit(match(mi$j, substring(nml$fallnx, 3L))), s2d(mi$v), nrow=length(li), ncol=nbl$fallnx, dimnames=list(nml$ineq, nml$fallnx))
    # explicit inequalities take precedence over generic ones
    # so eliminate fluxes which are already in inequalities
    
    # whether flux is present alone in flux >= smth
    j1p=nml$fallnx[as.integer(names(table(mi$j[mi$v == 1.])))]
    # whether flux is present alone in flux <= smth
    j1n=nml$fallnx[as.integer(names(table(mi$j[mi$v == -1.])))]
    # add standard limits
    nmup=c(flx=cupx, ffx=cupx, fln=if(cupn == 0.) Inf else cupn)
    nmlow=c(flx=0., ffx=0., fln=if(cupn == 0.) -Inf else -cupn, inout=cinout, notrev=if (clownr == 0.) -Inf else clownr)
    for (nm in unique(c(names(nmlow), names(nmup)))) {
        # >= low
        # exclude those already in mi
        nmkeep=nml[[nm]][! nml[[nm]] %in% j1p]
        nbkeep=length(nmkeep)
        if (!is.na(nmlow[nm]) && nmlow[nm] != -Inf && nbkeep > 0L) {
            tmp=simple_triplet_matrix(i=seq(nbkeep), j=match(nmkeep, nml$fallnx), v=rep(1., nbkeep), ncol=nbl$fallnx, dimnames=list(paste("low ", nm, ":", nmkeep, ">=", nmlow[nm], sep=""), NULL))
            mi=rbind(mi, tmp)
            li=c(li, rep(nmlow[nm], nbkeep))
        }
        # <= up
        # exclude those already in mi
        nmkeep=nml[[nm]][! nml[[nm]] %in% j1n]
        nbkeep=length(nmkeep)
        if (!is.na(nmup[nm]) && nmup[nm] != Inf && nbkeep > 0L) {
            tmp=simple_triplet_matrix(i=seq(nbkeep), j=match(nmkeep, nml$fallnx), v=rep(-1., nbkeep), ncol=nbl$fallnx, dimnames=list(paste("up ", nm, ":", nmkeep, "<=", nmup[nm], sep=""), NULL))
            mi=rbind(mi, tmp)
            li=c(li, rep(-nmup[nm], nbkeep))
        }
    }
    names(li)=rownames(mi)
    # remove inequalities with only constrained fluxes
    jc=which(startsWith(nml$fallnx, "c"))
    ic=Filter(I, sapply(unique(mi$i), function(ii) if (all(mi$j[mi$i==ii] %in% jc)) ii else 0L))
    if (length(ic)) {
        mi=mi[-ic,,drop=FALSE]
        li=li[-ic]
    }
    # replace d. fluxes by (ff,fc) linear combinations
#browser()
    jd=nml$fallnx[startsWithv(nml$fallnx, "d")]
    jfc=nml$fallnx[startsWithv(nml$fallnx, c("f", "c"))]
    jc=nml$fallnx[startsWithv(nml$fallnx, "c")]
    li=li - mi[,jc,drop=FALSE] %stm% fc[jc] - (mi[,jd,drop=FALSE] %stm% (invAfl %stm% pcgc2bfl[,nml$pcgc=="",drop=FALSE])[jd,,drop=FALSE])
    mi=mi[,jfc,drop=FALSE] + as.simple_triplet_matrix(mi[,jd,drop=FALSE] %stm% (invAfl %stm% pcgc2bfl[,startsWithv(nml$pcgc, c("f", "c")),drop=FALSE])[jd,,drop=FALSE])[,jfc,drop=FALSE]
    # move fc part to li so that only ff remains
    jc=colnames(mi)[startsWith(colnames(mi), "c")]
    mi=mi[,startsWith(colnames(mi), "f"),drop=FALSE]
    # spot fluxes that are in inequalities in alone mode (for --zc)
    ige=rownames(mi)[apply(mi, 1L, function(v) sum(v) == 1. && sum(v != 0.) == 1L) & li >= 0.]
    ige=nml$dfn[unique(c(
        sub("n:.+<=(.+)$", "\\1", grep("^n:.+<=.+$", ige, v=TRUE)),
        sub("[df]\\.n\\.(.+)>=.+$", "\\1", grep("^[df]\\.n\\..+>=.+$", ige, v=TRUE)),
        sub("inout: [df]\\.n\\.(.+)>=.+$", "\\1", grep("^inout [df]\\.n\\..+>=.+$", ige, v=TRUE))
    ))]
    ile=rownames(mi)[apply(mi, 1L, function(v) sum(v) == 1. && sum(v != 0.) == 1L) & li >= 0.]
    ile=nml$dfn[unique(c(
        sub("n:.+<=(.+)$", "\\1", grep("^n:.+<=.+$", ile, v=TRUE)),
        sub("[df]\\.n\\.(.+)>=.+$", "\\1", grep("^[df]\\.n\\..+>=.+$", ile, v=TRUE)),
        sub("inout: [df]\\.n\\.(.+)>=.+$", "\\1", grep("^inout [df]\\.n\\..+>=.+$", ile, v=TRUE))
    ))]
    
    # metab inequalities
    if (nbl$poolf) {
        lip=s2d(mip$lip)
        i=s2i(mip$i)
        mip=simple_triplet_matrix(i=i, j=na.omit(match(mip$j, names(nml$poolall))), v=s2d(mip$v), nrow=length(lip), ncol=nbl$poolall, dimnames=list(names(lip), nml$poolall))
        # extend inequalities ui, ci by cupp>= poolf >= clowp
        # but exclude metabolites that are individually set in the mip (FTBL)
        # whether pool is present alone in pool >= smth
        j1p=as.integer(names(table(mip$j[mip$v == 1.])))
        # whether pool is present alone in pool <= smth
        j1n=as.integer(names(table(mip$j[mip$v == -1.])))
        # add standard limits
        nmup=c(flx=cupx, ffx=cupx, fln=if(cupn == 0.) Inf else cupn)
        nmlow=c(flx=0., ffx=0., fln=if(cupn == 0.) -Inf else -cupn, inout=cinout, notrev=if (clownr == 0.) -Inf else clownr)
        # >= clowp
        # exclude those already in mip
        nmkeep=if (length(j1p)) nml$poolall[-j1p] else nml$poolall
        nbkeep=length(nmkeep)
        if (nbkeep > 0L) {
            tmp=simple_triplet_matrix(i=seq(nbkeep), j=match(nmkeep, nml$poolall), v=rep(1., nbkeep), ncol=nbl$poolall, dimnames=list(paste("low:", nmkeep, ">=", clowp, sep=""), NULL))
            mip=rbind(mip, tmp)
            lip=c(lip, rep(clowp, nbkeep))
        }
        # <= cupp
        # exclude those already in mip
        nmkeep=if (length(j1n)) nml$poolall[-j1n] else nml$poolall
        nbkeep=length(nmkeep)
        if (nbkeep > 0L) {
            tmp=simple_triplet_matrix(i=seq(nbkeep), j=match(nmkeep, nml$poolall), v=rep(-1., nbkeep), ncol=nbl$poolall, dimnames=list(paste("up:", nmkeep, "<=", cupp, sep=""), NULL))
            mip=rbind(mip, tmp)
            lip=c(lip, rep(-cupp, nbkeep))
        }
        # move constant pools to rhs
        jc=nml$poolc
        lip=lip-mip[,jc] %stm% poolc
        mip=mip[,nml$poolf]
    } else {
        mip=simple_triplet_zero_matrix(0L, 0L)
        lip=c()
    }

    # prepare ui matrix and ci vector for optimisation
    # ui%*%param-ci>=0
    ui=as.matrix(dbind(mi, mip))
    ci=c(li, lip)
    names(ci)=rownames(ui)
    # remove all 0 rows (ineq on constrained values)
    inz=which(apply(ui, 1L, function(v) any(v != 0.)))
    if (length(inz)) {
        if (any(ipos <- ci[-inz] > 0.)) {
            ipos=which(ipos)
            stop_mes("Following inequalities were set on constrained values and are violated:\n\t", paste(names(ci[-inz])[ipos], sep="", collapse="\n\t"), file=fcerr)
        }
        ui=ui[inz,,drop=FALSE]
        ci=ci[inz]
    } else {
        ui=NULL
        ci=NULL
    }
    # equalities on metabs
    if (nbl$poolf) {
        cp=setNames(s2d(ep$lp), names(ep$lp))
        ep=as.matrix(simple_triplet_matrix(i=s2i(ep$i), j=match(ep$j, names(nml$poolall)), v=s2d(ep$v), ncol=nbl$poolall, dimnames=list(NULL, nml$poolall)))
        rownames(ep)=names(cp)
    } else {
        ep=cp=NULL
    }
    }) # end with()
    # prepare inputs for case_i
    with(e, {
    if (case_i) {
        for (iexp in seq_len(nbl$exp)) {
            nm=nml$exp[[iexp]]
            # funlab list
            funlabli[[iexp]]=eval(parse(text=funlabli[[iexp]]))
            funlabli[[iexp]]={
                n_lapply(funlabli[[iexp]], function(met, it) {
                    n_lapply(it, function(ni, rcode) {
                        v=try(parse(text=rcode), silent=TRUE)
                        if (inherits(v, "try-error"))
                            stop_mes("Error in parsing R code '", rcode, "' for label '", met, "#", ni, "' in '", nm, "':\n", v, file=fcerr)
                        v
                    })
                })
            }
            if (inherits(funlabli[[iexp]], "try-error"))
                stop_mes(funlabli[[iexp]], file=fcerr)
            funlabR=ifelse(nchar(funlabR), paste(dirw, funlabR, sep="/"), "") # set to "" where file names are empty
        }
        # prepare mapping of metab pools on cumomers
        nbl$ipf2ircumo[[iexp]]=nbl$ipf2ircumo2[[iexp]]=list()
        for (iw in seq_len(nbl$rw)) {
            ix=seq_len(nbl$rcumos[iw])
            ipf2ircumo=ipf2ircumo2=match(nmim[nbl$crcumos[iw]+ix], nml$poolf, nomatch=0L)
            dims=c(1L, nbl$rcumos[iw], ifelse(emu, iw, 1L), nbl$tifu[iexp]-1L)
            dims2=c(1L, nbl$rcumos[iw], ifelse(emu, iw, 1L), nbl$tifu2[iexp]-1L)
            i=as.matrix(ipf2ircumo)
            i2=as.matrix(ipf2ircumo2)
            for (id in 2L:length(dims)) {
                cstr=sprintf("cbind(%srep(seq_len(dims[id]), each=prod(dims[seq_len(id-1L)])))", paste("i[, ", seq_len(id-1L), "], ", sep="", collapse=""))
                i=eval(parse(text=cstr))
            }
            for (id in 2L:length(dims2)) {
                cstr=sprintf("cbind(%srep(seq_len(dims2[id]), each=prod(dims2[seq_len(id-1L)])))", paste("i2[, ", seq_len(id-1L), "], ", sep="", collapse=""))
                i2=eval(parse(text=cstr))
            }
            colnames(i)=c("ipoolf", "ic", "iw", "iti")
            colnames(i2)=c("ipoolf", "ic", "iw", "iti")
            i=i[i[,1L]!=0L,,drop=FALSE]
            i2=i2[i2[,1L]!=0L,,drop=FALSE]
            # put the poolf column last
            nbl$ipf2ircumo[[iexp]][[iw]]=i[, c("ic", "iw", "ipoolf", "iti"), drop=FALSE]
            nbl$ipf2ircumo2[[iexp]][[iw]]=i2[, c("ic", "iw", "ipoolf", "iti"), drop=FALSE]
        }
        if (fullsys) {
            # prepare mapping of metab pools on cumomers for full system (emu is FALSE here)
            nbl$ipf2icumo[[iexp]]=nbl$ipf2icumo2[[iexp]]=list()
            for (iw in seq_len(nbl$wf)) {
                ix=seq_len(nbl$cumos[iw])
                ipf2icumo=ipf2icumo2=match(nmimf[nbc_cumos[iw]+ix], nml$poolf, nomatch=0L)
                dims=c(1L, nbl$cumos[iw], 1L, nbl$tifu[iexp]-1L)
                dims2=c(1L, nbl$cumos[iw], 1L, nbl$tifu2[iexp]-1L)
                i=as.matrix(ipf2icumo)
                i2=as.matrix(ipf2icumo2)
                for (id in 2L:length(dims)) {
                    cstr=sprintf("cbind(%srep(seq_len(dims[id]), each=prod(dims[seq_len(id-1L)])))", paste("i[, ", seq_len(id-1L), "], ", sep="", collapse=""))
                    i=eval(parse(text=cstr))
                }
                for (id in 2L:length(dims2)) {
                    cstr=sprintf("cbind(%srep(seq_len(dims2[id]), each=prod(dims2[seq_len(id-1L)])))", paste("i2[, ", seq_len(id-1L), "], ", sep="", collapse=""))
                    i2=eval(parse(text=cstr))
                }
                colnames(i)=c("ipoolf", "ic", "iw", "iti")
                colnames(i2)=c("ipoolf", "ic", "iw", "iti")
                i=i[i[,1L]!=0L,,drop=FALSE]
                i2=i2[i2[,1L]!=0L,,drop=FALSE]
                # put the poolf column last
                nbl$ipf2icumo[[iexp]][[iw]]=i[, c("ic", "iw", "ipoolf", "iti"), drop=FALSE]
                nbl$ipf2icumo2[[iexp]][[iw]]=i2[, c("ic", "iw", "ipoolf", "iti"), drop=FALSE]
            }
        }
        xil=xi2=vector("list", nbl$exp)
        for (iexp in seq(nbl$exp)) {
            fli=funlabli[[iexp]]
            if (length(fli) == 0) {
                # replicate first column in xi as many times as there are time points
                if (time_order == "2" || time_order == "1,2")
                    xi2[[iexp]]=matrix(xi[[iexp]], nrow=length(xi[[iexp]]), ncol=nbl$tifu2[[iexp]])
                xil[[iexp]]=matrix(xi[[iexp]], nrow=length(xi[[iexp]]), ncol=nbl$tifu[[iexp]])
            }  else {
                # use funlab
                envfunlab=new.env() # funlab code won't see influx's variables
                if (nchar(funlabR[[iexp]])) {
                    if (file.exists(funlabR[[iexp]])) {
                        es=try(source(funlabR[[iexp]], local=envfunlab), outFile=fcerr)
                    } else {
                        stop_mes("funlab script R '", funlabR[[iexp]], "' from '", nml$exp[[iexp]],"' does not exist.", file=fcerr)
                    }
                }
                xil[[iexp]]=funlab(tifull[[iexp]], nml$inp, fli, envfunlab, emu, nml$exp[[iexp]], fcerr)
                if (time_order == "2" || time_order == "1,2")
                    xi2[[iexp]]=funlab(tifull2[[iexp]], nml$inp, fli, envfunlab, emu, nml$exp[[iexp]], fcerr)
            }
        }
        xi=xil
        nbl$ip2ircumo=match(nmim, nml$poolall)
        if (fullsys) {
            nbl$ip2icumo=match(nmimf, nml$poolall)
            # prepare xif from funlab
            xilf=xi2f=vector("list", nbl$exp)
            for (iexp in seq(nbl$exp)) {
                fli=funlabli[[iexp]]
                if (length(fli) == 0) {
                    # replicate first column in xi as many times as there are time points
                    if (time_order == "2" || time_order == "1,2")
                        xi2f[[iexp]]=matrix(xif[[iexp]], nrow=length(xif[[iexp]]), ncol=nbl$tifu2[[iexp]])
                    xilf[[iexp]]=matrix(xif[[iexp]], nrow=length(xif[[iexp]]), ncol=nbl$tifu[[iexp]])
                } else {
                    # use funlab
                    xilf[[iexp]]=funlab(tifull[[iexp]], nml$xif, fli, envfunlab, emu=FALSE, nml$exp[[iexp]], fcerr)
                    if (time_order == "2" || time_order == "1,2")
                        xi2f[[iexp]]=funlab(tifull2[[iexp]], nml$xif, fli, envfunlab, emu=FALSE, nml$exp[[iexp]], fcerr)
                }
            }
            xif=xilf
            if (time_order == "2" || time_order == "1,2") {
                nml$inpf=nml$xif
                labargs$labargs2$emu=FALSE
            }
        }
    }
    })
    # starting points and jacobians
    with(e, {
    # prepare series of starting points
    if (nchar(fseries) > 0) {
       pstart=as.matrix(read.table(file.path(dirw, fseries), header=TRUE, row.names=1L, sep="\\t"))
       # skip parameters (rows) who's name is not in nm$param
       i=rownames(pstart) %in% nml$param
       if (!any(i)) {
          stop_mes("Option --fseries is used but no free parameter with known name is found.\\n", file=fcerr)
       }
       pstart=pstart[i,,drop=FALSE]
       cat("Using starting values form '", fseries, "' for the following free parameters:\n", paste(rownames(pstart), collapse="\n"), "\n", sep="", file=fclog)
       nseries=ncol(pstart)
       if (initrand) {
          # fill the rest of rows with random values
          i=nml$param %in% rownames(pstart)
          n=sum(!i)
          pstart=rbind(pstart, structure(matrix(runif(n*nseries), n, nseries), dimnames=list(NULL, sprintf(paste0("V%0", ceiling(log10(nseries+1)), "d"), seq(nseries)))))
          rownames(pstart)=c(rownames(pstart)[seq_len(nbl$param-n)], nml$param[!i])
       }
       if (nchar(iseries) > 0L) {
          iseries=unique(as.integer(eval(parse(t="c("%s+%iseries%s+%")"))))
          iseries=iseries[iseries<=nseries]
          # subsample
          pstart=pstart[,iseries, drop=FALSE]
          nseries=ncol(pstart)
       } else {
          iseries=seq_len(nseries)
       }
    } else if (nchar(iseries) > 0) {
       # first construct pstart then if needed fill it with random values
       # and only then subsample
       iseries=unique(as.integer(eval(parse(t="c(" %s+% iseries %s+%" )"))))
       nseries=max(iseries)
       pstart=matrix(rep(param, nseries), nrow=nbl$param, ncol=nseries)
       dimnames(pstart)=list(nml$param, sprintf(paste0("V%0", ceiling(log10(nseries+1)), "d"), seq(nseries)))
       # subsample
       pstart=pstart[,iseries, drop=FALSE]
    } else {
       iseries=1L
       pstart=as.matrix(param)
    }
    if (initrand) # fill pstart with random values
        pstart[]=runif(length(pstart))
    nseries=ncol(pstart)
    nml$pseries=rownames(pstart)

    if (is.null(nseries) || nseries==0)
       stop_mes("No starting values",  file=fcerr)

    pres=matrix(NA, nbl$param, nseries)
    rownames(pres)=nml$param
    colnames(pres)=colnames(pstart)
    costres=rep.int(NA, nseries)

    # prepare flux index conversion
    ifwrv=seq_len(nbl$fwrv)
    names(ifwrv)=nml$fwrv
    ifl_in_fw=if (nbl$fl) ifwrv[paste("fwd", substring(nml$fl, 4L), sep="")] else integer(0)
    iff_in_fw=if (nbl$ff > 0) ifwrv[paste("fwd", substring(nml$ff, 4L), sep="")] else integer(0)
    ifg_in_fw=if (nbl$fgr > 0) ifwrv[paste("fwd", substring(nml$fgr, 4L), sep="")] else integer(0)

    # index couples for jacobian df_dfl, df_dffd
    nbl$cfw_fl=nbl$crv_fl=cbind(ifl_in_fw, seq_len(nbl$fl))
    nbl$cfw_ff=nbl$crv_ff=cbind(iff_in_fw, seq_len(nbl$ff))
    nbl$cfw_fg=nbl$crv_fg=cbind(ifg_in_fw, nbl$ff+seq_len(nbl$fgr))
    nbl$crv_fl[,1L]=(nbl$fwrv/2)+nbl$crv_fl[,1L]
    nbl$crv_ff[,1L]=(nbl$fwrv/2)+nbl$crv_ff[,1L]
    nbl$crv_fg[,1L]=(nbl$fwrv/2)+nbl$crv_fg[,1L]

    nbl$c_x=c(0, cumsum(nbl$x))

    # fixed part of jacobian (unreduced by SD)
    # measured fluxes
    dufm_dp=cbind(dufm_dff(nbl, nml), matrix(0, nrow=nbl$fmn, ncol=nbl$poolf))
    dimnames(dufm_dp)=list(nml$fmn, nml$param)

    # measured pools
    dupm_dp=matrix(0., nbl$poolm, nbl$ff)
    if (nbl$poolf > 0L)
        dupm_dp=cbind(dupm_dp, measurements$mat$pool[,nml$poolf, drop=FALSE])
    dimnames(dupm_dp)=list(rownames(measurements$mat$pool), nml$param)
    # prepare jacobian env for time_order includes 2
    if (case_i && (time_order == "2" || time_order == "1,2"))
        jx_f2=new.env()

    # formated output in kvh file
    fkvh_saved=if (write_res && wkvh) file.path(dirres, "tmp", sprintf("%s_res.kvh", baseshort))
    retcode=numeric(nseries)
    })
    invisible(NULL)
}
#' make influx_si calculations
#'
#' @param e Environement with all necessary variables and place holders
#' @return None
calc=function(e) {
    # put_inside, zc and init scales
    with(e, {
    for (irun in seq_len(nseries)) {
        top_chrono(sprintf("run %-3d", irun), file=fclog)
        param[nml$pseries]=pstart[nml$pseries, irun]
        runsuf=if (nseries > 1L) "." %s+% colnames(pstart)[irun] else ""
        if (length(nseries) > 0L)
            cat("Starting point", runsuf, "\n", sep="", file=fclog)

        # prepare kvh file name
        fkvh=if (write_res && wkvh) file(substring(fkvh_saved, 1L, nchar(fkvh_saved)-4L) %s+% runsuf %s+% ".kvh", "w")

        # remove zc inequalities from previous runs
        izc=which(startsWith(nml$ineq, "zc "))
        if (length(izc)) {
            ui=ui[-izc,,drop=FALSE]
            ci=ci[-izc]
            nml$ineqi=rownames(ui)
        }
        # check if initial approximation is feasible
        ineq=as.numeric(ui%*%param-ci)
        names(ineq)=rownames(ui)
        # set tolerance for inequality
        tol_ineq=if ("BFGS" %in% methods) 0. else tol
        nbad=sum(ineq <= -tol_ineq)
        if (nbad > 0L) {
            top_chrono("put_ins", file=fclog)
            cat("The following ", nbad, " inequalities are not respected at starting point", runsuf, ":\n", sep="", file=fclog)
            i=ineq[ineq<= -tol_ineq]
            cat(paste(names(i), i, sep="\t", collapse="\n"), "\n", sep="", file=fclog)
            # put them inside
            if (write_res) {
                capture.output(pinside <- put_inside(param, ui, ci), file=fclog)
            } else {
                pinside <- put_inside(param, ui, ci)
            }
            if (any(is.na(pinside))) {
                if (!is.null(attr(pinside, "err")) && attr(pinside, "err")!=0) {
                    # fatal error occured
                    cat("put_inside", runsuf, ": ", attr(pinside, "mes"), "\n", file=fcerr, sep="")
                    retcode[irun]=attr(pinside, "err")
                    next; # next run in iseries
                }
            } else if (!is.null(attr(pinside, "err")) && attr(pinside, "err")==0) {
                # non fatal problem
                cat(paste("***Warning: put_inside: ", attr(pinside, "mes"), collapse=""), "\n", file=fclog)
            }
            param[]=pinside
        }

        # prepare zero crossing strategy
        # inequalities to keep sens of net flux on first call to opt_wrapper()
        # if active they are removed on the second call to opt_wrapper()
        # and finaly all zc constraints are relaxed on the last call to opt_wrapper()
        fallnx=param2fl(param, labargs)$fallnx
        mi_zc=simple_triplet_zero_matrix(0L, nbl$fallnx)
        colnames(mi_zc)=nml$fallnx
        li_zc=NULL
        nmizc=c()
        ifd=which(startsWithv(nml$fallnx, c("d", "f")))
        if (zerocross && length(ifd) > 0L) {
            top_chrono("zc ineq", file=fclog)
            # add lower limits on [df].net >= zc for positive net fluxes
            # and upper limits on [df].net <= -zc for negative net fluxes
            ipos=match(setdiff(names(which(fallnx[ifd]>=0.)), ige), nml$fallnx)
            ineg=match(setdiff(names(which(fallnx[ifd]<0.)), ile), nml$fallnx)
            mi_zc=simple_triplet_zero_matrix(nrow=length(ipos)+length(ineg), ncol=nbl$fallnx)
            colnames(mi_zc)=nml$fallnx
            nmizc=c(nmizc, paste("zc: ", nml$fallnx[ipos], ">=", zc, sep="", recycle0=TRUE))
            mi_zc[cbind(seq_along(ipos), ipos)]=1.
            nmizc=c(nmizc, paste("zc; ", nml$fallnx[ineg], "<=", -zc, sep="", recycle0=TRUE))
            mi_zc[cbind(length(ipos)+seq_along(ineg), ineg)]=-1.
        }
        rownames(mi_zc)=nmizc
        li_zc=rep(zc, length(nmizc)) # that's ok for both pos and neg constraints
        tmp=mi_zc[,nml$fl,drop=FALSE] %stm% (invAfl %stm% pcgc2bfl) # fcgc part of mi
        ui_zc=mi_zc[,nml$ff,drop=FALSE] + tmp[,nml$ff,drop=FALSE]
        ci_zc=li_zc - tmp[,nml$fc,drop=FALSE] %*% fallnx[nml$fc]
        ci_zc=ci_zc - tmp[,colnames(tmp)==""]
        ui_zc=cbind(ui_zc, simple_triplet_zero_matrix(nrow=nrow(mi_zc), ncol=nbl$poolf))
        
        # remove constant inequalities
        zi=if (ncol(ui_zc)) apply(ui_zc,1L,function(v) max(abs(v))<=tol_ineq) else rep(TRUE, nrow(ui_zc))

        inotsat=ci_zc[zi]>tol_ineq
        if (any(inotsat)) {
            cat("***Warning: the following constant zc inequalities are not satisfied:\n", file=fclog)
            cat("\t", nmizc[zi][inotsat], sep="\n\t", file=fclog)
        }
        ui_zc=ui_zc[!zi,,drop=FALSE]
        ci_zc=ci_zc[!zi]
        nmizc=nmizc[!zi]
        mi_zc=mi_zc[!zi,,drop=FALSE]
        ui_zc=as.matrix(ui_zc)

        # remove redundant/contradictory inequalities
        nbzc=nrow(ui_zc)
        nbi=nrow(ui)
        ired=c()
        tui=t(ui)
        uzcd=sapply(seq_len(nbzc), function(i) apply(abs(tui-ui_zc[i,]), 2L, max))
        uzcs=sapply(seq_len(nbzc), function(i) apply(abs(tui+ui_zc[i,]), 2L, max))
        czcd=abs(outer(abs(ci), abs(ci_zc), "-"))
        ired=which(apply((uzcd < tol_ineq | uzcs < tol_ineq) & czcd <= 1.e-2, 2L, any))
          
        if (length(ired) > 0L) {
            # remove all ired inequalities
            cat("The following ", length(ired), " zerocross inequalities are redundant and are removed:\n", paste(nmizc[ired], collapse="\n"), "\n", sep="", file=fclog)
            ui_zc=ui_zc[-ired,,drop=FALSE]
            ci_zc=ci_zc[-ired]
            nmizc=nmizc[-ired]
            mi_zc=mi_zc[-ired,,drop=FALSE]
        }
        if (nrow(ui_zc)) {
            # add zc inequalities
            ui=rbind(ui, ui_zc)
            ci=c(ci, ci_zc)
            nml$ineq=c(nml$ineq, nmizc)
        }
        rm(ui_zc, ci_zc, uzcd, uzcs, czcd)
        rres=NULL
        # see if there are any active inequalities at starting point
        ineq=as.numeric(ui%*%param-ci)
        names(ineq)=rownames(ui)
        nbad=sum(abs(ineq)<=tol_ineq)
        if (nbad > 0)
            cat("The following ", nbad, " inequalities(s) are active at starting point", runsuf, ":\n",
                paste(names(ineq[abs(ineq)<=tol_ineq]), collapse="\n"), "\n", sep="", file=fclog)


        # init kvh writing
        if (write_res && wkvh) {
            top_chrono("kvh init", file=fclog)
            cat("influx\n", file=fkvh)
            cat("\tversion\t", vernum, "\n", file=fkvh, sep="")
            cat("\tlabeling\t", if (case_i) "instationary" else "stationary", "\n", file=fkvh, sep="")
            # save options of command line
            obj2kvh(ropts, "runtime options", fkvh, indent=1L)
            obj2kvh(R.Version(), "R.Version", fkvh, indent=1L)
            cat("\tR command line\n", file=fkvh)
            obj2kvh(opts, "opts", fkvh, indent=2L)
            cat("\t\texecution date\t", format(Sys.time()), " cpu=", proc.time()[1L], "\n", sep="", file=fkvh)
            
            # resume system sizes
            obj2kvh(nbl$sys, "system sizes", fkvh)
            
            # save initial param
            cat("starting point\n", file=fkvh)
            names(param)=nml$param
            obj2kvh(param, "starting free parameters", fkvh, indent=1L)
        }
        
        # main part: call optimization
        # starting res
        if (!length(rres)) {
            rres <- lab_resid(param, cjac=FALSE, labargs)
            if (!is.null(rres$err) && rres$err) {
                cat("lab_resid", runsuf, ": ", rres$mes, "\\n", file=fcerr, sep="")
                retcode[irun]=rres$err
                next
            }
            if (any(is.infinite(rres$res))) {
                cat("At starting point, infinite values appeared in residual vector.", file=fcerr)
                retcode[irun]=1L
                next
            }
        }
        rcost=if (length(rres$res) && !all(ina <- is.na(rres$res))) sum(crossprod(rres$res[!ina])) else NA
        if (write_res && wkvh) {
            obj2kvh(rcost, "starting cost value", fkvh, indent=1L)
            obj2kvh(Afl, "flux system (Afl)", fkvh, indent=1L)
        }
        fg=numeric(nbl$fgr)
        names(fg)=nml$fgr
        if (nbl$fgr > 0)
            fg[paste("g.n.", substring(nml$poolf, 4), "_gr", sep="")]=nbl$mu*param[nml$poolf]
        if (write_res && wkvh) {
            btmp=as.numeric(p2bfl %stm% param[seq_len(nbl$nbl$ff)]+bp+g2bfl %stm% fg)
            names(btmp)=dimnames(Afl)[[1L]]
            obj2kvh(btmp, "flux system (bfl)", fkvh, indent=1L)
        }
        names(param)=nml$param
        if (optimize && nbl$ff+nbl$poolf > 0L) {
            if (!(least_norm || sln || !"nlsic" %in% methods)) {
                # check if at starting position all fluxes can be resolved
                top_chrono("check ja", file=fclog)
                rres=lab_resid(param, cjac=TRUE, labargs)
                if (sum(is.infinite(rres$res))) {
                    cat("Infinite values appeared in residual vector (at identifiability check)", file=fcerr)
                    retcode[irun]=1
                    next
                }
                if (any(is.infinite(rres$jacobian))) {
                    cat("Infinite values appeared in Jacobian (at identifiability check)", file=fcerr)
                    retcode[irun]=1L
                    next
                }
                qrj=qr(jx_f$dr_dff, LAPACK=TRUE)
                d=diag(qrj$qr)
                qrj$rank=sum(abs(d)>abs(d[1L])*tol)
                if (is.na(qrj$rank)) {
                    cat("Rank of starting jacobian could not be estimated.", file=fcerr)
                    retcode[irun]=1L
                    next
                }
                nmuns=if (qrj$rank) nml$ff[qrj$pivot[-(1:qrj$rank)]] else nml$ff
                if (qrj$rank < nbl$ff) {
                    # Too bad. The jacobian of free fluxes is not of full rank.
                    dimnames(jx_f$dr_dff)[[2L]]=c(nml$ffn, nml$ffx)
                    fname="dbg_dr_dff_singular" %s+% runsuf %s+% ".csv"
                    cat(sprintf("Provided measurements (labeling and fluxes) are not sufficient to resolve all free fluxes.\nUnsolvable fluxes may be:\n%s\nJacobian dr_dff is written in the result kvh file (if --wkvh is activated).\n",
                        paste(nmuns, sep=", ", collapse=", ")), file=fcerr)
                    if (write_res && wkvh)
                        obj2kvh(jx_f$dr_dff, "Jacobian dr_dff", fkvh, indent=0)
                    retcode[irun]=1L
                    next
                }
            }
            top_chrono("optim", file=fclog)
            # pass control to the chosen optimization method
            if (time_order=="1,2")
                labargs$time_order="1" # start with order 1, later continue with 2
            for (method in methods) {
                if (write_res) {
                    capture.output(res <- opt_wrapper(param, method, measurements, jx_f, labargs), file=fclog)
                } else {
                    res <- opt_wrapper(param, method, measurements, jx_f, labargs)
                }
                if ((!is.null(res$err) && res$err) || is.null(res$par)) {
                    cat("***Warning: error occured in first optimization pass", runsuf, ": ", res$mes, "\n", sep="", file=fclog)
                    res$par=rep(NA, length(param))
                    res$cost=NA
                } else if (!is.null(res$mes) && nchar(res$mes)) {
                    cat("***Warning: in first optimization pass in run ", runsuf, ": ", res$mes, "\n", sep="", file=fclog)
                }
                if (any(is.na(res$par))) {
                    res$retres$jx_f=NULL # to avoid writing of huge data
                    if (write_res && wkvh)
                        obj2kvh(res, "failed first pass optimization process information", fkvh)
                    cat("Optimization failed", runsuf, ": ", res$mes, "\n", file=fcerr, sep="")
                    # some additional information can be written into fkvh
                    retcode[irun]=max(res$err, 1L)
                    next
                }
                param=res$par
                if (zerocross && !is.null(mi_zc)) {
                    top_chrono("secondzc", file=fclog)
                    # inverse active "zc" inequalities
                    nminv=names(which((ui%*%res$par-ci)[,1L]<=tol_ineq))
                    i=grep("^zc ", nminv, v=TRUE)
                    if (length(i) > 0) {
                        i=str2ind(i, nminv)
                    cat("The following inequalities are active after first pass
        of zero crossing strategy and will be inverted", runsuf, ":\n", paste(nml$ineq[i], collapse="\n"), "\n", sep="", file=fclog)
                        ipos=grep(">=", nml$ineq[i], v=TRUE)
                        ineg=grep("<=", nml$ineq[i], v=TRUE)
                        ui[i,]=-ui[i,,drop=FALSE]
                        if (length(ipos)) {
                            ipzc=str2ind(ipos, nmizc)
                            ipos=str2ind(ipos, nminv)
                            ci[ipos]=as.numeric(zc+mi_zc[ipzc,,drop=FALSE]%*%mic)
                            nml$ineq[ipos]=sub(">=", "<=-", nml$ineq[ipos])
                        }
                        if (length(ineg)) {
                            inzc=str2ind(ineg, nmizc)
                            ineg=str2ind(ineg, nminv)
                            ci[ineg]=as.numeric(zc+mi_zc[inzc,,drop=FALSE]%*%mic)
                            nml$ineq[ineg]=sub("<=-", ">=", nml$ineq[ineg])
                        }
                        rownames(ui)=nminv
                        names(ci)=nminv
                        # enforce new inequalities
                        reopt=TRUE
                        if (write_res) {
                            capture.output(pinside <- put_inside(res$par, ui, ci), file=fclog)
                        } else {
                            pinside <- put_inside(res$par, ui, ci)
                        }
                        if (any(is.na(pinside))) {
                            if (!is.null(attr(pinside, "err")) && attr(pinside, "err")!=0) {
                                # fatal error occured, don't reoptimize
                                cat(paste("put_inside", runsuf, ": ", attr(pinside, "mes"), "\n", collapse=""), file=fcerr)
                                reopt=FALSE
                            }
                        } else if (!is.null(attr(pinside, "err")) && attr(pinside, "err")==0){
                            # non fatal problem
                            cat(paste("***Warning: put_inside", runsuf, ": ", attr(pinside, "mes"), "\n", collapse=""), file=fclog)
                        }
                        # reoptimize
                        if (reopt) {
                            cat("Second zero crossing pass", runsuf, "\n", sep="", file=fclog)
                            if (write_res) {
                                capture.output(reso <- opt_wrapper(pinside, method, measurements, new.env(), labargs), file=fclog)
                            } else {
                                reso <- opt_wrapper(pinside, method, measurements, new.env(), labargs)
                            }
                            if (reso$err || is.null(reso$par)) {
                                cat("***Warning: error in second zero crossing pass: ", reso$mes, "\n", sep="", file=fclog)
                            } else if (!is.null(reso$mes) && nchar(reso$mes)) {
                                cat("***Warning: second zero crossing pass", runsuf, ": ", reso$mes, "\n", sep="", file=fclog)
                            }
                            if(!reso$err && !is.null(reso$par) && !any(is.na(reso$par))) {
                                param=reso$par
                                res=reso
                                jx_f=labargs$jx_f
                            }
                            if (any(is.na(reso$par))) {
                                reso$retres$jx_f=NULL # to avoid writing of huge data
                                if (write_res && wkvh)
                                    obj2kvh(reso, "failed second pass optimization process information", fkvh)
                                cat("***Warning: second zero crossing pass failed. Keep free parameters from previous pass", runsuf, "\n", file=fclog, sep="")
                            }
                        }
                        # last pass, free all zc constraints
                        i=grep("^zc ", nminv)
                        if (length(i) > 0) {
                            top_chrono("last zc", file=fclog)
                            ui=ui[-i,,drop=FALSE]
                            ci=ci[-i]
                            nminv=nml$ineq[-i]
                            cat("Last zero crossing pass (free of zc constraints)", runsuf, "\n", sep="", file=fclog)
                            if (write_res) {
                                capture.output(reso <- opt_wrapper(param, method, measurements, new.env(), labargs), file=fclog)
                            } else {
                                reso <- opt_wrapper(param, method, measurements, new.env(), labargs)
                            }
                            if (reso$err || is.null(reso$par) || (!is.null(res$mes) && nchar(res$mes)))
                                cat("***Warning: last zero crossing (free of zc)", runsuf, ": ", reso$mes, "\n", sep="", file=fclog)
                            if(!reso$err && !is.null(reso$par) && !any(is.na(reso$par))) {
                                param=reso$par
                                res=reso
                                jx_f=labargs$jx_f
                            }
                            if (any(is.na(res$par))) {
                                res$retres$jx_f=NULL # to avoid writing of huge data
                                if (write_res && wkvh)
                                    obj2kvh(res, "failed last pass optimization process information", fkvh)
                                cat("***Warning: last zero crossing pass failed. Keep free parameters from previous passes", runsuf, "\n", file=fclog, sep="")
                            }
                        }
                    } else {
                        cat("After the first optimization, no zero crossing inequality was activated. So no reoptimization", runsuf, "\n", sep="", file=fclog)
                    }
                } # end if zero crossing
            } # for method
            param=res$par
            names(param)=nml$param
            if (excl_outliers != FALSE) {
                # detect outliers
                top_chrono("outliers", file=fclog)
                iva=!is.na(res$res)
                zpval=rz.pval.bi(res$res)
                iout=which(zpval <= excl_outliers & iva)
                #cat("iout=", iout, "\n", file=fclog)
                if (length(iout)) {
                    measurements$outlier=iout
                    outtab=cbind(residual=res$res[iout], `p-value`=zpval[iout])
                    row.names(outtab)=nml$resid[iout]
                    cat("Excluded outliers at p-value ", excl_outliers, ":\n", sep="", file=fclog)
                    write.table(outtab, file=fclog, append=TRUE, quote=FALSE, sep="\t", col.names=FALSE)
                
                    # optimize with the last method from methods
                    if (write_res) {
                        capture.output(reso <- opt_wrapper(param, tail(methods, 1L), measurements, new.env(), labargs), file=fclog)
                    } else {
                        reso <- opt_wrapper(param, tail(methods, 1L), measurements, new.env(), labargs)
                    }
                    if (reso$err || is.null(reso$par) || (!is.null(reso$mes) && nchar(reso$mes)))
                        cat("***Warning: error without outliers: ", reso$mes, "\n", sep="", file=fclog)
                    if (any(is.na(reso$par))) {
                        cat("***Warning: optimization with outliers excluded has failed", runsuf, "\n", file=fclog, sep="")
                        # continue without outlier exclusion
                        measurements$outlier=NULL
                    } else {
                        res=reso
                        param=reso$par
                        names(param)=nml$param
                        jx_f=labargs$jx_f
                        labargs$measurements=measurements # store outliers
                        if (write_res && wkvh)
                            obj2kvh(outtab, "excluded outliers", fkvh)
                    }
                } else {
                    cat("***Warning: outlier exclusion at p-value "%s+%excl_outliers%s+%" has been requested but no outlier was detected at this p-value threshold.", "\n", sep="", file=fclog)
                }
            }
            if (case_i && time_order=="1,2") {
                top_chrono("order 2", file=fclog)
                labargs$time_order="2" # continue with the 2-nd order
                if (write_res) {
                    capture.output(reso <- opt_wrapper(param, tail(methods, 1L), measurements, new.env(), labargs), file=fclog)
                } else {
                    reso <- opt_wrapper(param, tail(methods, 1L), measurements, new.env(), labargs)
                }
                if (reso$err || is.null(reso$par) || (!is.null(reso$mes) && nchar(reso$mes)))
                    cat("***Warning: order2: ", reso$mes, "\n", sep="", file=fclog)
                if (any(is.na(reso$par))) {
                    cat("***Warning: optimization time_order 2 (in '1,2' suite) has failed, run=", runsuf, "\n", file=fclog, sep="")
                } else {
                    res=reso
                    param=reso$par
                    names(param)=nml$param
                    jx_f=labargs$jx_f
                }
            }
            
            if (write_res && wkvh) {
                optinfo=list(
                    "fitted parameters"=param,
                    "last increment before backtracking"=res$lastp,
                    "last increment after backtracking"=res$laststep,
                    "iteration number"=res$it,
                    "convergence history"=res$hist,
                    "exit message"=res$mes
                )
                obj2kvh(optinfo, "optimization process information", fkvh)
            }
            rres=res$retres
        } else {
            top_chrono("resid jac", file=fclog)
            rres=lab_resid(param, cjac=TRUE, labargs)
        }
        top_chrono("postopt", file=fclog)
        # active constraints
        if (!all(is.na(param))) {
            ine=as.numeric(abs(ui%*%param-ci))<tol_ineq
            if (any(ine) && write_res && wkvh)
                obj2kvh(nml$ineq[ine], "active inequality constraints", fkvh)
        }
        poolall[nml$poolf]=param[nml$poolf]

        if (is.null(jx_f$jacobian)) {
            # final jacobian calculation
            if (write_res) {
                capture.output(rres <- lab_resid(param, cjac=TRUE, labargs), file=fclog)
            } else {
                rres <- lab_resid(param, cjac=TRUE, labargs)
            }
            if (!is.null(rres$err) && rres$err) {
                cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
                retcode[irun]=rres$err
                next
            }
        }
        rcost=cumo_cost(param, labargs, rres)
        pres[,irun]=param
        costres[irun]=rcost
        if (write_res) {
            if (wkvh) obj2kvh(rcost, "final cost", fkvh)
            resid=list()
            # get z p-values on residual vector
            zpval=rz.pval.bi(rres$res)
            resid[["labeled data"]]=i_lapply(jx_f$reslab, function(iexp, rl) if (is.matrix(rl)) rl else cbind(residual=rl, `p-value`=zpval[seq_along(rl)]))
      
            if (case_i)
                resid[["labeled data p-value"]]=lapply(jx_f$reslab, function(mtmp) {mtmp[]=zpval[seq_along(mtmp)]; mtmp})

            nbreslab_tot=sum(lengths(jx_f$reslab))
            if (length(jx_f$resflu))
                resid[["measured fluxes"]]=cbind(residual=jx_f$resflu, `p-value`=zpval[nbreslab_tot+seq_along(jx_f$resflu)])
            if (length(jx_f$respool))
                resid[["measured pools"]]=cbind(residual=if (is.matrix(jx_f$respool)) jx_f$respool[,1L] else jx_f$respool, `p-value`=zpval[nbreslab_tot+length(jx_f$resflu)+seq_along(jx_f$respool)])
            if (wkvh)
                obj2kvh(resid, "(simulated-measured)/sd_exp", fkvh)

            # simulated measurements -> out
            simul=list()
            if (case_i) {
                if (addnoise) {
                    simul[["labeled data"]]=lapply(seq_len(nbl$exp), function(iexp) jx_f$usm[[iexp]]+rnorm(length(jx_f$usm[[iexp]]))*measurements$dev$labeled[[iexp]])
                    names(simul[["labeled data"]])=nml$exp
                } else {
                    # move mass in usm into valid interval [0, 1] and sum=1
                    simul[["labeled data"]]=lapply(seq_len(nbl$exp), function(iexp) {
                        x=clamp(jx_f$usm[[iexp]], 0., 1.)
                        # get unique mass names to sum up to 1
                        nmx=rownames(x)
                        nmm=nmx[startsWith(nmx, "m:")]
                        if (length(nmm)) {
                            # get unique fragments
                            fr_u=unique(sapply(strsplit(nmm, ":", fixed=TRUE), function(v) paste0(c(v[1L:3L], ""), collapse=":")))
                            lapply(fr_u, function(nm) {
                                # get indexes per fragment
                                i=which(startsWith(nmx, nm))
                                mets=strsplit(nm, ":", fixed=TRUE)[[1L]][2L]
                                met1=strsplit(mets, "+", fixed=TRUE)[[1L]][1L]
                                if (length(i) < clen[met1]+1)
                                    return(NULL)
                                s=colSums(x[i,,drop=FALSE])
                                x[i,] <<- arrApply::arrApply(x[i,,drop=FALSE], 2, "multv", v=1./s)
                                NULL
                            })
                        }
                        x
                    })
                    names(simul[["labeled data"]])=nml$exp
                }
                # simul --> .miso.sim
                mlp2LAB=c(m="MS", l="LAB", p="PEAK")
                cnm=c("Id", "Comment", "Specie", "Fragment", "Dataset", "Isospecies", "Value", "SD", "Time", "Residual", "Pvalue")
                for (iexp in seq_len(nbl$exp)) {
                    fnm=nml$exp[[iexp]]
                    rnm=gsub("#", "", nml$meas[[iexp]], fixed=TRUE)
                    mnm=strsplitlim(rnm, ":", fixed=TRUE, lim=NA, strict=TRUE)
                    mnm=matrix(unlist(mnm), ncol=length(mnm[[1L]]), byrow=TRUE)
                    ct=rep(colnames(simul[["labeled data"]][[iexp]]), each=nrow(simul[["labeled data"]][[iexp]]))
                    c3=suppressWarnings(as.integer(mnm[, 3L]))
                    df=cbind(
                        "",
                        "",
                        Specie=mnm[, 2L],
                        Fragment=ifelse(mnm[, 1L] == "m", mnm[, 3L], ""),
                        Dataset=paste0(mlp2LAB[mnm[, 1L]], "_", mnm[, 2L], "_", mnm[, 3L]),
                        Isospecies=ifelse(mnm[, 1L] == "m",
                            paste0("M", mnm[, 4L]), # MS: M0, M1, etc
                            ifelse(mnm[, 1L] == "l", mnm[, 3L], # label: 01x+00x etc
                            paste0(mnm[, 3L], "->", # peak: 2->1,3 etc.
                            ifelse(mnm[, 4L] == "S", "",
                            ifelse(mnm[, 4L] == "D-", c3-1,
                            ifelse(mnm[, 4L] == "D+", c3+1,
                            paste0(c3-1L, ",", c3+1L) # DD
                        )))))),
                        Value=c(simul[["labeled data"]][[iexp]]),
                        SD=measdev[[iexp]],
                        Time=ct,
                        Resid=c(resid[["labeled data"]][[iexp]]),
                        Pvalue=c(resid[["labeled data p-value"]][[iexp]])
                    )
                    colnames(df)=cnm
                    write.table(df, sep="\t", quote=FALSE, row.names=FALSE, fileEncoding="utf8", file=file.path(dirres, paste0(fnm, runsuf, ".miso.sim")))
                }
            } else {
                if (addnoise) {
                    simlab=lapply(seq_len(nbl$exp), function(iexp) jx_f$simlab[[iexp]]+rnorm(length(jx_f$simlab[[iexp]]))*measurements$dev$labeled[[iexp]])
                    names(simlab)=nml$exp
                } else {
                    simlab=jx_f$simlab
                    names(simlab)=nml$exp
                }
                if (nbl$sc_tot > 0) {
                    simul[["labeled data (unscaled)"]]=jx_f$usimlab
                    simul[["labeled data (scaled)"]]=simlab
                } else {
                    simul[["labeled data"]]=simlab
                }
                # simlab --> .miso.sim
                mlp2LAB=c(m="MS", l="LAB", p="PEAK")
                cnm=c("Id", "Comment", "Specie", "Fragment", "Dataset", "Isospecies", "Value", "SD", "Time", "Residual", "Pvalue")
                for (iexp in seq_len(nbl$exp)) {
                    fnm=nml$exp[[iexp]]
                    rnm=gsub("#", "", nml$meas[[iexp]], fixed=TRUE)
                    mnm=strsplitlim(rnm, ":", fixed=TRUE, lim=NA, mat=TRUE)
                    c3=suppressWarnings(as.integer(mnm[, 3L]))
                    df=cbind(
                        "",
                        "",
                        Specie=mnm[, 2L],
                        Fragment=ifelse(mnm[, 1L] == "m", mnm[, 3L], ""),
                        Dataset=paste0(mlp2LAB[mnm[, 1L]], "_", mnm[, 2L], "_", mnm[, 3L]),
                        Isospecies=ifelse(mnm[, 1L] == "m",
                            paste0("M", mnm[, 4L]), # MS: M0, M1, etc
                            ifelse(mnm[, 1L] == "l", mnm[, 3L], # label: 01x+00x etc
                            paste0(mnm[, 3L], "->", # peak: 2->1,3 etc.
                            ifelse(mnm[, 4L] == "S", "",
                            ifelse(mnm[, 4L] == "D-", c3-1L,
                            ifelse(mnm[, 4L] == "D+", c3+1L,
                            paste0(c3-1, ",", c3+1L) # DD
                        )))))),
                        Value=simlab[[iexp]],
                        SD=measdev[[iexp]],
                        Time="",
                        resid[["labeled data"]][[iexp]]
                    )
                    colnames(df)=cnm
                    write.table(df, sep="\t", quote=FALSE, row.names=FALSE, fileEncoding="utf8", file=file.path(dirres, paste0(fnm, runsuf, ".miso.sim")))
                }
            }
            if (nbl$fmn) {
                if (addnoise)
                    simul[["measured fluxes"]]=jx_f$simfmn+rnorm(length(jx_f$simfm))*measurements$dev$flux
                else
                    simul[["measured fluxes"]]=jx_f$simfmn
                # measured fluxes --> .mflux
                cnm=c("Id", "Comment", "Flux", "Value", "SD", "Residual", "Pvalue")
                df=structure(cbind("", "", substring(names(simul[["measured fluxes"]]), 5L), simul[["measured fluxes"]], measurements$dev$flux, resid[["measured fluxes"]]), dimnames=list(NULL, cnm))
                write.table(df, sep="\t", quote=FALSE, row.names=FALSE, file=file.path(dirres, paste0(baseshort, runsuf, ".mflux.sim")))
            }
            if (nbl$poolm) {
                if (addnoise)
                    simul[["measured pools"]]=jx_f$simpool+rnorm(length(jx_f$simpool))*measurements$dev$pool
                else
                    simul[["measured pools"]]=jx_f$simpool
                # measured metabolites --> .mmet
                cnm=c("Id", "Comment", "Specie", "Value", "SD", "Residual", "Pvalue")
                df=structure(cbind("", "", substring(names(simul[["measured pools"]]), 4L), simul[["measured pools"]], measurements$dev$pool, resid[["measured pools"]]), dimnames=list(NULL, cnm))
                write.table(df, sep="\t", quote=FALSE, row.names=FALSE, file=file.path(dirres, paste0(baseshort, runsuf, ".mmet.sim")))
            }
            rm(resid, zpval)
            if (wkvh) obj2kvh(simul, "simulated measurements", fkvh)

            # SD -> out
            # get index of non null components
            iget=sapply(names(measurements$dev), function(nm) !is.null(measurements$dev[[nm]]) & nm %in% c("labeled", "flux", "pool"))
            if (wkvh) {
                obj2kvh(measurements$dev[iget], "measurement SD", fkvh)

                # gradient -> kvh
                if (length(jx_f$res) && !all(ina <- is.na(jx_f$res))) {
                    if (any(ina)) {
                        gr=2*as.numeric(crossprod(jx_f$res[!ina], jx_f$jacobian[!ina,,drop=FALSE]))
                    } else {
                        gr=2*as.numeric(crossprod(jx_f$res, jx_f$jacobian))
                    }
                    names(gr)=nml$param
                    obj2kvh(gr, "gradient vector", fkvh)
                }
                colnames(jx_f$udr_dp)=nml$param
                obj2kvh(jx_f$udr_dp, "jacobian dr_dp (without 1/sd_exp)", fkvh)
                # generalized inverse of non reduced jacobian
                if (length(jx_f$udr_dp) > 0L) {
                    svj=svd(jx_f$udr_dp)
                    invj=svj$v%*%(t(svj$u)/svj$d)
                    dimnames(invj)=rev(dimnames(jx_f$udr_dp))
                    obj2kvh(invj, "generalized inverse of jacobian dr_dp (without 1/sd_exp)", fkvh)
                }
            }
        } # endif write_res

        getx=TRUE
        if (fullsys) {
            nbl$xif=length(xif[[1L]])
            if (case_i && !is.null(cl))
                clusterExport(cl, c("labargs"))
            v=lab_sim(param, cjac=FALSE, labargs, fullsys)
            if (identical(v$err, 1L))
               stop_mes("fullsys: weight=", v$iw, "; ", v$mes, file=fcerr)
            x=if (case_i) v$xf else v$x
        } else {
            v=lab_sim(param, cjac=FALSE, labargs)
            x=if (case_i) v$xf else v$x
        }
        mid=cumo2mass(x)
        if (case_i) {
            mid=lapply(mid, function(m) m[sort(rownames(m)),,drop=FALSE])
        } else if (length(mid)) {
            mid=mid[sort(rownames(mid)),,drop=FALSE]
        }
        # write some info in result kvh
        if (write_res && wkvh) {
            obj2kvh(mid, "MID vector", fkvh)
            # constrained fluxes to kvh
            obj2kvh(fallnx[nml$fc], "constrained net-xch01 fluxes", fkvh)
        }
        fwrv=v$lf$fwrv
        fallnx=v$lf$fallnx
        flnx=v$lf$flnx
        fgr=fallnx[nml$fgr]

        # keep last jx_f in jx_f_last
        while (sensitive=="mc" && !all(is.na(param))) {
            top_chrono("monte-ca", file=fclog)
            if (set_seed)
                set.seed(seed)
            # reference simulation corresponding to the final param
            refsim=new.env()
            for (nmit in c("simlab", "simfmn", "simpool", "usm"))
                assign(nmit, jx_f[[nmit]], envir=refsim)
            # Monte-Carlo simulation in parallel way (if asked and possible)
            if (np > 1L) {
                spli=splitIndices(nmc, nodes);
                clusterExport(cl, c("param", "refsim", "runsuf", "spli"))
                cl_res=clusterEvalQ(cl, {mc_iter=TRUE; labargs$getx=FALSE; mc_res=lapply(spli[[idw]], mc_sim); rm(mc_iter); mc_res})
                mc_res=vector(nmc, mode="list")
                for (i in seq(nodes))
                    mc_res[spli[[i]]]=cl_res[[i]]
            } else {
                mc_res=lapply(seq_len(nmc), function(imc) cl_worker(funth=mc_sim, argth=list(imc)))
            }
            free_mc=sapply(mc_res, function(l) {if (class(l)=="character" || is.null(l) || is.na(l$cost) || l$err) { ret=rep(NA, nbl$param+3) } else { ret=c(l$cost, l$it, l$normp, l$par) }; ret })
            if (length(free_mc)==0) {
                cat("***Warning: parallel exectution of Monte-Carlo simulations has failed.", "\n", sep="", file=fclog)
                free_mc=matrix(NA, nbl$param+2L, 0L)
            }
            cost_mc=free_mc[1L,]
            nmc_real=nmc-sum(is.na(free_mc[4L,]))
            if (write_res && wkvh) {
                cat("monte-carlo\n", file=fkvh)
                indent=1L
                obj2kvh(cl_type, "cluster type", fkvh, indent)
                obj2kvh(avaco, "detected cores", fkvh, indent)
                avaco=max(1L, avaco, na.rm=TRUE)
                obj2kvh(min(avaco, np, na.rm=TRUE), "used cores", fkvh, indent)
                cat("\tfitting samples\n", file=fkvh)
                indent=2L
                obj2kvh(nmc, "requested number", fkvh, indent)
                obj2kvh(nmc_real, "calculated number", fkvh, indent)
                obj2kvh(nmc-nmc_real, "failed to calculate", fkvh, indent)
                # convergence section in kvh
                indent=1
                mout=rbind(round(free_mc[1:2,,drop=FALSE], 2),
                    format(free_mc[3,,drop=FALSE], di=2, sci=TRUE))
                dimnames(mout)=list(c("cost", "it.numb", "normp"), seq_len(ncol(free_mc)))
                obj2kvh(mout, "convergence per sample", fkvh, indent)
            }
            # remove failed m-c iterations
            free_mc=free_mc[-(1:3),,drop=FALSE]
            ifa=which(is.na(free_mc[1,]))
            if (length(ifa)) {
                if (ncol(free_mc) > length(ifa))
                    cat("***Warning: some Monte-Carlo iterations failed.", "\n", sep="", file=fclog)
                free_mc=free_mc[,-ifa,drop=FALSE]
                cost_mc=cost_mc[-ifa]
            }
            if (nmc_real <= 1L) {
                cat("No sufficient Monter-Carlo samples were successfully calculated to do any statistics.", "\n", sep="", file=fcerr)
                retcode[irun]=1
                break
            }
            rownames(free_mc)=nml$param
            # cost section in kvh
            if (write_res && wkvh) {
                cat("\tcost\n", file=fkvh)
                indent=2L
                obj2kvh(mean(cost_mc), "mean", fkvh, indent)
                obj2kvh(median(cost_mc), "median", fkvh, indent)
                obj2kvh(sd(cost_mc), "sd", fkvh, indent)
                obj2kvh(sd(cost_mc)*100./mean(cost_mc), "rsd (%)", fkvh, indent)
                obj2kvh(quantile(cost_mc, c(0.025, 0.95, 0.975)), "ci", fkvh, indent)
                
                # free parameters section in kvh
                cat("\tStatistics\n", file=fkvh)
                mout=c()
                indent=2L
                # param stats
                # mean
                parmean=apply(free_mc, 1L, mean)
                # median
                parmed=apply(free_mc, 1L, median)
                # covariance matrix
                covmc=cov(t(free_mc))
                obj2kvh(covmc, "covariance", fkvh, indent)
                # sd
                sdmc=sqrt(diag(covmc))
                # confidence intervals
                ci_mc=t(apply(free_mc, 1L, quantile, probs=c(0.025, 0.975)))
                ci_mc=cbind(ci_mc, t(diff(t(ci_mc))))
                colnames(ci_mc)=c("CI 2.5%", "CI 97.5%", "CI length")
                mout=cbind(mout, mean=parmean, median=parmed, sd=sdmc,
                   "rsd (%)"=sdmc*100/abs(parmean), ci_mc)
                obj2kvh(mout, "free parameters", fkvh, indent)
                
                # net-xch01 stats
                fallnx_mc=apply(free_mc, 2L, function(p)param2fl(p, labargs)$fallnx)
                fallnx=param2fl(param, labargs)$fallnx
                if (length(fallnx_mc)) {
                    dimnames(fallnx_mc)[[1L]]=nml$fallnx
                    # form a matrix output
                    fallout=matrix(0., nrow=nrow(fallnx_mc), ncol=0L)
                    # mean
                    parmean=apply(fallnx_mc, 1L, mean)
                    # median
                    parmed=apply(fallnx_mc, 1L, median)
                    # covariance matrix
                    covmc=cov(t(fallnx_mc))
                    dimnames(covmc)=list(nml$fallnx, nml$fallnx)
                    # sd
                    sdmc=sqrt(diag(covmc))
                    # confidence intervals
                    cinx_mc=t(apply(fallnx_mc, 1L, quantile, probs=c(0.025, 0.975)))
                    cinx_mc=cbind(cinx_mc, t(diff(t(cinx_mc))))
                    cinx_mc=cbind(cinx_mc, cinx_mc[,3]*100/abs(parmean))
                    colnames(cinx_mc)=c("CI 2.5%", "CI 97.5%", "CI 95% length", "relative CI (%)")
                    fallout=cbind(fallout, mean=parmean, median=parmed, sd=sdmc,
                       "rsd (%)"=sdmc*100/abs(fallnx), cinx_mc)
                    o=order(nml$fallnx)
                    obj2kvh(fallout[o,,drop=FALSE], "all net-xch01 fluxes", fkvh, indent)
                    obj2kvh(covmc[o,o], "covariance of all net-xch01 fluxes", fkvh, indent)
                    
                    # fwd-rev stats
                    fwrv_mc=apply(free_mc, 2, function(p)param2fl(p, labargs)$fwrv)
                    dimnames(fwrv_mc)[[1L]]=nml$fwrv
                    fallout=matrix(0, nrow=nrow(fwrv_mc), ncol=0)
                    # mean
                    parmean=apply(fwrv_mc, 1L, mean)
                    # median
                    parmed=apply(fwrv_mc, 1L, median)
                    # covariance matrix
                    covmc=cov(t(fwrv_mc))
                    dimnames(covmc)=list(nml$fwrv, nml$fwrv)
                    # sd
                    sdmc=sqrt(diag(covmc))
                    # confidence intervals
                    cif_mc=t(apply(fwrv_mc, 1L, quantile, probs=c(0.025, 0.975)))
                    cif_mc=cbind(cif_mc, t(diff(t(cif_mc))))
                    cif_mc=cbind(cif_mc, cif_mc[,3]*100/abs(fwrv))
                    dimnames(cif_mc)[[2L]]=c("CI 2.5%", "CI 97.5%", "CI 95% length", "relative CI (%)")
                    fallout=cbind(fallout, mean=parmean, median=parmed, sd=sdmc,
                       "rsd (%)"=sdmc*100/abs(parmean), cif_mc)
                    o=order(nml$fwrv)
                    obj2kvh(fallout[o,,drop=FALSE], "forward-reverse fluxes", fkvh, indent)
                    obj2kvh(covmc[o,o], "covariance of forward-reverse fluxes", fkvh, indent)
                }
            }
            break
        }
        if (length(sensitive) && nchar(sensitive) && sensitive != "mc") {
            cat(paste("Unknown sensitivity '", sensitive, "' method chosen.", sep=""), "\n", sep="", file=fcerr)
            retcode[irun]=1
            next
        }

        top_chrono("linstats", file=fclog)
        # Linear method based on jacobian x_f
        # reset fluxes and jacobians according to param
        if (is.null(jx_f$jacobian)) {
            if (write_res) {
                capture.output(rres <- lab_resid(param, cjac=TRUE, labargs), file=fclog)
            } else {
                rres <- lab_resid(param, cjac=TRUE, labargs)
            }
            if (!is.null(rres$err) && rres$err) {
                cat("lab_resid", runsuf, ": ", rres$mes, "\n", file=fcerr, sep="")
                retcode[irun]=rres$err
                next
            }
        } # else use the last calculated jacobian

        # covariance matrix of free fluxes
        if (length(jx_f$jacobian) > 0L && !all(is.na(param))) {
            svj=svd(jx_f$jacobian)
            if (svj$d[1L] == 0.) {
                i=rep(TRUE, length(svj$d))
            } else {
                i=svj$d/svj$d[1L]<1.e-10
                if (all(!i) && svj$d[1L]<1.e-10) {
                    # we could not find very small d, take just the last
                    i[length(i)]=TRUE
                }
            }
            ibad=apply(svj$v[, i, drop=FALSE], 2, which.contrib)
            ibad=unique(unlist(ibad))
            if (length(ibad) > 0L)
                cat(paste(if (nchar(runsuf)) runsuf%s+%": " else "", "***Warning: inverse of covariance matrix is numerically singular.\nStatistically undefined parameter(s) seems to be:\n",
                    paste(sort(nml$param[ibad]), collapse="\n"), "\nFor a more complete list, see SD column in '.tvar.sim' result file.", sep=""), "\n", sep="", file=fclog)
            # "square root" of covariance matrix (to preserve numerical positive definitness)
            rtcov=(svj$u)%*%(t(svj$v)/svj$d)
            # standard deviations of free fluxes
            if (write_res) {
                if (wkvh) cat("linear stats\n", file=fkvh)

                # sd free+dependent+growth net-xch01 fluxes
                nml$flfd=c(nml$ff, nml$fgr, nml$fl)
                if (nbl$ff > 0 || nbl$fgr > 0) {
                    i=seq_len(nbl$param)
                    i=c(head(i, nbl$ff), tail(i, nbl$fgr))
                    covfl=crossprod(rtcov[, i, drop=FALSE]%mmt%(rbind(diag(nbl$ff+nbl$fgr), nbl$dfl_dffg)%mrv%c(        rep.int(1., nbl$ff), fgr)))
                    dimnames(covfl)=list(nml$flfd, nml$flfd)
                    sdfl=sqrt(diag(covfl))
                } else {
                    sdfl=rep(0., nbl$fl)
                    covfl=matrix(0., nbl$fl, nbl$fl)
                }
                fl=c(head(param, nbl$ff), fgr, flnx)
                stats_nx=cbind("value"=fl, "sd"=sdfl, "rsd"=sdfl/abs(fl))
                rownames(stats_nx)=nml$flfd
                if (wkvh) {
                    o=order(nml$flfd)
                    obj2kvh(stats_nx[o,,drop=FALSE], "net-xch01 fluxes (sorted by name)", fkvh, indent=1L)
                    obj2kvh(covfl[o, o], "covariance net-xch01 fluxes", fkvh, indent=1L)
                }
             
                # flux, pool --> .tvar
                rnm=grep("_gr$", nml$fallnx, invert=TRUE, value=TRUE)
                cnm=c("Id", "Comment", "Name", "Kind", "Type", "Value", "SD", "Struct_identif")
                if (sensitive == "mc")
                    cnm=c(cnm, "Low_mc", "Up_mc")
                nx2suf=c(n="NET", x="XCH")
                fd2cap=c(f="F", d="D", c="C")

                mnm=matrix(unlist(strsplitlim(rnm, ".", fixed=TRUE, lim=3L)), ncol=3L, byrow=TRUE)
                o=natorder(mnm[, 3L])
                rnm=rnm[o]
                mnm=mnm[o,,drop=FALSE]
                vfl=fallnx[rnm]
                vfl=ifelse(mnm[,2L] == "x", clamp(vfl, 0., 1.), vfl)
                vsd=sdfl[rnm]
                vsd[is.na(vsd)]=0.
                df=cbind("", "", mnm[, 3L], nx2suf[mnm[, 2L]], fd2cap[mnm[, 1L]], vfl, vsd, ifelse(vsd > 10000, "no", "yes"))
                if (sensitive == "mc")
                    df=cbind(df, cinx_mc[rnm, 1L:2L])

                # sd of all fwd-rev
                if (nbl$ff > 0 || nbl$fgr > 0) {
                    i=seq_len(nbl$param)
                    i=c(head(i, nbl$ff), tail(i, nbl$fgr))
                    covf=crossprod(tcrossprod_simple_triplet_matrix(rtcov[,i, drop=FALSE], jx_f$df_dffp%mrv%c(rep.int(1., nbl$ff), head(poolall[nml$poolf], nbl$fgr))))
                    dimnames(covf)=list(nml$fwrv, nml$fwrv)
                    sdf=sqrt(diag(covf))
                } else {
                    sdf=rep(0., length(fwrv))
                }
                if (wkvh) {
                    mtmp=cbind(fwrv, sdf, sdf/abs(fwrv))
                    dimnames(mtmp)[[2L]]=c("value", "sd", "rsd")
                    o=order(nml$fwrv)
                    obj2kvh(mtmp[o,], "fwd-rev fluxes (sorted by name)", fkvh, indent=1L)
                    if (nbl$ff > 0 || nbl$fgr > 0)
                       obj2kvh(covf, "covariance fwd-rev fluxes", fkvh, indent=1L)
                }
                # pool -> kvh
                sdpf=poolall
                sdpf[]=0.

                if (nbl$poolf > 0) {
                    # covariance matrix of free pools
                    # "square root" of covariance matrix (to preserve numerical positive definitness)
                    poolall[nml$poolf]=param[nml$poolf]
                    # cov poolf
                    covpf=crossprod(rtcov[,nbl$ff+seq_len(nbl$poolf), drop=FALSE])
                    dimnames(covpf)=list(nml$poolf, nml$poolf)
                    sdpf[nml$poolf]=sqrt(diag(covpf))
                }
                if (length(poolall) > 0) {
                    if (wkvh) {
                        mtmp=cbind("value"=poolall, "sd"=sdpf, "rsd"=sdpf/poolall)
                        rownames(mtmp)=nml$poolall
                        o=order(nml$poolall)
                        obj2kvh(mtmp[o,,drop=FALSE], "metabolite pools (sorted by name)", fkvh, indent=1L)
                    }
                    if (nbl$poolf > 0) {
                        o=order(nml$poolf)
                        obj2kvh(covpf[o, o], "covariance free pools", fkvh, indent=1L)
                    }
                    rnm=names(poolall)
                    mnm=matrix(unlist(strsplitlim(rnm, ":", fixed=TRUE, lim=2L)), ncol=2L, byrow=TRUE)
                    o=natorder(mnm[, 2L])
                    rnm=rnm[o]
                    mnm=mnm[o,,drop=FALSE]
                    pfc2cap=c(pf="F", pc="C")
                    vsd=sdpf[rnm]
                    vsd[is.na(vsd)]=0.
                    dfp=cbind("", "", mnm[, 2L], "METAB", pfc2cap[mnm[,1L]], poolall[rnm], vsd, ifelse(vsd >= 10000., "no", "yes"))
                    if (sensitive == "mc") {
                        mci=ci_mc[nml$poolf, 1L:2L]
                        mci=rbind(mci, cbind(poolall[nml$poolc], poolall[nml$poolc]))
                        dfp=cbind(dfp, mci[rnm,])
                    }
                    df=rbind(df, dfp)
                }
                colnames(df)=cnm
                write.table(df, sep="\t", quote=FALSE, row.names=FALSE, file=file.path(dirres, paste0(baseshort, runsuf, ".tvar.sim")))
            }
        }
        # goodness of fit (chi2 test)
        if (length(jx_f$res)) {
            if (is.na(rcost)) {
                cat(sprintf("***Warning: chi2: Reduced cost value is NA. Chi2 test cannot be done.\n"), sep="", file=fclog)
            } else {
                nvres=sum(!is.na(jx_f$res))
                if (nvres > nbl$param) {
                    chi2test=list("chi2 value"=rcost, "data points"=nvres,
                       "fitted parameters"=nbl$param, "degrees of freedom"=nvres-nbl$param)
                    chi2test$`chi2 reduced value`=chi2test$`chi2 value`/chi2test$`degrees of freedom`
                    chi2test$`p-value, i.e. P(X^2<=value)`=pchisq(chi2test$`chi2 value`, df=chi2test$`degrees of freedom`)
                    chi2test$conclusion=if (chi2test$`p-value, i.e. P(X^2<=value)` > 0.95) "At level of 95% confidence, the model does not fit the data good enough with respect to the provided measurement SD" else "At level of 95% confidence, the model fits the data good enough with respect to the provided measurement SD"
                    if (write_res) {
                        if (wkvh) obj2kvh(chi2test, "goodness of fit (chi2 test)", fkvh, indent=1L)
                        fstat=file(file.path(dirres, sprintf("%s%s.stat", baseshort,  runsuf)), "w")
                        df=c(rcost, rcost/(nvres-nbl$param), nvres, nbl$param, nvres-nbl$param, chi2test$`p-value, i.e. P(X^2<=value)`, chi2test$conclusion)
                        names(df)=c("chi2_value", "chi2/df", "number_of_measurements", "number_of_parameters", "degrees_of_freedom", "p-value", "conclusion")
                        write.table(df, sep="\t", quote=FALSE, row.names=TRUE, file=fstat, col.names=FALSE)
                        close(fstat)
                    }
                } else {
                    cat(sprintf("***Warning: chi2: Measurement number %d is lower or equal to parameter number %d. Chi2 test cannot be done.\n", nvres, nbl$param), sep="", file=fclog)
                }
            }
        }
        if (prof)
            Rprof(NULL)
        if (write_res) {
            if (wkvh) close(fkvh)
            # write edge.netflux property
            fedge=file(file.path(dirres, "tmp", sprintf("edge.netflux.%s%s.attrs", baseshort,  runsuf)), "w")
            cat("netflux (class=Double)\n", sep="", file=fedge)
            nmedge=names(edge2fl)
            cat(paste(nmedge, fallnx[edge2fl], sep=" = "), sep="\n" , file=fedge)
            close(fedge)

            # write edge.xchflux property
            fedge=file(file.path(dirres, "tmp",  sprintf("edge.xchflux.%s%s.attrs", baseshort,  runsuf)), "w")
            flxch=paste(".x", substring(edge2fl, 4), sep="")
            ifl=charmatch(flxch, substring(names(fallnx), 2))
            cat("xchflux (class=Double)\n", sep="", file=fedge)
            cat(paste(nmedge, fallnx[ifl], sep=" = "), sep="\n" , file=fedge)
            close(fedge)

            # write node.log2pool property
            if (length(poolall)> 0) {
                fnode=file(file.path(dirres, "tmp", sprintf("node.log2pool.%s%s.attrs", baseshort,  runsuf)), "w")
                cat("log2pool (class=Double)\n", sep="", file=fnode)
                nmnode=substring(names(poolall), 4)
                cat(paste(nmnode, log2(poolall), sep=" = "), sep="\n" , file=fnode)
                close(fnode)
            }
        }
    }
    if (write_res) {
        close(e$fclog)
        close(e$fcerr)
    }
    }) # end with()
    invisible(NULL)
}

#' prepare list of spAbr structure for solving cumomer systems
#'
#' @param sp a list of lists with ind_a, ind_b from kvh input file
#' @param e an environment with variables from kvh input file
#' @return List of sub-lists, one per cumomer weight.
prep_spAbr=function(sp, emu, e) {
    res=lapply(seq_along(sp), function(iw) {
    l=new.env()
    list2env(sp[[iw]], envir=l)
    with(l, {
    w=iw
    nbfwrv=e$nbl$fwrv
    ind_a=s2i(ind_a)
    ind_b=s2i(ind_b)
    nbc=s2i(nbc)
    ba_x=s2i(ba_x) # base of cumomer indexes in incu vector
    nbcl=s2i(nbcl) # number of lighter cumomers
    maxprod=s2i(maxprod)
    if (nbc > 0L) {
        # matrix a
        ind_a=matrix(ind_a, ncol=3L, byrow=TRUE)
        colnames(ind_a)=c("indf", "ir0", "ic0")

        # vector b
        ind_b=matrix(ind_b, ncol=2L+maxprod, byrow=TRUE)
        colnames(ind_b)=c("indf", "irow", paste("indx", seq_len(maxprod), sep=""))

        # jacobian b_x
        iprodx=seq_len(maxprod)
        ind_bx=c()
        for (ix in iprodx) {
            i=ind_b[,2+ix]>ba_x # exclude from differentiation plain input entries
            ind_bx=rbind(ind_bx, ind_b[i,c(1L,2L,ix+2L,2L+iprodx[-ix])]) # move diff var to ic1 place
        }
        if (length(ind_bx)) {
          colnames(ind_bx)=c("indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1L)))
          ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_x
        }
        # emu case
        if (emu) {
            # cumo weights are always starting from 1 to weight max
            # if there is only one weight (max), the lower weights must be present
            # but corresponding matrices and vectors are of dim=0

            # for iw==1 emu+M1 are identical to cumomers
            # and the system A*x=b for emu+M0 does not change as
            # all fluxes in A and b sum to 0.

            # iw is the resulting fragment length
            nme2iemu=setNames(seq_along(e$nml$inemu), e$nml$inemu)
            nmc=e$nml$incu[c(ind_b[,2L+seq_len(maxprod)])]
            nbind=nrow(ind_b)
            if (iw > 1L && maxprod > 1L) {
                ba_e=1L+e$nbl$xiemu
                # prepare names
                dim(nmc)=c(nbind, maxprod)
                # get fragment length for each ind_x which is product of several terms
                flen=vapply(strsplit(nmc, ":"), function(v) if (length(v) > 1L) e$sumbit(as.numeric(v[2L])) else 0L, 1L)
                dim(flen)=dim(nmc)
                wid=apply(flen, 1L, paste0, collapse=",")
                wdisp=list() # weight dispatcher helper
                iw1=seq_len(iw-1L)
                for (ir in seq_len(nbind)) {
                    v=flen[ir,]
                    if (!is.null(wdisp[[wid[ir]]]))
                       next
                    m=Reduce(e$`%m+%`, v);
                    wdisp[[wid[ir]]]=lapply(iw1, function(i) which(m==i, arr.ind=TRUE)-1L)
                }
            }
            for (iwe in seq_len(iw)) {
                if (iwe == 1L || maxprod == 1L) {
                    # For m+0 (iw=1) vector b is the same in cumo and emu
                    ind_b_emu=cbind(iwe=1, ind_b)
                    ind_b_emu[,3L+iprodx]=nme2iemu[paste(nmc, iw-1L, sep="+")]
                    next
                }
                for (ir in seq_len(nbind)) {
                   addw=wdisp[[wid[ir]]][[iwe-1L]]
                   ie=nme2iemu[paste(rep(nmc[ir,], each=nrow(addw)), addw, sep="+")] # row emu names
                   dim(ie)=c(nrow(addw), maxprod)
                   ind_b_emu=rbind(ind_b_emu, cbind(iwe, ind_b[ir,1L], ind_b[ir,2L], ie))
                }
            }
            ind_b_emu[is.na(ind_b_emu)]=1L # ones stay ones

            # prepare b_x_emu
            ind_bx_emu=c()
            if (length(ind_bx) > 0L) {
               for (ix in iprodx) {
                  i=ind_b_emu[,3L+ix] > ba_e # exclude from differentiation plain input entries
                  ind_bx_emu=rbind(ind_bx_emu, ind_b_emu[i,c(1L:3L,ix+3L,3L+iprodx[-ix]), drop=FALSE]) # move diff var to ic1 place
               }
               if (length(ind_bx_emu)) {
                  colnames(ind_bx_emu)=c("iwe", "indf", "irow", "ic1", sprintf("indx%d", seq_len(maxprod-1L)))
                  ind_bx_emu[,"ic1"]=ind_bx_emu[,"ic1"]-ba_e
                  ind_bx_emu[,"irow"]=ind_bx_emu[,"irow"]+(ind_bx_emu[,"iwe"]-1L)*nbc
               }
            }
        }
    }

    # prepare mumps matrix
    if (nbc == 0L) {
        a=Rmumps$new(integer(0L), integer(0L), double(0L), nbc)
        b=simple_triplet_matrix(i=integer(0L), j=integer(0L), v=double(0L), nrow=nbc, ncol=1L)
    } else {
        stopifnot(is.matrix(ind_a))
        stopifnot(is.matrix(ind_b))
        # prepare sparse xmat where col_sums(xmat) will give a$v
        iv0=ind_a[,"ir0"]+ind_a[,"ic0"]*nbc
        o=order(iv0)
        ind_a=ind_a[o,]
        iv0=iv0[o]
        lrep=lrepx=rle(iv0)
        lrepx$values=seq_along(lrep$values)
        xmat=simple_triplet_matrix(i=unlist(lapply(lrep$lengths, seq_len)),
           j=inverse.rle(lrepx), v=rep(1, length(iv0)))
        iu0=lrep$values
        i=as.integer(iu0%%nbc)
        j=as.integer(iu0%/%nbc)
        a=Rmumps$new(i, j, rep(pi, length(iu0)), nbc)
        if (!is.null(e$control_ftbl$mumps)) {
           lapply(grep("^icntl_", names(e$control_ftbl$mumps), v=TRUE), function(nm) {
              i=suppressWarnings(as.integer(strsplit(nm, "_")[[1L]][2L]))
              v=suppressWarnings(as.integer(control_ftbl$mumps[[nm]]))
              if (!is.na(i) && !is.na(v))
                 a$set_icntl(v, i)
           })
        }
        iadiag=which(i==j)
        # prepare sparse bmat where col_sums(bmat) will give b$v
        if (emu) {
            stopifnot(is.matrix(ind_b_emu))
            iv0=ind_b_emu[,"irow"]+(ind_b_emu[,"iwe"]-1L)*nbc-1L
            nbbcol=w
            o=order(iv0)
            ind_b_emu=ind_b_emu[o,,drop=FALSE]
        } else {
            iv0=ind_b[,"irow"]-1L
            nbbcol=1L
            o=order(iv0)
            ind_b=ind_b[o,,drop=FALSE]
        }
        iv0=iv0[o]
        lrep=lrepx=rle(iv0)
        lrepx$values=seq_along(lrep$values)
        bmat=simple_triplet_matrix(i=unlist(lapply(lrep$lengths, seq_len)),
            j=inverse.rle(lrepx), v=rep(1L, length(iv0)))
        iu0=lrep$values
        i=as.integer(iu0%%nbc)
        j=as.integer(iu0%/%nbc)
        b=simple_triplet_matrix(i=i+1L, j=j+1L, v=rep(pi, length(iu0)), nrow=nbc, ncol=nbbcol)
    }
    }) # end with()
    suppressWarnings(rm(addw, flen, i, j, ie, ir, ix, iw1, iu0, iv0, iprodx, m, maxprod, iwe, o, nbind, nmc, nbbcol, nme2iemu, lrep, lrepx, v, wdisp, wid, envir=l))
    l
    }) # end lapply
}

# common functions for variable label input

# step labeling in a linear metabolic pathway with all different exchange rates 'nu' (nu=flux/metab_concentration).
# all metabolites are labeled at 0 at t=0
# return a matrix where one column corresponds to a given time point from tp and a row corresponds to a given metabolite
steplinpath=function(tp, nu) {
    nb_tp=length(tp)
    nb_nu=length(nu)
    # trivial case
    if (nb_tp == 0 || nb_nu == 0)
        return(matrix(NA, nrow=nb_nu, ncol=nb_tp))
    # test for all nu being > 0 and pairwise different
    stopifnot(all(nu >= 0.))
    diff_nu=outer(nu, nu, "!=")
    diff_nu=diff_nu[lower.tri(diff_nu)]
    stopifnot(all(diff_nu))
    # a is a list of coefficient vectors a[[imet]][knu]
    a=lapply(seq_along(nu), function(imet) sapply(seq(imet), function(knu) {v=nu[seq(imet)][-knu]; -prod(v/(v-nu[knu]))}))
    expt=exp(-nu%o%tp)
    res=t(1.+vapply(seq_along(nu), function(imet) {
        v=a[[imet]]
        colSums(v*expt[seq_along(v),, drop=FALSE])
    }, double(nb_tp)))
    dim(res)=c(nb_nu, nb_tp)
    colnames(res)=tp
    structure(res, a=a)
}

# more general than steplinpath2, arbitary initial conditions in 'init' and arbitrary heihgt of input labeling ('height')
steplinpath2=function(tp, nu, init=double(length(nu)), height=1.) {
    nb_tp=length(tp)
    nb_nu=length(nu)
    # trivial case
    if (nb_tp == 0 || nb_nu == 0)
        return(matrix(NA, nrow=nb_nu, ncol=nb_tp))
    # test for all nu being > 0 and pairwise different
    stopifnot(all(nu >= 0.))
    diff_nu=outer(nu, nu, "!=")
    diff_nu=diff_nu[lower.tri(diff_nu)]
    stopifnot(all(diff_nu))
    # a is a list of coefficient vectors a[[imet]][knu]
    a=Reduce(function(li, imet) {av=li[[imet-1]]*(nu[imet]/(nu[imet]-nu[seq_len(imet-1L)])); alast=init[imet]-(height+sum(av)); c(li, list(c(av, alast)))}, seq_len(nb_nu-1L)+1L, list(init[1L]-height))
    expt=exp(-nu%o%tp)
    res=t(height+vapply(seq_along(nu), function(imet) {
        v=a[[imet]]
        colSums(v*expt[seq_along(v),, drop=FALSE])
    }, double(nb_tp)))
    dim(res)=c(nb_nu, nb_tp)
    colnames(res)=tp
    structure(res, a=a)
}

# periodic step pulses with step intervals in 'Tint' and heights in 'Hint'. Initial conditions are in 'init'.
# The full duration of a complete period is sum(Tint)
ppulseslinpath=function(tp, nu, Tint, Hint=rep_len(c(1., 0.), length(Tint)), init=double(length(nu))) {
    stopifnot(length(Tint) == length(Hint))
    nb_tp=length(tp)
    # test for all nu being > 0 and pairwise different
    stopifnot(all(nu >= 0.))
    diff_nu=outer(nu, nu, "!=")
    diff_nu=diff_nu[lower.tri(diff_nu)]
    stopifnot(all(diff_nu))
    # partition tp in periods. Each period is composed of intervals
    intstart=c(0., cumsum(Tint))
    nb_int=length(Tint)
    tperiod=intstart[nb_int+1L]
    nb_period=max(ceiling(max(tp)/tperiod), 1L)
    res=NULL # will accumulate results
    for (iperiod in seq_len(nb_period)) {
        pstart=tperiod*(iperiod-1L)
        for (iint in seq_len(nb_int)) {
            tstart=pstart+intstart[iint]
            tphere=c(tp[tp >= tstart & tp < tstart+Tint[iint]], tstart+Tint[iint])-tstart
            # take init from the previous interval
            inithere=if (iperiod == 1L && iint == 1) init else reshere[,dim(reshere)[2L]]
            reshere=steplinpath2(tphere, nu, inithere, Hint[iint])
            colnames(reshere)=tphere+tstart
            res=cbind(res, reshere[,-length(tphere), drop=FALSE])
            if (iperiod == nb_period && iint == nb_int && ncol(res) < nb_tp)
                res=cbind(res, reshere[,dim(reshere)[2L], drop=FALSE])
        }
    }
    return(res)
}

# linear interpolation at time points tp with linear piece-wise function defined by x='knots' and y='v'
linterp=function(tp, knots, v, tol=1.e-10) {
    #browser()
    rtp=range(tp)
    tp_min=rtp[1L]
    tp_max=rtp[2L]
    rk=range(knots)
    knot_min=rk[1L]
    knot_max=rk[2L]
    nb_kn=length(knots)
    if (tp_min < knot_min-tol || tp_max >= knot_max+tol) {
        mes=ifelse(length(tp) == 1L,
            sprintf("Time point %f is outside of knot interval [%f, %f]", tp, knot_min, knot_max),
            sprintf("Time point interval [%f, %f] is not completely inside of knot interval [%f, %f]", tp_min, tp_max, knot_min, knot_max))
        stop(mes, call.=FALSE)
    }
    if (any(diff(knots) < 0.))
        stop("Provided knots are not monotonically increasing: {", paste0(knots, "; "), "} ", call.=FALSE)
    # find index of the closest left knot for all tp
    # knots are supposed being ordered monotonously and increasingly
    il=apply(outer(tp, knots, ">="), 1L, function(v) {w=which(v); if (length(w)) rev(w)[1L] else NA})
    il[il==nb_kn]=nb_kn-1L
    ir=il+1L # right knot
    # l(w)=(1-w)*y_left+w*y_right, w in [0,1]
    w=(tp-knots[il])/(knots[ir]-knots[il])
    v[il]+w*(v[ir]-v[il])
}

# periodic rectangular pulses. Duration of each time interval is defined in Tint numeric vector. Pulse amplitudes are in Hint, by defaults it's a repetition of 1 and 0 as many times as there are intervals in Tint.
ppulses=function(tp, Tint, Hint=rep_len(c(1., 0.), length(Tint))) {
    stopifnot(length(Tint) == length(Hint))
    nb_tp=length(tp)
    if (nb_tp == 0)
        return(double(0))
    tol=.Machine$double.eps*2**7
    # partition tp in periods. Each period is composed of intervals
    intstart=c(0., cumsum(Tint))
    nb_int=length(Tint)
    tperiod=intstart[nb_int+1L]
    nb_period=max(ceiling(max(tp)/tperiod), 1L)
    res=NULL # will accumulate results
    for (iperiod in seq_len(nb_period)) {
        #cat("ip=", iperiod, "\n")
        pstart=tperiod*(iperiod-1L)
        for (iint in seq_len(nb_int)) {
            #cat("iint=", iint, "\n")
            tstart=pstart+intstart[iint]
            if (abs(tp[nb_tp]-tstart-Tint[iint]) < tol) {
                tphere=tp[tp >= tstart-tol & tp <= tstart+Tint[iint]+tol]
            } else {
                tphere=tp[tp >= tstart & tp < tstart+Tint[iint]]
            }
            #cat("tph=", tphere, "\n")
            reshere=rep_len(Hint[iint], length(tphere))
            names(reshere)=tphere
            res=c(res, reshere)
            if (length(res) == nb_tp)
                return(res)
        }
    }
    stop("oops. Should not be there.")
}

#suppressPackageStartupMessages(require(deSolve))
#suppressPackageStartupMessages(require(Matrix))

icumo_resid=function(param, cjac, labargs) {
   # claculates residual vector of labeling propagation corresponding to param
   #cat("icumo_resid: param=", param, ", cjac=", cjac, "\n")
#cjac=F # to remove in the final version
   # from labargs to local vars
   for (item in ls(labargs))
      assign(item, get(item, env=labargs))

   nb_w=length(spa)
   sqm=measurements$dev$labeled
   sqf=measurements$dev$flux
   sqp=measurements$dev$pool
#browser()
   measvecti=measurements$vec$kin
   nb_ti=nb_f$ti
   nb_sc=nb_f$nb_sc
   nb_sc_tot=nb_f$nb_sc_tot
   nb_ff=nb_f$nb_ff
   nb_poolf=nb_f$nb_poolf

   # find simulated cumomers
   lres=lab_sim(param, cjac, labargs)
   if (!is.null(lres$err) && lres$err) {
      return(list(err=1, mes=lres$mes))
   }
   nb_lab=nb_f$nb_meas*(nb_ti-1L)
   nbc_lab=c(0L, cumsum(nb_lab))
   nb_lab_tot=sum(nb_lab)
   # list of indexes in residual vector by iexp
   ir=lapply(seq_len(nb_exp), function(iexp) sum(nb_lab[seq_len(iexp-1)])+seq_len(nb_lab[[iexp]]))
   if (is.null(jx_f$jacobian)) {
      # init variables in jx_f
      jx_f$jacobian=matrix(0., nrow=nb_lab_tot+nb_f$nb_fmn+nb_f$nb_poolm, ncol=nb_ff+nb_sc_tot+nb_poolf)
      dimnames(jx_f$jacobian)=list(nm_list$resid, nm_list$par)
      # constant part of jacobian
      jx_f$simlab=jx_f$ureslab=jx_f$reslab=vector("list", nb_exp)
      jx_f$udr_dp=jx_f$jacobian
   }
   for (iexp in seq_len(nb_exp)) {
      stopifnot(length(tifull[[iexp]])!=length(tifull2[[iexp]]))
      # scale simulated measurements scale*(usm)
      if (!noscale && nb_sc[[iexp]] > 0) {
         vsc=c(1.,param)[ir2isc[[iexp]]]
         jx_f$simlab[[iexp]]=jx_f$usm[[iexp]]*vsc
      } else {
         jx_f$simlab[[iexp]]=jx_f$usm[[iexp]]
      }
      rownames(jx_f$simlab[[iexp]])=rownames(jx_f$usm[[iexp]])=nm_list$meas[[iexp]]
      # diff between simulated and measured
      #inna=which(!is.na(measvecti)) # for removing NA measurements
      pool[nm_list$poolf]=param[nm_list$poolf]
      if (!is.null(measvecti[[iexp]])) {
         jx_f$ureslab[[iexp]]=jx_f$simlab[[iexp]]-measvecti[[iexp]] # unreduced labeled part
         jx_f$reslab[[iexp]]=jx_f$ureslab[[iexp]]/sqm[[iexp]]
      }
#browser()
      if (cjac) {
         # calculate jacobian
         # first, its labeling part (unscaled and unreduced)
         # next, flux part and measured pools part
         # for external usage
         #jx_f$udr_dp[ir[[iexp]],]=jx_f$dux_dp[[iexp]]
         bop(jx_f$udr_dp, c(1, nbc_lab[[iexp]], nb_lab[[iexp]]), "=", jx_f$dux_dp[[iexp]])
         if (!noscale && nb_sc[[iexp]] > 0) {
            # scale it
            #jx_f$jacobian[ir[[iexp]],]=vsc*jx_f$dux_dp[[iexp]]
            bop(jx_f$udr_dp, c(1, nbc_lab[[iexp]], nb_lab[[iexp]]), "*=", vsc)
            # add scale part of jacobian (the sparsity pattern doesn't change)
            jx_f$dr_dsc[[iexp]][nb_f$is2mti[[iexp]]]=jx_f$reslab[[iexp]][is2mti[[iexp]]][,1]
            jx_f$jacobian[ir[[iexp]], nb_ff+seq_len(nb_sc[[iexp]])]=jx_f$dr_dsc[[iexp]]
         } else {
            #jx_f$jacobian[ir[[iexp]],]=jx_f$dux_dp[[iexp]]
            bop(jx_f$jacobian, c(1, nbc_lab[[iexp]], nb_lab[[iexp]]), "=", jx_f$dux_dp[[iexp]])
         }
      }
   }
   if (cjac) {
      #jx_f$jacobian[nb_lab_tot+seq_len(nb_f$nb_fmn),]=dufm_dp
      bop(jx_f$jacobian, c(1, nb_lab_tot, nb_f$nb_fmn), "=", dufm_dp)
      #jx_f$jacobian[nb_lab_tot+nb_f$nb_fmn+seq_len(nb_f$nb_poolm),]=dupm_dp
      bop(jx_f$jacobian, c(1, nb_lab_tot+nb_f$nb_fmn, nb_f$nb_poolm), "=", dupm_dp)
      # reduce it
      #jx_f$jacobian[]=with(measurements$dev, jx_f$jacobian/c(unlist(kin), flux, pool))
      bop(jx_f$jacobian, 1, "/=", with(measurements$dev, c(unlist(kin), flux, pool)))
      # for later use
      jx_f$dr_dff=jx_f$jacobian[,seq_len(nb_ff),drop=FALSE]
   }
   jx_f$simfmn=lres$lf$fallnx[nm_list$fmn]
   jx_f$uresflu=jx_f$simfmn-measurements$vec$flux
   jx_f$simpool=(measurements$mat$pool%*%pool)[,1]
   jx_f$urespool=jx_f$simpool - measurements$vec$pool
   jx_f$resflu=jx_f$uresflu/sqf
   jx_f$respool=jx_f$urespool/sqp
   jx_f$res=c(unlist(jx_f$reslab), jx_f$resflu, jx_f$respool)
   if (length(jx_f$res)) {
      names(jx_f$res)=nm_list$resid
   }
   jx_f$ures=c(unlist(jx_f$ureslab), jx_f$uresflu, jx_f$urespool)
   if (length(jx_f$ures)) {
      names(jx_f$ures)=nm_list$resid
   }
   return(list(res=jx_f$res, jacobian=if (cjac) jx_f$jacobian else NULL))
}

icumo_cost=function(param, labargs, resl=icumo_resid(param, cjac=FALSE, labargs)) {
   if (!is.null(resl$err) && resl$err) {
      return(NULL)
   }
   if (any(ina <- is.na(resl$res))) {
      return(crossprod(resl$res[!ina]))
   } else {
      return(crossprod(resl$res))
   }
}

fwrv2sp=function(fwrv, spAbr, incu, emu=FALSE) {
   # calculate s in A*x+s (where x is cumomer vector
   # according to conventions explained in comments to python function
   # netan2Abcumo_spr() generating spAbr
   # return s
   # 2012-03-07 sokol
   # 2014-04-11 sokol: added emu option
   # 2016-09-26 sokol: adapted for arbitrary long reactions; removed sp

   # construct the sources s
   # for this weight
#options(warn=2)
   nb_c=spAbr$nb_c # cumomer or fragment number (when emu==T)
   w=spAbr$w # cumomer weight
   emuw=ifelse(emu, w, 1L)
   incu=as.matrix(incu)
   nco=ncol(incu)

   if (nb_c == 0) {
      return(simple_triplet_zero_matrix(nb_c, 1))
   }
   l=spAbr
   nm_sx=as.character(nco)
   if (is.null(l$sx)) {
      # we need sx because of many different time sets (first and second order + possible parallel experiments))
      l$sx=list()
   }
   if (is.null(l$sx[[nm_sx]])) {
      li=list()
      li$nco=nco
      #li$sxmat=simple_sparse_array(i=cbind(rep(l$bmat$i, nco), rep(l$bmat$j, nco), rep(seq_len(nco), each=length(l$bmat$i))),
      #   v=rep(l$bmat$v, nco), dim=c(l$bmat$nrow, l$bmat$ncol, nco))
      li$sxmat=simple_triplet_matrix(i=rep(l$bmat$i, nco), j=l$bmat$j+rep(seq(0, nco-1), each=length(l$bmat$i))*l$bmat$ncol, v=rep(l$bmat$v, nco), nrow=l$bmat$nrow, ncol=l$bmat$ncol*nco)
      li$s=simple_triplet_matrix(i=rep(l$b$i, nco), j=l$b$j+emuw*rep(seq_len(nco)-1, each=length(l$b$i)), v=rep(l$b$v, nco), nrow=l$b$nrow, ncol=l$b$ncol*nco)
      l$sx[[nm_sx]]=li
   }
#browser()
   ind_b=if (emu) spAbr[["ind_b_emu"]] else spAbr[["ind_b"]]
   nprodx=ncol(ind_b)-2-emu
   prodx=incu[c(ind_b[,2+emu+seq_len(nprodx)]),]
   dim(prodx)=c(nrow(ind_b), nprodx, nco)
   l$sx[[nm_sx]]$sxmat$v[]=fwrv[ind_b[,"indf"]]*arrApply(prodx, 2, "prod")
   #l$sx[[nm_sx]]$s$v[]=arrApply(as.array(l$sx[[nm_sx]]$sxmat), 1, "sum")
   l$sx[[nm_sx]]$s$v[]=slam::col_sums(l$sx[[nm_sx]]$sxmat)
   s=l$sx[[nm_sx]]$s
   return(s)
}

param2fl_usm_eul2=function(param, cjac, labargs, fullsys=FALSE) {
   # translate free params (fluxes+scales+pools) to fluxes and
   # unscaled simulated measurements (usm) for label propagation.
   # tifull may be more fine grained than ti. All ti must be in tifull
   # only ti moments are reported in usm and jacobian

   # implicite euler scheme is used on all time points in a given weight.
   # => no possibility to add a time point during a run.
   # jacobian is directly derived form discrete scheme and not from ODE solving

   # branched from param2fl_usm_eul().
   # 2014-07-09 sokol
#if (fullsys)
#browser()
   # from labargs to local vars
   for (item in ls(labargs))
      assign(item, get(item, env=labargs))
   if (is.null(labargs$getx))
      getx=FALSE
   if (fullsys) {
      spa=spaf
      nb_rcumos=nb_f$xf
      nb_x=nb_f$xf
      nm_x=nm_list$cumo
      nbc_x=nb_f$nbc_xf
      xi=xif
      rcumo_in_cumo=match(nm_list$rcumo, nm_x)
      nm_inp=nm_list$xif
      ip2ix=nb_f$ip2icumo
      ipf2ix=nb_f$ipf2icumo
   } else {
      nb_rcumos=nb_f$rcumos
      nm_x=nm_list$x
      nbc_x=nb_f$nbc_x
      nb_x=nb_f$x
      nm_inp=nm_list$inp
      ip2ix=nb_f$ip2ircumo
      ipf2ix=nb_f$ipf2ircumo
   }
#print(c(calc="", f=fullsys, labargs=labargs, a=spa[[1]]$a))
   nbc_cumos=c(0L, cumsum(nb_rcumos))
   nb_w=length(spa)
   nb_ti=nb_f$ti
   nb_tifu=nb_f$tifu
   # cumulated sum

   # calculate all fluxes from free fluxes
   fgr=numeric(nb_f$nb_fgr)
   names(fgr)=nm_list$fgr
   if (nb_f$nb_fgr)
      fgr[paste("g.n.", substring(nm_list$poolf, 4), "_gr", sep="")]=nb_f$mu*param[nm_list$poolf]
   lf=param2fl(param, labargs)
   fwrv=lf$fwrv
   nb_fwrv=length(lf$fwrv)
   nb_xi=length(nm_inp)
   nb_ff=nb_f$nb_ff
   nb_poolf=nb_f$nb_poolf
   nb_fgr=nb_f$nb_fgr
   nb_meas=nb_f$nb_meas
   nb_sc=nb_f$nb_sc
   # fullfill pool with free pools
   if (nb_poolf > 0) {
      pool[nm_list$poolf]=param[nm_list$poolf]
   }
   # prepare pool vectors
   # vm has the same length as the full label vector
   vm=pool[ip2ix]
   if (cjac) {
      #cat("param2fl_usm_eul2: recalculate jacobian\n")
      jx_f$df_dffp=df_dffp(param, lf$flnx, nb_f, nm_list)
   }
#if (interactive() && fullsys)
#browser()
#for (iw in seq_len(nb_w))
#print(c(iw=iw, f=fullsys, labargs=labargs, a=spa[[iw]]$a))
   Alit=lapply(seq_len(nb_w), function(iw) {-fwrv2Abr(fwrv, spa[[iw]], NULL, nm_x[nbc_x[iw]+seq_len(nb_x[iw])], getb=FALSE,  emu=(emu && !fullsys))$A$triplet()})
#print(c(calc2="", f=fullsys, labargs=labargs, a=labargs$spa[[1]]$a))
#stop("aha")
   dtru=unique(unlist(lapply(seq_len(nb_exp), function(iexp) as.character(round(diff(tifull[[iexp]]), 6)))))
   # prepare place for (diag(vm)/dt-a)^-1 common to all iexp
   if (is.null(labargs$ali_w) || sum(sapply(ali_w, function(s) nrow(s[[1]]))) != tail(nbc_x, 1)) {
#cat("fullsys=", fullsys, "; rebuild ali_w for", tail(nbc_x, 1), "\n", file=fclog)
#browser()
      ali_w=list()
      for (iw in seq_len(nb_w)) {
         nb_c=spa[[iw]]$nb_c
         emuw=ifelse(emu && !fullsys, iw, 1L)
         vmw=vm[nbc_cumos[iw]+seq_len(nb_c)]
         vmw=rep(vmw, emuw)
         redim(vmw, c(nb_c, emuw))
         ali_w[[iw]]=lapply(dtru, function(dtu) {
#if (interactive()) browser()
            dti=1./as.double(dtu)
            a=Alit[[iw]]
            #a$v[spa[[iw]]$iadiag]=vmw[,1L]*dti+a$v[spa[[iw]]$iadiag]
            asp=Rmumps$new(a) # just a place-holder
            asp$set_icntl(0, 7) # at first position: 0=AMD (current value), 2=amf, 3=scotch, 4=pord, 5=metis
            n_lapply(labargs$control_ftbl$mumps, function(nm, it) {
               if (startsWith(nm, "icntl_")) {
                  i=suppressWarnings(as.integer(strsplit(nm, "_")[[1L]][2L]))
                  v=suppressWarnings(as.integer(it))
                  asp$set_icntl(v, i)
               }
            })
            #asp$set_icntl(400, 14) # increase by 400% working space
            #if (packageVersion("rmumps") >= "5.1.1-1")
            #   asp$set_keep(40, 1) # undocumented feature of mumps (cf. their mail on mumps-user group from 12/04/2017)
            return(asp)
         })
         names(ali_w[[iw]])=dtru
      }
      labargs$ali_w=ali_w
   }
   ntico_max=max(sapply(seq_len(nb_exp), function(iexp) nb_tifu[[iexp]]-1L))
   nb_row_max=max(sapply(seq_len(nb_w), function(iw) {emuw=ifelse(emu && !fullsys, iw, 1L); spa[[iw]]$nb_c*emuw}))
   #xpf=double(nbc_x[nb_w+1L]*(nb_ff+nb_poolf)*ntico_max)
   #sfpw=double(nb_row_max*ntico_max*nb_poolf)
   #xpfw=double(nb_row_max*(nb_ff+nb_poolf)*ntico_max)
   #xpf1=double(nb_row_max*(nb_ff+nb_poolf))
   for (iexp in seq_len(nb_exp)) {
      if (nb_ti[iexp] < 2) {
         return(list(err=1, mes="Number of time points is less than 2"))
      }
      if (!all(ti[[iexp]] %in% tifull[[iexp]])) {
         return(list(err=1, mes="Not all time moments in ti are present in tifull vector"))
      }

      # prepare vectors at t1=0 with zero labeling
      # incu, xi is supposed to be in [0; 1]
      stopifnot(!is.null(dim(xi[[iexp]])))
      x1=c(1., xi[[iexp]][,1L], rep(0., nbc_x[nb_w+1])) # later set m+0 to 1 in x1
      names(x1)=c("one", nm_inp, nm_x)
      # prepare time vectors
      dt=diff(tifull[[iexp]])
      stopifnot(all(dt > 0.))
      ntico=nb_tifu[[iexp]]-1L # number of time columns
      idt=seq_len(ntico)
      itifu=seq_len(nb_tifu[[iexp]])
      invdt=1./dt

      nb_mcol=ncol(measmat[[iexp]])
      # prepare ponderation with actual metab pools
      pwe[[iexp]][ipwe[[iexp]]]=pool[ip2ipwe[[iexp]]]
      spwe=tapply(pwe[[iexp]], pool_factor[[iexp]], sum)
      spwe=1./as.numeric(spwe[nm_list$measmat[[iexp]]])
      pwe[[iexp]]=pwe[[iexp]]*spwe
      xsim=matrix(x1, nrow=length(x1), ncol=ntico)
      bop(xsim, c(1, 1, nb_xi), "=", xi[[iexp]][,-1])

      dimnames(xsim)=list(names(x1), tifull[[iexp]][-1L])
#if (interactive() && fullsys)
#browser()
      if (cjac) {
         #cat("param2fl_usm_eul2: recalculate jacobian\n")
         if (is.null(labargs$xpf) || length(labargs$xpf) != nbc_x[nb_w+1L]*(nb_ff+nb_poolf)*ntico) {
            labargs$xpf=double(nbc_x[nb_w+1L]*(nb_ff+nb_poolf)*ntico)
         }
         xpf=labargs$xpf
         redim(xpf, c(nbc_x[nb_w+1L], nb_ff+nb_poolf, ntico))
         #resize(xpf, c(nbc_x[nb_w+1L], nb_ff+nb_poolf, ntico))
         if (length(ijpwef[[iexp]])) {
            dpwe=-pwe[[iexp]]*spwe
            dpwe[-ipwe[[iexp]]]=0.
            dpwe=(dpwe+dp_ones[[iexp]]*spwe)
         }
      }
      # prepare data for iadt array
      dtr=as.character(round(dt, 6L))
      # just update already inversed matricies from previous iexp
      for (iw in seq_len(nb_w)) {
         emuw=ifelse(emu && !fullsys, iw, 1L)
         nb_c=spa[[iw]]$nb_c
         if (nb_c == 0)
            next
#browser()
         ixw=nbc_x[iw]+seq_len(nb_x[iw])
         inxw=(1L+nb_xi)+ixw
         nb_row=nb_c*emuw
         inrow=(1L+nb_xi+nbc_x[iw])+seq_len(nb_row)
         imw=nbc_x[iw]+seq_len(nb_row) # mass index in x (all but last)
         vmw=vm[nbc_cumos[iw]+seq_len(nb_c)]
         vmw=rep(vmw, emuw)
         redim(vmw, c(nb_c, emuw))
         # prepare (diag(vm)/dt-a)^-1
         if (iexp == 1) {
            ali_w[[iw]][]=lapply(names(ali_w[[iw]]), function(dtu) {
               dti=1./as.double(dtu)
               asp=ali_w[[iw]][[dtu]]
               if (!inherits(asp, "Rcpp_Rmumps"))
                  asp=attr(asp, "asp")
               av=Alit[[iw]]$v
               av[spa[[iw]]$iadiag]=vmw[,1L]*dti+av[spa[[iw]]$iadiag]
               asp$set_mat_data(av)
               if (cjac && nb_c < 65) {
                  m=asp$inv()
                  attr(m, "asp")=asp
                  return(m)
               } else {
                  return(asp)
               }
            })
         }
         ilua=pmatch(dtr, names(ali_w[[iw]]), dup=TRUE)
         if (emu && !fullsys) {
            # for the first time point, set m+0 to 1 in x1
            x1[(1L+nb_xi+nbc_x[iw])+seq_len(nb_c)]=1.
            xsim[inxw,1L]=x1[inxw]
            imwl=nbc_x[iw]+nb_row+seq_len(nb_c) # the last mass index in x
         }
         # source terms
         st=fwrv2sp(fwrv, spa[[iw]], xsim, emu=emu && !fullsys)
         if (any(is.na(st)))
            return(list(x=NULL, iw=iw, err=1L, mes="NA appeared in source term"))
         st=as.matrix(st)
#st_save=st+0.
         # calculate labeling for all time points
         xw1=x1[inrow]
         redim(xw1, c(nb_c, emuw))
         #xsim[inxw,]=vapply(idt, function(idtr) {
         #   xw2=lusolve(iadt[[dtr]], (xw1+st[,idtr]))
         #   xw1[] <<- xw2
         #   if (emu) {
         #      return(c(xw2, 1.-rowSums(xw2)))
         #   } else {
         #      return(xw2)
         #   }
         #}, x1[inxw])
         #xw2=vapply(idt, function(idtr) {
         #   xw2=solve(ali[[ilua[idtr]]], vmw*xw1/dt[idtr]+st[,idtr])
         #   xw1[] <<- xw2
         #}, xw1)
#if (interactive() && fullsys)
#browser()
         redim(st, c(nb_c, emuw, ntico))
         tmp=try(solve_ieu(invdt, xw1, vmw, ali_w[[iw]], st, ilua), silent=TRUE)
         if (inherits(tmp, "try-error")) {
#browser()
            rerr=attr(tmp, "condition")
            if (length(grep("rmumps:.*info\\[1\\]=-10,", rerr$message, fixed=FALSE))) {
               # find 0 rows if any
               l=spa[[iw]]
               ag=aggregate(abs(lf$fwrv[l$ind_a[,"indf"]]), list(l$ind_a[,"ir0"]), sum)
               izc=ag$Group.1[ag$x <= 1.e-10]
               izf=names(which(abs(lf$fwrv)<1.e-7))
               mes=paste("Cumomer matrix is singular. Weight=", iw, ". Try '--clownr N' or/and '--zc N' options with small N, say 1.e-3\nor constrain some of the fluxes listed below to be non zero\n",
                  "Zero rows in cumomer matrix A at weight ", iw, ":\n",
                  paste(nm_list$x[ixw][izc+1], collapse="\n"), "\n",
                  "Zero fluxes are:\n",
                  paste(izf, collapse="\n"), "\n",
                  sep="")
            } else {
               mes=as.character(rerr$message)
            }
            return(list(x=NULL, iw=iw, err=1L, mes=mes))
         }
         if (any(is.na(st))) {
#browser()
            return(list(x=NULL, iw=iw, err=1L, mes="NA appeared in ODE solution"))
         }
         #       dim(xw2)=c(nb_c, emuw, ntico)
         #xsim[inrow,]=st #xw2
         bop(xsim, c(1, 1L+nb_xi+nbc_x[iw], nb_row), "=", st)
         if (emu && !fullsys) {
            #xsim[1L+nb_xi+imwl,]=1.-arrApply(st, 2, "sum")
            bop(xsim, c(1, 1L+nb_xi+nbc_x[iw]+nb_row, nb_c), "=", 1.-arrApply(st, 2, "sum"))
         }
         if (cjac) {
#browser()
            # prepare jacobian ff, pf
            # rhs for all time points on this weight
            # parts before b_x%*%...
            #Rprof(file="fx2jr.Rprof", append=TRUE)
            if (is.null(labargs$xpfw) || is.null(labargs$xpfw[[iw]]) || length(labargs$xpfw[[iw]]) != nb_row*(nb_ff+nb_poolf)*ntico) {
               if (is.null(labargs$xpfw))
                  labargs$xpfw=vector("list", nb_w)
               labargs$xpfw[[iw]]=double(nb_row*(nb_ff+nb_poolf)*ntico)
            }
            xpfw=labargs$xpfw[[iw]]
            redim(xpfw, c(nb_row, nb_ff+nb_poolf, ntico))
            #resize(xpfw, c(nb_c*emuw, nb_ff+nb_poolf, ntico))
            bop(xpfw, 1, "=", 0.)
            #xpf1=double(nb_c*emuw*(nb_ff+nb_poolf))
            #resize(xpf1, c(nb_c, emuw*(nb_ff+nb_poolf)))
            #bop(xpf1, 1, "=", 0.) # xpf1 is always 0
            #sfpw=double(nb_row*ntico*nb_poolf)
            #resize(sfpw, c(nb_c, emuw, ntico, nb_poolf))
            #bop(sfpw, 1, "=", 0.)
            sj=fx2jr(fwrv, spa[[iw]], nb_f, xsim)
            #Rprof(NULL)
            # ff part
            if (nb_ff+nb_fgr > 0) {
               #tmp=sj$j_rhsw%stm%(-jx_f$df_dffp)
               #redim(tmp, c(nb_row, ntico, nb_ff+nb_fgr))
               ##xpfw[,seq_len(nb_ff+nb_fgr),]=-aperm(tmp, c(1L, 3L, 2L))
               #bop(xpfw, c(3, 0, nb_ff+nb_fgr), "=", aperm(tmp, c(1L, 3L, 2L)))
               jrhs_ff(sj$j_rhs, jx_f$df_dffp, xpfw)
               #if (sum(xpfw[,seq(nb_ff+nb_fgr),]-aperm(tmp, c(1L, 3L, 2L))) > 1.e-14)
               #   browser()
            }
            # poolf part
            if (nb_poolf > 0) {
#browser()
               i2x=ipf2ix[[iexp]][[iw]]
               i2xf=ipf2ix[[iexp]][[iw]]
               #bop(i2xf, c(2,2,1), "+=", nb_ff)
               i2xf[,3]=i2xf[,3]+nb_ff
               xw2=(cbind(x1[inrow], xsim[inrow, -ntico, drop=FALSE])-xsim[inrow, , drop=FALSE])%mrv%invdt
               redim(xw2, c(nb_c, emuw, ntico))
               #dim(xw2)=c(nb_c, emuw*ntico)
               #tmp=at%stm%xw2+c(st)
               #dim(tmp)=c(nb_c, emuw, ntico)
               #sfpw[i2x]=tmp[i2x[,-4L]]
               #bop(sfpw, i2x, "=", xw2[i2x[,-4L,drop=FALSE]])
               #xpfw[,nb_ff+seq_len(nb_poolf),]=(if (nb_fgr > 0) xpfw[,nb_ff+seq_len(nb_poolf,)] else 0.) + aperm(sfpw, c(1L, 2L, 4L, 3L))
               redim(xpfw, c(nb_c, emuw, nb_ff+nb_poolf, ntico))
               if (nb_fgr > 0) {
                  #bop(xpfw, c(2, nb_ff, nb_poolf), "+=", aperm(sfpw, c(1L, 2L, 4L, 3L)))
                  bop(xpfw, i2xf, "+=", xw2[i2x[,-3L,drop=FALSE]])
               } else {
                  #bop(xpfw, c(2, nb_ff, nb_poolf), "=", aperm(sfpw, c(1L, 2L, 4L, 3L)))
                  bop(xpfw, i2xf, "=", xw2[i2x[,-3L,drop=FALSE]])
                  redim(xpfw, c(nb_row, nb_ff+nb_poolf, ntico))
               }
            }
            # add lighter xpf (b_x%*%...)
            if (iw > 1L) {
#browser()
               #ir=seq_len(nb_row)
               #ic=seq_len(nbc_x[iw])
               #pti=proc.time()
               #for (idtr in idt) {
               #   xpfw[,,idtr]=xpfw[,,idtr]-sj$b_x[ir+(idtr-1L)*nb_row,]%stm%xpf[ic,,idtr]
               #}
               mult_bxxc(xpfw, sj$b_x, xpf)
               #cat("iw=", iw, "; len(x)=", length(sj$b_x[ir,]@x), "\n", sep="")
               #print(proc.time()-pti)
            }
            # solve the system at each time point
#browser()
            #xpfw=vapply(idt, function(idtr) {
            #   #dtr=as.character(round(dt[idtr], 10L))
            #   xpf1[] <<- lusolve(ali[[pmatch(dtr[idtr], dtru)]], c(xpfw[,,idtr])+xpf1) # +xpf1 makes that it is a matrix of a suitable size            xpf1[]=xpfw[,idtr,]
            #}, xpf1)
            #xpfw[]=vapply(idt, function(idtr) {
            #   xpf1[] <<- solve(ali[[ilua[idtr]]], c(xpfw[,,idtr])+c(vmw)*xpf1/dt[idtr]) # +xpf1 makes that it is a matrix of a suitable size            xpf1[]=xpfw[,idtr,]
            #}, xpf1)
            #dim(xpfw)=c(nb_c, emuw, nb_ff+nb_poolf, ntico)
            vmw=rep(vmw, nb_ff+nb_poolf)
            redim(vmw, c(nb_c, emuw*(nb_ff+nb_poolf)))
            redim(xpfw, c(nb_c, emuw*(nb_ff+nb_poolf), ntico))
            solve_ieu(invdt, NULL, vmw, ali_w[[iw]], xpfw, ilua)
            redim(xpfw, c(nb_c, emuw, nb_ff+nb_poolf, ntico))
            #xpfw[]=aperm(xpfw, c(1L, 2L, 4L, 3L))
#browser()
            #xpf[imw,,]=xpfw
            bop(xpf, c(1, nbc_x[iw], nb_row), "=", xpfw)
            if (emu && !fullsys) {
               # treat the last weight
               #xpf[imwl,,]=-arrApply(xpfw, 2, "sum")
               bop(xpf, c(1, nbc_x[iw]+nb_row, nb_c), "=", -arrApply(xpfw, 2, "sum"))
            }
         }
      } # iw loop
      #jx_f$xsim=xsim # for debugging only
      # get ti moments corresponding to measurements
      isel=itifu[tifull[[iexp]] %in% ti[[iexp]]][-1L]-1L
      ntise=length(isel)
      xsim=xsim[-seq_len(1L+nb_xi),, drop=FALSE]
      if (getx) {
         xsimf=xsim # full simulation (in time)
         xsim=xsim[,isel,drop=FALSE]
         # usm
#browser()
         mx=measmat[[iexp]] %stm% (if (nrow(xsim) == nb_mcol && !fullsys) xsimf else (if (emu) memu_in_cumo %stm% xsimf + cemu_in_cumo else xsimf[rcumo_in_cumo,,drop=FALSE])) + memaone[[iexp]]
         if (length(ipooled[[iexp]]) > 1L) {
            usmf=as.matrix(meas2sum[[iexp]]%stm%(pwe[[iexp]]*mx)) # full simulated measurements (in time)
         } else {
            usmf=mx
         }
         usm=usmf[,isel,drop=FALSE]
      } else {
         # usm
         mx=measmat[[iexp]]%stm%(if (nrow(xsim) == nb_mcol && !fullsys) xsim[,isel,drop=FALSE] else (if (emu) memu_in_cumo %stm% xsimf + cemu_in_cumo else xsim[rcumo_in_cumo,isel,drop=FALSE]))+memaone[[iexp]]
         if (length(ipooled[[iexp]]) > 1L) {
            usm=as.matrix(meas2sum[[iexp]]%stm%(pwe[[iexp]]*mx))
         } else {
            usm=mx
         }
      }

      if (cjac) {
         #jx_f$xpf=xpf # for debugging only
         #xpf=aperm(xpf[,,isel,drop=FALSE], c(1L, 3L, 2L))
         #redim(xpf, c(nbc_x[nb_w+1L], ntise*(nb_ff+nb_poolf)))
         # scale part of jacobian
         if (nb_f$nb_sc_tot != 0L) {
            stop_mes("nb_sc != 0L is not implemented as meaningless for dynamic labeling. Use --noscale option.", file=fcerr)
         }
         #dux_dp=measmat[[iexp]]%stm%xpf
         dux_dp=mm_xpf(measmat[[iexp]], xpf, isel)
         #redim(xpf, c(nbc_x[nb_w+1L], ntise, (nb_ff+nb_poolf)))
         #dimnames(xpf)=list(nm_x, ti[[iexp]][-1], nm_list$par)
         nr=nrow(measmat[[iexp]])
         if (length(ipooled[[iexp]]) > 1L) {
            redim(dux_dp, c(dim(dux_dp)[1], ntise*(nb_ff+nb_poolf)))
            dux_dp=meas2sum[[iexp]]%stm%(pwe[[iexp]]*dux_dp) # resize
            nr=nrow(meas2sum[[iexp]])
         }
         redim(dux_dp, c(nr, ntise, nb_ff+nb_poolf))
         if (length(ijpwef[[iexp]]) > 0L) {
            # derivative of pool ponderation factor
            dpw_dpf=double(nrow(measmat[[iexp]])*ntise*nb_poolf)
            dim(dpw_dpf)=c(nrow(measmat[[iexp]]), ntise, nb_poolf)
            tmp=c(mx)*dpwe
            dim(tmp)=dim(dpw_dpf)
            dpw_dpf[ijpwef[[iexp]]]=tmp[ijpwef[[iexp]]]
            dim(dpw_dpf)= c(nrow(measmat[[iexp]]), ntise*nb_poolf)
            dux_dp[,,nb_ff+seq_len(nb_poolf)]=dux_dp[,,nb_ff+seq_len(nb_poolf)]+c(meas2sum[[iexp]]%stm%dpw_dpf)
         }
         dimnames(dux_dp)=list(nm_list$meas[[iexp]], ti[[iexp]][-1L], nm_list$par)
         jx_f$dux_dp[[iexp]]=dux_dp
         #jx_f$xpf[[iexp]]=xpf
      }
      dimnames(usm)=list(nm_list$meas[[iexp]], ti[[iexp]][-1L])
      # store usefull information in global list jx_f
      jx_f$param=param
      jx_f$usm[[iexp]]=usm
      if (getx) {
         jx_f$usmf[[iexp]]=usmf
         jx_f$xsim[[iexp]]=xsim
         jx_f$xsimf[[iexp]]=xsimf
      }
   }
   if (getx) {
      names(jx_f$usm)=names(jx_f$usmf)=names(jx_f$xsim)=names(jx_f$xsimf)=nm_list$nm_exp
      res=list(usm=jx_f$usm, usmf=jx_f$usmf, x=jx_f$xsim, xf=jx_f$xsimf, dux_dp=jx_f$dux_dp, lf=lf, df_dffp=jx_f$df_dffp)
   } else {
      names(jx_f$usm)=nm_list$nm_exp
      res=list(usm=jx_f$usm, dux_dp=jx_f$dux_dp, lf=lf, df_dffp=jx_f$df_dffp)
   }
   return(res)
}

param2fl_usm_rich=function(param, cjac, labargs, fullsys=FALSE) {
   # Richardson extrapolation to get order 2 in ODE solve
#print(c(rich="", labargs=labargs, spa_a1=labargs$spa[[1L]]$a))
   if (labargs$time_order=="2") {
      getx=FALSE
      if (!is.null(labargs$getx))
         getx=labargs$getx
      labargs$labargs2$getx=getx
      # solve with step=h/2
      if (!is.null(labargs$cl) && is.null(.GlobalEnv$mc_iter)) {
         # do in parallel only out off MC iterations
         clusterExport(labargs$cl, c("param", "cjac", "fullsys"), envir=environment())
#print(labargs$cl[[1]])
#lila=parLapply(labargs$cl, c("labargs", "labargs"), function(nm) format(labargs))
#cat("lila=\n")
#print(lila)
#clusterEvalQ(labargs$cl, {cat("usm idth=", idth, "\n"); print(labargs)})
         if (getx)
            clusterEvalQ(labargs$cl, {labargs$labargs2$getx=labargs$getx=TRUE})
         else
            clusterEvalQ(labargs$cl, {labargs$labargs2$getx=labargs$getx=FALSE})
         res=clusterEvalQ(labargs$cl, {
#print(c(evalq="", labargs=labargs, a=labargs$spa[[1]]$a))
            if (idw < 3)
               try(param2fl_usm_eul2(param, cjac, if (idw == 1) labargs else labargs$labargs2, fullsys))
         })
         if (length(labargs$cl) < 2L) {
            res=c(res, clusterEvalQ(labargs$cl, {
#print(c(evalq2="", labargs=labargs, a=labargs$spa[[1]]$a))
               try(param2fl_usm_eul2(param, cjac, labargs$labargs2, fullsys))
            }))
         }
#clusterEvalQ(labargs$cl, print(c(rich_cl="", labargs=labargs, spa_a1=labargs$spa[[1L]]$a)))
         #res=parLapply(labargs$cl, seq(2), function(ith) {
         #   param2fl_usm_eul2(param, cjac, if (ith == 1) labargs else labargs$labargs2, fullsys)
         #}) # parLapply() creates new labargs which does not have valid spa[[iw]]$a
      } else {
         # do sequentially
         res=lapply(seq(2), function(i) param2fl_usm_eul2(param, cjac, if (i == 1) labargs else labargs$labargs2, fullsys))
      }
      for (i in seq_along(res)) {
         r=res[[i]]
         if (inherits(r, "try-error")) {
            if (interactive())
               recover()
            attributes(r)=NULL
#browser()
            return(list(err=1L, mes=r, ithread=i))
         }
      }
      res1=res[[1]]
      if (!is.null(res1$err) && res1$err) {
         return(res1)
      }
      res2=res[[2]]
      if (!is.null(res2$err) && res2$err) {
         return(res2)
      }
      # Richardson interpolation
      jx_f=labargs$jx_f
#browser()
      for (iexp in seq_len(labargs$nb_exp)) {
         jx_f$usm[[iexp]]=2*res2$usm[[iexp]]-res1$usm[[iexp]]
         if (getx) {
            jx_f$usmf[[iexp]]=2*res2$usmf[[iexp]][,seq.int(2, ncol(res2$usmf[[iexp]]), 2)]-res1$usmf[[iexp]]
            jx_f$xsim[[iexp]]=2*res2$x[[iexp]]-res1$x[[iexp]]
         }
         if (cjac) {
            jx_f$dux_dp[[iexp]]=2*res2$dux_dp[[iexp]]-res1$dux_dp[[iexp]]
            #jx_f$dux_dp=labargs$jx_f$dux_dp
         }
      }
      res1$usm[]=jx_f$usm
      res1$dux_dp[]=jx_f$dux_dp
      jx_f$df_dffp=res1$df_dffp
      if (getx) {
         res1$usmf[]=jx_f$usmf
         res1$x[]=jx_f$xsim
      }
   } else {
      res1=param2fl_usm_eul2(param, cjac, labargs, fullsys)
   }
   return(res1)
}
# transform a funlab list 'li' into matrix #nm_inp x #tp having input labeling in time points 'tp'
# li entries: "metab name" -> "int iso mask" -> R-code depending on vector 'tp'
# nm_inp cumo: "Glc:63"
# nm_inp emu: "Glc:63+0"

funlab=function(tp, nm_inp, li, env, emu, fname, fcerr, tol=1.e-7) { #sqrt(.Machine$double.eps)) {
   # lit is a nested list: met => str(isoint) => vector of legth #tp
   lit=n_lapply(li,
   function(met, m) {
      n_lapply(m,
      function(nm_iso, rcode) {
         env$t=tp
#browser()
         v=if (is.numeric(rcode[[1L]])) rep(rcode[[1L]], length(tp)) else try(eval(rcode, env), silent=TRUE) # time dependent isotopomers, i.e. functions applied on t
         if (inherits(v, "try-error")) {
            stop_mes("Error in R code '", format(rcode[[1L]]), "' for input label '", met, "#", nm_iso, "' from '", fname, "':\n", v, file=fcerr)
         }
         if (any(ibad <- is.na(suppressWarnings(as.double(v))))) {
            ibad=which(ibad)[1L]
            stop_mes("Input label '", met, "#", nm_iso, "' from '", fname, "' produced a non numeric value at t=", tp[ibad], ": '", v[ibad], "'.", file=fcerr)
         }
         if (length(v) == 0L)
			stop_mes("Input label '", met, "#", nm_iso, "' from '", fname, "' has no data from R expression '", format(rcode[[1L]]), "'.", file=fcerr)
         if (length(v) != length(tp))
			stop_mes("Input label '", met, "#", nm_iso, "' from '", fname, "' has not the same length (", length(v), ") as time vector (", length(tp), ")", file=fcerr)
         v[v < 0. & v >= -tol]=0.
         v[v > 1. & v <= 1.+tol]=1.
         if (any(ibad <- v < 0.)) {
            ibad=which(ibad)[1L]
            stop_mes("Input label '", met, "#", nm_iso, "' from '", fname, "' produced a negative value at t=", tp[ibad], ": '", v[ibad], "'.", file=fcerr)
         }
         if (any(ibad <- v > 1.)) {
            ibad=which(ibad)[1L]
            stop_mes("Input label '", met, "#", nm_iso, "' from '", fname, "' produced a value > 1 at t=", tp[ibad], ": '", v[ibad], "'.", file=fcerr)
         }
         v
      })
   })
   # complete to 1 if necessary
   for (met in names(lit)) {
      m=lit[[met]]
      # sanity check, sum > 1
      su=Reduce("+", m)
      if (any(ibad <- su > 1.+tol)) {
         ibad=which(ibad)[1L]
#browser()
         stop_mes("Input labeled metabolite '", met, "' from '", fname, "' sums up to a value greater than 1 at t=", tp[ibad], "; sum-1=", su[ibad]-1., ".", file=fcerr)
      }
      if (! ("0" %in% names(m))) {
         # "the rest is unlabeled"
         lit[[met]][["0"]]=1.-su
      } else if (length(m) == 2L**clen[met]-1L) {
         # "guess the lacking one"
         nm_all=as.character(seq(2**clen[met])-1)
         lack=nm_all[which(!nm_all %in% names(m))]
         lit[[met]][[lack]]=1.-su
      } else if (any(ibad <- su < 1.-tol)) {
         # sanity check, sum < 1
         ibad=which(ibad)[1L]
         stop_mes("Input labeled metabolite '", met, "' from '", fname, "' sums up to a value less than 1 at t=", tp[ibad], "; 1-sum=", 1.-su[ibad], ".", file=fcerr)
      }
   }
   sp=matrix(unlist(strsplit(nm_inp, ":", fixed=TRUE)), nrow=2L)
   cres=matrix(0., nrow=length(nm_inp), ncol=length(tp))
   if (emu) {
      for (j in seq(ncol(sp))) {
         # find what isotopomers in lit contributes to this nm_inp
         met=sp[1L, j]
         iemu=as.integer(strsplit(sp[2L, j], "+", fixed=TRUE)[[1L]])
         iso=as.integer(names(lit[[met]]))
         i=sapply(iso, function(ii) sum(as.integer(intToBits(bitops::bitAnd(ii, iemu[1])))) == iemu[2L])
         res=double(length(tp))
         if (any(i))
            res=Reduce("+", lit[[met]][i])
         cres[j,]=res
      }
   } else {
      for (j in seq(ncol(sp))) {
         # find what isotopomers in lit contributes to this nm_inp
         met=sp[1L, j]
         icu=as.integer(sp[2L, j])
         iso=as.integer(names(lit[[met]]))
         i=sapply(iso, function(ii) bitops::bitAnd(ii, icu) == icu)
         res=double(length(tp))
         if (any(i))
            res=Reduce("+", lit[[met]][i])
         cres[j,]=res
      }
   }
   return(cres)
}

# Copyright 2008-2013, INRA, France
# Author: Serguei SOKOL, sokol@insa-toulouse.fr
# License: GPL v2 http://www.gnu.org/licenses/gpl-2.0.html

# This an eclectic collection of R functions useful in variuous
# contexts.

# map values on color table for plot min->col[1], max->col[n]
val2col = function(val, col=rainbow(16L, start=0, end=4/6)) {
# creates vectors of length=NROW(val) translating val to colors
# min_val is mapped to col[1] and
# max_val is mapped to col[maxcol]
# default 16 rainbow colors min in red, max in blue
   val.min = min(val)
   val.max = max(val)
   nval = NROW(val)
   ncol = NROW(col)
   res = rep("", nval)
   for (i in 1L:nval) {
      res[i] = col[1L+floor(ncol*(val[i]-val.min)/(1.001*(val.max-val.min)))]
   }
   res
}
norm2<-function(v) crossprod(as.numeric(v))[1L]
norm<-function(v) {
   sqrt(norm2(v))
}
cnorm2=function(v) {
   Re(sum(Adj(v)%*%(v)))
}
house<-function(v,x,st=1L) {
   # apply housholder transform defined by v to x or
   # to a part of x starting from st
   n=NROW(x)
   x=as.matrix(x,n)
   m=NCOL(x)
   if (st>n) {
      # hmm, do nothing
      return(x)
   }
   v=c(v,rep(0,n-st+1L-NROW(v)))
   for (j in 1L:m) {
      x[st:n,j]=x[st:n,j]-2*v*(v%*%x[st:n,j])
   }
   x
}
#pos=function(x) 0.5*(x+abs(x))
pos=function(x) {x[x<0]=0.; return(x)}
neg=function(x) {x[x>0]=0.; return(-x)}
spick_det=function(sp, npick, lag=5) {
   # singulet pick detection in a nmr spectrum
   # returns a param array suitable for deconvolution
   n=length(sp)
   cs=exp_smooth(cumsum(sp))
   di=diff(cs, 3, lag=lag)
   o=order(di)+30
   param=c(0., 0., 0.0001); # sigma and lambda detected later, gauss fraction set very small
   for (i in 1L:npick) {
      # next greatest pick
      param=c(param, o[1L]); # add position of the pick
      # detect half height pick support
      maxp=sp[o[1L]]
      il=o[1L]:max(o[1L]-10*lag,1)
      lpos=which(sp[il]<=0.5*maxp)[1L]
      ir=o[1L]:min(o[1L]+10*lag,n)
      rpos=which(sp[ir]<=0.5*maxp)[1L]
      hw=0.5*(rpos+lpos)
      amp=pi*hw*maxp
      param=c(param, amp); # add amplitude of the pick
      # cancel 4*hw from o
      il=max(o[1L]-2*hw,1)
      ir=min(o[1L]+2*hw,n)
      o=o[!(o %in% il:ir)]
   }
   param[1L] = param[2L] = hw
}
exp_smooth=function(y, lambda=1./3.) {
   # smooth by convolution with normfactor*exp(-lambda*|x|)
   # lambda is in [0;1]
   # 0 => very smoothed (constant=leftmost value, not normalized)
   # 1 => no smooth at all
   n=NROW(y)
   ys=y
   l1=(1.-lambda)
   # forward march
   for (i in 2:n) {
      ys[i]=lambda*ys[i]+l1*ys[i-1L]
   }
   # backward march
   for (i in (n-1L):1L) {
      ys[i]=lambda*ys[i]+l1*ys[i+1L]
   }
   return(ys)
}
proc2par=function(dirn) {
   # in dirname dirn get procs and proc2s files, extract
   # "xdim", "si"  and some other params, then transform them in
   # a list with members: dims, ppm, axename
   # dims[1] is moving fastest
   fn=c("procs", "proc2s")

   # place holders
   xdim=1L:2L
   si=1:2
   ppm=cbind(start=c(0, 0), end=c(0, 0))
   sf=c(0, 0)
   axename=c("", "")

   for (i in 1L:2L) {
      f=file.path(dirn, fn[i])
      data=as.matrix(read.table(f, comment.char="", fill=TRUE))

      ir=which(data[,1L]=="##$XDIM=")
      xdim[i]=as.integer(data[ir,2L])

      ir=which(data[,1L]=="##$SI=")
      si[i]=as.integer(data[ir,2L])

      ir=which(data[,1L]=="##$AXNAME=")
      axename[i]=data[ir,2L]

      ir=which(data[,1L]=="##$F1P=")
      ppm[i,]=as.double(c(data[ir+1L,2L], data[ir,2L]))

      ir=which(data[,1L]=="##$SF=")
      sf[i]=as.double(c(data[ir, 2]))
   }
   rownames(ppm)=axename
   return(list(dims=c(xdim, floor(si/xdim)), ppm=ppm, sf=sf, axename=axename))
}
bf2mtx=function(file_name, dims=proc2par(dirname(file_name))$dims, ty="int") {
   # read a block structured file (like 2rr of topspin)
   # cnct is a connection
   # dims is a vector of dimensions of size 4
   # dims[1] is for index moving fastest
   d=array(readBin(file_name, ty, prod(dims)), dims)
   dc=matrix(d, dims[1L]*dims[3L], dims[2L]*dims[4L])
   # repack in contigous way
   if (dims[3L]==1 && dims[4L]==1) {
      return(dc)
   }
   for (i4 in 1:dims[4L]) {
      for (i2 in 1:dims[2L]) {
         dc[,i2+(i4-1)*dims[2L]]=d[,i2,,i4]
      }
   }
   return(dc)
}
read.2Dbruk=function(file_name, dims=proc2par(dirname(file_name))$dims, ty="int") {
   # read bruker formated file of 2D spectrum (like 2rr, 2ri and so on)
   # In the same directory it must be files procs and proc2s or
   # parameter dims provided explicitly.
   # Return a 4-dimenesionnal array, first two dimensions for
   # a block size, and the last two for block numbers in F1 and F2
   # directions.
   # use matrix(aperm(result, c(1,3,2,4)), nrow=dim1*dim3) to transofrm
   # a resulting array into contigous matrix
   array(readBin(file_name, ty, prod(dims)), dims)
}
read.1Dbruk=function(dir_name, ty="int") {
   # read bruker formated file of 1D spectrum real=1r, imaginary=1i
   # In the same directory it must be files 1r and 1i
   # Return a complex vector.
   fr=file.path(dir_name, "1r")
   fi=file.path(dir_name, "1i")
   nb_pnt=file.info(fr)$size/4
   complex(
      re=readBin(fr, ty, nb_pnt),
      im=readBin(fi, ty, nb_pnt)
   )
}
terre3d=function(z3, ...) {
   library(rgl)
   x=1:nrow(z3)
   y=1:ncol(z3)
   zlim <- range(z3)
   fact=max(x,y)/(zlim[2L]-zlim[1L])/2
   zlen=16
   colorlut=terrain.colors(zlen)
   col=colorlut[round((z3-zlim[1L])/(zlim[2L]-zlim[1L])*(zlen-1)) + 1 ]
   surface3d(x, y, fact*z3, color=col, back="lines", ...)
}
qcut=function(x, qntl=0.5, val=0) {
   # quantile cut to val of x columns
   # v[v<=quantile(v,qntl)]=val
   x=as.matrix(x, nrow=NROW(x))
   return(apply(x,2,function(v){v[v<=quantile(v,qntl)]=val; return(v)}))
}
cmpcut=function(x, lag=round(0.5*NROW(x)), val=0, app=2) {
   # compact cut to val of x columns (app=2) or rows (app=1)
   # start=which.max(diff(cumsum(v),lag=lag))
   # v[1:start,(start+lag):end]=val
   # NB: the support of non cut values is equal lag+1
   x=as.matrix(x, nrow=NROW(x))
   x=apply(x,app,function(v){n=NROW(v); if (lag>=n) { s=1; } else { s=which.max(diff(cumsum(v),lag=lag)); }; if (s > 1) { v[1:(s-1)]=val; }; if ((s+lag) < n) { v[(s+lag+1):n]=val; }; return(v)})
   if (app==1) {
      x=t(x)
   }
   x[x<val]=val
   return(x)
}
smooth025=function(v, repet=1) {
   # smooth by convolution with 0.25;0.5;0.25
   # NB: the returned vector is two points shorter than initial one
   # (one point out from each end)
   v=as.vector(v)
   n=NROW(v)
#cat("n=", n, "\n", sep="")
   if (n<3 || repet < 1) {
      # the vector is too short or no smoothing is asked
      # send it back as is
      return(v)
   }
   v=v[1:(n-1)]+v[2:n]
   v=0.25*(v[1:(n-2)]+v[2:(n-1)])
   if (repet<=1) {
      return(v)
   } else {
      return(smooth025(v, repet-1))
   }
}
smooth725=function(v, repet=1L) {
   # smooth by convolution with 0.25;0.5;0.25
   # NB: the returned vector has the same length as original one.
   # Extreme points have weights 0.75, 0.25 on left and 0.25;0.75 on right
   v=as.vector(v)
   n=NROW(v)
#cat("n=", n, "\n", sep="")
   if (n<2L || repet < 1L) {
      # the vector is too short or no smoothing is asked
      # send it back as is
      return(v)
   }
   # extend v beyond interval and NA gaps
   # indexes of valid value having NA on its left
   nal=c(0, which(is.na(head(v,-1)) & !is.na(v[-1L])))+1
   # indexes of valid value having NA on its right
   nar=c(which(is.na(v[-1L]) & !is.na(head(v,-1))), n)
   ve=c(NA, v, NA)
   ve[nal]=v[nal]
   ve[nar+2L]=v[nar]
   ve=head(ve,-1)+ve[-1L]
   ve=0.25*(head(ve,-1)+ve[-1L])
   if (repet<=1L) {
      return(ve)
   } else {
      return(smooth725(ve, repet-1L))
   }
}
smooth725dx=function(m, dx=rep(1., NROW(m)-1L), repet=1L) {
   # smooth columns of 'm' on a grid 'x' with weights w1*x1+(w1+w2)*x2+w2*x3
   # where w1=0.5*dx2/(dx1+dx2) and w2=0.5-w1
   # NA are not permitted
   resmat=is.matrix(m) || is.data.frame(m)
   m=as.matrix(m)
   nr=nrow(m)
   # sum of neighbors nrow=nr+1
   sn=rbind(m[1L,,drop=FALSE], m)+rbind(m, m[nr,,drop=FALSE])
   dxe=c(0, dx, 0)
   # weighted sum, nrow=nr
   res=c(dx, dx[nr-1L])*sn[-nr-1L,,drop=FALSE] +
      c(dx[1L],dx)*sn[-1L,,drop=FALSE]
   sdx_inv=0.5/c(2*dx[1L],dx[-1L]+dx[-nr+1L],2*dx[nr-1L])
   res=sdx_inv*res
   if (repet > 1L) {
      smooth725dx(res, dx, repet-1L)
   } else {
      if (resmat) res else as.vector(res)
   }
}
smdec=function(v) {
   # smooth by convolution with 0.25;0.5;0.25 and decimate
   # by taking every second point
   n=NROW(v)
#cat("n=", n, "\n", sep="")
   if (n<3) {
      # the vector is too short
      # send it back as is
      return(v)
   }
#cat("n2=", n, "\n", sep="")
   return(smooth025(v)[seq(1,n-2,2)])
}

smdec2d=function(z) {
   z1=apply(z,2,smdec)
   return(t(apply(z1,1,smdec)))
}

coarse_n=function(v, nsc=ceiling(log2(length(v))), f=smdec) {
   # return a list of scaled down vectors
   # first list element is original vector
   # second one is scaled down once and so on.
   # If all scales down are possible
   # then the list will have nsc+1 items
   # otherwise the last item is the vector
   # which could not be scaled down by lack of elements
   # f is a function used to passe from fine
   # to coarse level (smdec by default)
   res=list(v)
   if (nsc <= 0) {
      return(res)
   }
   for (i in 1:nsc) {
      sc=f(res[[i]])
      if (NROW(sc)==NROW(res[[i]]) || (NCOL(res[[i]]) > 1 && (NCOL(sc)==NCOL(res[[i]])))) {
         # no more possible scale down
         return(res)
      }
      res=append(res, list(sc))
   }
}

refine=function(vc,nf) {
   # refine the coarse vector vc to the size nf.
   # This is inverse of the coarsening (smooth+decimation) operation
   # refinement is done by linear interpolation.
   nc=NROW(vc)
   if (nf < 2*nc+1) {
      # bad coherence between vector lengths
      # do nothing
      return(vc)
   }
   vf=rep(0., nf)
   dvc=0.5*diff(c(0., vc, 0.))
   i2=seq(2,nf-1,by=2)
   # inject coarse values on even nodes
   vf[i2]=vc
   # interpolate on odd nodes
   vf[i2-1L]=vc-dvc[1:nc]
   # interpolate at the right end
   vf[i2[nc]+1L]=vc[nc]+dvc[nc+1L]
   if (i2[nc]!=nf-1) {
      # very far right end is just put to zero
      vf[nf]=0.
   }
   return(vf)
}

refine2x1d=function(zc,nf1,nf2) {
   # return refined zc to n1 x n2 field
   zf=matrix(0, nf1, nf2)
   nc1=nrow(zc)
   nc2=ncol(zc)
   for (i2 in 1:nc2) {
      # refine along the columns
      zf[,i2]=refine(zc[,i2], nf1)
   }
   for (i1 in 1:nf1) {
      # refine along the rows
      zf[i1,]=refine(zf[i1,1:nc2], nf2)
   }
   return(zf)
}

ipeaks=function(y, decreasing=TRUE) {
   # return a vector of indexes corresponding to peaks in a vector y
   # By default, the peaks are sorted in decreasing order.
   # The peaks are searched only in the form /\ (mountain) and not in /-\ (plateau)
   d=sign(diff(y))
   # make the same length as y (linear extrapolation)
   d=c(1,d,-1); # doubt benefice on the ends
   d=diff(d)
   ip=which(d==-2)
   o=order(y[ip], decreasing=decreasing)
   return(ip[o])
}
peak_tv=function(y, ip=ipeaks(y)) {
   # y is data vector, ip are indexes of peaks
   # total variation of a peak=2*y-yleft-yright where yleft
   # and yright are closest valley's bottoms on left and right from peak
   # return tv vector of the same length as ip and in the same order
   # than peaks
   # cf. ivalleys() and ihhw_peak()
   o=order(ip)
   n=length(y)
   ipb=c(1, ip[o], n)
   np=length(ip)
   yl=apply(t(1:np), 2, function(i) {max(y[ipb[i+1L]]-y[ipb[i]:ipb[i+1L]], na.rm=T)})
   yr=apply(t(1+(1:np)), 2, function(i) {max(y[ipb[i]]-y[ipb[i]:ipb[i+1L]], na.rm=T)})
   tv=1:np
   tv[o]=yr+yl
   return(tv)
}
ivalleys=function(y, ip=ipeaks(y)) {
   # y is data vector, ip are indexes of peaks
   # return indexes of deepest points between peaks and index limits
   o=order(ip)
   n=length(y)
   ipb=c(1, ip[o], n)
   np=length(ip)
   il=ir=numeric(np)
   il[o]=ipb[1:np]-1+apply(t(1:np), 2, function(i) {which.max(y[ipb[i+1L]]-y[ipb[i]:ipb[i+1L]])})
   ir[o]=ipb[1+(1:np)]-1+apply(t(1+(1:np)), 2, function(i) {which.max(y[ipb[i]]-y[ipb[i]:ipb[i+1L]])})
   return(cbind(left=il, center=ip, right=ir))
}
ihhw_peak=function(y, ip=ipeaks(y)) {
   # y is data vector, ip are indexes of peaks
   # return indexes of half-height width or deepest points between
   # peaks and index limits whichever comes first.
   o=order(ip)
   n=length(y)
   ipb=c(1, ip[o], n)
   np=length(ip)
   il=ir=numeric(np)
   il[o]=ipb[1:np]-1+apply(t(1:np), 2, function(i) {v=y[ipb[i]:ipb[i+1L]]; which.last(y[ipb[i+1L]]/2.>=v | v==min(v, na.rm=T))})
   ir[o]=ipb[1+(1:np)]-1+apply(t(1+(1:np)), 2, function(i) {v=y[ipb[i]:ipb[i+1L]]; which.first(y[ipb[i]]/2.>=v | v==min(v, na.rm=T))})
   return(cbind(left=il, center=ip, right=ir))
}
ipeaks2d=function(y, decreasing=TRUE) {
   # return a matrix n x 2 who's rows are composed of
   # indexe couples correponding to peaks in a matrix y
   # By default, the peaks are sorted in decreasing order.
   # The peaks are searched only in the form /\ (2d mountain in x,y direction)
   # and not in /-\ (plato) form.
   # The matrix y is prolongated by 0-order approximation
   n=dim(y)
   # make the same length as y (const extrapolation)
   d1=diff(sign(diff(rbind(y[1,],y,y[n[1L],]))))
   d2=t(diff(sign(diff(rbind(y[,1L],t(y),y[,n[2L]])))))
   i=d1*d2==4
   o=order(y[i], decreasing=decreasing)
   return(matrix(which(i, arr.ind=T)[o,], length(o)))
}
ipeak_close=function(d, iref, thre=0.5, repet=0, ip=ipeaks(smooth025(d-min(d),repet))) {
   # among all peaks in d chose one whose index
   # is closest to iref and whose height is above
   # thre*highest peak
   n=length(d)
   # shift d to make it positive then smooth
   d=smooth025(d-min(d),repet)
   # keep only peaks who's tv is above threshold*highest_tv
   tv=peak_tv(d, ip)
   ip=ip[tv>=thre*tv[1L]]+repet
   irt=ip[which.min(abs(ip-iref))]
   return(irt)
}
lorentz=function(w,w0=0,lambda=1) {
   l=1./lambda
   w=l*(w-w0)
   res=l/(pi*(w**2+1.))
   return(res)
   # (w-w0) at half height = lambda
}

discr_lorentz=function(w,w0=0,lambda=1) {
   # discreet approximation of lorentz function
   # w must be a vector of midpoints on which the
   # mean lorentz values are calculated
   l=1./lambda
   w=l*(w-w0)
   n=NROW(w)
   if (n<2) {
      stop("discr_lorentz: vector dimension is too low")
   }
   w=0.5*c(3*w[1L]-w[2L],w[1:(n-1)]+w[2:n],3*w[n]-w[n-1L])
   return(diff(atan(w))/diff(w)/pi)
}

solve_toeplitz=function(Toe,y) {
   # solves toeplitz system Toe%*%x=y
   # Toe is a list with fileds d, col, row
   # defining a toeplitz matrix (n+1)x(n+1) where n=length(col)
   # The Levison-Durbin algorithm is used.
   # x is returned
   col=Toe$col
   ns=length(col)
   d=Toe$d
   row=Toe$row
   x=f=b=rep(0., ns+1)
   f[1L]=b[1L]=1./d
   x[1L]=y[1L]*b[1L]
   for (i in 1:ns) {
      ii=1:i
      ii1=c(ii,i+1)
      eb=row[ii]%*%b[ii]
      ef=rev(col[ii])%*%f[ii]
      ex=rev(col[ii])%*%x[ii]
      deti=1./(1.-ef*eb)
      ft=deti*f[ii1]
      bt=deti*c(0.,b[ii])
      f[ii1]=ft-ef*bt
      b[ii1]=bt-eb*ft
      x[ii1]=x[ii1]+(y[i+1L]-ex)*b[ii1]
   }
   return(x)
}

cqr_gs=function(a, tol=1.e-10) {
   # QR decomposition of a (complex) matrix a by Gram-Schmidt algorithm
   # without pivoting
   # NB. For some matrices it can be numerically unstable.
   # Q is normal and orthogonal Q* %*% Q=diag(1)
   # dim(a) = c(n,p), n>=p
   # dim(Q) = c(n,p1) with p1 < p if a is rank deficient
   # dim(R) = c(p1,p)
   # rank(a) = p1
   a=as.matrix(a)
   n=dim(a)[1L]
   p=dim(a)[2L]
   p1=p
   Q=matrix(0, n, p)
   R=matrix(0, p, p)
   aux=rep(0, p)
   for (ic in 1:p) {
      u=Adj(a[,ic])
      if (ic > 1) {
         icm1=min(ic-1,p1)
         #r=Adj(u%*%Q[,1:icm1])
         # reorthogonalisation
         r=rep(0,icm1)
         for (icc in 1:icm1) {
            r[icc]=Adj(u%*%Q[,icc])
            u=u-Adj(r[icc]*Q[,icc])
         }
         #prj=Q[,1:icm1]%*%r
         #u=u-Adj(prj)
         R[1:icm1,ic]=r
      }
      nrm=as.vector(sqrt(Mod(u%*%Adj(u))))
      if (p1==p && Mod(nrm)<=tol) {
         # rank deficient
         p1=ic-1
      }
      if (Mod(nrm)>tol) {
         u=u/nrm
         R[ic,ic]=u%*%a[,ic]
         Q[,ic]=Adj(u)
      }
      aux[ic]=nrm
   }
   return(list(Q=Q[,1:p1], R=R[1:p1,], rank=p1, nrm=aux))
}
cqr_gs.solve=function(cqr, b) {
   # solve cqr*x=b where cqr is a qr decomposition of some rectangular
   # complex matrix

   # QR*x=b => R*x=Adj(Q)*b => x=inv(R)*Adj(Q)*b
   if (!is.list(cqr)) {
      cqr=cqr_gs(cqr)
   }
   b=as.matrix(b)
   n=dim(b)[1L]
   nb=dim(b)[2L]
   b=Adj(Adj(b)%*%cqr$Q)
   p1=cqr$rank
   R=as.matrix(cqr$R)
   p=dim(R)[2L]
   x=matrix(0., p, nb)
   for (ir in p1:1) {
      if (ir < p) {
         b[1:ir,]=b[1:ir,]-R[1:ir,ir+1L]%o%x[ir+1,]
      }
      x[ir,]=b[ir,]/R[ir,ir]
   }
   return(x)
}
vander=function(x, nc=NROW(x)) {
   # construct vandermonde matrix
   outer(x, 0:(nc-1), `^`)
}
# <-- 2013-05-02 from http://rwiki.sciviews.org/doku.php?id=misc:r_accuracy:high_precision_arithmetic
# the following function is written to work both
# with double precision and with mpfr numbers (cf Rmpfr package)
inv.vandermonde <- function(a)
{
    n <- length(a)
    B <- array(a - a, dim=c(n, n)) # zeros with the same accuracy
    B[1, ] <- 1
    num <- B[1, ]
    for (i in 1:n)
    {
        C <-  - a[i] * B
        C[2:n, ] <- C[2:n, ] + B[1:(n-1), ]
        B[, - i] <- C[, - i]
        p <- a - a[i]
        p[i] <- 1
        num <- num * p
    }
    B / array(rep(num, each=n), dim=c(n, n))
}
# -->
Adj=function(m) {
   # adjoint matrix (Conj + transp)
   return(Conj(t(m)))
}
solve_vander_t=function(v, b) {
   # solve transpose of square vandermonde
   # system (ones are on the first row) t(V(v))*x=b
   # defined by a vector v and rhs b.
   # b might be a matrix of multiple rhs.
   # algorithm of Bjork
   n=length(v)
   if (n==1) {
      return(b)
   }
   nm1=n-1
   b=as.matrix(b)
   for (k in 1:nm1) {
      for (i in n:(k+1)) {
         b[i,]=b[i,]-v[k]*b[i-1,]
      }
   }
   for (k in nm1:1) {
      for (i in (k+1):n) {
         b[i,]=b[i,]/(v[i]-v[i-k])
      }
      for (i in k:nm1) {
         b[i,]=b[i,]-b[i+1,]
      }
   }
   return(b)
}
gsum=function(z,n) {
   # calculate the sum of geometric series
   # 1+z+z^2+...+z^(n-1) (n terms)
   if (z==1) {
      return(n)
   }
   return((1-z^n)/(1-z))
}
eval_formula=function(f, l) {
   # evaluate an expression of rhs for formula f with values from a list l
   f=as.formula(f)
   return(with(l, eval(f[[length(f)]])))
}
# robust estimators
# weighted estimators are used
# weights are calculated with biquadratique function 1/(1+x^2)^2
biquadw=function(v, center=median(v), scale=mad(v,center=center,constant=3)){
   scale=max(scale, max(abs(v-center))/length(v), 1.e-14) # avoid div by 0
   v=(v-center)/scale
   v=1+v*v
   1./(v*v)
}
sigmaw=function(v, center=median(v), scale=mad(v,center)) {
   # weight function in sigmoid form. The sigmoid is obtained with pnorm()
   if (scale==0)
      scale=1
   v=abs(v-center)/scale
   pnorm(2*(v-2.), lower.tail=F)
}
rcov=function(m,...){
   # robust estimation of covariance matrix (covariance of columns)
   m=matrix(m,NROW(m))
   wt=apply(m,2,biquadw);	# weight per element
   wt=apply(wt,1,prod)**(1/NCOL(m));	# weight per row (individum)
   wt=wt/sum(wt)
   cov.wt(m,wt)
}
rz.pval.mono=function(x,...){
   # consider x as gausian sample, estimate its mean and sdev in robust way
   # and return p-values mono-tail.
   wt=biquadw(x,...)
   wt=wt/sum(wt)
   par=cov.wt(matrix(x, NROW(x)),wt)
   pnorm((x-par$center)/sqrt(par$cov), lower.tail=FALSE)
}
rz.pval.bi=function(x, fweight=sigmaw, ...){
   # consider x as gausian sample, estimate its mean and sdev in robust way
   # and return p-values bi-tail (NA is returned for NA in x)
   # treat only valid entries (skip NA)
   iva=!is.na(x)
   res=rep(NA, length(x))
   if (sum(iva) < 2) {
      return(res)
   }
   x=x[iva]
   wt=fweight(x,...)
   wt=wt/sum(wt)
   par=cov.wt(matrix(x, NROW(x)),wt)
   sd=sqrt(par$cov)
   if (sd==0.)
      sd=1.
   res[iva]=pnorm(abs(x-c(par$center))/c(sd), lower.tail=FALSE)*2
   attr(res, "robust_mean") = par$center
   attr(res, "robust_sd") = sd
   attr(res, "wt") = par$wt
   return(res)
}
z.pval.mono=function(x,...){
   # consider x as gausian sample, estimate its mean and sdev
   # and return p-values mono-tail.
   pnorm((x-mean(x))/sd(x), lower.tail=FALSE)
}
rmean_sd=function(x,...) {
   # estimate mean and sd in robust way
   wt=biquadw(x,...)
   wt=wt/sum(wt)
   p=cov.wt(matrix(x, NROW(x)),wt)
   return(list(m=p$center, sd=sqrt(p$cov)))
}
join=function(sep, v, ...) {
   # convert elements of vector v (and all following arguments)
   # in strings and join them using sep as separator.
   return(paste0(c(v,...), collapse=sep))
}
qr_ceq=function(a, b, ceq=NULL, deq=NULL) {
   # solve least square linear system ax=b with equality constrainsts cx=d
   # method: null space base is used to reduce the dimension
   # of original system x=n*y+x_p where x_p is particular solution
   # for cx_p=d
   if (is.null(ceq) || is.null(deq)) {
      # plain qr problem
      return(qr.solve(a, b))
   }
   #library(MASS)
   ns=Null(t(ceq))
   # particular solution of constraints
   x_p=qr.solve(ceq, deq)

   # reduced least square problem
   ar=a%*%ns
   br=b-a%*%x_p
   y=qr.solve(ar, br)
   xr=ns%*%y+x_p
   return(xr)
}
int2bit=function(i, len=31, onech="1", zch="0") {
   # return a string with a bit mask of an integer i
   mapply(function(i_, l_, o_, z_) paste0(int2bitv(i_, l_, o_, z_), collapse=""), i, len, onech, zch)
}
int2bitv=function(i, len=31, one="1", zero="0") {
   # return a vector where each bit in the integer i is replaced by one or zero values.
   # if one adn zero are not homogeneous in type, a list is returned instead of a vector.
   mask=bitwShiftL(1,(len-1):0)
   drop(sapply(i, function(ii) ifelse(bitwAnd(ii, mask)>0, one, zero)))
}
str2ind=match #function(qry, ref) {
   # find indexes of strings from qry in ref string vector
   # It can be usefull for retriving row/column indexes
   # from row/column names for a given set of names
   # return integer vector of indexes (NA if an entry is not in ref)
   #return(apply(as.matrix(qry), 1, function(s)which(ref==s)[1L]))
#}
which.first=function(lv) {
   # return the first index of logical lv vector
   # which is true
   return(head(which(lv),1))
}
which.last=function(lv) {
   # return the last index of logical lv vector
   # which is true
   return(tail(which(lv),1))
}
which.contrib=function(v, thre=0.95) {
   # return the indexes of v who's cumulated sum of squares is
   # over norm2(v)*thre
   v2=v*v
   o=order(v2, decreasing=T)
   cs=cumsum(v2[o])
   i=o[which(cs<=tail(cs,1)*thre)]
   if (length(i)==0) {
      return(head(o,1))
   } else {
      return(i)
   }
}

# custom operators
`%dot%`<-function(a,b)tcrossprod(a,t(b)) # a%dot%b===a%*%b sometimes more efficient than plain %*%
# you might want to set
#`%*%`<-`%dot%` # use rm(`%*%`) to turn back to the classic %*%
# test it for performance before any use in production

`%tmm%`<-function(a,b)crossprod(a,b) # a%tmm%b===t(a)%*%b
`%mmt%`<-function(a,b)tcrossprod(a,b) # a%mmt%b===a%*%t(b)
`%mrv%`<-function(m, v) {
   # multiply each row of m by a vector v term by term
   # length(v) must be == ncol(m)
   if (inherits(m, "simple_triplet_matrix")) {
      m$v=m$v*v[m$j]
      return(m)
   } else {
      return(m*rep(v, rep(nrow(m), length(v))))
   }
}
`%rep%`<-function(v, n) {
   # repeat vector v n times
   rep.int(v, n)
}
`%s+%`<-function(s1, s2) {
   # concatenate two strings by paste()
   paste(s1, s2, sep="")
}
`%s*%`<-function(s, n) {
   # repeat string s n times by paste() with collapse
   paste0(rep(s, n), collapse="")
}

Heaviside=function(x) {
   return(0.5+0.5*sign(x))
}

Nulla=function (M, rcond=1.e10) {
    # use Lapack for null space basis
    # derived from MASS::Null
    tmp <- qr(as.matrix(M), LAPACK=TRUE)
    d=abs(diag(tmp$qr))
    n=length(d)
#browser()
    if (d[1L]==0.) {
       tmp$rank = 0
    } else {
       tmp$rank = sum(d/d[1L] > 1./rcond)
    }
    set <- if (tmp$rank == 0L)
        1L:n
    else
        -(1L:tmp$rank)
    bn=qr.Q(tmp, complete = TRUE)[, set, drop = FALSE]
    attr(bn, "qr")=tmp
    return(bn)
}
jordan=function(a, rcond=1.e10) {
   # similar to eigen()
   # additional field is $jordan
   # which is a 2 column integer matrix of eigenvalue indexes relative to $values (first column)
   # and their jordan order (second column, 1 means no jordan block)
   # potential for optimization:
   #  - projections to eigen spaces

   # 2012-04-20 sokol: first version
   # 2013-09-12 sokol: jordan info to 2 column matrix

   a=as.matrix(a)
   n=nrow(a)
   stopifnot(n==ncol(a))
   if (n==1) {
      return(list(values=c(a), vectors=as.matrix(1.), jordan=t(c(1L, 1L))))
   }
   tol=1./rcond
   i=1:n
   ea=eigen(a)
   u=ea$vectors
   if (typeof(u)=="complex") {
      cu=Conj(u)%tmm%u
   } else {
      cu=crossprod(u)
   }
   # start with no jordan blocks, later if found, extra rows are deleted
   jordan=cbind(i, jorder=1L)

   # overdiagonal correlation==1 indicates jordan bloc of order > 1
   dve=which(abs(abs(cu[cbind(i[-n], i[-n]+1)])-1.)<=tol)
   if (length(dve)==0) {
   } else if (length(dve)==1) {
      jordan[dve,2L]=2
      jordan=jordan[-dve-1L,,drop=F] # delete extra row
      i=dve:(dve+1L)
      ea$values[i]=mean(ea$values[i])
   } else {
      # find left and right end of each linear interval in dve
      dd=diff(dve)
      le=c(dve[1L], dve[1L+which(dd!=1L)]) # startin rows
      ri=c(dve[which(dd!=1L)],tail(dve,1L)) # ending rows of the overdiag
      jordan[le,2L]=ri-le+2
      iextra=c()
      for (i in 1L:length(le)) {
         ii=le[i]:ri[i]
         iextra=c(iextra, ii)
         ii=c(ii, ri[i]+1)
         ea$values[ii]=mean(ea$values[ii]) # replace by mean close values
      }
      iextra=1L+iextra
      jordan=jordan[-iextra,,drop=F]
   }
   ea$jordan=jordan
   # get basis vectors for each block
   for (i in 1L:nrow(jordan)) {
      v=jordan[i,]
      if (v[2L] == 1) {
         # not jordan, skip it
         next
      }
      qa=qr(as.matrix(a)-diag(ea$values[v[1L]], n), LAPACK=T)
      # calculate u_j as solution of alam%*%u_j=u_(j-1)
      for (ii in v[1L]+(1L:(v[2L]-1L))) {
         #cat("i=", i, "\n")
         ev=ls_ln(qa, ea$vectors[,ii-1L])
         ea$vectors[,ii] = ev #/sqrt(norm2(ev))
      }
   }
   return(ea)
}
bjord=function(values, jordan) {
   # prepare jordan form with vector values on diagonal and 1 on over diagonal
   # where appropriate (indicated by last column in jordan, cf jordan())
   # For test: aj=jordan(a); a must be close to
   # aj$vectors%*%bjord(aj$values, aj$jordan)%*%solve(aj$vectors)
   res=diag(values, length(values))
   if (length(jordan) == 0) {
      return(res)
   }
   iover=which(jordan[,2L]>1)
   if (length(iover) == 0L) {
      return(res)
   }
   ile=jordan[iover,1L]
   iri=ile+jordan[iover,2L]-2L
   i=unlist(lapply(1L:length(iover), function(i) ile[i]:iri[i]))
   res[cbind(i, i+1L)]=1
   return(res)
}
expjord=function(values, jordan, t=1) {
   # calculate exponential of jordan form exp(J*t)
   # given by diagonal vector values and
   # a jordan structure (cf jordan())
   # time moments are in the vector t.

   # return a three dimensional array, first two dimensions
   # are for blocks and the third for time t.
   # 2012-04-21 sokol
   # 2013-09-12 sokol: jordan is passed to a 2 column matrix

   n=length(values)
   nt=length(t)
   # get maximal size of jordan block
   maxj=max(jordan[,2L])
   mj1=maxj-1L
   tv=vander(t, maxj)%mrv%(1./cumprod(c(1., iseq(mj1))))
   expvt=exp(values%o%t)
   res=vapply(1L:nt, function(iti) diag(expvt[,iti], n), numeric(n*n))
   if (maxj==1L) {
      # plain diagonal matrices
      return(array(res, dim=c(n, n, nt)))
   }
   # fill overdiagonals by t^i/i!: i=0 on diagonal, i=1 on first overdiagonal and so on
   # make index row-col for overdiag terms, one per ioff
   irc=list()
   for (ioff in iseq(mj1)) {
      ib=which(jordan[,2L]-ioff > 0)
      ile=jordan[ib,1L]
      iri=ile+(jordan[ib,2L]-ioff-1L)
      irc=append(irc, list(unlist(lapply(1L:length(ib), function(i) {
         (ile[i]:iri[i])*(n+1L)+(ioff-1L)*n
      }))))
   }
   for (ioff in iseq(mj1)) {
      for (iti in 1L:nt) {
         i=irc[[ioff]]
         res[i,iti]=tv[iti, ioff+1]
         # multiply by exp
         ie=(i-1)%%n+1
         res[i,iti]=res[i,iti]*expvt[ie,iti]
      }
   }
   if (nt==1) {
      dim(res)=c(n, n)
   } else {
      dim(res)=c(n, n, nt)
   }
   return(res)
}
expmj=function(a, t=1., x=NULL) {
   # calculate a series of exp(a*t) for multiple t
   # by using jordan canonical form
   # Optionally exp(a*t) is multiplied by a vector x.
   # Return a 3d array if x==NULL or a matrix
   # where each column correspond to a time moment t: exp(a*t)*x
   # 2012/04/22 sokol

   nt=length(t)
   aj=jordan(a)
   u=aj$vectors
   ej=expjord(aj$values, aj$jordan, t)
   if (is.null(x)) {
      uinv=solve(u)
      res=vapply(1:nt, function(iti) {
         c(u%*%ej[,,iti]%*%uinv)
      }, c(ej[,,1L]))
   } else {
      ux=solve(u, x)
      res=vapply(1:nt, function(iti) {
         c(u%*%(ej[,,iti]%*%ux))
      }, x)
   }
   if (nt==1) {
      res=matrix(res, nrow=nrow(a))
   } else {
      res=array(res, dim=dim(ej))
   }
   return(res)
}
cubic=function(x, x1, x2, y1, y2, k1, k2) {
   # return a matrix of cubic curves, time runs along columns
   t=(x-x1)/(x2-x1)
   a=k1*(x2-x1)-(y2-y1)
   b=-k2*(x2-x1)+(y2-y1)
   q=(1-t)%o%y1 + t%o%y2 + (t*(1.-t))*((1.-t)%o%a + t%o%b)
   return(q)
}
powmx=function(a, pow, x=NULL) {
   # power square matrix a**pow optionnaly multiplyed by a vector x
   # pow is rounded to an integer.
   # due to a binary decomposition of n, it can be less multiplications
   # than n.
    if (!is.null(x)) {
       ans=x
    } else {
       ans="identity"
    }
    pow=round(pow)
    if (pow==0L) {
       if (ans[1L]=="identity") {
          return(diag(nrow(a)))
       }
       return(ans)
    } else if (pow < 0L) {
       a=solve(a)
       pow=-pow
    }
    mmcount=0
    while (pow > 0L) {
        if (pow%%2L) {
           if (ans[1L]=="identity") {
              ans=a
           } else {
              ans=a%*%ans
              mmcount=mmcount+1L
           }
        }
        pow=pow%/%2L
        if (pow > 0L) {
           a=a%*%a
           mmcount=mmcount+1L
        }
    }
    #cat("mmcount=", mmcount, "\n", sep="")
    return(ans)
}
is.diff=function(v1, v2, tol=1.e-7) {
   # test if two numerical vectors of the same length (not checked here)
   # are different. NA are silently omitted.
   # return TRUE if max(abs(v1-v2)) > tol
   # If any of v1 or v2 is NULL, TRUE is returned
   if (is.null(v1) || is.null(v2)) {
      return(TRUE)
   }
   return(max(abs(v1-v2), na.rm=T) > tol)
}
iseq=function(n) {
   # positive sequence of integer numbers 1:n
   # if n=0 then integer(0) is returned
   seq.int(from=1L, to=n, length=pos(n))
}
erf=function(x) 2.*pnorm(x*sqrt(2.))-1.
erfc=function(x) 1.-erf(x)

`%stw%`=function(a, b) {
   # check if the string(s) a starts with the string(s) b
   substr(a, 1L, nchar(b))==b
}
memuse=function(...) {
   # Return a vector of used memory in bytes for each object returned by ls(...)
   # in the calling frame
   # The vector is named by object names. The "..." is passed through to ls()
   env=parent.frame()
   sapply(ls(env=env, ...), function(nam) object.size(get(nam, env=env)))
}
conf=function(x, f) {
   # convolves a signal x with a filter f
   # return a vector of the same length as x
   convolve(x, rev(f), t="o")[length(f)/2+iseq(length(x))]
}
funique=function(x, tol=1.e-7) {
   # like unique() but on float numbers which are considered the same
   # if their abs diff is less or equal to tol
   n=length(x)
   inx=iseq(n)
   # find same numbers (only lower tirangle is accounted)
   #a=abs(outer(x, x, `-`))<=tol
   a=abs(rep(x, each=n) - x)<=tol
   b=outer(inx, inx, `>=`)
   dim(a)=dim(b)
   same=a & b
   # a unique index
   iu=unique(apply(same, 2, function(v) max(which(v))))
   # how many times repeated
   #rep=rowSums(same)
   return(x[iu])
}
adot=function(a1, a2, d1=NULL, d2=NULL) {
   # dot product for two arrays a1 and a2 over
   # dimensions d1 and d2 respectively.
   # If not given, d1 and d2 are take to be
   # the last and first indexes respectively.
   # For example, a classical matrix dot product
   # would result in a call adot(m1, m2, 2, 1) or
   # shorter adot(m1, m2)

   # Method: a1 and a2 are permuted to make d1 the last and d2 the
   # first index in the array, then arrays are reshaped to matrices
   # to use a classical dot product then the result is reshaped
   # back to a due array.

   dim1=dim(a1)
   nd1=length(dim1)
   dim2=dim(a2)
   if (is.null(dim2)) {
      dim2=c(length(a2), 1L)
   }
   nd2=length(dim2)
   if (is.null(d1)) {
      d1=nd1
   }
   if (is.null(d2)) {
      d2=1L
   }
   stopifnot(dim1[d1] == dim2[d2])
   # permute a1 to make d1 the last index
   if (d1 != nd1 && d1 != 1L) {
      a1=aperm(a1, c((1L:nd1)[-d1],d1))
   }
   a1t=d1==1L
   a2t=F
   if (! a1t) {
      a2t=d2==nd2
   }
   # permute a2 to make d2 the first index
   if (d2 != 1L && !a2t) {
      a2=aperm(a2, c(d2, (1L:nd2)[-d2]))
   }
   # reshape
   if (a1t) {
      # keep running dimension at first place
      dim(a1)=c(dim1[d1], prod(dim1[-d1]))
   } else {
      dim(a1)=c(prod(dim1[-d1]), dim1[d1])
   }
   if (a2t) {
      # keep running dimension at last place
      dim(a2)=c(prod(dim2[-d2]), dim2[d2])
   } else {
      dim(a2)=c(dim2[d2], prod(dim2[-d2]))
   }
   # dot product
   if (a1t) {
      res=a1%tmm%a2
   } else if (a2t) {
      res=a1%mmt%a2
   } else {
      if (dim1[2L]==1L) {
         res=c(a1)*rep(a2, each=dim1[1L])
      } else {
         res=a1%*%a2
      }
   }
   # back-reshape
   #res=as.array(res)
   dim(res)=c(dim1[-d1], dim2[-d2])
   return(res)
}
floatmatch=function(x, table, tol=1.e-7) {
   # like match() but works on floating numbers considered as matching
   # if their abs diff is less or equal to tol
   # unmatched values have NA in their corresponding positions
   di=abs(outer(as.double(x), as.double(table), "-")) <= tol
   #dim(di)=c(length(x), length(table))
   res=vapply(1:nrow(di), function(i) which(di[i,])[1L], 1L)
   return(res)
}
extrem_parab=function(x, y) {
   # find the extremum point of a quadratic parabola
   # defined by three distinct points (length(x)==length(y)==3)
   # Return a three component vector named x, y and d2
   # The "d2" component is set to the second derivative,
   # which helps to know if it's a minimum or maximum.
   # In the case of a straight line, d2 is set to 0 and x=y=NA
   # To get the value of this parabola in any point xa from the retrived
   # vector res, one can do
   # res["y"]+0.5*res["d2"]*(xa-res["x"])**2
   # test: extrem_parab(1:3, (1:3)**2) must return c(0, 0, 2)

   stopifnot(length(x)==length(y))
   stopifnot(length(x)==3L)
   dx=diff(x)
   dy=diff(y)
   d=dy/dx
   if (d[1L]==d[2L]) {
      # it's a straight line :(
      res=c(x=NA, y=NA, d2=0.)
      return(res)
   }

   # diff of middles of the intervals
   dxmid=mean(dx)

   # second finite difference
   d2=diff(d)/dxmid
   type=if (d2 > 0.) "min" else "max" # d2==0 is already treated
   xmid=mean(x[1L:2L])
   xe=xmid-d[1L]/d2 # this is the "x"
   # find the first derivative at x1
   dy1=d[1]-d2*dx[1]*0.5
   dxe=xe-x[1]
   ye=y[1]+dy1*dxe+0.5*d2*dxe*dxe
   return(c(x=xe, y=ye, d2=d2))
}
vars2list=function(nm_vars) {
   # Put variables whose names are in the vector nm_vars as items of
   # the returned list.
   stopifnot(is.character(nm_vars))
   res=list()
   for (nm in nm_vars) {
      res[[nm]]=get(nm, env=parent.frame())
   }
   return(res)
}
list2vars=function(li) {
   # Set variables in the calling frame from the items of named list li
   # Return NULL
   stopifnot(is.list(li))
   for (nm in names(li)) {
      assign(nm, li[[nm]], env=parent.frame())
   }
   return(NULL)
}
stop_mes=function(..., file=stderr()) {
   # print the error message mes to the error file (by default stderr)
   # and exit with status 1 without environement saving
   # If the session is intercative and the file is not stderr,
   # the message is duplicated on the screen via stop(mes)
   cat(..., "\n", sep="", file=file)
   if (isatty(stdin()) && file!=stderr()) {
      stop(..., call.=FALSE)
   }
   if (!isatty(stdin())) {
      q("no", status=1)
   }
}
lusolve=function(lua, b, perm=NULL) {
   # solve a normal system a*x=b when lu(a) is already available.
   # b may be a matrix.
   # Return the solution x.
   db=dim(b)
   b=as.matrix(b)
   class(b)="double"
   clua=class(lua)
   if (clua=="sparseLU") {
      # sparse LU is detected
      x=backsolve(lua@U, forwardsolve(lua@L, b[lua@p+1L,,drop=F]))
      x[lua@q+1L,]=x
   } else if (clua=="denseLU") {
      # dense LU here, use lapack
      if (!is.loaded("dgetrs")) {
         lapack.path <- file.path(R.home(), ifelse(.Platform$OS.type == "windows",
            file.path("bin", .Platform$r_arch, "Rlapack"), file.path("lib", "libRlapack")))
         dyn.load(paste(lapack.path,.Platform$dynlib.ext, sep=""))
      }
      n=nrow(b)
      info=-1L
      trans="N"
      res=.Fortran("dgetrs", trans, n, ncol(b), lua@x, n, lua@perm, b, n, info)
      x=res[[7L]]
   } else if (clua=="magmaLU") {
      #cat("magmaLU\n")
      x=magma::solve(lua, b)
   } else if (clua=="matrix" || clua=="numeric") {
      # dense plain matrix
      # pivot is supposed to be given. if null => plain 1,2,3,...
      lua=as.matrix(lua)
      if (is.null(perm)) {
         perm=seq_len(ncol(lua))
      }
      if (!is.loaded("dgetrs")) {
         lapack.path <- file.path(R.home(), ifelse(.Platform$OS.type == "windows",
            file.path("bin", .Platform$r_arch, "Rlapack"), file.path("lib", "libRlapack")))
         dyn.load(paste(lapack.path,.Platform$dynlib.ext, sep=""))
      }
      n=nrow(b)
      info=-1L
      trans="N"
      res=.Fortran("dgetrs", trans, n, ncol(b), lua, n, perm, b, n, info)
      x=res[[7L]]
   } else {
      stop(sprintf("Expected an object of class 'sparseLU', 'denseLU' or 'magmaLU'. Instead, got a '%s' class.", class(lua)))
   }
   dim(x)=db
   return(x)
}
imat2iv=function(imat, dim) {
   # translate matrix indeces to a flat vector ones
   # e.g. if imat is a two column matrix, its first column is supposed
   # to be row numbers and the second one the column numbers.
   # the results will be a vector of indeces pointing to the same
   # matrix elements as imat but treating mat as a flat vector
   # (column wise stored as usual in R)
   # length(dim) must be equal to ncol(imat)
   # dim is a vector of dimension in a matrix to which imat is supposed
   # point to.
   # Return a vector iv with length(iv)=nrow(imat)
   # NB If dim(imat) is not set, i.e. it is a plain vector,
   # it is returned as is.
   # If dim(imat) is set, it's length must equal 2, i.e. imat must be
   # a matrix, not nD array. if the matrix imat has n columns, its elements
   # are pointing to a nD array.

   stopifnot(ncol(imat)==length(dim))
   if (is.null(dim(imat))) {
      return(imat)
   }
   stopifnot(length(dim(imat))==2L)
   imat[,-1L]=imat[,-1L]-1L
   iv=rowSums(imat%mrv%c(1L, cumprod(dim[-length(dim)])))
   return(iv)
}
dgemm=function(a, b, transa=F, transb=F, alpha=1., beta=0., c=matrix(0., ifelse(transa, ncol(a), nrow(a)), ifelse(transb, nrow(b), ncol(b)))) {
   if (!is.loaded("dgemm")) {
      lapack.path <- file.path(R.home(), ifelse(.Platform$OS.type == "windows",
         file.path("bin", "Rlapack"), file.path("lib", "libRlapack")))
      #dyn.load(paste(lapack.path,.Platform$dynlib.ext, sep=""))
      #dyn.load("/opt/intel/mkl/lib/intel64/libmkl_gf_ilp64.so")
      #dyn.load("/opt/intel/mkl/lib/intel64/libmkl_gnu_thread.so")
      #dyn.load("/opt/intel/mkl/lib/intel64/libmkl_core.so")
      #dyn.load("/usr/local/src/xianyi-OpenBLAS-9c51cdf/libopenblas.so")
      #dyn.load("/opt/OpenBLAS/lib/libopenblas.so")
      #dyn.load("/usr/lib64/atlas/libf77blas.so")
      #dyn.load("/usr/local/atlas/lib64/libsatlas.so")
      #dyn.load("/usr/local/src/ATLAS-3.11.22/build/lib/libsatlas.so")
      #dyn.load("/usr/local/atlas/lib64/libf77blas.so")
      #dyn.load("/usr/local/src/ATLAS-3.10.2/build/lib/libsatlas.so")
      dyn.load("/usr/local/src/ATLAS-3.11.39/build/lib/libsatlas.so")
   }
   m=ifelse(transa, ncol(a), nrow(a))
   n=ifelse(transb, nrow(b), ncol(b))
   k=ifelse(transa, nrow(a), ncol(a))
   res=.Fortran("dgemm", ifelse(transa, "T", "N"), ifelse(transb, "T", "N"), m, n, k, as.double(alpha), as.double(a), nrow(a), as.double(b), nrow(b), as.double(beta), as.double(c), nrow(c))
   c=res[[12L]]
   dim(c)=c(m, n)
   #dimnames(c)=list(if (transa) colnames(a) else rownames(a), if (transb) rownames(b) else colnames(b))
   return(c)
}
ci.plot=function(x, y=NULL, ylow=NULL, yup=NULL, length=0.1, ...) {
   # error bars
   if (missing(yup)) {
      yup=ylow
      ylow=y
      y=x
      x=seq_len(length(y))
   }
   if (!is.null(yup))
      arrows(x, y, x, yup, angle=90, code=2, length=length, ...)
   if (!is.null(ylow))
      arrows(x, y, x, ylow, angle=90, code=2, length=length, ...)
}
trimws=function(s, side=c("both", "left", "right")) {
#' trim white spaces
#'
#' use base::sub() to trim white spaces so the attributes are preserved
#'
#' @param s character vector
#' @param side character one of 'left', 'right' or 'both' (default)
#'
#' @return trimmed character vector
   side=match.arg(side)
   le="^\\s+"
   ri="\\s+$"
   return(switch(side, "left"=sub(le, "", s), "right"=sub(ri, "", s), "both"=sub(le, "", sub(ri, "", s))))
}
image.simple_triplet_matrix=function(m, ...) {
   nm=deparse(substitute(m))
   layout(matrix(c(1,1,1, 3, 2, 3), ncol=2), widths=c(8,1), height=c(1,3,1))
   op=par(mar=c(0, 1, 1, 1), oma=c(4, 1, 4, 1.5), las=1)
   plot(x=c(1, m$ncol), y=c(m$nrow, 1),
      xlab="columns", ylab="rows",
      xlim=c(1, m$ncol), ylim=c(m$nrow, 1),
      asp=1, main=sprintf("%s %dx%d", nm, m$nrow, m$ncol),
      axes=FALSE,
      type="n", ...)
   axis(1, at=seq(m$ncol))
   axis(2, at=seq(m$nrow))
   polygon(x=c(.9, .9, m$ncol+.1, m$ncol+.1), y=c(.9, m$nrow+.1, m$nrow+.1, .9))
   colr <- rainbow(100, start=4/6, end=0)
   z=cut(m$v, 100, label=FALSE)
   points(x=m$j, y=m$i, pch=15, col=colr[z], ...)
   image(1, seq(min(m$v), max(m$v), length.out=100), t(seq(min(m$v), max(m$v), length.out=100)),
      xlab="", ylab="", col=colr, axes=FALSE)
   axis(4)
   par(op)
}
stm2sparse=function(m, ...) {
#' convert slam::simple_triplet_matrix to Matrix class
#'
#' Additional parameters '...' are passed to sparseMatrix() call (c.f. e.g. giveCsparse=TRUE param)
   return(Matrix::sparseMatrix(i=m$i, j=m$j, x=m$v, dims=c(m$nrow, m$ncol), dimnames=m$dimnames, ...))
}
sparse2stm=function(m) {
   #' convert Matrix:ccs format to simple triplet matrix (slam)
   #' 
   return(slam::simple_triplet_matrix(m@i+1L, rep.int(seq_len(ncol(m)), diff(m@p)), m@x, nrow(m), ncol(m), dimnames(m)))
}
ccs2sparse=function(m, ...) {
#' convert ccs ad hoc class to Matrix class
#'
#' Additional parameters '...' are passed to sparseMatrix() call (c.f. e.g. giveCsparse=TRUE param)
   return(Matrix::sparseMatrix(i=m$i, p=m$p, x=m$x, index1=FALSE, dims=c(m$nrow, m$ncol), dimnames=m$dimnames, ...))
}

stm2ccs=function(a) {
   #' convert slam::simple_triplet_matrix a to a list having components i, p, x corresponding to ccs format. 
   #'
   #' Result will contain also the fields nrow, ncol, dimnames heritated from m. Note that entries i and p are 0-based.
   #' Repeated entries (same (i,j) will remain repeated in ccs format.
   m=a$nrow
   n=a$ncol
   # sort in column-major order
   o=order(a$i+a$j*m)
   p=tapply(rep(1L, length(a$j)), a$j[o], sum)[as.character(seq_len(n))]
   p[is.na(p)]=0L
   return(list(i=a$i[o]-1, p=as.integer(c(0L, cumsum(p))), x=a$v[o], nrow=m, ncol=n, dimnames=a$dimnames))
}
is_alpha=function(ch) {
   #' test if ch is an alpha character. If nchar(ch) > 1 then only the first char is tested
   return(length(grep("[:alpha:]", as.character(ch)[1L])) > 0L)
}
is_abspath=function(p) {
   #' test if a file path is absolute one or not
   if (is.null(p) || is.na(p))
      return(FALSE)
   return(startsWith(p, "/") || (is_alpha(substr(p, 1L, 1L)) && (startsWith(substr(p, 2, nchar(p)), ":/") || startsWith(substr(p, 2, nchar(p)), ":\\"))))
}

mat2ccs=function(a, tol=.Machine$double.eps*64) {
   #' convert dense matrix a into ccs format with entries i, p, x, nrow, ncol, dimnames'
   
   a=as.matrix(a)
   inz=abs(a) > tol
   i=row(a)[inz]-1L
   p=c(0L, cumsum(colSums(inz)))
   return(list(i=row(a)[inz]-1L, p=c(0L, cumsum(colSums(inz))), x=a[inz], nrow=nrow(a), ncol=ncol(a), dimnames=dimnames(a)))
}
sort.simple_triplet_matrix=function(a) {
   o=order(a$i+a$j*a$nrow)
   a$i=a$i[o]
   a$j=a$j[o]
   a$v=a$v[o]
   a
}
as.function.character=function(x, envir=parent.frame()) match.fun(x)
as.function.name=function(x, envir=parent.frame()) match.fun(x)
as.function.formula=function(f, envir=parent.frame()) {
   f=as.formula(f)
   switch(length(f),
      stop("Invalid formula"),
      {
         rhs=f[[2]]
         arg=all.vars(rhs)
      },
      {
         rhs=f[[3]]
         arg=if (is.character(f[[2]])) strsplit(f[[2]], ",", fixed=TRUE)[[1]] else all.vars(f[[2]])
      }
   )
   arg=if (length(arg)) eval(parse(text=paste0("alist(", paste0(paste0(arg, "="),collapse=", "), ")"))) else alist()
   as.function(c(arg, rhs), envir=envir)
}
as.function.call=function(f, envir=parent.frame()) {
   f=as.call(f)
   switch(as.character(f[[1]]),
      "~"=return(as.function(as.formula(f), envir)),
      "expression"=return(as.function(f[[2L]], envir)),
      "quote"=return(as.function(f[[2L]], envir)),
      "as.function"=return(eval(f, envir))
   )
   arg=all.vars(f)
   arg=if (length(arg)) eval(parse(text=paste0("alist(", paste0(paste0(arg, "="),collapse=", "), ")"))) else alist()
   as.function(c(arg, f), envir=envir)
}
as.function.expression=function(f, envir=parent.frame()) {
   f=as.expression(f)
   as.function(f[[1L]])
}
wrap_fun=function(app, envir=parent.frame()) {
   fn=substitute(app)
   nm=deparse(fn)
   stopifnot(is.name(fn))
   la=args(app)
   li=as.list(la)
   li[[length(li)]]=bquote({mc=match.call(.(fn)); mc[[1]]=as.name(.(nm)); if ("FUN" %in% names(mc)) mc[["FUN"]]=as.function(mc[["FUN"]], .(envir)); eval(mc, .(envir))})
   #print(envir)
   as.function(li, envir=envir)
}
sliderfn=function(param, minp=0, maxp=1, delta=1, fn=function(x) x, ...) {
   nm_p=names(param)
   nb_p=length(param)
   ld=list(...)
   rep0=double(nb_p)
   minp=minp+rep0
   maxp=maxp+rep0
   delta=delta+rep0
   if (is.null(nm_p)) {
      nm_p=paste("p", seq_len(nb_p), sep="")
   }
   refresh.code<-function(...){
      p=sapply(seq_len(nb_p), function(i) aplpack::slider(no=i))
      do.call(fn, c(list(p), ld))
   }
   library(tcltk)
   aplpack::slider(refresh.code, sl.names=nm_p, sl.mins=minp, sl.maxs=maxp, sl.deltas=delta, sl.defaults=param, prompt=TRUE)
   fn(param, ...)
}
trim=function(x, trim=0., na.rm=FALSE) {
   # extracted from base::mean.default()
   if (na.rm) 
        x <- x[!is.na(x)]
   n <- length(x)
   if (trim > 0 && n) {
        if (is.complex(x)) 
            stop("trimmed means are not defined for complex data")
        if (anyNA(x)) 
            return(NA_real_)
        if (trim >= 0.5) 
            return(stats::median(x, na.rm = FALSE))
        lo <- floor(n * trim) + 1
        hi <- n + 1 - lo
        x <- sort.int(x, partial = unique(c(lo, hi)))[lo:hi]
    }
    x
}
natorder=function(s, ...) {
   # natural ordering: 1,2,11 (not 1,11,2)
   # ... are passed to order()
   if (length(s) == 0L)
      return(integer(0))
   # split to have numbers (vn) and not numbers (vs) form a list then order
   vn=strsplit(s, "[^0-9]+")
   vs=strsplit(s, "[0-9]+")
   len=max(lengths(vn))
   if (len == 0L)
      return(order(s, ...))
   vn=t(sapply(vn, function(v) c(v, rep.int("", len-length(v)))))
   storage.mode(vn)="integer"
   vn[is.na(vn)]=-1L
   dim(vn)=c(length(vn)/len, len)
   lens=max(lengths(vs))
   vs=t(sapply(vs, function(v) c(v, rep.int("", lens-length(v)))))
   dim(vs)=c(length(vs)/lens, lens)
   # interleave vs and vn
   vi=c()
   for (i in seq_len(max(len ,lens))) {
      if (i <= lens)
         vi=c(vi, list(vs[,i]))
      if (i <= len)
         vi=c(vi, list(vn[,i]))
   }
   return(do.call(base::order, c(vi, ...)))
}
natsort=function(s, ...) {
   s[natorder(s, ...)]
}
vgrep=base::Vectorize(base::grep, "pattern")
strsplitlim=function(..., lim=0L, strict=FALSE, mat=FALSE) {
   # strsplit() with limit number of items in output vector
   # if lim <= 0, no limit is applied for strict==FALSE && mat==FALSE
   # if lim is NA, the limit is set to the maximal found length
   # strict=TRUE for lim > 0 means that the results will have exactly 'lim' columns
   # if mat=TRUE and lim is applied, then the result is returned as matrix with lim columns
   # Note that mat=TRUE implies strict=TRUE
   res=base::strsplit(...)
   call=as.list(match.call(definition=args(base::strsplit), call=as.call(list("strsplit", ...))))
   res[nchar(call$x) == 0L] = ""
   if (length(res) == 0L)
      return(if (strict || mat) {
         if (!is.na(lim)) matrix("", 0L, lim) else matrix("", 0L, 0L)
      } else {
         res
      })
   if (is.na(lim) || (mat && lim == 0L))
      lim=max(lengths(res))
   lim=as.integer(lim)
   if (lim > 0L) {
      sep=call$split
      i=seq_len(lim-1L)
      if (strict || mat) {
         res=lapply(res, function(v) {n=length(v); if (lim < n) c(v[i], paste0(v[-i], collapse=sep)) else c(v, rep("", lim-n))})
      } else {
         res=lapply(res, function(v) if (lim < length(v)) v=c(v[i], paste0(v[-i], collapse=sep)) else v)
      }
      if (mat)
         res=matrix(unlist(res), ncol=lim, byrow=TRUE)
   } else {
      if (mat)
         res=matrix(unlist(res), ncol=, byrow=TRUE)
   }
   res
}
clamp=function(x, low, high) {
   stopifnot(low <= high)
   x[x < low]=low
   x[x > high]=high
   x
}
#' multiple assignments
#'
#' .(a,b) %m=% 1:2 <=> a <- 1; b <- 2
#' .(a,b,) %m=% 1:10 <=> a <- 1; b <- 2; the rest (i.e. 3:10) is ignored
#' .(a,,b) %m=% 1:3 <=> a <- 1; b <- 3; "2" is skipped
#' .(a,b) %m=% 1:3 => error, not enough symbols on lhs
#' .(a,b) %m=% 1 => error, too many symbols on lhs
`%m=%`=function(lhs, rhs, envir=parent.frame()) {
   nm_lhs=as.list(substitute(lhs))[-(1L)]
   stopifnot(all(sapply(nm_lhs, is.symbol)))
   nm_lhs=as.character(nm_lhs)
   #print(nm_lhs)
   if (nchar(tail(nm_lhs, 1L)) == 0L)
      stopifnot(length(nm_lhs) <= length(rhs))
   else
      stopifnot(length(nm_lhs) == length(rhs))
   lapply(seq_along(nm_lhs), function(i) {nm=nm_lhs[[i]]; if (nchar(nm)) assign(nm, rhs[[i]], envir=envir)})
   invisible(NULL)
}
s2i=function(v, na.rm=TRUE) {v=setNames(suppressWarnings(as.integer(v)), names(v)); if (na.rm) na.omit(v) else v}
s2d=function(v, na.rm=TRUE) {v=setNames(suppressWarnings(as.double(v)), names(v)); if (na.rm) na.omit(v) else v}
#' vectorized form of endsWith
endsWithv=function(x, suffix)
   as.logical(rowSums(vapply(suffix, endsWith, logical(length(x)), x=x)))
#' vectorized form of startsWith
startsWithv=function(x, prefix)
   as.logical(rowSums(vapply(prefix, startsWith, logical(length(x)), x=x)))

#' vectorize cbind() on the second argument. nrow(res)=nrow(v1)*nrow(v2)
cbindv2=function(v1, v2) cbind(rep(v1, length(v2)), rep(v2, each=length(v1)))
#' lapply running on pairs (name, item) on named lists or vectors
n_lapply=function(X, FUN, ...) {
   nm=names(X)
   lapply(setNames(seq_along(X), nm), function(i) do.call(FUN, list(nm[i], X[[i]], ...)))
}
#' lapply running on pairs (index, item) on lists or vectors
i_lapply=function(X, FUN, ...)
   lapply(setNames(seq_along(X), names(X)), function(i) do.call(FUN, list(i, X[[i]], ...)))
#' write time info
top_chrono=function(what, fileout=stdout(), fmt="%-9s: ", doit=mget("TIMEIT", envir=parent.frame(), ifnotfound=FALSE)$TIMEIT)
   if (doit)
      cat(sprintf(fmt, what), format(Sys.time()), " cpu=", proc.time()[1L], "\n", sep="", file=fileout)
#' diagonal bind of matrices. The result is slam::simple_triplet_matrix
dbind=function(...) {
   lima=list(...)
   if (length(lima) == 0L)
      return(NULL)
   nr=sapply(lima, NROW)
   nc=sapply(lima, NCOL)
   cnr=c(0L, cumsum(nr))
   cnc=c(0L, cumsum(nc))
   nmc=lapply(lima, colnames)
   nmr=lapply(lima, function(m) if (is.null(dim(m))) names(m) else rownames(m))
   if (any(lengths(nmr)))
      nmr=i_lapply(nmr, function(i,v) if (length(v) == 0L) rep("", nr[i]) else v)
   if (any(lengths(nmc)))
      nmc=i_lapply(nmc, function(i,v) if (length(v) == 0L) rep("", nc[i]) else v)
   nmr=Reduce(c, nmr)
   nmc=Reduce(c, nmc)
   res=slam::simple_triplet_zero_matrix(tail(cnr, 1L), tail(cnc, 1L))
   for (ima in seq_along(lima)) {
      if (nr[ima] == 0L || nc[ima] == 0L)
         next
      ir=cnr[ima]+seq(nr[ima])
      ic=cnc[ima]+seq(nc[ima])
      res[ir,ic]=lima[[ima]]
   }
   dimnames(res)=list(nmr, nmc)
   res
}

# 2011-03-06 sokol
# function to manipulate kvh format
obj2kvh=function(obj, objname, conct=stdout(), indent=0) {
   # write in kvh file an R object: scala, vector, matrix and list.
   # other objects are written as an output string of toString() function
   # conct is a connection opened for writing;
   # indent is tab offset for object name;
   #
   # Exemple of use:
   # m=matrix(1:6,2,3);
   # fcn=file("m.kvh", "w");
   # obj2kvh(m, "m", fcn);
   # close(fcn);
   # To add a content to existent file use "a" as open mode
   # fcn=file("m.kvh", "a");
   cls=class(obj);
   indent=max(indent,0);
   open_here=F
   if (class(conct)[1]=="character") {
      # open a file for writing if non existent yet otherwise raise an error
      if (file.exists(conct)) {
         stop(sprintf("Cannot write to existent file '%s'. To overwrite it, open a connection in 'w' or 'wb' mode.", conct))
      }
      conct=file(conct, "wb")
      open_here=T
   }
   if (is.vector(obj) && !is.list(obj) && (length(obj)==1 && is.null(names(obj)))) {
      # unnamed scalar
      cat(rep("\t", indent, sep=""), sep="", file=conct);
      cat(c(esc_kvh_k(objname), "\t", obj, "\n"), sep="", file=conct);
   } else if (cls=="matrix" || substring(cls, nchar(cls)-5)=="Matrix") {
      # matrix name
      cat(rep("\t", indent, sep=""), sep="", file=conct);
      cat(c(esc_kvh_k(objname), "\n"), sep="", file=conct);
      # place for row names
      cat(rep("\t", indent+1, sep=""), sep="", file=conct);
      cat("row_col\t", sep="", file=conct);
      # column names if any else column numbers
      if (dim(obj)[[2]] > 0) {
         if (length(dimnames(obj)[[2]])==dim(obj)[[2]]) {
            cat(dimnames(obj)[[2]], sep="\t", file=conct);
         } else {
            cat(paste("V", 1:dim(obj)[[2]], sep=""), sep="\t", file=conct);
         }
      }
      cat("\n", file=conct);
      # row name followed by the row values
      if (dim(obj)[[1]] > 0) {
         if (length(dimnames(obj)[[1]])==dim(obj)[[1]]) {
            rownms=dimnames(obj)[[1]];
         } else {
            rownms=1:dim(obj)[[1]];
         }
         for (i in 1:dim(obj)[[1]]) {
            cat(rep("\t", indent+1), sep="", file=conct);
            cat(c(rownms[i], obj[i,]), sep="\t", file=conct);
            cat("\n", file=conct);
         }
      }
   } else if (is.vector(obj) && !is.list(obj) && NROW(obj) >= 1) {
      # vector
      cat(rep("\t", indent, sep=""), sep="", file=conct);
      cat(esc_kvh_k(objname), file=conct);
      cat("\n", file=conct);
      # row name followed by the row values
      if (length(names(obj))==NROW(obj)) {
         rownms=names(obj);
      } else {
         rownms=1:NROW(obj);
      }
      for (i in 1:NROW(obj)) {
         cat(rep("\t", indent+1), sep="", file=conct);
         cat(c(rownms[i], esc_kvh_v(obj[i])), sep="\t", file=conct);
         cat("\n", file=conct);
      }
   } else if (is.list(obj)) {
      # list => recursive call if the list is not empty
      cat(rep("\t", indent, sep=""), sep="", file=conct);
      cat(esc_kvh_k(objname), file=conct);
      if (length(obj) > 0) {
         cat("\n", file=conct);
         # row name followed by the row values
         if (length(names(obj))==length(obj)) {
            rownms=names(obj);
         } else {
            rownms=1:length(obj);
         }
         for (i in 1:length(obj)) {
            obj2kvh(obj[[i]], rownms[i], conct, indent+1);
         }
      } else {
         cat("\t\n", file=conct);
      }
   } else if (length(obj)==1 && (class(obj) == "numeric" ||
         class(obj) == "character")) {
      # scalar value
      cat(rep("\t", indent, sep=""), sep="", file=conct);
      cat(c(esc_kvh_k(objname), esc_kvh_v(format(obj[[1]]))), sep="\t", file=conct);
      cat("\n", file=conct);
   } else {
      # unlnown type, write its string value
      cat(rep("\t", indent, sep=""), sep="", file=conct);
      cat(c(esc_kvh_k(objname), esc_kvh_v(format(obj))), sep="\t", file=conct);
      cat("\n", file=conct);
   }
   if (open_here) {
      close(conct)
   }
   return(NULL)
}
esc_kvh_k=function(s) {
   return(gsub("([\t\\\n])", "\\\\\\1", s));
}
esc_kvh_v=function(s) {
   return(gsub("([\\\n])", "\\\\\\1", s));
}
kvh2list=function(fp, lev=0, indent=0) {
#   Read a kvh file from fp stream descriptor
#   and organize its content in a named nested list
#   list(k1=v1, k2=list(k2.1=v2.1))
#   If at some level the first key is row_col
#   then a matrix with names row and columns is tried
#   to be read.
#   If fp is a string, it is used in open() operator
#   for binary reading
# NB: repeted key names in the same hierarchical scope will be
# silently overwritten. So only the last key=value pair will be returned
# NB: all content is of character type.


   # check the stream
   open_here=FALSE;
   if (is.character(fp)) {
      #cat(paste("open ", fp), "\n");
      oldloc=Sys.getlocale("LC_CTYPE");
      Sys.setlocale("LC_CTYPE", "en_US")
      fp=file(fp, "rb");
      seek(fp, 0);
      open_here=TRUE;
   }
   # error control
   if (lev < 0 || indent < 0) {
      stop(sprintf("lev=%d, indent=%d both must be positive", lev, indent));
   }
   if (lev < indent) {
      stop(sprintf("lev=%d, indent=%d, lev must be greater or equal to indent", lev, indent));
   }
#    don't know an equivalent of tell() in R :(
#    if lev > fp.tell():
#        raise NameError("lev=%d, file position=%d, lev must be less or equal to file position"%(lev[0], fp.tell()));
#    if indent[0] > fp.tell():
#        raise NameError("indent=%d, file position=%d, indent must be less or equal to file position"%(indent[0], fp.tell()));
   # algorithm:
   # advance to requested indent (=level)
   # if not sucsessful return an empty list
   # read a key 
   # if sep==\t read value
   # elif sep=\n
   #     recursive call
   #     if no result at the level+1 put empty value
   # else put empty value
   tlist=list();
   key="";
   val="";
   while (TRUE) {
      # make current position to point to the begining of a key
      # so go through an appropriate tab number for the current level
      while (indent < lev) {
         # set file pointer to the requested indentation
         char=readChar(fp, 1);
         if (length(char) && char!="\t") {
            if (length(char) && nchar(char)==1) {
                seek(fp,-1,origin="current");
            }
            break;
         } else if (length(char) == 0) {
            break;
         }
         indent=indent+1;
      }
      if (indent < lev) {
         # we could not read till the requested level
         # so the current level is finished;
         if (open_here) {
            Sys.setlocale("LC_CTYPE", oldloc);
            close(fp);
         }
         return(list(kvh=tlist, indent=indent));
      }
      ksv=kvh_read_keyval(fp);
      key=ksv$key;
      sep=ksv$sep;
      val=ksv$val
      if (sep=="\t") {
         #tlist[[key]]=kvh_read_val(fp);
         tlist[[key]]=val
         indent=0;
      } else if (sep=="\n") {
         lev=lev+1;
         indent=0;
         nextlev=kvh2list(fp, lev, indent);
         nextlist=nextlev$kvh;
         indent=nextlev$indent;
         if (length(nextlist) && names(nextlist)[1] == "row_col") {
            #cat("row_col list names=", names(nextlist), sep="\n");
            cnames=unlist(strsplit(nextlist[["row_col"]], "\t"));
            nc=length(cnames);
            all_col_eq=TRUE;
            m=matrix("", 0, nc);
            for (s in nextlist[-1]) {
               r=unlist(strsplit(s, "\t"));
               if (length(r) != nc) {
                  all_col_eq=FALSE;
                  break;
               }
               m=rbind(m, r);
            }
            if (all_col_eq) {
               dimnames(m)=list(names(nextlist)[-1], cnames);
               nextlist=m;
            }
         }
         lev=lev-1;
         if (length(nextlist)==0) {
             # no value and no deeper level
             tlist[[key]]="";
         } else {
             tlist[[key]]=nextlist;
         }
      } else {
         # we are at the end of file
         if (indent || nchar(key)) {
            tlist[[key]]="";
         }
         if (open_here) {
            Sys.setlocale("LC_CTYPE", oldloc);
            close(fp);
         }
         if (lev) {
            indent=0;
            return(list(kvh=tlist, indent=indent));
         } else {
            return(tlist);
         }
      }
   }
}

kvh_read_key=function(fp) {
   #  Read a string from the current position till the first unescaped
   #  \t, \n or the end of the stream fp.
   #  Return a list (key=key, sep=sep). sep="" at the end of the stream
   key="";
   while (TRUE) {
      char=readChar(fp, 1);
      if (!length(char) || !nchar(char)) {
          return(list(key=key, sep=""));
      } else if (char=="\\") {
         # try to read next char if any
         nextchar=readChar(fp, 1);
         if (!length(nextchar) || !nchar(nextchar)) {
            # end of file
            return(list(key=key,sep=""));
         } else {
            # just add the escaped char
            key=paste(key, nextchar, sep="");
         }
      } else if (char=="\t" || char=="\n") {
         return(list(key=key, sep=char));
      } else {
         # just add a plain char
         key=paste(key, char, sep="");
      }
   }
}
kvh_read_val=function(fp) {
   #  Read a string from current position till the first unescaped
   #  \n or the end of file.
   #  Return the read string.
   val="";
   while (TRUE) {
      char=readChar(fp, 1);
      if (!length(char) || !nchar(char) || char=="\n") {
         return(val);
      } else if (char=="\\") {
          # try to read next char if any
          nextchar=readChar(fp, 1);
          if (!length(nextchar) || !nchar(nextchar)) {
             # end of file
             return(val);
          } else {
             # just add escaped char
             val=paste(val, nextchar, sep="");
          }
      } else {
         # just add a plain char
         val=paste(val, char, sep="");
      }
   }
}
kvh_read_keyval=function(fp) {
   #  Read a string from the current position till the first unescaped
   #  \n or the end of the stream fp.
   #  Return a list (key=key, sep=sep, val=val). sep="" at the end of the stream
   totrow=""
   while (TRUE) { # read till the end of line is unescaped \n or fp end
      row=readLines(fp, 1, warn=F)
      if (length(row)==0 && nchar(totrow)==0) {
         # we were at the end
         return(list(key="", val="", sep=""))
      }
      totrow=paste(totrow, row, sep="", collapse="")
      # see if we need to read further
      rend=regexpr("\\\\*$", row)
#print(paste("row=", row, "rend=", rend))
      if (attr(rend, "match.length") %% 2 == 0) {
         # the row end is not escaped => it is completely read
         break
      } else {
         # append the next row
         next
      }
   }
   # split the totrow in key, sep, val
   rsep=gregexpr("[\\]*\t", totrow)
   isep=attr(rsep[[1]], "match.length")
   isep=which(isep != -1 && isep %% 2 == 1)
   if (length(isep)) {
      # there is a separator tab
      endkey=rsep[[1]][isep[1]]+attr(rsep[[1]], "match.length")[isep[1]]-2
      key=substring(totrow, 1, endkey)
      sep="\t"
      val=substring(totrow, endkey+2)
   } else {
      # no tab separator
      key=totrow
      sep="\n"
      val=NULL
   }
   # strip backslashes
   keyval=as.list(gsub("\\\\(.)", "\\1", c(key=key, val=val)))
   keyval$sep=sep
   return(keyval)
}
kvh_get_matrix=function(f, v) {
   # return a plain matrix stored in the field v of a kvh file f.
   # v can be a vector of subfield keys.
   
   # read the file in a vector
   cont=readLines(f)
   ncont=length(cont)
   # get start line number by grep successively all fields in v
   # and the indent
   indent=0
   nstart=1
   for (it in v) {
      #res=system(sprintf("tail -n +%d '%s' 2>&1| grep -m 1 -n '\\t*%s$'", nstart+1, f, it), intern=T, ignore.stderr=T)
      nstart=nstart+grep(sprintf("\\t*\\Q%s\\E$", it), cont[nstart:ncont])[1]
      indent=which(nchar(strsplit(cont[nstart], "\t", fix=T)[[1]])>0)[1]-1
   }
   # get end number of the matrix in the kvh
   #res=system(sprintf("tail -n +%d '%s' 2>&1| grep -m 1 -n -E ^'%s\\w'", nstart+1, f, join("", rep("\t", indent))), intern=T)
   nend=grep(sprintf("^\\t{0,%d}[^\t]", indent-1), cont[nstart:ncont])
   if (length(nend)) {
      nend=nstart+nend[1]-2
   } else {
      nend=ncont
   }
   d=matrix(unlist(strsplit(cont[nstart:nend], "\t")), byrow=T, nrow=nend-nstart+1)[,-(1:indent), drop=F]
   rownames(d)=d[,1]
   if (rownames(d)[1]=="row_col") {
      colnames(d)=d[1,]
      d=d[-1,-1,drop=F]
   } else {
      d=d[,-1,drop=F]
   }
   dn=dimnames(d)
   wop=options()$warn
   options(warn=-1)
   num<-as.numeric(d)
   options(warn=wop)
   if (!any(is.na(num))) {
      d=matrix(num, nrow=nrow(d))
      dimnames(d)=dn
   }
   return(d)
}

#TIMEIT=0; # 1 to enable time printing at some stages
tmp=try(flush(fclog), silent=TRUE)
if (length(find("TIMEIT")) && TIMEIT && !inherits(tmp, "try-error")) {
   cat("load    : ", format(Sys.time()), " cpu=", proc.time()[1], "\n", sep="", file=fclog)
}
build_mult_bxxc=function(dirx) {
   fcpp="mult_bxxc.cpp"
   fso=paste("mult_bxxc", .Platform$dynlib.ext, sep="")
   if (!file.exists(file.path(dirr, "mult_bxxc.txt")) || !file.exists(file.path(dirr, fso)) ||
      file.mtime(file.path(dirr, fso)) < file.mtime(file.path(dirr, fcpp))) {
      # freshly compile the code (==first use or .so is outdated)
      frmu=file.path(system.file(package="rmumps"), "libs", .Platform$r_arch, paste("rmumps", .Platform$dynlib.ext, sep=""))
      Sys.setenv(PKG_LIBS=sprintf('"%s"', frmu))
      Sys.setenv(PKG_CXXFLAGS="-std=c++11 -fopenmp") # ‑mveclibabi=svml
      tes=capture.output(sourceCpp(file.path(dirr, "mult_bxxc.cpp"), verbose=TRUE))
      dl_str=grep("dyn.load", tes, value=TRUE)
      ftmp=sub(".*'(.*)'.*", "\\1", dl_str)
      dl_inf=sub("^(.*) <- dyn.load\\(.*$", "\\1", dl_str)
      fu_li=sub("// ", "", grep("// ", tes, value=TRUE))
      file.copy(ftmp, file.path(dirr, fso), overwrite = TRUE, copy.date=TRUE)
      sy=sapply(fu_li, function(it) {s=grep(paste(it, " <- ", sep=""), tes, value=TRUE, fixed=TRUE); sub(dl_inf, "multdll", s)})
      write.table(sy, file=file.path(dirr, "mult_bxxc.txt"), col.names=FALSE, row.names=FALSE)
   }
}
# build compiled code
#build_mult_bxxc(dirx)
#browser()
so=.Platform$dynlib.ext
#fso=paste("mult_bxxc", so, sep="")
## define R functions from mult_bxxc.so
#multdll=dyn.load(file.path(dirr, fso))
#sy=as.matrix(read.table(file=file.path(dirr, "mult_bxxc.txt"), header=FALSE))[,1]
#for (rsy in sy) {
#   eval(parse(text=rsy))
#}
#rm(multdll)

dfcg2fallnx=function(nb_f, flnx, param, fc, fg) {
   # produce complete flux (net,xch)*(dep,free,constr,growth) vector
   # from dep,free,constr,growth
   f=c(flnx[seq_len(nb_f$nb_fln)], param[seq_len(nb_f$nb_ffn)], fc[seq_len(nb_f$nb_fcn)], fg,
      flnx[nb_f$nb_fln+seq_len(nb_f$nb_flx)], param[nb_f$nb_ffn+seq_len(nb_f$nb_ffx)], fc[nb_f$nb_fcn+seq_len(nb_f$nb_fcx)], numeric(nb_f$nb_fgr))
   return(f)
}

cumo_resid=function(param, cjac=TRUE, labargs) {
   nm_local=c("jx_f", "pool", "measurements", "nm_list", "ir2isc", "jacobian", "nb_f", "nb_exp", "noscale")
   for (item in nm_local) {
      assign(item, labargs[[item]])
   }
   # find x for all weights and experiments
   lres=lab_sim(param, cjac, labargs)
   if (!is.null(lres$err) && lres$err) {
      return(list(err=1, mes=lres$mes))
   }

   # find simulated scaled measure vector scale*(measmat*x)
   if (is.null(jx_f$simlab)) {
      jx_f$simlab=jx_f$ureslab=jx_f$reslab=vector("list", nb_exp)
      names(jx_f$simlab)=names(jx_f$ureslab)=names(jx_f$reslab)=nm_list$nm_exp
   }
   for (iexp in seq_len(nb_exp)) {
      if (noscale) {
         jx_f$simlab[[iexp]]=jx_f$usimlab[[iexp]]
      } else {
         jx_f$simlab[[iexp]]=jx_f$usimlab[[iexp]]*c(1.,param)[ir2isc[[iexp]]]
      }
      names(jx_f$simlab[[iexp]])=names(jx_f$usimlab[[iexp]])=names(measurements$vec$labeled[[iexp]])
      # diff between simulated and measured
      jx_f$ureslab[[iexp]]=(jx_f$simlab[[iexp]]-measurements$vec$labeled[[iexp]])
      jx_f$reslab[[iexp]]=jx_f$ureslab[[iexp]]/measurements$dev$labeled[[iexp]]
   }

   # diff between simulated and measured
   pool[nm_list$poolf]=param[nm_list$poolf]
   jx_f$simfmn=jx_f$lf$fallnx[nm_list$fmn]
   jx_f$simpool=(measurements$mat$pool%*%pool)[,1]
   jx_f$uresflu=jx_f$simfmn-measurements$vec$flux
   jx_f$resflu=jx_f$uresflu/measurements$dev$flux
   jx_f$urespool=jx_f$simpool-measurements$vec$pool
   jx_f$respool=jx_f$urespool/measurements$dev$pool
   jx_f$res=c(unlist(jx_f$reslab), jx_f$resflu, jx_f$respool)
   jx_f$res[measurements$outlier]=NA
   jx_f$ures=c(unlist(jx_f$ureslab), jx_f$uresflu, jx_f$urespool)

   if (cjac) {
#browser()
      # jacobian
      cumo_jacob(param, labargs)
      if (is.null(labargs$jacobian)) {
         jacobian=matrix(0., length(nm_list$resid), length(param))
         dimnames(jacobian)=list(nm_list$resid, nm_list$par)
         labargs$jacobian=jacobian
      }
#require(numDeriv)
#r=function(p) cumo_resid(p, F, labargs)$res
#jacobian=jacobian(r, param)
      jacobian[]=as.numeric(with(measurements$dev, jx_f$udr_dp/c(unlist(labeled), flux, pool)))
      jx_f$jacobian=jacobian
      jx_f$dr_dff=jacobian[,seq_len(nb_f$nb_ff),drop=FALSE]
      labargs$jacobian=jacobian
      return(list(res=jx_f$res, jacobian=jacobian))
   } else {
      return(list(res=jx_f$res))
   }
}

cumo_cost=function(param, labargs, resl=lab_resid(param, cjac=FALSE, labargs)) {
   if (!is.null(resl$err) && resl$err) {
      return(NA)
   }
   res=resl$res
   if (is.null(res))
      return(NA)
   iva=!is.na(res)
   vres=res[iva]
   fn=crossprod(vres)[1L]
   return(fn)
}

param2fl=function(param, labargs) {
   # claculate all fluxes from free fluxes
   
   # local variabl assignments from labargs
   nm_local=c("nb_f", "nm_list", "invAfl", "p2bfl", "bp", "g2bfl", "fc")
   for (item in nm_local) {
      assign(item, labargs[[item]])
   }
   
   fg=numeric(nb_f$nb_fgr)
   names(fg)=nm_list$fgr
   if (nb_f$nb_fgr > 0) {
      fg[paste("g.n.", substring(nm_list$poolf, 4), "_gr", sep="")]=nb_f$mu*param[nm_list$poolf]
   }
   flnx=as.numeric(invAfl%*%(p2bfl%stm%param[seq_len(nb_f$nb_ff)]+c(bp)+g2bfl%stm%fg))
   names(flnx)=nm_list$flnx
   fallnx=c(dfcg2fallnx(nb_f, flnx, param, fc, fg))
   names(fallnx)=nm_list$fallnx
   fwrv=c(fallnx2fwrv(fallnx, nb_f))
   names(fwrv)=nm_list$fwrv
   lf=list(fallnx=fallnx, fwrv=fwrv, flnx=flnx)
   labargs$jx_f$lf=lf
   return(lf)
}

param2fl_x=function(param, cjac=TRUE, labargs, fullsys=FALSE) {
   # translate free params (fluxes+scales) to fluxes and cumomers
   # or emus
   # local variabl assignments form labargs
   nm_local=ls(labargs)
   for (item in nm_local) {
      assign(item, labargs[[item]])
   }
   if (fullsys) {
      nb_x=nb_f$xf
      nb_xi=nb_f$xif
      xi=xif
      nm_x=nm_list$cumo
      spa=spaf
      rcumo_in_cumo=match(nm_list$rcumo, nm_x)
   } else {
      nb_x=nb_f$x
      nb_xi=nb_f$xi
      nm_x=nm_list$x
      nb_x=nb_f$x
   }
   nb_w=length(nb_x)
   nbc_x=cumsum(c(0., nb_x))
   nb_ff=nb_f$nb_ff
   nb_poolf=nb_f$nb_poolf
   nb_fgr=nb_f$nb_fgr
   nb_meas=nb_f$nb_meas
   nm_exp=nm_list$nm_exp
   nb_sc=nb_f$nb_sc
   nb_sc_tot=nb_f$nb_sc_tot
   fg=nb_f$mu*param[nm_list$poolf] # the same alphabetical order
   names(fg)=nm_list$fgr
   pool[nm_list$poolf]=param[nm_list$poolf] # inject variable pools to pool vector

   # calculate all fluxes from free fluxes
   lf=param2fl(param, labargs)
   if (is.null(jx_f$x) || nrow(jx_f$x) != sum(nb_x)) {
      jx_f$x=matrix(0, nrow=sum(nb_x), nb_exp)
      dimnames(jx_f$x)=list(nm_x, nm_exp)
      jx_f$usimlab=vector("list", nb_exp)
      names(jx_f$usimlab)=nm_exp
   }
   x=jx_f$x
   usimlab=jx_f$usimlab
#browser()
   if (is.null(labargs$incu) || length(labargs$incu[[1L]]) != 1+nb_xi+nbc_x[nb_w+1L]) {
      labargs$incu=incu=lapply(seq_len(nb_exp), function(iexp) c(1, xi[[iexp]], double(nbc_x[nb_w+1L])))
      # unreduced residuals derivated by scale params
      labargs$dur_dsc=dur_dsc=lapply(seq_len(nb_exp), function(iexp) matrix(0., nrow=nb_meas[[iexp]], ncol=nb_sc_tot))
      labargs$dux_dp=dux_dp=lapply(seq_len(nb_exp), function(iexp) matrix(0., nb_meas[[iexp]], nb_ff+nb_sc_tot+nb_poolf))
   }
   incu=labargs$incu
   dur_dsc=labargs$dur_dsc
   dux_dp=labargs$dux_dp
   Ali=lapply(seq_len(nb_w), function(iw) fwrv2Abr(lf$fwrv, spa[[iw]], NULL, NULL, getb=FALSE, emu=emu && !fullsys)$A)
   if (cjac) {
      # derivation of fwrv fluxes by free parameters: free fluxes+concentrations
      mdf_dffp=df_dffp(param, jx_f$lf$flnx, nb_f, nm_list)
      jx_f$df_dffp=mdf_dffp
      if (is.null(labargs$x_f)) {
         labargs$x_f=matrix(0., nrow=sum(nb_x), ncol=nb_ff+nb_fgr)
      }
      x_f=labargs$x_f
   } else {
      x_f=NULL
   }
   for (iexp in seq_len(nb_exp)) {
      # prepare measurement pooling operations
      pwe[[iexp]][ipwe[[iexp]]]=pool[ip2ipwe[[iexp]]]
      spwe=tapply(pwe[[iexp]], pool_factor[[iexp]], sum)
      spwe=1./spwe[nm_list$measmat[[iexp]]]
      pwe[[iexp]]=c(pwe[[iexp]]*spwe)
      # construct the system A*x=b from fluxes
      # and find x for every weight
      # if fj_rhs is not NULL, calculate jacobian x_f
      if (cjac) {
         if (length(ijpwef[[iexp]])) {
            dpwe=-pwe[[iexp]]*spwe
            # dpwe is shortened to non zero entries in dpw_dpf
            dpwe=ifelse(ipf_in_ppw[[iexp]][ijpwef[[iexp]][,1L]]==ijpwef[[iexp]][,2L], (spwe+dpwe)[ijpwef[[iexp]][,1L]], dpwe[ijpwef[[iexp]][,1L]])
         }
      }
      
      # simulate labeling weight by weight
      ba_x=0
      for (iw in seq_len(nb_w)) {
         nb_c=spa[[iw]]$nb_c
         emuw=ifelse(emu && !fullsys, iw, 1L)
         if (nb_c == 0) {
            next
         }
         ixw=nbc_x[iw]+seq_len(nb_x[iw])
         incuw=(1L+nb_xi)+ixw
#cat("iw=", iw, "\there 1\n")
#if (iw==1) {
#   print(labargs)
#   print(spa[[iw]])
#}
         if (emu && !fullsys) {
            b=fwrv2Abr(lf$fwrv, spa[[iw]], incu[[iexp]], nm_list$emu[[iexp]][ixw], getA=FALSE, emu=emu && !fullsys)$b
         } else {
            b=fwrv2Abr(lf$fwrv, spa[[iw]], incu[[iexp]], nm_x[ixw], getA=FALSE, emu=emu && !fullsys)$b
         }
#browser()
         xw=try(solve(Ali[[iw]], b), silent=TRUE)
#print(head(xw))
         if (inherits(xw, "try-error")) {
#browser()
            rerr=attr(xw, "condition")
            if (length(grep("rmumps:.*info\\[1\\]=-10,", rerr$message, fixed=FALSE))) {
               # find 0 rows if any
               l=spa[[iw]]
               ag=aggregate(abs(lf$fwrv[l$ind_a[,"indf"]]), list(l$ind_a[,"ir0"]), sum)
               izc=ag$Group.1[ag$x <= 1.e-10]
               izf=names(which(abs(lf$fwrv)<1.e-7))
               mes=paste("Cumomer matrix is singular. Try '--clownr N' or/and '--zc N' options with small N, say 1.e-3\nor constrain some of the fluxes listed below to be non zero\n",
                  "Zero rows in cumomer matrix A at weight ", iw, ":\n",
                  paste(nm_list$x[ixw][izc+1], collapse="\n"), "\n",
                  "Zero fluxes are:\n",
                  paste(izf, collapse="\n"), "\n",
                  sep="")
            } else {
               mes=as.character(rerr$message)
            }
            return(list(x=NULL, iw=iw, fA=Ali[[iw]], err=1L, mes=mes))
         }
         if (emu && !fullsys) {
            xw=c(xw, 1.-rowSums(xw))
         }
         incu[[iexp]][incuw]=xw
         if (cjac && nb_ff+nb_fgr > 0) {
            # calculate jacobian x_f
            # first, calculate right hand side for jacobian calculation
            # j_rhsw, b_x from sparse matrices
            # bind cumomer vector
            j_b_x=fx2jr(jx_f$lf$fwrv, spa[[iw]], nb_f, incu[[iexp]])
            j_rhsw=j_b_x$j_rhsw%stm%mdf_dffp
            b_x=j_b_x$b_x
            if (iw > 1) {
               if (ba_x > 0) {
                  bop(j_rhsw, 1, "+=", b_x%stm%x_f[seq_len(ba_x),,drop=FALSE])
               }
            }
            redim(j_rhsw, c(nb_c, emuw*(nb_ff+nb_fgr)))
            tmp=try(solve(Ali[[iw]], j_rhsw))
            if (inherits(tmp, "try-error")) {
               #browser()
               mes="Some obscure problem with label matrix.\n"
               return(list(x=NULL, iw=iw, fA=Ali[[iw]], err=1L, mes=mes))
            } else {
               bop(j_rhsw, 1, "=", tmp)
            }
            if (emu && !fullsys) {
               redim(j_rhsw, c(nb_c, iw, nb_ff+nb_fgr))
               bop(x_f, c(1, ba_x, iw*nb_c), "=", j_rhsw)
               # m+N component
               #x_f[ba_x+iw*nb_c+seq_len(nb_c),]= -apply(j_rhsw, c(1L,3L), sum)
               bop(x_f, c(1, ba_x+iw*nb_c, nb_c), "=", -arrApply(j_rhsw, 2, "sum"))
            } else {
               bop(x_f, c(1, ba_x, nb_c), "=", j_rhsw)
            }
         }
         ba_x=ba_x+nb_x[iw]
      }
   
      #rownames(incu)=c("one", nm_list$inp, nm_list$x)
      x[, iexp]=tail(incu[[iexp]], -nb_xi-1L)
      
      # calculate unreduced and unscaled measurements
      if (nrow(x) == ncol(measmat[[iexp]]) && !fullsys) {
         mx=(measmat[[iexp]]%stm%x[, iexp])[,1]+memaone[[iexp]]
      } else {
         if (emu) {
            mx=(measmat[[iexp]]%stm%(memu_in_cumo %stm% x[, iexp] + cemu_in_cumo))[,1]+memaone[[iexp]]
         } else {
            mx=(measmat[[iexp]]%stm%x[rcumo_in_cumo, iexp])[,1]+memaone[[iexp]]
         }
      }
      # measurement vector before pool ponderation
#browser()
      if (length(ipooled[[iexp]]) > 1L) {
         mv=meas2sum[[iexp]]%stm%(pwe[[iexp]]*mx)
      } else {
         mv=mx
      }
      jx_f$usimlab[[iexp]]=as.numeric(mv)
      if (cjac) {
         # scale part of jacobian
         if (!noscale && nb_sc[[iexp]] > 0) {
            is2m=nb_f$is2m
            dur_dsc[[iexp]][is2m[[iexp]]]=mv[is2m[[iexp]][,1]]
         }
   #browser()
         # free flux part of jacobian (and partially free pools if present in x_f)
         if (nb_ff+nb_fgr > 0) {
            mffg=measmat[[iexp]]%stm%x_f
            if (length(ipooled[[iexp]]) > 1L) {
               mffg=meas2sum[[iexp]]%stm%(pwe[[iexp]]*mffg)
            }
         } else {
            mffg=matrix(0., nrow=nb_meas[[iexp]], ncol=0L)
         }
         # free pool part of jacobian
         mff=mffg
         mpf=matrix(0., nrow=nb_meas[[iexp]], ncol=nb_f$nb_poolf)
         if (nb_f$nb_poolf > 0L) {
            if (length(ijpwef[[iexp]]) > 0L) {
               # derivation of pool weights
               dpw_dpf[[iexp]]$v=as.double(mx[ijpwef[[iexp]][,1L]]*dpwe)
               mpf[]=meas2sum[[iexp]]%stm%dpw_dpf[[iexp]]
               # growth flux depending on free pools
               if (nb_fgr > 0L) {
                  bop(mpf, 1, "+=", as.matrix(mffg[,nb_ff+seq_len(nb_fgr),drop=FALSE]))
                  mff=mffg[,seq_len(nb_ff)]
               } else {
                  mff=mffg
               }
            }
         }
         mff=as.matrix(mff)
         if (!noscale) {
            vsc=c(1., param)[ir2isc[[iexp]]]
            mff=vsc*mff
            mpf=vsc*mpf
         }
         # store usefull information in global list jx_f
         bop(dux_dp[[iexp]], c(2, 0, nb_ff), "=", mff)
         bop(dux_dp[[iexp]], c(2, nb_ff, nb_sc_tot), "=", dur_dsc[[iexp]])
         bop(dux_dp[[iexp]], c(2, nb_ff+nb_sc_tot, nb_f$nb_poolf), "=", mpf)
         jx_f$param=param
         jx_f$x_f[[iexp]]=x_f
         jx_f$dux_dp[[iexp]]=dux_dp[[iexp]]
      }
   }
   jx_f$x=x
   return(list(x=jx_f$x, lf=jx_f$lf))
}

Tiso2cumo=function(len) {
   if (len<0) {
      return(FALSE)
   }
   if (len==0) {
      return(matrix(1,1,1))
   }
   # recursive call for len>1
   T=Tiso2cumo(len-1)
   return(rbind(cbind(T,T),cbind(diag(0,NROW(T)),T)))
}

Tcumo2iso=function(len) {
   if (len<0) {
      return(FALSE)
   }
   if (len==0) {
      return(matrix(1,1,1))
   }
   # recursive call for len>1
   T=Tcumo2iso(len-1)
   return(rbind(cbind(T,-T),cbind(diag(0,NROW(T)),T)))
}

Tiso2mass=function(len) {
   mass=matrix(0, len+1, 2**len)
   for (i in 0:(2**len-1)) {
      s=sumbit(i)
      mass[s+1,i+1]=1
   }
   return(mass)
}

Vcumo2iso0=function(len) {
   # coefficients of first row of matrix Tcumo2iso
   # giving the conversion to isotopomer of weight 0
   if (len<0) {
      return(FALSE)
   }
   if (len==0) {
      return(c(1))
   }
   # recursive call for len>1
   V=Vcumo2iso0(len-1)
   return(c(V,-V))
}

sumbit=function(i) {
   # return the sum of bits in every component of the integer vector i
   # The result has the length=length(i)
   return(as.integer(colSums(outer(2**(0:30), as.integer(i), bitops::bitAnd) > 0)))
}

cumo2mass=function(x, sep=":", emusep="+") {
   # convert cumomer or emu vector(s) to MID vector(s)
   # x may be multiple column matrix,
   # each of its column is then translated into MID column.
   # x names expected in format Metab:N, where N is an integer.
   # or Metab:N+m, where m is emu weight M+m .
   
   if (length(x)==0) {
      return(NULL)
   }
   # prepare x as matrix
   nb_exp=NA
   if (is.vector(x) && !is.list(x)) {
      nm_x=names(x)
      x=as.matrix(x)
   } else if (is.matrix(x)) {
      nm_x=rownames(x)
   } else if (is.list(x)) {
      nm_x=rownames(x[[1]])
      nb_exp=length(x)
      nm_exp=names(x)
   } else {
      stop("x is an unknown structure. It must be vector, matrix or a list of matrices")
   }
   
   # is it emu or cumomer vector
   emu=TRUE
   if (is.na(strsplit(nm_x[1], emusep, fixed=TRUE)[[1]][2]))
      emu=FALSE
#browser()
   if (emu) {
      # just take the longest fragments and return their MID
      spl=data.frame(t(vapply(strsplit(nm_x, "[" %s+% sep %s+% emusep %s+% "]"), c, character(3))),
         stringsAsFactors=FALSE)
      spl[,2]=as.integer(spl[,2])
      longest=tapply(spl[,2], list(spl[,1]), max)
      o=order(names(longest))
      longest=longest[o]
      nm_l=names(longest)
      # select the MIDs of the longest fragment
      if (is.na(nb_exp)) {
         res=x[unlist(sapply(nm_l, function(nm) which(spl[,1L]==nm & spl[,2L]==longest[nm]))),,drop=FALSE]
      } else {
         i=unlist(sapply(nm_l, function(nm) which(spl[,1L]==nm & spl[,2L]==longest[nm])))
         res=lapply(x, function(xx) xx[i,,drop=FALSE])
      }
      return(res)
   }

   # separate cumos by name and order by weight
   metabs=c(); # unique metab names
   spl=as.matrix(sapply(nm_x, function(s) {
      v=strsplit(s, sep, fixed=TRUE)[[1]]
      if (length(v)==2) {
         return(v)
      } else {
         # badly formed cumomer name
         return(c(NA, NA))
      }
   }))
   i=!is.na(spl[2,])
   if (is.na(nb_exp)) {
      x=x[i,,drop=FALSE]
   } else {
      x=lapply(x, "[", i,,drop=FALSE)
   }
   spl=spl[,i,drop=FALSE]
   n=if (is.na(nb_exp)) nrow(x) else nrow(x[[1L]])
   i=seq_len(n)
   icumo=as.integer(spl[2L,])
   metabs=spl[1L,]
   umetabs=union(metabs, NULL)
#cat("metabs:\n")
#print(metabs)
#cat("tbl:\n")
#print(tbl)
   # extract, order and convert each metab vector
   if (is.na(nb_exp)) {
      res=matrix(0., nrow=0, ncol=ncol(x))
      for (metab in umetabs) {
#cat(paste(metab,":\n",sep=""))
         im=metabs==metab
#print(d)
         o=order(icumo[im])
         # ordered cumomer vector with #0==1 component
         vcumo=rbind(1,x[im,,drop=FALSE][o,,drop=FALSE])
         clen=log2(nrow(vcumo))
         # check that we have all components
         sb=sumbit(max(icumo[im]))
         if (!isTRUE(all.equal(sb, clen))) {
            next
         }
         # mass vector
         mass=as.matrix(Tiso2mass(clen)%*%(Tcumo2iso(clen)%*%vcumo))
         rownames(mass)=paste(metab, "+", 0:clen, sep="")
         res=rbind(res, mass)
      }
   } else {
      rres=lapply(seq_len(nb_exp), function(iexp) matrix(0., nrow=0, ncol=ncol(x[[iexp]])))
      names(rres)=names(x)
      for (iexp in seq_len(nb_exp)) {
         res=rres[[iexp]]
         for (metab in umetabs) {
            im=metabs==metab
            o=order(icumo[im])
            # ordered cumomer vector with #0==1 component
            vcumo=rbind(1,x[[iexp]][im,,drop=FALSE][o,,drop=FALSE])
            clen=log2(nrow(vcumo))
            # check that we have all components
            sb=sumbit(max(icumo[im]))
            if (!isTRUE(all.equal(sb, clen))) {
               next
            }
            # mass vector
            mass=as.matrix(Tiso2mass(clen)%*%(Tcumo2iso(clen)%*%vcumo))
            rownames(mass)=paste(metab, ":", clen, "+", 0:clen, sep="")
            res=rbind(res, mass)
         }
         rres[[iexp]]=res
      }
      res=rres
   }
   return(res)
}
#' Generate a matrix+vector of transition 'm' and 'cnst' s.t. m%*%cumo+cnst -> emu
#'
#' @param nme Character vector of emu names
#' @param nmc Character vector of cumomer names
#' @param clen Integer named vector of carbon lengths for each metabolite
#' @return list(m=slam::simple_triplet_matrix, cnst=Numeric vector)
emu_in_cumo=function(nme, nmc) {
   met=strsplitlim(nme, ":", fixed=TRUE, mat=TRUE)
   mask=strsplitlim(met[,2L], "+", fixed=TRUE, mat=TRUE)
   mw=as.integer(mask[,2L])
   mask=as.integer(mask[,1L])
   met=met[,1L]
   # run through (met, mask) which are supposed to be unique in nme
   tmp=list()
   m=slam::simple_triplet_zero_matrix(length(nme), length(nmc))
   dimnames(m)=list(nme, nmc)
   cnst=double(length(nme))
   names(cnst)=nme
#browser()
   tapply(data.frame(met, mask, mw), list(met, mask), function(df) {
      if (nrow(df) == 0L)
         return(NULL)
#browser()
      mask=df$mask[1L]
      met=df$met[1L]
      lenmask=sumbit(mask)
      chlen=as.character(lenmask)
      lencu=2L^lenmask-1L
      if (is.null(tmp[[chlen]]))
         tmp[[chlen]]=Tiso2mass(lenmask)%*%Tcumo2iso(lenmask)
      ie=as.integer(rownames(df))
      bshift={i=0L; bshift=mask; while (bitops::bitAnd(bshift, 1L) == 0L) {bshift=bitops::bitShiftR(bshift, 1L); i=i+1L}; i}
      ic=match(sprintf("%s:%d", met, bitops::bitShiftL(seq_len(lencu), bshift)), nmc)
      m[ie, ic] <<- tmp[[chlen]][df$mw+1L,-1L]
      cnst[ie] <<- cnst[ie]+tmp[[chlen]][,1L]
      NULL
   })
   list(m=m, cnst=cnst)
}
cumo2lab=function(x) {
   # converts cumomer vector to fraction of labeled isotopomer 1-i#0
   # separate cumos by name and order by weight
   x=as.matrix(x)
   n=nrow(x)
   nm_x=rownames(x)
   if (is.null(nm_x)) {
      return(NULL)
   }
   metabs=c(); # unique metab names
   spl=unlist(strsplit(nm_x,":",fix=TRUE))
   i=1:n
   icumo=as.integer(spl[2*i])
   metabs=spl[2*i-1]
   umetabs=union(metabs, NULL)
#cat("metabs:\n")
#print(metabs)
#cat("tbl:\n")
#print(tbl)
   # extract, order and convert each metab vector
   res=c()
   for (metab in umetabs) {
#      cat(paste(metab,":\n",sep=""))
      im=metabs==metab
      o=order(icumo[im])
      # ordered cumomer matrix with #0==1 component
      vcumo=rbind(1,x[im,,drop=FALSE][o,,drop=FALSE])
      clen=log2(nrow(vcumo))
      # labeled fraction
      lab=1-Vcumo2iso0(clen)%*%vcumo
      rownames(lab)=metab
      res=rbind(res, lab)
   }
   return(res)
}
cumo2iso=function(x) {
   # converts cumomer vector to isotopomer vector
   # separate cumos by name and order by weight
   x=as.matrix(x)
   n=nrow(x)
   nm_x=rownames(x)
   if (is.null(nm_x)) {
      return(NULL)
   }
   metabs=c(); # unique metab names
   spl=unlist(strsplit(nm_x,":",fix=TRUE))
   i=1:n
   icumo=as.integer(spl[2*i])
   metabs=spl[2*i-1]
   umetabs=union(metabs, NULL)
   # extract, order and convert each metab vector
   res=c()
   for (metab in umetabs) {
      im=metabs==metab
      o=order(icumo[im])
      # ordered cumomer matrix with #0==1 component
      vcumo=rbind(1,x[im,,drop=FALSE][o,,drop=FALSE])
      clen=round(log2(nrow(vcumo)))
      # labeled fraction
      lab=Tcumo2iso(clen)%*%vcumo
      rownames(lab)=paste(metab, seq_len(2**clen)-1, sep=":")
      res=rbind(res, lab)
   }
   return(res)
}
cumo_gradj=function(param, labargs) {
   # calculate gradient of cost function for cumomer minimization probleme
   if (any(ina <- is.na(jx_f$res)))
      grad=2*as.numeric(crossprod(jx_f$res[!ina], jx_f$jacobian[!ina,,drop=FALSE]))
   else
      grad=2*as.numeric(crossprod(jx_f$res, jx_f$jacobian))
   return(grad)
}

# cost function for donlp2 solver
cumo_fn=function(p) {
   return(cumo_cost(p, labargs))
}

cumo_dfn=function(p) {
   return(cumo_gradj(p, labargs))
}

attr(cumo_fn, "gr")=cumo_dfn
#cumo_fn@gr=cumo_dfn
cumo_jacob=function(param, labargs) {
   # calculate jacobian dmeas_dparam and some annexe matrices
   # without applying invvar matrix
   # The result is in a returned list jx_f.
   jx_f=labargs$jx_f
   nb_exp=labargs$nb_exp
   nblr=sapply(jx_f$dux_dp, nrow) # labeled residual lengths
   nblr_tot=sum(nblr)
   if (is.null(labargs$jtmp)) {
      labargs$jtmp=double(nblr_tot*length(param))
      redim(labargs$jtmp, c(nblr_tot, length(param)))
   }
   tmp=labargs$jtmp
   base=0
   for (iexp in seq_len(nb_exp)) {
      tmp[base+seq_len(nblr[iexp]),]=jx_f$dux_dp[[iexp]]
      base=base+nblr[iexp]
   }
   if (is.null(jx_f$udr_dp)) {
      jx_f$udr_dp=rbind(tmp, labargs$dufm_dp, labargs$dupm_dp)
   } else {
      jx_f$udr_dp[seq_len(nblr_tot),]=tmp
   }
   dimnames(jx_f$udr_dp)=list(labargs$nm_list$resid, labargs$nm_list$par)
   return(NULL)
}

fwrv2Abr=function(fwrv, spAbr, incu, nm_rcumo, getA=TRUE, getb=TRUE, emu=FALSE) {
   # calculate sparse A and b (in A*x=b where x is cumomer vector)
   # from fields of the list spAbr
   # return a list(A, b)
   # 2012-02-21 sokol
   #
   # update :
   # added emu parameter.
   # In emu mode b_pre_emu, ind_fbe, ind_xe1 and ind_xe2 are lists
   # in spAbr one term per m+i weght.
   # incu is inemu vector
   # nm_rcumo is nm_emu
   # when returns b, it is a matrix with as many columns as cumomer weight.
   # emu+mi for i=0,N-1 N is the fragment weight can be calculated
   # from A*x=b.
   # emu+mN have to be calculated from 1-sum(lighter weights m+i)
   # 2012-07-16 sokol
   
   #nb_c=spAbr$nb_c # cumomer or fragment number (when emu==TRUE)
   #w=spAbr$w # cumomer weight
#cat("fwrv2Abr 1\n")
   nb_c=spAbr$nb_c
   if (nb_c == 0) {
      A=spAbr$a
      b=spAbr$b
      return(list(A=if (getA) A else NULL, b=if (getb) b else NULL))
   }
   if (getA) {
      ind_a=spAbr$ind_a
      if (!is.matrix(ind_a))
         ind_a=t(ind_a)
      #x=fwrv[ind_a[,"indf"]]
      #i=which(ind_a[,"ir0"]==ind_a[,"ic0"])
      #x[i]=-x[i] # diagonal terms are negative
      #A=sparseMatrix(i=ind_a[,"ir0"]+1, j=ind_a[,"ic0"]+1, x=x, dims=c(nb_c, nb_c), giveCsparse=FALSE)
      #dimnames(A)=list(head(nm_rcumo, nb_c), head(nm_rcumo, nb_c))
      #A=Rmumps$new(ind_a[,"ir0"], ind_a[,"ic0"], x, nb_c)
      spAbr$xmat$v <- fwrv[ind_a[,"indf"]]
      x <- col_sums(spAbr$xmat)
      x[spAbr$iadiag] <- -x[spAbr$iadiag]
#print(spAbr)
      spAbr$a$set_mat_data(x)
   }
   
   # construct a complete b vector
   if (getb) {
      ind_b=if (emu) spAbr[["ind_b_emu"]] else spAbr[["ind_b"]]
#      if (!is.matrix(ind_b))
#         ind_b=t(ind_b)
      nprodx=ncol(ind_b)-2-emu
      prodx=incu[c(ind_b[,2+emu+seq_len(nprodx)])]
      dim(prodx)=c(nrow(ind_b), nprodx)
      spAbr$bmat$v=fwrv[ind_b[,"indf"]]*arrApply(prodx, 2, "prod")
      spAbr$b$v=-col_sums(spAbr$bmat)
   }
   return(list(A=if (getA) spAbr$a else NULL, b=if (getb) spAbr$b else NULL))
}

fx2jr=function(fwrv, spAbr, nb, incu) {
   # calculate sparse j_rhs and b_x from fields of the list spAbr
   # according to conventions explained in comments
   # to python function netan2Abcumo_spr() generating spAbr
   # Return a list j_rhs, b_x
   # nb is a list of various numbers (cumomers, emus and so on)
   # 2012-02-22 sokol
   #
   # update: added emu approach
   # if emu then incu is inemu vector
   # 2012-07-18 sokol
   #
   # update: added vectorization for multiple incu vectors considered
   # as matrix columns (there are nco of them) . output is a matrix with dim
   # (nb_x*nco, nb_fwrv)
   # 2014-07-15 sokol
   # cannot work for fullsys as nb contains numbers for reduced system
   
   # we derivate a*x=b implicitly
   # a_f*x + a*x_f=b_f + b_xl*xl_f
#browser()
   nb_c=spAbr$nb_c
   if (nb_c==0) {
      # no system at this weight
      return(list(j_rhsw=NULL, b_x=NULL, j_rhswp=NULL, b_xp=NULL))
   }
   emu=is.matrix(spAbr$ind_b_emu)
   nb_fwrv=spAbr$nb_fwrv
   nb_cl=spAbr$nb_cl
   w=spAbr$w
   nb_xi=nb$xi
   
   # a_fx
   ind_a=spAbr$ind_a
   if (!is.matrix(ind_a))
      ind_a=t(ind_a)
   i=ind_a[,"ic0"]==ind_a[,"ir0"]
   incu=as.matrix(incu)
   nco=ncol(incu)
   nro=nrow(ind_a)
   emuw=ifelse(emu, w, 1L)
   nb_xw=nb_c*emuw
   # first a_fx creation for further updates (a_fx can be of many different sizes
   # depending on the time scheme for ODE and possible parallel experiments)
   nm_a_fx=as.character(nco)
   if (is.null(spAbr$a_fxx)) {
      # create auxiliary data for a_fx
      spAbr$a_fxx=list()
   }   
   if (is.null(spAbr$a_fxx[[nm_a_fx]])) {
#cat("build", nm_a_fx, "\n", file=fclog)
      l=new.env()
      l$nco=nco
      if (emu) {
         ia=(ind_a[,"ir0"]+1L)+rep((seq_len(w)-1L)*nb_c, each=nro)
         ja=rep(ind_a[,"indf"], w)
      } else {
         ia=ind_a[,"ir0"]+1L
         ja=ind_a[,"indf"]
      }
      l$ineg=which(ind_a[,"ic0"]==ind_a[,"ir0"])
      ia=ia+rep((seq_len(nco)-1L)*(nb_c*emuw), each=nro*emuw)
      ja=rep(ja, nco)
      nar=nb_xw*nco # row number in a_fx, b_f, b_x
      iv1=ia+(ja-1)*nar
      o=order(iv1)
      l$oa_x=o
      iv1=iv1[o]
      lrep=lrepx=rle(iv1)
      lrepx$values=seq_along(lrep$values)
      l$xmat=simple_triplet_matrix(i=unlist(lapply(lrep$lengths, seq_len)),
         j=inverse.rle(lrepx), v=rep(1, length(iv1)))
      iu1=lrep$values
      i=as.integer((iu1-1)%%nar)+1L
      j=as.integer((iu1-1)%/%nar)+1L
      l$a_fx=simple_triplet_matrix(i=i, j=j, v=rep(1, length(i)), nrow=nar, ncol=nb_fwrv)
      
      # prepare b_f auxiliaries
      ind_b=if(emu) spAbr$ind_b_emu else spAbr$ind_b
      nro=nrow(ind_b)
      ib=ind_b[,"irow"]+if(emu) nb_c*(ind_b[,"iwe"]-1L) else 0L
      jb=ind_b[,"indf"]
      ib=ib+rep((seq_len(nco)-1L)*nb_xw, each=nro)
      jb=rep(jb, nco)
      iv1=ib+(jb-1)*nar
      o=order(iv1)
      l$ob_f=o
      iv1=iv1[o]
      lrep=lrepx=rle(iv1)
      lrepx$values=seq_along(lrep$values)
      l$b_fmat=simple_triplet_matrix(i=unlist(lapply(lrep$lengths, seq_len)),
         j=inverse.rle(lrepx), v=rep(1, length(iv1)))
      iu1=lrep$values
      i=as.integer((iu1-1)%%nar)+1L
      j=as.integer((iu1-1)%/%nar)+1L
      l$b_f=simple_triplet_matrix(i=i, j=j, v=rep(1, length(i)), nrow=nar, ncol=nb_fwrv)
      # cache ind and pos for (b_f-a_fx)
      l$bma_pos=if (l$b_f$nrow*l$b_f$ncol < 2251799813685248 && l$a_fx$nrow*l$a_fx$ncol < 2251799813685248) match(l$a_fx$i+l$a_fx$j*l$a_fx$nrow, l$b_f$i+l$b_f$j*l$b_f$nrow, nomatch=0L) else match_ij(l$a_fx$i, l$a_fx$j, l$b_f$i, l$b_f$j)
      l$bma_ind=which(l$bma_pos == 0L)
      
      # prepare b_x auxiliaries
      if (length(spAbr$ind_bx) > 0) {
         ind_bx=if (emu) spAbr$ind_bx_emu else spAbr$ind_bx
         nro=nrow(ind_bx)
         ib=ind_bx[,"irow"]
         jb=ind_bx[,"ic1"]
         ib=ib+rep((seq_len(nco)-1L)*nb_xw, each=nro)
         jb=rep(jb, nco)
         iv1=ib+(jb-1)*nar
         o=order(iv1)
         l$ob_x=o
         iv1=iv1[o]
         lrep=lrepx=rle(iv1)
         lrepx$values=seq_along(lrep$values)
         l$b_xmat=simple_triplet_matrix(i=unlist(lapply(lrep$lengths, seq_len)),
            j=inverse.rle(lrepx), v=rep(1, length(iv1)))
         iu1=lrep$values
         i=as.integer((iu1-1)%%nar)+1L
         j=as.integer((iu1-1)%/%nar)+1L
         l$b_x=simple_triplet_matrix(i=i, j=j, v=rep(1, length(i)), nrow=nar, ncol=nb$nbc_x[w])
      } else {
         l$b_x=simple_triplet_zero_matrix(nrow=nar, ncol=nb$nbc_x[w])
      }
      spAbr$a_fxx[[nm_a_fx]]=l
   }
   x=incu[(1L+nb_xi+nb$nbc_x[w])+seq_len(nb_xw),,drop=FALSE]
   aux=spAbr$a_fxx[[nm_a_fx]]
   if (emu) {
      redim(x, c(nb_c, w, nco))
      tmp=x[ind_a[,"ic0"]+1L,,,drop=FALSE]
      tmp[aux$ineg,,]=-tmp[aux$ineg,,]
   } else {
      tmp=x[ind_a[,"ic0"]+1L,,drop=FALSE]
      tmp[aux$ineg,]=-tmp[aux$ineg,]
   }
#browser()
   aux$xmat$v[]=tmp[aux$oa_x]
   aux$a_fx$v[]=slam::col_sums(aux$xmat)
   a_fx=aux$a_fx
   
   # prepare b_f
   # NB emu: b is shorter than xw by the last M+N vector which is added as (1-sum(lighter weights))
   ind_b=if(emu) spAbr$ind_b_emu else spAbr$ind_b
   nprodx=ncol(ind_b)-2-emu
   prodx=incu[c(ind_b[,2+emu+seq_len(nprodx)]),]
   dim(prodx)=c(nrow(ind_b), nprodx, nco)
   aux$b_fmat$v[]=-arrApply(prodx, 2, "prod")[aux$ob_f]
   aux$b_f$v[]=slam::col_sums(aux$b_fmat)
   b_f=aux$b_f
   
   # prepare b_x
   if (length(spAbr$ind_bx) > 0) {
      ind_bx=if (emu) spAbr$ind_bx_emu else spAbr$ind_bx
      nprodx=ncol(ind_bx)-3-emu
      if (nprodx >= 1) {
         prodx=incu[c(ind_bx[,3+emu+seq_len(nprodx)]),]
         dim(prodx)=c(nrow(ind_bx), nprodx, nco)
         aux$b_xmat$v[]=(-fwrv[ind_bx[,"indf"]]*arrApply(prodx, 2, "prod"))[aux$ob_x]
      } else {
         aux$b_xmat$v[]=(-fwrv[ind_bx[,"indf"]])[aux$ob_x]
      }
      aux$b_x$v[]=slam::col_sums(aux$b_xmat)
      b_x=aux$b_x
   } else {
      b_x=simple_triplet_zero_matrix(nrow=nb_xw*nco, ncol=nb$nbc_x[w])
   }
#browser()
   j_rhsw=stm_pm(b_f, a_fx, "-", aux$bma_pos, aux$bma_ind)
   if (is.null(aux$o_j)) {
      o=order(j_rhsw$i+j_rhsw$nrow*j_rhsw$j)
      aux$o_j=o
   }
   o=aux$o_j
   j_rhsw$i[]=j_rhsw$i[o]
   j_rhsw$j[]=j_rhsw$j[o]
   j_rhsw$v[]=j_rhsw$v[o]
   return(list(j_rhsw=j_rhsw, b_x=b_x))
}

put_inside=function(param, ui, ci, tol_in=1.e-10, tol_out=1.e-7, tol_desc=1.e-3, rcond=1.e7) {
   # put param inside of feasible domain delimited by u%*%param >= ci
   nm_par=names(param)
   mes=""
   ineq=as.numeric(ui%*%param)-ci
   if (all(ineq>-tol_in)) {
      # nothing to do, already inside and well inside
      return(param)
   }
   dp=ldp(as.matrix(ui), -ineq, rcond)
   if (!is.null(dp)) {
      # get new active inequalities
      ineqd=as.numeric(ui%*%(param+dp))-ci
      # check that we are not too far outside
      if (any(ineqd < -tol_out)) {
         param[]=NA
         attr(param, "mes")="Inequality system is ill-conditioned. Failed to solve."
         attr(param, "err")=1
         return(param)
      }
      iact=ineqd<=tol_in
#print(ineqd[iact])
      # solve an ldp pb to find non decreasing direction
      # for active inequalities
      ma=ui[iact,,drop=FALSE]
      na=sum(iact)
      # find closest vector to c(1,1,...) making the direction increasing
      tma=tcrossprod(ma)
      suppressWarnings(bet <- ldp(tma, tol_desc - apply(tma, 1, sum), rcond))
      if (is.null(bet)) {
         param=param+dp
         attr(param, "mes")="Infeasible constraints for inside direction."
         attr(param, "err")=0
         return(param)
      }
      vn=crossprod(ma, 1.+bet)
      vn=vn/norm(vn)
      decr=(ui%*%vn)<0.
      alpha=((-ineqd)/(ui%*%vn))[decr]
      alpha=alpha[alpha>0]
      alpha=0.5*min(tol_desc, alpha)
      dpn=dp+alpha*vn
      # check that new dp is still inside
      if (any(ui%*%(param+dpn)-ci < -tol_in)) {
         attr(param, "err")=0 # just a warning
         attr(param, "mes")="Failed to put free parameters strictly inside of the feasible domain. They are left on the border."
         dpn=dp
      }
      names(param)=nm_par
      if (!is.null(mget("nb_ff", ifnotfound=list(NULL))[[1L]]) && nb_ff > 0) {
         i=abs(dpn[seq_len(nb_ff)])>=tol_in
         if (any(i)) {
            tmp=cbind(param[1:nb_ff], param[1:nb_ff]+dpn[1:nb_ff], dpn[1:nb_ff])
            dimnames(tmp)=list(nm_par[1:nb_ff], c("outside", "inside", "delta"))
            obj2kvh(tmp[i,,drop=FALSE], "Free fluxes put inside of feasible domain")
         }
      }
      # move starting point slightly inside of feasible domain
      param=param+as.numeric(dpn)
   } else {
      param[]=NA
      mes="Infeasible inequalities."
      if (!is.null(rownames(ui))) {
         mes=join("\n", c(mes, rownames(ui)))
      }
      attr(param, "mes")=mes
      attr(param, "err")=1
   }
   return(param)
}

df_dffp=function(param, flnx, nb_f, nm_list) {
   # derivation of fwrv by free_fluxes+poolf (and not growth fluxes neither log(poolf))
   ah=1.e-10; # a heavyside parameter to make it derivable in [-ah; ah]
   nb_fwrv=nb_f$nb_fwrv
   nm_par=names(param)
   i_fln=grep("d.n.", names(flnx), fixed=TRUE)
   i_flx=grep("d.x.", names(flnx), fixed=TRUE)
   i_ffn=grep("f.n.", nm_par, fixed=TRUE)
   i_ffx=grep("f.x.", nm_par, fixed=TRUE)
   if (nb_f$nb_fgr > 0) {
      i_fgn=grep("pf:", nm_par, fixed=TRUE)
   } else {
      i_fgn=c()
   }
   i_fgx=c(); #grep("g.x.", nm_par, fixed=TRUE) # must be always empty
   nb_ff=length(i_ffn)+length(i_ffx)
   nb_fgr=length(i_fgn)+length(i_fgx)
   #df_dfl=Matrix(0., nb_fwrv, length(flnx))
   #df_dffd=Matrix(0., nb_fwrv, nb_ff+nb_fgr)
   df_dfl=simple_triplet_zero_matrix(nb_fwrv, length(flnx))
   df_dffd=simple_triplet_zero_matrix(nb_fwrv, nb_ff+nb_fgr)
   # derivation by dependent fluxes
   # net part
   net=flnx[i_fln]
   hnet=Heaviside(net)
   i=abs(net)<ah
   hnet[i]=net[i]/ah
   # xch part
   xch=flnx[i_flx]
   xch=1./(1.-xch)**2
   
   # forward fluxes
   df_dfl[nb_f$cfw_fl]=c(hnet, xch)
   # reverse fluxes
   df_dfl[nb_f$crv_fl]=c(hnet-1., xch)
   
   # derivation by free fluxes
   # net part
   net=param[i_ffn]
   hnet=Heaviside(net)
   i=abs(net)<ah
   hnet[i]=net[i]/ah
   # xch part
   xch=param[i_ffx]
   xch=1./(1.-xch)**2
   # forward fluxes
   if (length(nb_f$cfw_ff) > 0)
      df_dffd[nb_f$cfw_ff]=c(hnet, xch)
   # reverse fluxes
   if (length(nb_f$crv_ff) > 0)
      df_dffd[nb_f$crv_ff]=c(hnet-1., xch)
   
   # derivation by growth fluxes
   # forward fluxes
   if (length(nb_f$cfw_fg) > 0)
      df_dffd[nb_f$cfw_fg]=rep.int(1., length(i_fgn))
   # reverse fluxes
   if (length(nb_f$crv_fg) > 0)
      df_dffd[nb_f$crv_fg]=0.
   
   res=df_dfl%stm%nb_f$dfl_dffg+df_dffd
   if (nb_fgr > 0) {
      i=res$j > nb_ff
      res$v[i]=res$v[i]*nb_f$mu
   }
   dimnames(res)=list(nm_list$fwrv, names(param)[c(i_ffn, i_ffx, i_fgn, i_fgx)])
   o=order(res$i+res$nrow*res$j)
   res$i[]=res$i[o]
   res$j[]=res$j[o]
   res$v[]=res$v[o]
   return(res)
}

dufm_dff=function(nb_f, nm_list) {
   # measured fluxes derivation (non reduced by SD)
   res=matrix(0., length(nm_list$fmn), length(nm_list$ff))
   dimnames(res)=list(nm_list$fmn, nm_list$ff)
   # derivate free measured fluxes (trivial)
   i=grep("f.n.", nm_list$fmn, fixed=TRUE)
   if (length(i) > 0) {
      res[i,nm_list$fmn[i]]=diag(length(i))
   }
   # derivate dependent measured fluxes
   i=grep("d.n.", nm_list$fmn, fixed=T, value=TRUE)
   if (length(i) > 0) {
      res[i,]=as.matrix(nb_f$dfl_dffg[i,1:length(nm_list$ff)])
   }
   return(res)
}

plot_ti=function(ti, x, m=NULL, ...) {
   # plot time curse curves x[icurve, itime] and points from m
   # x and m are supposed to have the same dimension and organization
   nm=rownames(x)
   nb_curve=nrow(x)
   if (is.null(nm)) {
      nm=1:nb_curve
   } else {
      o=order(nm)
      nm=nm[o]
      x=x[o,,drop=FALSE]
      if (!is.null(m) && nrow(x)==nrow(m)) {
         m=m[o,,drop=FALSE]
      }
   }
   # x and m may have different time moments
   if (is.null(m)) {
      tim=ti
      inna=c()
   } else {
      tim=as.numeric(colnames(m))
      inna=which(!is.na(m))
   }
   plot(range(ti, tim), range(c(x,m[inna])), t="n", ylab="Labeling", xlab="Time", ...)
   matplot(ti, t(x), t="l", lty=1:nb_curve, col=1:nb_curve, lwd=2, add=TRUE)
   legend("topright", legend=nm, lty=1:nb_curve, col=1:nb_curve, lwd=2, cex=0.75)
   if (!is.null(m)) {
      # plot measured points
      for (i in 1:nrow(m)) {
         inna=which(!is.na(m[i,]))
         points(tim[inna], m[i,inna], col=i, cex=0.5, t="b", lwd=0.5)
         if (nrow(m) == nb_curve) {
            # draw filled polygons between simulation and data
            polygon(c(ti,rev(tim[inna])), c(x[i,], rev(m[i,inna])), col=rgb(red=t(col2rgb(i)), alpha=31, max=255), bord=FALSE)
         }
      }
   }
}

get_usm=function(f) {
   # return list of ti, usm from a _res.kvh file f

   # get skip and end number in the kvh
   d=kvh_get_matrix(f, c("simulated unscaled labeling measurements"))
   ti=as.numeric(colnames(d))
   o=order(rownames(d))
   return(list(ti=ti, usm=d[o,,drop=FALSE]))
}

get_labcin=function(f, nm_meas=NULL) {
   # get labeling cinetic data form file f
   # with rows matching at the best nm_meas (if any)
   d=as.matrix(read.table(f, header=T, row.names=1, sep="\t", check=F, comment=""))
   # strip the last field (row id) in nm_meas and make it correspond
   # to rownames of d
   if (is.null(nm_meas)) {
      return(d)
   }
   nm_r=rownames(d)
   nm=sapply(nm_meas, function(s) {
      v=strsplit(s, ":", fix=TRUE)[[1]]
      v[length(v)]=""
      pmatch(paste(v, sep=":", collapse=":"), nm_r)
   })
   nm=nm[!is.na(nm)]
   return(d[nm,])
}

get_hist=function(f, v) {
   # matrix from history field from a _res.kvh file f

   # get skip and end number in the kvh
   d=kvh_get_matrix(f, c("history", v))
   return(d)
}

spr2emu=function(spr, nm_incu, nm_inemu, nb) {
   # translate spAbr structure written for reduced cumo into
   # spemu structure for EMU
   # each term f_i*x_j*x_k in b is converted into a Cauchy product terms
   # f_i*Sum_p,q[(e_e(j)+Mp)*(e_e(k)+Mq)] where p+q=current emu weight (iwe)
   # emu weight (iwe) runs from 1 (+M0) to iwc (+M(iwc-1)). 
   # So for each cumoweight iwc there will be iwc columns in the final b vector
   # Input:
   # spr - cumomer sparse structures
   # nm_incu - vector of cumomer (i.e. fragment) names
   # of length 1+inp+cumo
   # nm_inemu - names of emu components ("one"+input+emu)
   # nb is list of various numbers (cumomers, emus and so on)
   
   # Returns spr structure for emu
   # 2012-07-12 sokol
   # 2016-09-25 sokol: adapted for arbitrary reaction length
   nw=length(spr)
   spemu=spr
   if (nw < 1) {
      return(spemu)
   }
   nb_xiemu=nb$xiemu
   #x2tb_f=spr[[1]]$x2tb_f
   nme2iemu=seq_along(nm_inemu)
   names(nme2iemu)=nm_inemu
   ba_e=length(nm_inemu)
   
   # cumo weights are always starting from 1 to weight max
   # if there is only one weight (max), the lower weights must be present
   # but corresponding matrices and vectors are of dim=0

   # for iwc==1 emu+M1 are identical to cumomers
   # and the system A*x=b for emu+M0 does not change as
   # all fluxes in A and b sum to 0.
   for (iwc in seq_len(nw)) {
      # iwc is the resulting fragment length
      sp=spr[[iwc]]
      spemu[[iwc]]=sp
      nb_c=sp$nb_c
      if (nb_c == 0) {
         next
      }
#browser()
      ind_b=sp$ind_b
      ind_b_emu=NULL
      nb_ind=nrow(ind_b)
      nprodx=ncol(ind_b)-2
      nm_c=nm_incu[c(ind_b[,2+seq_len(nprodx)])]
      iprodx=seq_len(nprodx)
      if (iwc > 1 && nprodx > 1) {
         ba_e=1+nb_xiemu
         # prepare names
         dim(nm_c)=c(nb_ind, nprodx)
         # get fragment length for each ind_x which is product of several terms
         flen=vapply(strsplit(nm_c, ":"), function(v) if (length(v) > 1) sumbit(as.numeric(v[2])) else 0, 1)
         dim(flen)=dim(nm_c)
         wid=apply(flen, 1, paste0, collapse=",")
         wdisp=list() # weight dispatcher helper
         for (ir in seq_len(nb_ind)) {
            v=flen[ir,]
            if (!is.null(wdisp[[wid[ir]]]))
               next
            m=Reduce(`%m+%`, v);
            wdisp[[wid[ir]]]=lapply(seq_len(iwc-1), function(i) which(m==i, arr.ind=TRUE)-1)
         }
      }
     
      for (iwe in seq_len(iwc)) {
         # iwe runs from m+0 to m+(iwc-1) to form all masses but last for
         # the current fragment length.
         if (iwe == 1L || nprodx == 1L) {
            # For m+0 (iwe=1) vector b is the same in cumo and emu
            tmp=cbind(iwe=iwe, ind_b)
            tmp[,3L+iprodx]=nme2iemu[paste(nm_c, iwe-1L, sep="+")]
            ind_b_emu=rbind(ind_b_emu, tmp)
         } else {
            for (ir in seq_len(nb_ind)) {
               addw=wdisp[[wid[ir]]][[iwe-1]]
               ie=nme2iemu[paste(rep(nm_c[ir,], each=nrow(addw)), addw, sep="+")] # row emu names
               dim(ie)=c(nrow(addw), nprodx)
               ind_b_emu=rbind(ind_b_emu, cbind(iwe, ind_b[ir,1L], ind_b[ir,2L], ie))
            }
         }
      }
      ind_b_emu[is.na(ind_b_emu)]=1 # ones stay ones
      spemu[[iwc]]$ind_b_emu=ind_b_emu
      # prepare b_x
      ind_bx=c()
      if (length(sp[["ind_bx"]]) > 0) {
         for (ix in iprodx) {
            i=ind_b_emu[,3L+ix] > ba_e # exclude from differentiation plain input entries
            tmp=ind_b_emu[i,,drop=FALSE]
            ind_bx=rbind(ind_bx, tmp[,c(1L:3L,ix+3L,3L+iprodx[-ix])]) # move diff var to ic1 place
         }
         if (length(ind_bx)) {
            colnames(ind_bx)=c("iwe", "indf", "irow", "ic1", sprintf("indx%d", seq_len(nprodx-1)))
            ind_bx[,"ic1"]=ind_bx[,"ic1"]-ba_e
            ind_bx[,"irow"]=ind_bx[,"irow"]+(ind_bx[,"iwe"]-1)*nb_c
         }
      }
      spemu[[iwc]]$ind_bx_emu=ind_bx
      spemu[[iwc]]$nb_emul=sum(head(nb$emus, iwc-1))
   }
   return(spemu)
}

opt_wrapper=function(param, method, measurements, jx_f, labargs, trace=1) {
   oldmeas=labargs$measurements
   labargs$measurements=measurements
   labargs$jx_f=jx_f
   if (method == "BFGS") {
#browser()
      control=list(maxit=500L, trace=trace)
      control[names(control_ftbl$BFGS)]=control_ftbl$BFGS
      res=constrOptim(param, cumo_cost, grad=cumo_gradj,
         ui, ci, mu = 1e-5, control,
         method="BFGS", outer.iterations=100L, outer.eps=1e-08,
         labargs)
   } else if (method == "Nelder-Mead") {
      control=list(maxit=1000, trace=trace)
      control[names(control_ftbl[["Nelder-Mead"]])]=control_ftbl[["Nelder-Mead"]]
      res=constrOptim(param, cumo_cost, grad=cumo_gradj,
         ui, ci, mu = 1e-4, control,
         method="Nelder-Mead", outer.iterations=100, outer.eps=1e-08,
         labargs)
   } else if (method == "SANN") {
      control=list(maxit=1000, trace=trace)
      control[names(control_ftbl$sann)]=control_ftbl$sann
      res=constrOptim(param, cumo_cost, grad=cumo_gradj,
         ui, ci, mu = 1e-4, control,
         method="SANN", outer.iterations=100, outer.eps=1e-08,
         labargs)
   } else if (method == "nlsic") {
      control=list(trace=trace, btfrac=0.8, btdesc=0.1, maxit=50, errx=1.e-5,
         ci=list(report=FALSE), history=FALSE, adaptbt=TRUE, sln=sln,
         maxstep=max(10.*sqrt(norm2(param)), 1.),
         rcond=1.e7
      )
      control[names(control_ftbl$default)]=control_ftbl$default
      control[names(control_ftbl$nlsic)]=control_ftbl$nlsic
      res=nlsic(param, lab_resid, 
         ui, ci, control, e=ep, eco=cp, flsi=lsi_fun,
         labargs)
   } else if (method == "ipopt") {
      control=list(max_iter=500, print_level=trace*5)
      control[names(control_ftbl$ipopt)]=control_ftbl$ipopt
      tui=c(t(ui))
      eval_g=function(x, labargs) {
         return(ui%*%x)
      }
      eval_jac_g=function(x, labargs) {
         return(tui)
      }
      ui_row_spars=rep.int(1, ncol(ui))
      res=ipoptr(param, cumo_cost, cumo_gradj,
         lb=NULL, ub=NULL,
         eval_g=eval_g,
         eval_jac_g=eval_jac_g,
         eval_jac_g_structure=lapply(1:nrow(ui), function(i)ui_row_spars),
         constraint_lb=ci,
         constraint_ub=rep(1.e19, length(ci)),
         eval_h=NULL,
         eval_h_structure=NULL,
         opts=control,
         ipoptr_environment=new.env(),
         labargs)
      res$par=res$solution
      names(res$par)=nm_par
   } else if (method == "pso") {
      control=list(
         type="SPSO2011",
         trace=trace,
         maxit=100,
         reltol=1.e-2
      )
      control[names(control_ftbl$pso)]=control_ftbl$pso
#print(control_ftbl)
#print(control)
      res=try(psoptim_ic(param, cumo_cost, labargs, mean=0.5, control=control, ui=ui, ci=ci), silent=TRUE)
#print(res)
      if (inherits(res, "try-error")) {
         res=list(err=1L, par=NULL, mes=attr(res, "condition")$message)
      } else {
         tmp=list(err=res$msgcode, par=res$par, mes=res$msg)
         res[c("msg", "par", "msg")]=NULL
         res=c(tmp, res) # preserve the rest of the fields: stats etc.
      }
   } else {
      stop_mes("Unknown minimization method '", method, "'", file=fcerr)
   }
   if (is.null(res$err)) {
      res$err=0L
   }
   labargs$measurements=oldmeas
   return(res)
}

# wrapper for Monte-Carlo simulations
mc_sim=function(imc) {
#cat("mc_sim imc=", imc, "\n")
#print(labargs$spa[[1]])
   #set.seed(seeds[imc])
   #cat(sort(ls(pos=1)), sep="\n", file=sprintf("tmp_%d.log", imc))
   labargs=get("labargs", envir=.GlobalEnv)
   for (item in c("nb_f", "measurements", "case_i", "dirres", "baseshort", "nb_exp"))
      assign(item, labargs[[item]])
   # random measurement generation
#cat("simlab=\n")
#print(head(as.double(refsim$simlab)))
   
   if (case_i) {
      meas_mc=lapply(seq_len(nb_exp), function(iexp) if (nb_f$nb_meas[iexp]) refsim$usm[[iexp]]+rnorm(n=length(refsim$usm[[iexp]]))*measurements$dev$labeled[[iexp]] else NULL)
   } else {
      meas_mc=lapply(seq_len(nb_exp), function(iexp) if (nb_f$nb_meas[iexp]) refsim$simlab[[iexp]]+rnorm(n=length(refsim$simlab[[iexp]]))*measurements$dev$labeled[[iexp]] else NULL)
   }
#cat("meas=\n")
#print(head(meas_mc))
   if (nb_f$nb_fmn) {
      fmn_mc=refsim$simfmn+rnorm(n=length(refsim$simfmn))*measurements$dev$flux
   } else {
      fmn_mc=c()
   }
   if (nb_f$nb_poolm) {
      poolm_mc=refsim$simpool+rnorm(n=length(refsim$simpool))*measurements$dev$pool
   } else {
      poolm_mc=c()
   }
#cat("imc=", imc, "\\n", sep="")
#browser()
   # minimization
   measurements_mc=measurements
   if (case_i) {
      measurements_mc$vec$kin=meas_mc
   } else {
      measurements_mc$vec$labeled=meas_mc
   }
   measurements_mc$vec$flux=fmn_mc
   measurements_mc$vec$pool=poolm_mc
   loc_jx_f=new.env()
#rres=lab_resid(param, TRUE, labargs)
#d=diag(qr(rres$jacobian, LAPACK=TRUE)$qr)
#cat("param=", param, "\n", sep=" ")
#cat("d=", d, "\n", sep=" ")
   res=opt_wrapper(param, tail(methods, 1L), measurements_mc, loc_jx_f, labargs, trace=0)
   #save(res, file=sprintf("mc_%d.RData", imc))
   if (res$err && !is.null(res$mes) && nchar(res$mes) > 0) {
   #if (TRUE) {
      fclog=file(file.path(dirres, "tmp", sprintf("%s.%smc%d.log", baseshort, runsuf, imc)), "wb")
      cat((if (res$err) "***Error" else "***Warning"), " in Monte-Carlo i=", imc, ": ", res$mes, "\n", file=fclog, sep="")
      close(fclog)
      if (res$err) {
         res=list(cost=NA, it=res$it, normp=res$normp, par=res$par, err=res$err)
         rm(loc_jx_f)
         gc()
         return(list(cost=NA, it=res$it, normp=res$normp, par=res$par, err=res$err))
      }
   }
   # return the solution
   iva=!is.na(res$res)
   vres=res$res[iva]
   res=list(cost=crossprod(vres)[1], it=res$it, normp=res$normp, par=res$par, err=res$err)
   rm(loc_jx_f)
   gc() # for big problems we run easily out of memory
   return(res)
}
cl_worker=function(funth=NULL, argth=NULL) {
   if ("labargs" %in% names(argth))
      labargs=argth$labargs
   tryCatch({
#cat("cl_worker imc=", imc, "\tmem=", sum(memuse()), "\n", sep="")
#print(ls(labargs$spa[[1]]))
      #if (is.null(labargs$spa[[1]]$a)) {
      #   labargs$spa=sparse2spa(labargs$spa)
#print(labargs$spa[[1]])
      #}
#print(labargs$spa[[1]]$a)
#browser()
      do.call(funth, argth)
#cat("i=", i, "\tmem=", sum(memuse()), "\n", sep="")
   },
   error=function(e) {
      traceback()
      print(e)
      stop(e)
   })
}

fallnx2fwrv=function(fallnx, nb_f) {
   n=length(fallnx)
   # extract and reorder in fwrv order
   net=fallnx[nb_f$inet2ifwrv]
   xch=fallnx[nb_f$ixch2ifwrv]
   # expansion 0;1 -> 0;+inf of xch (second half of fallnx)
   xch=xch/(1-xch)
   # fw=xch-min(-net,0)
   # rv=xch-min(net,0)
   fwrv=c(xch-pmin(-net,0),xch-pmin(net,0))
   return(fwrv)
}
stm_pm=function(e1, e2, pm=c("+", "-"), pos=if (e1$nrow*e1$ncol < 2251799813685248 && e2$nrow*e2$ncol < 2251799813685248) match(e2$i+e2$j*e2$nrow, e1$i+e1$j*e1$nrow, nomatch=0L) else match_ij(e2$i, e2$j, e1$i, e1$j), ind=which(pos == 0L)) {
   # 2**51 is the max matrix size that fits the length of double mantissa (53 bits))
   if (pm == "+") {
      e1$v[pos] = e1$v[pos] + e2$v[pos > 0L]
      e1$v = c(e1$v, e2$v[ind])
   } else {
      e1$v[pos] = e1$v[pos] - e2$v[pos > 0L]
      e1$v = c(e1$v, -e2$v[ind])
   }
   e1$i = c(e1$i, e2$i[ind])
   e1$j = c(e1$j, e2$j[ind])
   return(e1)
}
# reorder indexes to accelerate sparse matrix construction
sparse2spa=function(spa) {
   for (ispa in seq_along(spa)) {
      l=spa[[ispa]];
      if (l$nb_c == 0) {
         l$a=Rmumps$new(integer(0L), integer(0L), double(0L), l$nb_c)
         l$b=simple_triplet_matrix(i=integer(0L), j=integer(0L), v=double(0L), nrow=l$nb_c, ncol=1)
         next
      }
      l$l=l;
      with(l, {
#browser();
      if (!is.matrix(ind_a))
         ind_a=t(ind_a)
      if (!is.matrix(ind_b))
         ind_b=t(ind_b)
      # prepare sparse xmat where col_sums(xmat) will give a$v
      iv0=ind_a[,"ir0"]+ind_a[,"ic0"]*nb_c
      o=order(iv0)
      ind_a=ind_a[o,]
      iv0=iv0[o]
      lrep=lrepx=rle(iv0)
      lrepx$values=seq_along(lrep$values)
      xmat=simple_triplet_matrix(i=unlist(lapply(lrep$lengths, seq_len)),
         j=inverse.rle(lrepx), v=rep(1, length(iv0)))
      iu0=lrep$values
      i=as.integer(iu0%%nb_c)
      j=as.integer(iu0%/%nb_c)
      l$a=Rmumps$new(i, j, rep(pi, length(iu0)), nb_c)
#cat("sparse2spa: nb_c=", nb_c, "\n")
      if (!is.null(control_ftbl$mumps)) {
#if (interactive()) browser()
         lapply(grep("^icntl_", names(control_ftbl$mumps), v=TRUE), function(nm) {
            i=suppressWarnings(as.integer(strsplit(nm, "_")[[1L]][2]))
            v=suppressWarnings(as.integer(control_ftbl$mumps[[nm]]))
            if (!is.na(i) && !is.na(v))
               l$a$set_icntl(v, i)
         })
      }
      l$iadiag=which(i==j)
      # prepare sparse bmat where col_sums(bmat) will give b$v
      if (emu && !is.null(l$ind_b_emu)) {
         if (!is.matrix(ind_b_emu))
            ind_b_emu=t(ind_b_b_emu)
         iv0=ind_b_emu[,"irow"]+(ind_b_emu[,"iwe"]-1)*nb_c-1L
         nb_bcol=w
         o=order(iv0)
         ind_b_emu=ind_b_emu[o,,drop=FALSE]
      } else {
         iv0=ind_b[,"irow"]-1L
         nb_bcol=1L
         o=order(iv0)
         ind_b=ind_b[o,,drop=FALSE]
      }
#browser()
      iv0=iv0[o]
      lrep=lrepx=rle(iv0)
      lrepx$values=seq_along(lrep$values)
      bmat=simple_triplet_matrix(i=unlist(lapply(lrep$lengths, seq_len)),
         j=inverse.rle(lrepx), v=rep(1, length(iv0)))
      iu0=lrep$values
      i=as.integer(iu0%%nb_c)
      j=as.integer(iu0%/%nb_c)
      l$b=simple_triplet_matrix(i=i+1, j=j+1, v=rep(pi, length(iu0)), nrow=nb_c, ncol=nb_bcol)
   })}
   return(spa)
}
`%m+%`=function(m, n) outer(if (is.array(m)) m else seq(0, m), seq(0, n), "+")

# Copyright 2011-2014, INRA, France
# Author: Serguei SOKOL, sokol@insa-toulouse.fr
# License: GPL v2 http://www.gnu.org/licenses/gpl-2.0.html

# define cBind(), rBind() if Matrix is not loaded
if (!exists("cBind", mode="function")) {
   #cat("cBind not found\n")
   cBind=cbind
   rBind=rbind
}
if (!exists("join", mode="function")) {
   #cat("cBind not found\n")
   join=function(sep, v, ...) {
      # convert elements of vector v (and all following arguments)
      # in strings and join them using sep as separator.
      return(paste(c(v,...), sep="", collapse=sep))
   }
}

nlsic=function(par, r, u=NULL, co=NULL, control=list(), e=NULL, eco=NULL, flsi=lsi, ...) {
#print(match.call())
   # solve non linear least square problem min ||r(par,...)$res||
   # with optional inequality constraints u*par>=co
   # and optional equality constraints e*par=eco
   # Parameters:
   # - par is initial values for parameter vector (can be in non feasible domain)
   # - r is a function calculating residual vector
   # by a call to r(par, cjac=T|F, ...)
   # par is a current paramenter vector,
   # ... are params passed through to r()
   # and cjac is set to TRUE if jacobian is required
   # The call to r() must return a list having a field "res" containing the residual vector and optionnaly a field "jacobian"
   # when cjac is set to TRUE.
   # - u linear constrant matrix in u*par>=co
   # - co constraint vector
   # controls (=by default values):
   # - errx=1.e-7 error on l2 norm of the iteration step sqrt(pt*p).
   # - maxit=100 maximum of newton iterations
   # - btstart=1 staring value for backtracking coefficient coefficient
   # - btfrac=0.5 (0;1) by this value we diminish the step till tight up
   # to the quadratic model of norm reduction in backtrack (bt) iterations
   # - btdesc=0.1 (0;1) how good we have to tight up to the quadratic model
   # 0-we are very relaxe, 1 we are very tight (may need many bt iterations)
   # - btmaxit=15 maximum of backtrack iterations
   # - btkmin=1.e-7 a floor value for backtracking fractioning
   # - trace=0 no information is printed during iterations (1 - print is active)
   # - rcond=1.e10 maximal condition number in QR decomposition
   #   starting from which a matrix is considered as numerically rank
   #   deficient. The inverse of this number is also used as a measure of very
   #   small number.
   # - ci = list of options relative to confidence interval estimation
   #  + p=0.95 p-value of confidence interval. If you need a plain sd value,
   #    set p-value to 0.6826895
   #  + report=T report (or not and hence calculate or not) confidence
   #       interval information (in the field hci, as 'half confidence interval' width)
   # - history=TRUE report or not the convergence history
   # - adaptbt=FALSE use or not adaptive backtracking
   # - mnorm=NULL a norm matrix for a case sln==TRUE (cf next parameter)
   # - sln=FALSE use or not (default) least norm of the solution
   #   (instead of least norm of the increment)
   # - maxstep=NULL a maximal norm for increment step (if not NULL), must be positive
   # - monotone=FALSE should or not the cost decrease be monotone. If TRUE, then at
   #    first non decrease of the cost, the iterations are stopped with a warning message.
   # Output:
   # - list(par, <some convergence information>)
   # Method:
   # sequential lsi globalized by backtracking technique.
   # If e, eco are not NULL, reduce jacobian before lsi() call.
   # Notes:
   # If the function r() returns a list having a field "jacobian" it is
   # supposed to be equal to the jacobian dr/dpar.
   # If not, numerical derivation numDeriv::jacobian()
   # is used for its construction.
   
   n=length(par)
   m=NROW(co)
   nm_par=names(par)
   
   # predefined controls, then overwritten by actual values
   con=list(errx=1.e-7, maxit=100, btstart=1., btfrac=0.5, btdesc=0.1,
      btmaxit=15, btkmin=1.e-7, trace=0, rcond=1.e10, ci=list(p=0.95, report=T),
      history=FALSE, adaptbt=FALSE, mnorm=NULL, sln=FALSE, maxstep=NULL, monotone=FALSE)
   nmsC=names(con)
   nmsci=names(con$ci)
   # predefined confidence interval parameters, then overwritten
   ci=con$ci
   if (!is.null(control$ci)) {
      ci[(namci <- names(control$ci))] <- control$ci
   } else {
      namci <- names(con$ci)
   }
   con[(namc <- names(control))] <- control
   con$ci=ci
   mes=NULL
   if (length(noNms <- namc[!namc %in% nmsC])) {
      mes=join("", "nlsic: unknown name(s) in control: ", join(", ", noNms))
      return(list(par=NULL, error=1, mes=mes))
   }
   if (length(noNms <- namci[!namci %in% nmsci])) {
      mes=join("", "nlsic: unknown names in control$ci: ", join(", ", noNms))
      return(list(par=NULL, error=1, mes=mes))
   }
   if (!is.null(con$maxstep) && con$maxstep <= 0.) {
      mes=sprintf("nlsic: maxstep parameter in control list must be positive, got %g instead", con$maxstep)
      return(list(par=NULL, error=1, mes=mes))
   }
   if (!is.null(con$maxstep) && con$maxstep <= con$errx) {
      mes=sprintf("nlsic: maxstep parameter in control list is less than errx (maxstep=%g, errx=%g)", con$maxstep, con$errx)
      return(list(par=NULL, error=1, mes=mes))
   }
   
   # history matrices
   hpar=hp=hstep=hres=c()
   if (con$history) {
      hpar=cBind(received=par)
      hist=list()
   } else {
      hist=NULL
   }
   
   if (!is.null(e)) {
      e=matrix(e, ncol=n)
      ne=nrow(e)
   } else {
      ne=0
   }
   econstr=!is.null(e) && !is.null(eco) && nrow(e)>0 && ncol(e)==length(par)

   # make u matrix if u=NULL
   if (is.null(u)) {
      u=matrix(0, nrow=0, ncol=n)
      co=c()
   }
   if (econstr) {
      nr=nrow(e)
      nc=ncol(e)
      if (nr > nc) {
         return(list(par=NULL, error=1, mes="nlsic: matrix e is over determined."))
      }
      # affine transform epar -> par s.t. e*par=eco
      # par=parp+Null(t(e))%*%epar, where epar is new parameter vector
      nte=Nulla(t(e))
      qe=attr(nte, "qr")
      if (qe$rank < nr) {
         return(list(par=NULL, error=1, mes="nlsic: matrix e is rank deficient."))
      }
      # particular solution
      parp=qr.qy(qe, c(backsolve(qe$qr, eco[qe$pivot], trans=T), double(n-nr)))
      ue=u%*%nte
      epar=crossprod(nte, c(par)-parp)
      par[]=nte%*%epar+parp
   }
   ine=if (nrow(u) > 0) co-u%*%c(par) else NULL
   if (!is.null(ine) && any(ine > 1./con$rcond)) {
      # project par into feasible domain
      # in case if residual function is defined only on feasible domain
      if (econstr) {
         x=ldp(ue, ine, con$rcond)
         if (is.null(x)) {
            return(list(
               par=NULL,
               error=1,
               mes="nlsic: Unfeasible constraints at starting point"
            ))
         }
         laststep=nte%*%x
         par[]=c(par)+laststep
      } else {
         x=ldp(u, ine, con$rcond)
         if (is.null(x)) {
            mes="nlsic: Unfeasible constraints at starting point (u%*%par-co>0):"
            if (!is.null(rownames(u))) {
               mes=join("\n", c(mes, paste(rownames(u), " (", -ine, ")", sep="")))
            }
            return(list(
               par=NULL,
               error=1,
               mes=mes
            ))
         }
         laststep=x
         par[]=c(par)+laststep
      }
   }
   
   # newton globalized iterations
   it=0
   btit=0
   converged=F
   laststep=par
   laststep[]=0.
   p=laststep
   while (!converged && it < con$maxit) {
      mes=NULL
      if (it == 0) {
#browser()
         # residual vector
#cat("jac it=0", par, sep="\n")
         lres=r(par, cjac=TRUE, ...)
         if (!is.null(lres$err) && lres$err) {
            return(list(
               par=c(par),
               retres=lres,
               it=it,
               btit=btit,
               error=1,
               mes=paste("nlsic: Problem in first residual calculation",
                  lres$mes, sep="\n"))
            )
         }
         res=as.numeric(lres$res)
         iva=which(!is.na(res)) # valid entries in res
         if (length(iva)==0) {
            # we check it only at it=0 hoping that NA-structure remains the same
            # all the long ietrations
            return(list(
               par=NULL,
               error=1,
               mes="nlsic: no valid residual value."
            ))
         }
         vres=res[iva]
         b=-res
         norb=sqrt(norm2(vres))
         #cat("norb0=", norb, "\n", sep="")
         norres=norb
         klast=0
         if (con$trace) {
            cat("it=", it, "\tres=", norb, "\n", sep="")
         }
         if (norb < 1.e-20) {
            # we are already at solution point
            converged=TRUE
            normp=0
            a=NULL
            next
         }
      } else {
         b=-res
         norb=norres
      }
      # jacobian
      a=NULL
      if ("jacobian" %in% names(lres) && !is.null(lres$jacobian)) {
         a=lres$jacobian[iva,,drop=FALSE]
         colnames(a)=nm_par
      } else {
         # may be we are here because the last call was with cjac=FALSE
         if (it > 0) {
#cat("jac", par, sep="\n")
            lres=r(par, cjac=TRUE, ...)
            res=as.numeric(lres$res)
            iva=!is.na(res)
            vres=res[iva]
            b=-res
            norres=sqrt(norm2(vres))
            norb=norres
            if ("jacobian" %in% names(lres) && !is.null(lres$jacobian)) {
               a=lres$jacobian[iva,,drop=FALSE]
               colnames(a)=nm_par
            }
         }
      }
      if (is.null(a)) {
         # needs something like library(numDeriv) before calling nlsic()
         a=jacobian(function(x) as.numeric(r(x, cjac=FALSE, ...)$res), par)[iva,,drop=FALSE]
         colnames(a)=nm_par
      }
      # solve linear ls
      
      ine=if (nrow(u) > 0) co-u%*%c(par) else NULL
      # newton direction
      if (econstr) {
         if (con$sln) {
            p=flsi(a%*%nte, -vres, ue, ine, rcond=con$rcond, con$mnorm, -c(par))
         } else {
            p=flsi(a%*%nte, -vres, ue, ine, rcond=con$rcond)
         }
         p=nte%*%p
      } else {
         if (con$sln) {
            p=flsi(a, -vres, u, ine, rcond=con$rcond, con$mnorm, -c(par))
         } else {
            p=flsi(a, -vres, u, ine, rcond=con$rcond)
         }
      }
      names(p)=nm_par
#browser()
      if (con$history) {
         hpar=cBind(hpar, par)
         colnames(hpar)[ncol(hpar)]=it
         hp=cBind(hp, c(p))
         hres=cBind(hres, res)
         hist=list(par=hpar, p=hp, res=hres, step=hstep)
      }
      if (anyNA(p)) {
         names(par)=nm_par
         return(list(
            par=c(par),
            it=it,
            btit=btit,
            error=1,
            history=hist,
            jacobian=a,
            retres=lres,
            mes=paste("nlsic: Problem in solving linear problem with constraint",
               attr(p, "mes"), sep="\n")))
      } else if (! is.null(attr(p, "mes"))) {
         mes=join("\n", mes, attr(p, "mes"))
      }
      
      normp=sqrt(norm2(p))
      converged=(normp <= con$errx)
      if (normp == 0) {
         ############### no need for backtracking at this stage
         laststep=p
         par[]=c(par)+laststep
         it=it+1
         btit=0
         resdecr=NULL
#cat("normp=0", par, sep="\n")
         res=as.numeric(r(par, cjac=FALSE, ...)$res)
         iva=!is.na(res)
         vres=res[iva]
         norres=sqrt(norm2(vres))
         if (con$history) {
            hstep=cBind(hstep, c(laststep))
            hist=list(par=hpar, p=hp, res=hres, step=hstep)
         }
         if (con$trace && (it < 10 || !it%%10)) {
            cat("it=", it, "\tres=", norres, "\tnormstep=", normp, "\tbtk=", klast, "\n", sep="")
         }
         break
      }
      # check if the direction p is descending
      ap=as.double(a%*%p)
      n2ap=norm2(ap)
      resap=crossprod(vres, ap)
      if (resap > 0.) {
         laststep=p*NA
         mes=paste("nlsic: LSI returned not descending direction",
            attr(p, "mes"), sep="\n")
         break
      }
      k=con$btstart; # fraction of p
      if (!is.null(con$maxstep)) {
         kms=con$maxstep/normp
         if (kms < k) {
            k=kms
         }
      }
      # backtrack iterations
      btit=0
      descending=FALSE
      while (!descending && btit < con$btmaxit && k >= con$btkmin) {
         laststep=k*p
#cat("btit=", btit, par+c(laststep), sep="\n")
         lres=try(r(par+c(laststep), cjac=FALSE, ...))
         if (inherits(lres, "try-error")) {
            k=max(k*con$btfrac, con$btkmin)
            btit=btit+1
            next
         }
         if (isTRUE(lres$err != 0)) {
            return(list(
               par=c(par),
               laststep=c(laststep),
               retres=lres,
               it=it,
               btit=btit,
               error=1,
               mes=paste("nlsic: Problem in residual calculation",
                  lres$mes, sep="\n"))
            )
         }
         res=as.numeric(lres$res)
         iva=!is.na(res) # valid entries in res
         vres=res[iva]
         norres=sqrt(norm2(vres))
         #cat("norres=", norres, "\n", sep="")
         #scaprod=crossprod(vres, ap)-resap
         #resdecr=sqrt(scaprod); # residual decreasing
         realdecr=crossprod(b[iva]-vres, vres+b[iva]) # normally it is positive
         lindecr=-k*(2*resap+k*n2ap)
         #descending=(
         #   scaprod >=0. &&
         #   sqrt(scaprod) >= con$btdesc*sqrt(n2ap*k) &&
         #   norres < norb
         #)
         descending=(realdecr>=con$btdesc*lindecr)
         klast=k
         if (con$adaptbt) {
            h=max(min(2., 1./(2.-(norres-norb)*(norres+norb)/(resap*k))), con$btfrac)
            # check that p*k*h won't violate inequalities (for h > 1 only)
            if (h > 1. && nrow(u) > 0) {
               if (any(u%*%(c(par)+(k*h)*p)-co <= -1.e-10)) {
                  h=con$btfrac
               }
            }
            k=k*h
            #cat("h=", h, "klast=", klast, "k=", k, "\n")
         } else {
            k=k*con$btfrac
         }
         k=max(k, con$btkmin)
         btit=btit+1
      }
      if (inherits(lres, "try-error")) {
         return(list(
            par=c(par),
            laststep=rep(NA, length(par)),
            retres=lres,
            it=it,
            btit=btit,
            error=1,
            mes="nlsic: residual calculation failed during all backtracking iterations"
         ))
      }

      par[]=c(par)+laststep
      it=it+1
      if (con$monotone) {
         if (norres > norb) {
            converged=T
            mes=join("\n", mes, "nlsic: Non monotone descrease of cost function has occured.")
         }
      }
      if (con$trace && ((it < 10 || !it%%10) || converged)) {
         cat("it=", it, "\tres=", norres, "\tnormstep=", normp, "\tbtk=", klast, "\n", sep="")
      }
      if (con$history) {
         hstep=cBind(hstep, laststep)
         hist=list(par=hpar, p=hp, res=hres, step=hstep)
      }
   }
   if (con$trace && !(it < 10 || !it%%10) && !converged) {
      cat("it=", it, "\tres=", norres, "\tnormstep=", normp, "\tbtk=", klast, "\n", sep="")
   }
   if (it >= con$maxit) {
      mes=join("\n", mes, "nlsic: Maximal non linear iteration number is achieved")
   }
   if (btit >= con$btmaxit) {
      mes=join("\n", mes, "nlsic: Maximal backtrack iteration number is achieved")
   }
   # restore names
   names(par)=names(laststep)=names(p)=nm_par
   # confidence interval
   #browser()
   nr=length(vres)
   fdeg=max(1., nr-n+ne) # freedom degrees
   if (con$ci$report) {
      sd_res=sqrt(sum(vres**2)/fdeg)
      if (is.null(a)) {
#cat("first jac", par, sep="\n")
         a=r(par, TRUE, ...)$jacobian
         if (is.null(a)) {
            # needs something like library(numDeriv) before calling nlsic()
#cat("num jac", par, sep="\n")
            a=jacobian(function(x) as.numeric(r(x, cjac=FALSE, ...)$res), par)
            colnames(a)=nm_par
         }
      }
      if (econstr) {
         jac=a%*%nte
      } else {
         jac=a
      }
      covpar=try(solve(crossprod(jac)), silent=T)
      if (inherits(covpar, "try-error")) {
         sv=svd(jac)
         covpar=tcrossprod(sv$v*rep(1./pmax(sv$d, 1./con$rcond), rep(nrow(sv$v), ncol(sv$v))))
      }
      if (econstr) {
         covpar=nte%*%tcrossprod(covpar, nte)
      }
      dimnames(covpar)=list(nm_par, nm_par)
      d=sqrt(diag(covpar))
      hci=(-qt((1.-con$ci$p)/2., fdeg)*sd_res)*d
      names(hci)=nm_par
   } else {
      sd_res=hci=covpar=ci_fdeg=NULL
   }
   return(list(
      par=c(par),
      lastp=c(p),
      hci=hci,
      ci_p=con$ci$p,
      ci_fdeg=fdeg,
      sd_res=sd_res,
      covpar=covpar,
      laststep=c(laststep),
      normp=normp,
      res=c(res),
      prevres=c(vres),
      jacobian=a,
      retres=lres,
      it=it,
      btit=btit,
      history=hist,
      error=0,
      mes=mes)
   )
}
lsi=function(a, b, u=NULL, co=NULL, rcond=1.e10, mnorm=NULL, x0=NULL) {
   # solve linear least square problem (min ||Ax-b||)
   # with inequality constraints ux>=co
   # Method:
   # 1. reduce the pb to ldp (min(xat*xa) => least distance programming)
   # 2. solve ldp
   # 3. change back to x
   # mnrom, and x0 are dummy parameters which are here to make lsi()
   # compatible with lsi_ln() argument list
   
   if (! is.qr(a)) {
      n=ncol(a)
      aq=qr(a, LAPACK=T)
   } else {
      n=ncol(a$qr)
      aq=a
   }
   d=abs(diag(aq$qr))
#cat("d=", d, "\n")
   aq$rank=sum(d>d[1]/rcond)
   if (is.na(aq$rank)) {
      x=rep(NA, n)
      attr(x, "mes")="lsi: Rank could not be estimated in least squares\n"
      return(x)
   }
   if (aq$rank < n) {
      x=rep(NA, n)
      attr(x, "mes")=
         paste("lsi: Rank deficient matrix in least squares\n",
         n-aq$rank,
         " unsolvable variable(s):\n",
         paste(dimnames(a)[[2]][aq$pivot[-(1:aq$rank)]],
         aq$pivot[-(1:aq$rank)], sep="\t", collapse="\n"), "\n",
         sep="")
      return(x)
   }
   x0=qr.solve(aq, b)
   if (!is.null(u) && nrow(u)>0) {
      # we do have inequalities
      # prepare variable change
      ut=t(backsolve(aq$qr, t(as.matrix(u[, aq$pivot, drop=FALSE])), trans=T))
      xa=ldp(ut, co-u%*%x0, rcond)
      if (is.null(xa)) {
         # Infeasible constraints detected by ldp
         xa=rep(NA, n)
         attr(xa, "mes")="lsi: ldp() revealed unfeasible constrants"
         return(xa)
      }
      x=xa
      xa=backsolve(aq$qr, xa)
      x[aq$pivot]=xa
      x=x+x0
      cou=co-u%*%x
      if (any(cou > 1.e-10)) {
         # round errors made fail inequality constraints
         # force them as much as possible even by degrading the residual
         dx=ldp(u, cou, rcond)
         if (!is.null(dx)) {
            x=x+dx
         } # else leave x as is
      }
   } else {
      # plain QR
      x=x0
   }
   return(x)
}
lsi_ln=function(a, b, u=NULL, co=NULL, rcond=1.e10, mnorm=NULL, x0=NULL) {
   # solve linear least square problem (min ||A*x-b||)
   # with inequality constraints ux>=co
   # If A is rank deficient, least norm solution ||mnorm*(x-x0)|| is used.
   # If the matrix mnorm is NULL, it is supposed to be an identity matrix.
   # If the vector x0 is NULL, it is treated as 0 vector.
   
#if(anyNA(u))
#   browser()
   mes=""
   if (! is.qr(a)) {
      a=as.matrix(a)
      n=ncol(a)
      aq=qr(a, LAPACK=T)
   } else {
      n=ncol(a$qr)
      aq=a
   }
   d=diag(aq$qr)
   aq$rank=sum(abs(d)>abs(d[1])/rcond)
   if (aq$rank == 0) {
      # matrix a is zero => no x can diminish the residual norm
      if (!is.null(u) && nrow(u) > 0) {
         # there are some inequalities to deal with
         if (any(co > 1.e-10)) {
            # at least we satisfy inequalities
            x=ldp(u, co)
            if (is.null(x)) {
               x=rep(NA, n)
               attr(x, "mes")="lsi_ln: matrix a is zero rank and ldp() revealed unfeasible constrants"
            }
            return(x)
         } else {
            # they are already satisfied => return 0 vector
            return(double(n))
         }
      } else {
         # no inequalities
         return(double(n))
      }
   }
   # here after the rank is > 0
   rdefic=aq$rank < n
   if (!rdefic) {
      # just passthrough params to lsi()
      return(lsi(aq, b, u, co, rcond))
   }
   # prepare free variable substitution
   ndefic=n-aq$rank
   i1=seq(len=aq$rank)
   ndefic=n-aq$rank
   i2=seq(aq$rank+1, n, len=ndefic)
   r=qr.R(aq)[i1,,drop=FALSE]
   r1=r[,i1,drop=FALSE]
   r2=r[,i2,drop=FALSE]
   qrr=qr(t(r), LAPACK=T)
   # null space and its complement bases
   ba=qr.Q(qrr, complete=T)
   bal=ba[,i1,drop=FALSE]
   ban=ba[,i2,drop=FALSE]
   # least norm without constraints
   x=bal%*%backsolve(qrr$qr, qr.qty(aq, b)[qrr$pivot], trans=T)
   #x0=backsolve(r1, bt) # implicitly, free variables are set to zero
   #x=c(x0, rep(0., ndefic)) # we unpivot just before return
   #browser()
   if (!is.null(u) && nrow(u)>0) {
      up=u[,aq$pivot,drop=FALSE]
      cou=co-up%*%x
      if (any(cou > 1.e-10)) {
         uz=up%*%ban
         # minimize ||y;z||
         ut=t(backsolve(qrr$qr, t(as.matrix(up%*%bal)), trans=F))
         ut=cBind(ut, uz)
         ya=ldp(ut, cou, rcond)
         if (!is.null(ya)) {
            # move along the borders to diminish ||a*x-b||
            # the solution is searched for in the form
            # y=ya+bau*yz
            # ia are indexes of border equations to add as equality constraints (active set)
            cou=as.numeric(cou-ut%*%ya)
            ia=which(cou > -1.e-10) # must not be empty if we are here
            if (length(ia) == 0L) {
               # but it can happen for badly conditioned ut
               # let take the inequality closest to 0
               ia=which.max(cou)
            }
            bau=Nulla(t(ut[ia,,drop=FALSE]))
#if (anyNA(ut[-ia,,drop=FALSE]%*%bau))
#   cat("sent NA in lsi_ln(.., u, ...)\n")
            yz=lsi_ln(bau[i1,,drop=FALSE], -ya[i1], ut[-ia,,drop=FALSE]%*%bau, cou[-ia], rcond=rcond)
            if (!anyNA(yz)) {
               # got a solution
               ya=ya+bau%*%yz
               dx=bal%*%backsolve(qrr$qr, ya[i1], trans=T)+ban%*%ya[i2]
               x=x+dx
               attr(x, "mes")=attr(yz, "mes")
            } else {
               x=rep(NA, n)
               attr(x, "mes")=join("\n", attr(x, "mes"), "lsi_ln: failed to glide along borders.")
               return(x)
            }
         } else {
            # unfeasible constraints
            x=rep(NA, n)
            attr(x, "mes")="lsi_ln: unfeasible constraints"
            return(x)
         }
         # solve lsi_ln within just Null space (without modifying ||y||)
         cou=co-up%*%x
         if(is.null(mnorm)) {
            mban=ban
            if (is.null(x0)) {
               x0=-x
            } else {
               x0=x0-x
            }
         } else {
            mban=mnorm%*%ban
            if (is.null(x0)) {
               x0=-mnorm%*%x
            } else {
               x0=mnorm%*%(x0-x)
            }
         }
         z=lsi_ln(mban, x0, uz, cou)
         if (!anyNA(z)) {
            x=x+ban%*%z
            attr(x, "mes")=join("\n", attr(x, "mes"), attr(z, "mes"))
         } else {
            #print(list(a=a, b=b, u=u, co=co))
#browser()
            attr(x, "mes")=join("\n", attr(x, "mes"), "lsi_ln: Unfeasible constraints in null space. (It must not be. Round off errors struck again.)")
         }
      }
   }
   x[aq$pivot]=x
   if (!is.null(u)) {
      cou=co-u%*%x
      if (any(cou > 1.e-10)) {
         # round errors made fail inequality constraints
         # force them as much as possible even by degrading the residual
         dx=ldp(u, cou, rcond)
         if (!is.null(dx)) {
            x=x+dx
         } # else leave x as is
      }
   }
   attr(x, "mes")=join("\n", attr(x, "mes"), paste(
      "lsi_ln: Rank deficient matrix in least squares\n",
      ndefic, " free variable(s):\n",
      paste(dimnames(a)[[2]][aq$pivot[i2]],
      aq$pivot[-i1], sep="\t", collapse="\n"),
      "\nLeast L2-norm solution is provided.",
      sep=""))
   return(x)
}
ldp=function(u, co, rcond=1.e10) {
   # solve least distance programing: find x satisfying u*x>=co and s.t. min(||x||)
   # by passing to nnls
   # (non negative least square) problem
   # return x or Null (in case of non-feasible inequalities)
   m=NROW(u)
   n=ncol(u)
   if (m == 0) {
      # no inequality to satisfy => trivial case
      return(double(n))
   }
   rcond=abs(rcond)
   # eliminate 0 rows from u
   maxu=apply(u, 1, function(v) max(abs(v)))
   i0=which(maxu < 1.e-13)
   if (length(i0) > 0) {
      if (all(co[i0] < 1.e-10)) {
         u=u[-i0,,drop=FALSE]
         co=co[-i0]
         m=m-length(i0)
         if (m == 0) {
            # no inequality to satisfy => trivial case
            return(double(n))
         }
      } else {
         # non feasible 0 constraints
         return(NULL)
      }
   }
   
   maxco=max(co)
   if (maxco<=1.e-10) {
      # all rhs are < 0 => trivial case
      return(double(n))
   }
   e=rBind(t(u), t(co))
   f=double(n+1L)
   f[n+1]=1.
   resnnls=nnls::nnls(e, f)
   feasible=sqrt(resnnls$deviance) > 1.e-10 && resnnls$residuals[n+1] != 0.
   if (feasible) {
      x=resnnls$residuals[1:n]/(-resnnls$residuals[n+1])
      # check for numerical stability problems
      ux=u%*%x
      cou=co-ux
      if (FALSE && any(cou > 1.e-10)) { # FALSE because it can worsen the situation
         # second trial
         e[n+1,]=cou
         rn=nnls::nnls(e, f)
         if (rn$residuals[n+1]!=0.) {
            x=x-rn$residuals[1:n]/rn$residuals[n+1]
         } else {
            x=NULL
         }
      } else if (all(cou<0) && !all(x==0.)) {
         # round off error pushed the solution inside of feasible domain
         # shorten it till the closest border
         alpha=ux/co
         alpha=min(alpha[alpha>=1.], na.rm=T)
         x=x/alpha
      }
   } else {
      x=NULL
   }
   return(x)
}
if (length(find("norm2"))==0) {
   norm2=function(v)crossprod(as.numeric(v))[1]
}
ls_ln_old=function(a, b, rcond=1.e10) {
   # least squares with least norm
   # no LAPACK in the second qr()
   if (! is.qr(a)) {
      a=qr(a, LAPACK=T)
   }
   n=ncol(a$qr)
   d=diag(a$qr)
   a$rank=sum(abs(d)>abs(d[1])/rcond)
   rdefic=a$rank < n
   i1=1:a$rank
   i2=(a$rank+1):n
   r=qr.R(a)[i1,,drop=FALSE]
   if (!rdefic) {
      # plain ls
      x=backsolve(r, qr.qty(a, b))
      x[a$pivot]=x
      return(x)
   }
   # prepare free variable substitution
   r1=r[,i1,drop=FALSE]
   r2=r[,i2,drop=FALSE]
   qrr=qr(t(r), LAPACK=F)
   # null space and its complement bases
   ba=qr.Q(qrr, complete=T)
   bal=ba[,i1,drop=FALSE]
   # least norm
   x=bal%*%backsolve(qr.R(qrr), qr.qty(a, b), trans=T)
   x[a$pivot]=x
   return(x)
}
ls_ln=function(a, b, rcond=1.e10) {
   # least squares with least norm
   # LAPACK is called in the second qr() too.
   if (! is.qr(a)) {
      a=qr(a, LAPACK=T)
   }
   n=ncol(a$qr)
   d=diag(a$qr)
   a$rank=sum(abs(d)>abs(d[1])/rcond)
   if (a$rank == 0) {
      return(double(n)) # return plain 0 vector
   }
   rdefic=a$rank < n
   i1=seq(len=a$rank)
   r=qr.R(a)[i1,,drop=FALSE]
   if (!rdefic) {
      # plain ls
      x=backsolve(r, qr.qty(a, b))
      x[a$pivot]=x
      return(x)
   }
   ndefic=n-a$rank
   i2=seq(a$rank+1, n, len=ndefic)
   # prepare free variable substitution
   qrr=qr(t(r), LAPACK=T)
   # least norm
   x=qr.qy(qrr, c(backsolve(qrr$qr, qr.qty(a, b)[qrr$pivot], trans=T), rep.int(0., ndefic)))
   x[a$pivot]=x
   return(x)
}
lsie_ln=function(a, b, u=NULL, co=NULL, e=NULL, ce=NULL, rcond=1.e10) {
   # solve linear least square problem (min ||A*x-b||)
   # with inequality constraints u*x>=co and equality constraints e*x=ce
   # Method:
   # reduce the pb to lsi_ln on the null-space of e
   if (is.qr(a)) {
      n=ncol(a$qr)
      aqr=T
   } else {
      n=ncol(a)
      aqr=F
   }
   if (!is.null(e) && nrow(e) > 0) {
      # x is searched in a form xp+bn*z
      # where xp is a particular solution of e*x=ce
      # bn is a basis of e null space and z is a
      # new unknown vector.
      nr=nrow(e)
      nc=ncol(e)
      if (nr > nc) {
         x=rep(NA, n)
         attr(x, "mes")="lsie_ln: matrix e is over determined."
         return(x)
      }
      bn=Nulla(t(e))
      qe=attr(bn, "qr")
      if (qe$rank < nr) {
         x=rep(NA, n)
         attr(x, "mes")="lsie_ln: matrix e is rank deficient."
         return(x)
      }
      # particular solution
      xp=qr.qy(qe, c(backsolve(qe$qr, ce[qe$pivot], trans=T), double(n-nr)))
      if (aqr) {
         R=qr.R(a, complete=T)
         b=b-qr.qy(a, R%*%xp[a$pivot])
         a=qr.qy(a, R%*%bn[a$pivot,,drop=FALSE])
      } else {
         b=b-a%*%xp
         a=a%*%bn
      }
      if (!is.null(u)) {
         co=co-u%*%xp
         u=u%*%bn
      }
      z=lsi_ln(a, b, u, co, rcond)
      x=xp+bn%*%z
      if (!is.null(attr(z, "mes"))) {
         attr(x, "mes")=attr(z, "mes")
      }
      return(x)
   }
}
ls_ln_svd=function(a, b, rcond=1.e10) {
   # least squares of least norm by svd(a)
   sa=svd(a)
   d=sa$d
   rank=sum(d > d[1L]/rcond)
   if (rank == 0L) {
      return(rep(0., ncol(a)))
   }
   i=seq_len(rank)
   x=sa$v[,i]%*%(crossprod(sa$u[,i], b)/d[i])
   return(x)
}
tls=function(a, b) {
   # total least square by svd
   sab=svd(cbind(a, b))
   n=ncol(a)
   v=sab$v[,length(sab$d)]
   return(v[seq_len(n)]/(-v[n+1L]))
}
lsi_reg=function(a, b, u=NULL, co=NULL, rcond=1.e10, mnorm=NULL, x0=NULL) {
   # solve linear least square problem (min_x ||a*x-b||)
   # with inequality constraints ux>=co
   # If a is rank deficient, regularization term lambda^2*||mnorm*(x-x0)||^2
   # is added to ||a*x-b||^2. The rank is estimated as number of singular values
   # above d[1]*1.e-10 where d[1] is the highest singular value.
   # The scalar lambda is an optional positive parameter
   # and is treated as relative to the highest singular value of a.
   # Its value is calculated from rcond parameter (which is preserved
   # for compatibility with others lsi_...() functions
   # At return, lambda can be found in attributes of the returned vector x.
   # NB. lambda is set to NA
   # if rank(a)==0 or a is of full rank or if there is no inequality.
   # If the matrix mnorm is NULL, it is supposed to be an identity matrix.
   # If the vector x0 is NULL, it is treated as 0 vector.
   # Return: the solution vector x with attribute "lambda"
   
   mes=""
   lambda=1./sqrt(rcond)
   if (is.qr(a)) {
      # get back the matrix from qr
      a=qr.X(a)
   }
   n=ncol(a)
   m=nrow(a)
   if (m < n) {
      # make nrow(a) >= ncol(a) by repeating a and b as many times as needed
      nrep=ceiling(n/m)
      a=aperm(array(a, dim=c(m, n, nrep)), c(1,3,2))
      dim(a)=c(m*nrep, n)
      b=rep(b, nrep)
   }
   sva=svd(a)
   d=sva$d
   arank=sum(d > d[1]*1.e-10)
   x0=if (is.null(x0)) double(n) else x0
   if (arank == 0) {
      # matrix a is zero => no x can diminish the residual norm
      if (!is.null(u) && nrow(u) > 0) {
         # there are some inequalities to deal with
         co0=co-u%*%x0
         if (any(co0 > 1.e-10)) {
            # at least we satisfy inequalities
            if (is.null(mnorm)) {
               dx=ldp(u, co0)
               if (is.null(dx)) {
                  x=rep(NA, n)
                  attr(x, "mes")="lsi_reg: matrix a is zero rank and ldp() revealed unfeasible constrants"
               }
            } else {
               x=lsi_reg(mnorm, mnorm%*%x0, u, co, rcond, NULL, NULL)
            }
         } else {
            # inequalities are already satisfied
            x=x0
         }
      } else {
         # no inequalities
         x=x0
      }
      attr(x, "lambda")=NA
      return(x)
   }
   # hereafter, the arank is > 0
   i=seq_len(arank)
   if (NROW(u) == 0) {
      # no inequality
      # plain ls_ln
      if (arank == n) {
         x=sva$v[,i]%*%(crossprod(sva$u[,i,drop=FALSE], b)/d[i])
         attr(x, "lambda")=NA
      } else {
         mes=sprintf("lsi_reg: Rank deficient matrix in least squares
There is (are) %d free variable(s).
Regularized L2-norm solution is provided.", n-arank)
         if (is.null(mnorm)) {
            mnorm=diag(1., n)
         }
         lambda=d[1]*lambda
         lam2=lambda**2
         d2=diag(d**2, n)
         mv=mnorm%*%sva$v
         mv2=crossprod(mv)
         bx0=crossprod(mv, mnorm%*%x0)
         bt=d*crossprod(sva$u, b)+lam2*x0
         x=sva$v%*%solve(d2+lam2*mv2, d*bt)
         attr(x, "lambda")=lambda
         attr(x, "mes")=mes
      }
   } else {
      # there are inequalities
      if (arank == n) {
         # a is of full rank => no lambda to use, plain lsi
         invd=1./d
         bt=crossprod(sva$u, b)
         ut=(u%*%sva$v)*rep(invd, rep(n, n))
         y=ldp(ut, co-ut%*%bt)
         x=sva$v%*%(invd*(y+bt))
         attr(x, "lambda")=NA
      } else {
         mes=sprintf("lsi_reg: Rank deficient matrix in least squares
There is (are) %d free variable(s).
Regularized L2-norm solution is provided.", n-arank)
         if (is.null(mnorm)) {
            mnorm=diag(1., n)
         }
         # transformed rhs
         mv=mnorm%*%sva$v
         bx0=crossprod(mv, mnorm%*%x0)
         bt=d*crossprod(sva$u, b)
         # semi-transformed u (it lacks a factor 1/(d**2+(lambda*mv)**2) )
         uv=u%*%sva$v
         mv2=crossprod(mv)
         # ldp to find approximate solution
         lambda=d[1]*lambda
         lam2=lambda**2
         d2=diag(d**2, n)+lam2*mv2
         ut=t(solve(t(d2), t(uv)))
         btt=bt+lam2*bx0
         y=ldp(ut, co-ut%*%btt)
         x=sva$v%*%solve(d2, btt+y)
         attr(x, "lambda")=lambda
         attr(x, "mes")=mes
      }
   }
   return(x)
}
uplo2uco=function(param, upper=NULL, lower=NULL, linear=NULL) {
   # Return a list with a matrix u and a vector co such that u%*%param-co>=0
   # translates the inequalities param <= upper and param >= lower
   # Names in upper and lower must be present in names of param
   nm_par=names(param)
   nlo=length(lower)
   nup=length(upper)
   nli=length(linear)
   u=matrix(0., nrow=nup+nlo+nli, ncol=length(param))
   co=numeric(nrow(u))
   colnames(u)=nm_par
   rownames(u)=c(
      if (nup) paste(names(upper), " <= ", upper, sep="") else NULL,
      if (nlo) paste(names(lower), " >= ", lower, sep="") else NULL,
      linear
   )
   names(co)=rownames(u)
   # fill u and co
   if (nup) {
      u[seq_len(nup), names(upper)]=diag(-1, nup)
      co[seq_len(nup)]=-upper
   }
   u[nup+seq_len(nlo), names(lower)]=diag(1, nlo)
   co[nup+seq_len(nlo)]=lower

   # parse inequalities
   if (nli) {
      vema=try(equa2vecmat(nm_par, linear, sep=">="))
      if (inherits(vema, "try-error")) {
         stop("Error in parsing inequalities")
      }
      i=nup+nlo+seq_len(nli)
      u[i, ]=vema[,-1L]
      co[i]=vema[,1L]
   }
   return(list(u=u, co=co))
}
equa2vecmat=function(nm_par, linear, sep="=") {
   # parse a text vector of linear equations and produce a corresponding
   # matrix and right hand side vector
   # Input:
   #  - nm_par a text vector of variable names. It will be used in the symbolic
   # derivation.
   #  - linear is a text vector of linear equations like "a+2*c+3*b = 0"
   #  - sep is the separator of two parts of equations. Use for example
   #    ">=" for linear inequalities
   # Return: an augmented matrix. Its first column is the rhs vector.
   # Other columns are named by nm_par.
   # If the vector linear is NULL or its content is empty a NULL is returned
   
   # Sanity check
   stopifnot(length(sep)==1 && nchar(sep) > 0)
   stopifnot(length(nm_par)>=1 && all(nchar(nm_par)) > 0)
   
   vlin=sapply(linear, function(it) strsplit(it, sep)[[1]])
   if (length(vlin) && !is.matrix(vlin)) {
      stop(sprintf("Linear (in)equalities are expected to have '%s' sign in them", sep))
   }
   if (length(vlin) == 0) {
      # we are set
      return(NULL)
   }
   # each column in vlin is an (in)equality
   # first row is left part, the second row is the right part
   # derive left and right parts to get the matrix
   ze=double(length(nm_par))
   names(ze)=nm_par
   ze=as.list(ze)
   de=apply(vlin, 2L, function(ineq) {
      le=with(ze, eval(deriv(parse(text=ineq[1]), nm_par)))
      ri=with(ze, eval(deriv(parse(text=ineq[2]), nm_par)))
      v=c(ri-le, attr(le, "gradient")-attr(ri, "gradient"))
      return(v)
   })
   rownames(de)=c("rhs", nm_par)
   return(t(de))
}
lsi_lim=function(a, b, u=NULL, co=NULL, rcond=1.e10, mnorm=NULL, x0=NULL) {
   suppressWarnings(limSolve::lsei(A=a, B=b, G=u, H=co)$X)
}
Nulla=function (M, rcond=1.e10) {
    # use Lapack for null space basis
    # derived from MASS::Null
    tmp <- qr(as.matrix(M), LAPACK=TRUE)
    d=abs(diag(tmp$qr))
    n=length(d)
#browser()
    if (d[1L]==0.) {
       tmp$rank = 0
    } else {
       tmp$rank = sum(d/d[1L] > 1./rcond)
    }
    set <- if (tmp$rank == 0L)
        1L:n
    else
        -(1L:tmp$rank)
    bn=qr.Q(tmp, complete = TRUE)[, set, drop = FALSE]
    attr(bn, "qr")=tmp
    return(bn)
}

plot_mti=function(ti, x, m=NULL, ...) {
   # plot MS time curse curves x[icurve, itime] and points from m
   # x and m are supposed to have the same naming and organization
#browser()
   nm=if (NROW(x) > NROW(m)) rownames(x) else rownames(m)
   nb_curve=NROW(x)
   if (length(nm) == 0L) {
      nb_curve=NROW(x)
      nm=seq_len(nb_curve)
      nm_leg=as.character(seq_len(nb_curve))
   } else {
      # strip the ftbl row number
      nm=sub(":[-0-9]+$", "", nm)
      # make names look like M_0, M_1 etc.
      if (length((nms <- strsplit(nm, ":", fixed=TRUE))[[1L]]) > 2L) {
         nm_leg=as.expression(sapply(nms, function(v) substitute(M[i], list(i=v[4L]))))
      } else {
         nm_leg=as.expression(sapply(seq_len(nb_curve)-1, function(v) substitute(M[i], list(i=v))))
      }
   }
   # x and m may have different time moments
   if (is.null(m)) {
      tim=ti
      inna=c()
   } else {
      tim=as.numeric(colnames(m))
      inna=which(!is.na(m))
   }
   plot(range(ti, tim), range(c(x,m[inna])), t="n", ylab="Label", xlab="Time", ...)
   if (!is.null(x))
      matplot(ti, t(x), t="l", lty=seq_len(nb_curve), col=seq_len(nb_curve), lwd=2, add=TRUE, ...)
   if (!is.null(m)) {
      # plot measured points
      for (i in seq_len(nrow(m))) {
         inna=which(!is.na(m[i,]))
         if (length(inna) == 0)
            next
         points(tim[inna], m[i,inna], col=i, cex=0.5, t="b", lwd=0.5, ...)
         if (nrow(m) == nb_curve && !is.null(x)) {
            # draw filled polygons between simulation and data
            iti=which(ti >= min(tim[inna]) & ti <= max(tim[inna]))
            polygon(c(ti[iti],rev(tim[inna])), c(x[i,iti], rev(m[i,inna])), col=rgb(red=t(col2rgb(i)), alpha=60, max=255), bord=FALSE, ...)
         }
      }
   }
   legend("topright", legend=nm_leg, lty=seq_len(nb_curve), col=1:nb_curve, lwd=2, cex=0.75, bg=rgb(0.97,0.97,0.97, 0.75))
}
plot_lti=function(ti, x, m=NULL, ...) {
   # plot label (other than MS) time curse curves x[icurve, itime] and points from m
   # x and m are supposed to have the same dimension (2) and organization
   nm=if (is.null(m)) rownames(x) else rownames(m)
   nb_curve=nrow(x)
   if (is.null(nm)) {
      nb_curve=nrow(x)
      nm=seq_len(nb_curve)
      nm_leg=as.character(seq_len(nb_curve))
   } else {
      nb_curve=if (is.null(m)) nrow(x) else nrow(m)
      # strip the ftbl row number
      nm=sub(":[-0-9]+$", "", nm)
      # make names look like l:x01, l:x10 etc.
      if (length(nms <- strsplit(nm, ":", fixed=TRUE)[[1L]]) > 2L) {
         nm_leg=paste0(nms[c(1L,3L)], collapse=":")
      } else {
         nm_leg=as.character(seq_len(nb_curve))
      }
   }
   # x and m may have different time moments
   if (is.null(m)) {
      tim=ti
   } else {
      tim=as.numeric(colnames(m))
   }
   plot(range(ti, tim), range(x, m, na.rm=TRUE), t="n", ylab="Label", xlab="Time", ...)
   if (!is.null(x))
      matplot(ti, t(x), t="l", lty=seq_len(nb_curve), col=seq_len(nb_curve), lwd=2, add=TRUE, ...)
   if (!is.null(m)) {
      # plot measured points
      for (i in seq_len(nrow(m))) {
         inna=which(!is.na(m[i,]))
         if (length(inna) == 0)
            next
         points(tim[inna], m[i,inna], col=i, cex=0.5, t="b", lwd=0.5, ...)
         if (nrow(m) == nb_curve && !is.null(x)) {
            # draw filled polygons between simulation and data
            tmax=max(tim[inna])
            iti=which(ti <= tmax)
            polygon(c(ti[iti],rev(tim[inna])), c(x[i,iti], rev(m[i,inna])), col=rgb(red=t(col2rgb(i)), alpha=60, max=255), bord=FALSE, ...)
         }
      }
   }
   legend("topright", legend=nm_leg, lty=1:nb_curve, col=1:nb_curve, lwd=2, cex=0.75, bg=rgb(0.97,0.97,0.97, 0.75))
}
#browser()
if (write_res) {
   for (iexp in seq_len(nb_exp)) {
      usmf=jx_f$usmf[[iexp]] # unscaled simulated measurements
      me=measurements$vec$kin[[iexp]] # measured dynamic labeling data
      if (!is.null(measurements$outlier[[iexp]])) {
         iout=measurements$outlier[[iexp]]
         iout=iout[iout <= prod(dim(me))] # only outliers of label kinetics
         me[iout]=NA # measured dynamic labeling data
      }

      # get unique measured MS fragment names
      nm_selm=natsort(grep("^m:", if (is.null(rownames(me))) rownames(usmf) else rownames(me), v=TRUE))
      pdf(sprintf("%s/%s.pdf", dirres, nm_exp[iexp]))
#browser()
      if (length(nm_selm) > 0L) {
         plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
         text(0.5, 0.05, lab="MS measurements", cex=2)
         nmf=strsplitlim(nm_selm, ":", fixed=TRUE, mat=TRUE)
         # detect metabs with incomplete mid, e.g. only M+0
         fraglen=strsplitlim(nmf[,3L], ",", fixed=TRUE, mat=TRUE)
         mets=trimws(strsplitlim(nmf[,2L], "+", fixed=TRUE, mat=TRUE))
         incompls=split(seq_len(NROW(nmf)), list(nmf[,2L], nmf[,3L]))
         incompl=sapply(incompls, function(i) {
            if (length(i) == 0L) return(FALSE)
            len=sum(nchar(fraglen[i[1L],]) > 0L)
            len=if (len > 0L) len else clen[mets[i[1L],1L]]
            return(len > length(i))
         })
         names(incompl)=mets[sapply(incompls, "[", 1L)]
         incompl=Filter(I, incompl)
         incompl=unlist(strsplit(names(incompl), "+", fixed=TRUE))
         nmf=unique(apply(nmf[,2L:3L, drop=FALSE], 1L, paste0, sep="", collapse=":"))
         nmm=setdiff(Filter(nchar, mets), incompl)
         for (metf in nmf) {
            i=grep(sprintf("m:%s:", metf), nm_selm, fixed=TRUE, value=TRUE)
            #isim=pmatch(sapply(strsplit(i, ":", fixed=TRUE), function(v) paste0(v[-length(v)], collapse=":")), rownames(usmf))
            isim=grep(sprintf("m:%s:", metf), rownames(usmf), fixed=TRUE, value=TRUE)
            mf=strsplit(metf, ":", fixed=TRUE)[[1L]]
            met=mf[1L]
            fr=mf[2L]
            metlen=clen[trimws(strsplit(met, "+", fixed=TRUE)[[1L]][1L])]
            mainlab=if (is.na(fr) || fr == paste(seq_len(metlen), collapse=",") || fr == sprintf("1~%d", metlen))
               met else
               sprintf("%s:%s", met, fr)
            plot_mti(tifull[[iexp]][-1L], usmf[isim,,drop=FALSE], me[i,,drop=FALSE], main=mainlab, ylim=0:1)
         }
      } else {
         nmm=character(0L) # no measured metabolites
      }
      # plot non measured MS from mid
#browser()
      if (exists("mid") && length(mid)) {
         nm_simm=rownames(mid[[iexp]])
         nmmid=if (length(nm_simm) > 0L) unique(strsplitlim(nm_simm, "+", fixed=TRUE, mat=TRUE)[,1L]) else character(0L)
         nmmid=strsplitlim(nmmid, ":", fixed=TRUE, mat=TRUE)[,1L]
         nmp=natsort(setdiff(nmmid, nmm))
         if (length(nmp) && length(nm_simm)) {
            plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
            text(0.5, 0.05, lab="MS simulations", cex=2)
         }
         for (met in nmp) {
            i=grep(sprintf("^%s:", met), nm_simm, value=TRUE)
            if (length(i) == 0L)
               next
            plot_mti(tifull[[iexp]][-1L], mid[[iexp]][i,,drop=FALSE], NULL, main=met, ylim=0:1)
         }
         # get unique label (!=MS) fragment names
         nm_sell=natsort(grep("^[^m]:", if (is.null(rownames(me))) rownames(usmf) else rownames(me), v=TRUE))
         if (length(nm_sell) > 0) {
            plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
            text(0.5, 0.05, lab="NMR measurements", cex=2)
            nmf=unique(apply(structure(sapply(strsplit(nm_sell, ":", fixed=TRUE), "[", 1:4)[1:3,], dim=c(3L, length(nm_sell))), 2L, paste0, sep="", collapse=":"))
            for (metf in nmf) {
               i=grep(sprintf("%s:", metf), nm_sell, fix=TRUE, v=TRUE)
               #isim=pmatch(sapply(strsplit(i, ":", fixed=TRUE), function(v) paste0(v[-length(v)], collapse=":")), rownames(usmf))
               isim=grep(sprintf("%s:", metf), rownames(usmf), fix=TRUE, v=TRUE)
               if (length(isim) == 0L)
                  next
               mf=strsplit(metf, ":", fixed=TRUE)[[1L]]
               met=mf[2L]
               fr=mf[3L]
               metlen=clen[trimws(strsplit(met, "+", fixed=TRUE)[[1]][1])]
               if (is.na(fr) || fr == paste(seq_len(metlen), collapse=",") || fr == sprintf("1~%d", metlen)) {
                  mainlab=met
               } else {
                  mainlab=sprintf("%s:%s", met, fr)
               }
               plot_lti(tifull[[iexp]][-1L], usmf[isim,,drop=FALSE], me[i,,drop=FALSE], main=mainlab, ylim=0:1)
            }
         }
      }
      # plot input labeling if emu and varying in time
      if (emu && case_i && any(apply(xi[[1L]], 1L, diff) != 0.)) {
         plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
         text(0.5, 0.05, lab="Input MS", cex=2)
         nmmid=if (length(nm_xiemu) > 0L) unique(strsplitlim(nm_xiemu, "+", fixed=TRUE, mat=TRUE)[,1L]) else character(0L)
         nmmid=strsplitlim(nmmid, ":", fixed=TRUE, mat=TRUE)
         o=natorder(nmmid[,1L])
         frag=nmmid[o,2L]
         nmmid=nmmid[o,1L]
         # full frag replce by "" and partial frags replace by "11001"
         frag_01=int2bit(as.integer(frag), clen[nmmid])
         labfrag=ifelse(frag_01 == sapply(clen[nmmid], function(n) paste0(rep.int("1", n), collapse="")), "", paste0("#", frag_01))
#browser()         
         i_lapply(nmmid, function(imet, met) {
            i=grep(sprintf("^%s:%s\\+", met, frag[imet]), nm_xiemu, value=TRUE)
            if (length(i) != 0L)
               plot_mti(tifull[[iexp]], xi[[iexp]][i,,drop=FALSE], NULL, main=paste0(met, labfrag[imet], collapse=""), ylim=0:1)
         })
      }
      dev.off()
   }
}

plot_ms=function(x, m=NULL, dev=NULL, ...) {
   # plot stacked ms bars from x and m
   # x and m are supposed to have the same dimension and organization
   n=length(x)
   nm=names(x)
   
   if (length(m)) {
      m=matrix(m, nrow=n)
      nc=ncol(m)
      colnames(m)=rep("meas", nc)
   } else {
      nc=1
   }
   if (length((nms <- strsplit(nm, ":", fixed=TRUE))[[1]]) > 2) {
      nm_leg=as.expression(sapply(nms, function(v) substitute(M[i], list(i=v[4]))))
   } else {
      nm_leg=as.expression(sapply(seq_len(n)-1, function(v) substitute(M[i], list(i=v))))
   }
   xlim=range(0, if (length(m) && !is.null(dev)) min(colSums(m, na.rm=TRUE)-dev[1]) else 0, sum(x), if (length(m) && !is.null(dev)) max(col_sums(m, na.rm=TRUE))+dev else 0)*1.1
   bc=barplot(cbind(sim=x, m), width=0.1*diff(xlim), horiz=TRUE, xlab="MS fraction", ylim=c(0, 0.25*nc), xlim=xlim, asp=TRUE, col=co,
      legend.text=nm_leg, args.legend=list(cex=0.75, horiz=TRUE), ...)
   if (!is.null(m) && !is.null(dev)) {
      for (j in seq(ncol(m))) {
         cume=cumsum(m[,j])
         h=seq(-1, 1, len=n)*0.03
         segments(cume-dev, bc[j+1]+h, cume+dev, bc[j+1]+h)
         arrows(cume-dev, bc[j+1]+h, cume+dev, bc[j+1]+h, length=0.05, angle=80, code=3)
      }
   }
}
plot_lab=function(x, m=NULL, dev=NULL, ...) {
   # plot stacked bars of LABEL_MEASUREMENTS
   # x and m are supposed to have the same dimension and organization
   n=length(x)
   nm=names(x)
   if (length((nms <- strsplit(nm, ":", fixed=TRUE))[[1]]) > 1) {
      nm_leg=sapply(nms, "[", 3)
   } else {
      nm_leg=paste("#", seq_len(n), sep="")
   }
   xlim=range(0, sum(x), sum(m)+dev)*1.1
   bc=barplot(cbind(sim=x, meas=m), width=0.08*diff(xlim), horiz=TRUE, xlab="Label fraction", ylim=xlim*0.25, xlim=xlim, asp=TRUE, col=co,
      legend.text=nm_leg, args.legend=list(cex=0.75, horiz=TRUE), ...)
   if (!is.null(m) && !is.null(dev)) {
      cume=cumsum(m)
      h=seq(-1, 1, len=n)*0.03
      segments(cume-dev, bc[2]+h, cume+dev, bc[2]+h)
      arrows(cume-dev, bc[2]+h, cume+dev, bc[2]+h, length=0.05, angle=80, code=3)
   }
}
plot_peak=function(x, m=NULL, dev=NULL, ...) {
   # plot stacked bars of PEAK_MEASUREMENTS
   # x and m are supposed to have the same dimension and organization
   n=length(x)
   nm=names(x)
   if (length((nms <- strsplit(nm, ":", fixed=TRUE))[[1]]) > 1) {
      nm_leg=sapply(nms, "[", 4)
   } else {
      nm_leg=seq_len(n)
   }
   bc=barplot(cbind(sim=x, meas=m), width=0.1, horiz=TRUE, xlab="Peak fraction", ylim=c(0, 0.25), xlim=range(0, sum(x), sum(m)+dev, if (length(m)) m[1]-dev else 0)*1.1, asp=TRUE, col=co,
      legend.text=nm_leg, args.legend=list(cex=0.75, horiz=TRUE), ...)
   if (!is.null(m) && !is.null(dev)) {
      cume=cumsum(m)
      h=seq(-1, 1, len=n)*0.03
      segments(cume-dev, bc[2]+h, cume+dev, bc[2]+h)
      arrows(cume-dev, bc[2]+h, cume+dev, bc[2]+h, length=0.05, angle=80, code=3)
   }
}
plot_flux=function(x, m=NULL, dev=NULL, ...) {
   # plot FLUX_MEASUREMENTS
   # x and m are supposed to have the same dimension and organization
   n=length(x)
   xlim=range(0, x, m-dev, m+dev)*1.1
   bc=barplot(cbind(sim=x, meas=m), width=0.05*diff(xlim), horiz=TRUE, xlab="Flux value", ylim=c(-0.1, 0.2)*diff(xlim), xlim=xlim, col=co, ...)
   if (!is.null(m) && !is.null(dev)) {
      cume=cumsum(m)
      segments(cume-dev, bc[2], cume+dev, bc[2])
      arrows(cume-dev, bc[2], cume+dev, bc[2], length=0.1, angle=80, code=3)
   }
}
plot_pool=function(x, m=NULL, dev=NULL, ...) {
   # plot METAB_MEASUREMENTS
   # x and m are supposed to have the same dimension and organization
   n=length(x)
   xlim=range(0, x, m-dev, m+dev)*1.1
   w=0.1*diff(xlim)
   bc=barplot(cbind(sim=x, meas=m), width=w, horiz=TRUE, xlab="Metabolite concentration", ylim=c(-0.08, 0.17)*20*w, xlim=xlim, col=co, ...)
   if (!is.null(m) && !is.null(dev)) {
      cume=cumsum(m)
      segments(cume-dev, bc[2], cume+dev, bc[2])
      arrows(cume-dev, bc[2], cume+dev, bc[2], length=0.1, angle=80, code=3)
   }
}
# colors from http://tools.medialab.sciences-po.fr/iwanthue/ (param: 20, soft (k-means)))
co=c(
"#45aecf",
"#d0502b",
"#7f63d7",
"#66b344",
"#c34db6",
"#b9b53d",
"#4e71c0",
"#da9234",
"#8e9bdf",
"#8c8c42",
"#cb86d4",
"#437e43",
"#d03f7c",
"#59bf8f",
"#d0454e",
"#8a5191",
"#965e2a",
"#de82a2",
"#df926c",
"#a84f5b"
)
if (is.null(.GlobalEnv$jx_f) || is.null(jx_f$simlab)) {
   stop_mes("plot_smeas.R: simulated data are not available. Plotting skipped", file=fcerr)
}
if (write_res) {
   for (iexp in seq_len(nb_exp)) {
      sim=jx_f$simlab[[iexp]]
      me=measurements$vec$labeled[[iexp]] # measured stationary ms data

      # get unique met-fragment names
      nm_sel=grep("^m:", if (is.null(names(me))) names(sim) else names(me), v=TRUE)
      pdf(sprintf("%s/%s.pdf", dirres, nm_exp[iexp]), width=8, height=6)
      if (length(nm_sel) > 0) {
         plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
         text(0.5, 0.05, lab="MS measurements\n(error bars=±2*dev)", cex=2)
         nmf=natsort(unique(apply(sapply(strsplit(nm_sel, ":", fixed=TRUE), "[", 1:4)[2:3,], 2, paste0, sep="", collapse=":")))
         for (metf in nmf) {
            i=grep(sprintf("m:%s:", metf), nm_sel, fixed=TRUE, v=TRUE)
            # count repeated fragments
            nbf=length(grep(sprintf("m:%s:0", metf), i, fixed=TRUE, v=TRUE))
            if (nbf > 1) {
               isim=i[seq(length(i)/nbf)]
            } else {
               isim=i
            }
            mf=strsplit(metf, ":")[[1]]
            met=mf[1]
            fr=mf[2]
            if (is.na(fr))
               fr=""
            metlen=clen[mets_in_res[[iexp]][i[1]]]
            if (fr == "" || fr == paste(seq_len(metlen), collapse=",") || fr == sprintf("1~%d", metlen)) {
               mainlab=met
            } else {
               mask=rep("0", metlen)
               mask[eval(parse(text=paste0("c(", sub("~", ":", fr, fixed=TRUE), ")")))]="1"
               mainlab=sprintf("%s #%s", met, paste0(mask, collapse=""))
            }
            if (!all(is.na(sim[isim])))
               plot_ms(sim[isim], me[i], 2*measurements$dev$labeled[[iexp]][i], main=mainlab)
         }
      }
      # plot MS of non measured metabs
   #browser()
      if (!is.null(.GlobalEnv$mid)) {
         nm_sim=names(mid[,iexp])
         # get "pyr" from "m:pyr:1~3:0:171" (on ms)
         nmm=unique(sapply(strsplit(nm_sel, ":", fixed=TRUE), "[", 1:4)[2,])
         # get "pyr" from "pyr:7+0" (on simulated)
         nmmid=unique(sapply(strsplit(nm_sim, "+", fixed=TRUE), "[", 1))
         if (emu)
            nmmid=unique(sapply(strsplit(nmmid, ":", fixed=TRUE), "[", 1))
         nmp=sort(setdiff(nmmid, nmm))
         if (length(nmp)) {
            plot(0:1, c(0,0.1), type="n", axes=FALSE, xlab="", ylab="")
            text(0.5, 0.05, lab="MS simulations", cex=2)
         }
         for (met in nmp) {
            if (emu) {
               i=grep(sprintf("^%s:", met), nm_sim, v=TRUE)
               # take fragments
               fr=unique(sapply(strsplit(i, "[+:]"), "[", 2))
               for (f in fr) {
                  i=grep(sprintf("^%s:%s\\+", met, f), nm_sim, v=TRUE)
                  fi=as.integer(f)
                  mainlab=if (fi == 2**clen[met]-1) met else sprintf("%s #%s", met, int2bit(fi, clen[met]))
                  if (!all(is.na(mid[i, iexp])))
                     plot_ms(mid[i, iexp], NULL, NULL, main=mainlab)
               }
            } else {
               i=grep(sprintf("^%s\\+[0-9]+$", met), nm_sim, v=TRUE)
               if (!all(is.na(mid[i, iexp])))
                  plot_ms(mid[i, iexp], NULL, NULL, main=met)
            }
         }
      }
      # LABEL_MEASURMENTS
      nm_sel=grep("^l:", if (is.null(names(me))) names(sim) else names(me), v=TRUE)
      if (length(nm_sel) > 0) {
         plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
         text(0.5, 0.05, lab="Label measurements\n(error bars=±2*dev)", cex=2)
         nm=sort(unique(sapply(strsplit(nm_sel, ":", fixed=TRUE), "[", 2)))
         for (met in nm) {
            i=grep(sprintf("l:%s:", met), nm_sel, fixed=TRUE, v=TRUE)
            plot_lab(sim[i], me[i], 2*measurements$dev$labeled[[iexp]][i], main=met)
         }
      }
      # PEAK_MEASURMENTS
      nm_sel=grep("^p:", if (is.null(names(me))) names(sim) else names(me), v=TRUE)
      if (length(nm_sel) > 0) {
         plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
         text(0.5, 0.05, lab="Peak measurements\n(error bars=±2*dev)", cex=2)
         nmp=sort(unique(apply(sapply(strsplit(nm_sel, ":", fixed=TRUE), "[", 2:3), 2, paste, collapse=":")))
         for (metp in nmp) {
            i=grep(sprintf("p:%s:", metp), nm_sel, fix=TRUE, v=TRUE)
            plot_peak(sim[i], me[i], 2*measurements$dev$labeled[[iexp]][i], main=metp)
         }
      }
      # FLUX_MEASURMENTS
      nm_sel=names(fmn)
      if (length(nm_sel) > 0) {
         plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
         text(0.5, 0.05, lab="Flux measurements\n(error bars=±2*dev)", cex=2)
         nmf=sort(substring(nm_sel, 5))
         for (f in nmf) {
            i=grep(sprintf("^.\\.n\\.%s$", f), nm_sel, v=TRUE)
            plot_flux(jx_f$simfmn[i], fmn[i], 2*measurements$dev$flux[i], main=f)
         }
      }
      # POOL_MEASURMENTS
      nm_sel=names(measurements$vec$pool)
      if (length(nm_sel) > 0) {
         plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
         text(0.5, 0.05, lab="Metabolite pool measurements\n(error bars=±2*dev)", cex=2)
         nmp=sort(substring(nm_sel, 4))
         for (p in nmp) {
            i=grep(sprintf("pm:%s", p), nm_sel, fixed=TRUE, v=TRUE)
            plot_pool(jx_f$simpool[i], measurements$vec$pool[i], 2*measurements$dev$pool[i], main=p)
         }
      }
     dev.off()
   }
}

# This file can be used as a postreatment script in influx_s
# software (cf. parameter posttreat_R in FTBL/OPTIONS section)

# Purpose: save the whole environement in a mynetwork.RData file
# to explore later in an interactive R session.

# file name to save
if (write_res) {
    f=file.path(dirres, "tmp", sprintf("%s.RData", baseshort))
    save(list = ls(all = TRUE), file = f)
}

suppressPackageStartupMessages(library(nnls)); # for non negative least square
#suppressPackageStartupMessages(library(Matrix, warn=F, verbose=F)); # for sparse matrices
#options(Matrix.quiet=TRUE)
suppressPackageStartupMessages(library(slam)); # for quick sparse matrices
suppressPackageStartupMessages(library(parallel))
#use_magma=suppressWarnings(suppressPackageStartupMessages(require(magma, quietly=T)))
#use_magma=F
suppressPackageStartupMessages(library(Rcpp))
suppressPackageStartupMessages(library(RcppArmadillo))
suppressPackageStartupMessages(library(rmumps))
suppressPackageStartupMessages(library(arrApply)); # for fast apply() on arrays

#' store sparse matrices in <pref>_01.mtx, <pref>_02.mtx, etc
#'
#' Files <pref>_[0-9]+.mtx are silently cleaned up before writing if exist.
#' Files are written in MTX format, i.e. each row is a triplicate (i, j, x)
#' The first row is a triplicate (nrow, ncol, nb_nonzero)
#' The number in file name is the cumomer weight.
mat2file=function(param, labargs, pref=paste0("cumo_", baseshort, "_"), dres=file.path(dirres, "tmp")) {
    pbase=file.path(dres, pref)
    fli=list.files(dres, pattern=paste0(pref, "[0-9]+\\.mtx"))
    suppressWarnings(file.remove(fli))
    ndig=floor(log10(length(spa)))+1L
    dfmt=sprintf("%%0%dd", ndig)
    lf=param2fl(param, labargs)
    for (w in seq_along(labargs$spa)) {
        fname=file.path(paste0(pbase, sprintf(dfmt, w), ".mtx"))
        atri=fwrv2Abr(lf$fwrv, labargs$spa[[w]], NULL, getA=TRUE, getb=FALSE, labargs$emu)$A$triplet()
        mat2mtx(atri, fname)
    }
}
#browser()
mat2file(param, labargs)

# This work is based on a CRAN package pso (https://CRAN.R-project.org/package=pso ) by Claus Bendtsen <papyrus.bendtsen at gmail.com>.
# As the original license requires, this modified file is released under terms of LGPL-3.
# modification's author: Serguei Sokol (sokol <at> insa-toulouse <dot> fr)
# modification's Copyright: INRAE/CNRS/INSA, 2020.

aap=arrApply::arrApply

psoptim_ic <- function (par, fn, ..., magnitude=1, mean=0,
                     control = list(), ui=NULL, ci=NULL) {
  fn1 <- function(par) fn(par, ...)/p.fnscale
  mrunif <- function(n,m,magnitude,mean) {
    return(matrix(runif(n*m,-1,1),nrow=n,ncol=m)*magnitude+mean)
  }
  norm <- function(x) sqrt(sum(x*x))
  rsphere.unif <- function(n,r) {
    temp <- runif(n, 0., 1.)
    return((runif(1,min=0,max=r)/norm(temp))*temp)
  }
  svect <- function(a,b,n,k) {
    temp <- rep(a,n)
    temp[k] <- b
    return(temp)
  }
  normcol=function(mat)
    aap(mat, 1, "norm")
  mrsphere.unif <- function(n,r) {
    m <- length(r)
    temp <- matrix(runif(n*m, 0, 1),n,m)
    return(aap(temp, 2, "multv", v=runif(m,min=0,max=r)/normcol(temp)))
  }
  almost1=1.-1.e5*.Machine$double.eps
  npar <- length(par)
  nm_par=names(par)
  con <- list(trace = 0, fnscale = 1, maxit = 1000L, maxf = Inf,
              abstol = -Inf, reltol = 0, REPORT = 10,
              s = NA, k = 3, p = NA, w = 1/(2*log(2)),
              c.p = .5+log(2), c.g = .5+log(2), d = NA,
              v.max = NA, rand.order = TRUE, max.restart=Inf,
              maxit.stagnate = Inf,
              trace.stats = FALSE, type = "SPSO2007",
              tolineq=1.e-10)
  nmsC <- names(con)
  con[(namc <- names(control))] <- control
  if (length(noNms <- namc[!namc %in% nmsC]))
    warning("unknown names in control: ", paste(noNms, collapse = ", "))
  ## Argument error checks
  if (any(!is.finite(magnitude)))
    stop("magnitude must be finite value")
  if (any(!is.finite(mean)))
    stop("magnitude must be finite value")
  p.type <- pmatch(con[["type"]],c("SPSO2007","SPSO2011"))-1
  if (is.na(p.type)) stop("type should be one of \"SPSO2007\", \"SPSO2011\"")
  if (!is.null(ui)) {
    if (is.null(ci))
      stop("both 'ui' and ci' must be NULL or not NULL simultaneously")
    if (nrow(ui) != NROW(ci))
      stop("row number in 'ui' and 'ci' must be the same")
    if (ncol(ui) != length(par))
      stop("column number in 'ui' must be equal to length(par)")
  }
  if (!is.null(ci) && is.null(ui))
    stop("both 'ui' and ci' must be NULL or not NULL simultaneously")
  
  p.trace <- con[["trace"]]>0L # provide output on progress?
  p.fnscale <- con[["fnscale"]] # scale funcion by 1/fnscale
  p.maxit <- con[["maxit"]] # maximal number of iterations
  p.maxf <- con[["maxf"]] # maximal number of function evaluations
  p.abstol <- con[["abstol"]] # absolute tolerance for convergence
  p.reltol <- con[["reltol"]] # relative minimal tolerance for restarting
  p.report <- as.integer(con[["REPORT"]]) # output every REPORT iterations
  p.s <- ifelse(is.na(con[["s"]]),ifelse(p.type==0,floor(10+2*sqrt(npar)),40),
                con[["s"]]) # swarm size
  p.p <- ifelse(is.na(con[["p"]]),1-(1-1/p.s)^con[["k"]],con[["p"]]) # average % of informants
  p.w0 <- con[["w"]] # exploitation constant
  if (length(p.w0)>1) {
    p.w1 <- p.w0[2]
    p.w0 <- p.w0[1]
  } else {
    p.w1 <- p.w0
  }
  p.c.p <- con[["c.p"]] # local exploration constant
  p.c.g <- con[["c.g"]] # global exploration constant
  p.d <- ifelse(is.na(con[["d"]]),norm(magnitude),con[["d"]]) # domain diameter
  p.vmax <- con[["v.max"]]*p.d # maximal velocity
  p.randorder <- as.logical(con[["rand.order"]]) # process particles in random order?
  p.maxrestart <- con[["max.restart"]] # maximal number of restarts
  p.maxstagnate <- con[["maxit.stagnate"]] # maximal number of iterations without improvement
  p.trace.stats <- as.logical(con[["trace.stats"]]) # collect detailed stats?
  p.has_ic <- !is.null(ui)
  p.tolineq <- con[["tolineq"]]
  
  if (p.trace) {
    cat("S=",p.s,", K=",con[["k"]],", p=",signif(p.p,4),", w0=",
            signif(p.w0,4),", w1=",
            signif(p.w1,4),", c.p=",signif(p.c.p,4),
            ", c.g=",signif(p.c.g,4), "\n")
    cat("v.max=",signif(con[["v.max"]],4),
            ", d=",signif(p.d,4), "\n")
    if (p.trace.stats) {
      stats.trace.it <- c()
      stats.trace.error <- c()
      stats.trace.f <- NULL
      stats.trace.x <- NULL
    }
  }
  ## Initialization
  if (p.reltol!=0) p.reltol <- p.reltol*p.d
  X <- mrunif(npar,p.s,magnitude,mean)
  if (!anyNA(par)) X[,1] <- par
  # put inside
  if (p.has_ic) {
    X <- vapply(seq(ncol(X)), function(i) put_inside(X[,i], ui, ci), X[,1L])
    mean=rowMeans(X)
  }
#browser()
  if (p.type==0) {
    V <- mrunif(npar,p.s,magnitude,0)
  } else { ## p.type==1
    V <- matrix(runif(npar*p.s,min=-magnitude,max=magnitude),npar,p.s)
    p.c.p2 <- p.c.p/2 # precompute constants
    p.c.p3 <- p.c.p/3
    p.c.g3 <- p.c.g/3
    p.c.pg3 <- p.c.p3+p.c.g3
  }
  if (!is.na(p.vmax)) { # scale to maximal velocity
    temp <- normcol(V)
    temp <- pmin.int(temp,p.vmax)/temp
    V <- aap(V, 2, "multv", v=temp)
  }
  f.x <- apply(X,2,fn1) # first evaluations
  stats.feval <- p.s
  P <- X
  f.p <- f.x
  P.improved <- rep(FALSE,p.s)
  i.best <- which.min(f.p)
  error <- f.p[i.best]
  init.links <- TRUE
  if (p.trace && p.report==1) {
    cat("It 1: fitness=",signif(error,4), "\n")
    if (p.trace.stats) {
      stats.trace.it <- c(stats.trace.it,1)
      stats.trace.error <- c(stats.trace.error,error)
      stats.trace.f <- c(stats.trace.f,list(f.x))
      stats.trace.x <- c(stats.trace.x,list(X))
    }
  }
  ## Iterations
  msgcode=0
  stats.iter <- 1
  stats.restart <- 0
  stats.stagnate <- 0
  while (stats.iter<p.maxit && stats.feval<p.maxf && error>p.abstol &&
         stats.restart<p.maxrestart && stats.stagnate<p.maxstagnate) {
    stats.iter <- stats.iter+1
    if (p.p!=1 && init.links) {
      links <- matrix(runif(p.s*p.s,0,1)<=p.p,p.s,p.s)
      diag(links) <- TRUE
    }
    ## The swarm moves
    if (p.p==1)
      j <- rep(i.best,p.s)
    else # best informant
      j <- sapply(1:p.s,function(i)
                  which(links[,i])[which.min(f.p[links[,i]])]) 
    temp <- (p.w0+(p.w1-p.w0)*max(stats.iter/p.maxit,stats.feval/p.maxf))
    V <- temp*V # exploration tendency
    if (p.type==0) {
      V <- V+mrunif(npar,p.s,p.c.p*0.5,p.c.p*0.5)*(P-X) # exploitation
      temp <- j!=(1:p.s)
      V[,temp] <- V[,temp]+mrunif(npar,sum(temp),p.c.p*0.5,p.c.p*0.5)*(P[,j[temp]]-X[,temp])
    } else { # SPSO 2011
      temp <- j==(1:p.s)
      temp <- aap(P, 2, "multv", v=svect(p.c.p3,p.c.p2,p.s,temp))+
        aap(P[,j], 2, "multv", v=svect(p.c.g3,0,p.s,temp))-
        aap(X, 2, "multv", v=svect(p.c.pg3,p.c.p2,p.s,temp)) # G-X
      V <- V+temp+mrsphere.unif(npar,normcol(temp))
    }
    if (!is.na(p.vmax)) {
      temp <- normcol(V)
      temp <- pmin.int(temp,p.vmax)/temp
      V <- aap(V, 2, "multv", v=temp)
    }
#print(stats.iter)
#print(P-X)
#print("V generated")
#print(V)
    if (p.has_ic) {
      # enforce constraints
      X1 <- X+V
      ine1 <- ui%*%X1 - ci
      ine <- ui%*%X - ci
      if (any(ine < -p.tolineq)) {
        iw=which(ine<0, arr.ind=TRUE)
        nm_i=if (is.null(rownames(ui))) iw[,1L] else rownames(ui)[iw[,1L]]
        mes=format(rbind(c("violation", "ineq", "iparticle"), cbind(ine[ine<0], nm_i, iw[,2L])))
        mes=paste0(apply(mes, 1, paste0, collapse=" "), collapse="\n\t")
#browser()
        msg=paste0("not all particles satisfy inequality constraints (iter=", stats.iter, "):\n\t", mes)
        msgcode=5
        break
      }
      for (j in seq(ncol(X))) {
        if (!any(ibad <- (ine1[,j] < -p.tolineq))) {
          X[,j] <- X[,j]+V[,j]
          next
        }
        alpha=min((ine[ibad,j]-p.tolineq)/(ine[ibad,j]-ine1[ibad,j])) # aim at a value slightly over 0
        if (!is.finite(alpha))
          alpha <- 0.
        alpha <- (if (alpha > 0.) almost1 else 1./almost1)*alpha # alpha can be < 0 if X was already slightly outside of the domain
        V[,j] <- alpha*V[,j]
#browser()
        if (any(ui%*%(X[,j]+V[,j])-ci < -p.tolineq))
          V[,j] <- (if (alpha  > 0.) almost1 else 1./almost1)*V[,j]
        X[,j] <- X[,j]+V[,j]
        # remove the normal component of V_j looking outside of the domain (normal to the constraint hyperplane)
        ibad <- which.min(ui%*%X[,j] - ci)
        nrm=ui[ibad,]%*%V[,j]
        if (nrm < 0.)
          V[,j] <- V[,j]-ui[ibad,]*c(nrm/sum(ui[ibad,]**2))
      }
    } else {
      X <- X+V
    }
#print("V used")
#print(V)
    ## Evaluate function
    f.x <- apply(X,2,fn1)
    stats.feval <- stats.feval+p.s
    temp <- f.x<f.p
    if (any(temp)) { # improvement
      P[,temp] <- X[,temp]
      f.p[temp] <- f.x[temp]
      i.best <- which.min(f.p)
    }
    if (stats.feval>=p.maxf) break
    if (p.reltol!=0) {
      d <- X-P[,i.best]
      d <- max(normcol(d))
      if (d<p.reltol) {
        # restart
        X <- mrunif(npar,p.s,magnitude,mean)
        # put inside
        if (p.has_ic) {
          X <- vapply(seq(ncol(X)), function(i) put_inside(X[,i], ui, ci), X[,1L])
          mean=rowMeans(X)
        }

        V <- mrunif(npar,p.s,magnitude,0)
        if (!is.na(p.vmax)) {
          temp <- normcol(V)
          temp <- pmin.int(temp,p.vmax)/temp
          V <- aap(V, 2, "multv", v=temp)
        }
        stats.restart <- stats.restart+1
        if (p.trace) cat("It ", stats.iter, ": restarting", "\n", sep="")
      }
    }
    init.links <- f.p[i.best]==error # if no overall improvement
    stats.stagnate <- ifelse(init.links,stats.stagnate+1,0)
    error <- f.p[i.best]
    if (p.trace && stats.iter%%p.report==0) {
      if (p.reltol!=0) 
        cat("It ",stats.iter,": fitness=",signif(error,4),
                ", swarm diam.=",signif(d,4), "\n", sep="")
      else
        cat("It ",stats.iter,": fitness=",signif(error,4), "\n", sep="")
      if (p.trace.stats) {
        stats.trace.it <- c(stats.trace.it,stats.iter)
        stats.trace.error <- c(stats.trace.error,error)
        stats.trace.f <- c(stats.trace.f,list(f.x))
        stats.trace.x <- c(stats.trace.x,list(X))
      }
    }
  }
  if (error<=p.abstol) {
    msg <- "Converged"
    msgcode <- 0
  } else if (stats.feval>=p.maxf) {
    msg <- "Maximal number of function evaluations reached"
    msgcode <- 1
  } else if (stats.iter>=p.maxit) {
    msg <- "Maximal number of iterations reached"
    msgcode <- 2
  } else if (stats.restart>=p.maxrestart) {
    msg <- "Maximal number of restarts reached"
    msgcode <- 3
  } else if (msgcode==5) {
    ; # inequalities failed
  } else {
    msg <- "Maximal number of iterations without improvement reached"
    msgcode <- 4
  }
  if (p.trace) cat(msg, "\n")
  o <- list(par=structure(P[,i.best], names=nm_par),value=f.p[i.best],
            counts=c("function"=stats.feval,"iteration"=stats.iter,
              "restarts"=stats.restart),
            convergence=msgcode,message=msg)
  if (p.trace && p.trace.stats) o <- c(o,list(stats=list(it=stats.trace.it,
                                                error=stats.trace.error,
                                                f=stats.trace.f,
                                                x=stats.trace.x)))
  return(o)
}

source("aide_plot.R")
# read simulated and real measurements
f="chlamy_i_comp_10_res.kvh"; td=get_usm(f); nmm=rownames(td$usm); ti=td$ti; me=get_labcin("chlamy_pulse_comp_final.txt", nmm)
# plot similated vs measured data for a given metabolite
i=grep(":Glc", nmm, fix=T); plot_ti(ti, td$usm[i,,drop=F], me[i,,drop=F])

# read simulated cumomers
xs=kvh_get_matrix(f, "simulated cumomers"); tis=as.numeric(colnames(xs)); nmx=rownames(xs); ms=cumo2mass(xs); nmma=rownames(ms)
# plot cumomers of weight 1 (their index is an integer power of 2)
ix=grep("^Sed.*_cy", nmma, fix=F); plot_ti(tis, ms[ix,])

# write one metabolite per file pdf
mets=unique(sapply(nmm, function(n) strsplit(n, "[:+]")[[1]][2]))
sapply(mets, function(m) {
   cat(m, "\n");
   i=grep(join("", c(":", m)), nmm, fix=TRUE);
   if (length(i) > 0) {
      pdf(join("", c(m, ".pdf")));
      plot_ti(td$ti, td$usm[i,,drop=FALSE], me[i,,drop=FALSE], main=m);
      dev.off()
   } else {
      cat("not found: ", m, "\n")
   }
})

# preparations
#load("mynetwork.RData") <--- adapt for your file name
source(file.path(dirr, "libs.R"))
source(file.path(dirr, "opt_cumo_tools.R"))
source(file.path(dirr, "opt_icumo_tools.R")) # uncoment for influx_i use
tmp=sparse2spa(spa)

# doing something useful
# here, we calculate a vector of cost values, one per MC iteration
#cost_mc=apply(free_mc, 2, function(p) cumo_cost(p, labargs))
# do something else ...

plot_ti=function(ti, x, m=NULL, ...) {
   # plot time curse curves x[icurve, itime] and points from m
   # x and m are supposed to have the same dimension and organization
   nm=if (is.null(m)) rownames(x) else rownames(m)
   nb_curve=nrow(x)
   if (is.null(nm)) {
      nb_curve=nrow(x)
      nm=seq_len(nb_curve)
   } else {
      nb_curve=if (is.null(m)) nrow(x) else nrow(m)
      # strip the ftbl row number
      nm=sub(":[-0-9]+$", "", nm)
      # make names look like M_0, M_1 etc.
      if (length((nms <- strsplit(nm, ":", fixed=TRUE))[[1]]) > 2) {
         nm_leg=as.expression(sapply(nms, function(v) substitute(M[i], list(i=v[4]))))
      } else {
         nm_leg=as.expression(sapply(seq_len(nb_curve)-1, function(v) substitute(M[i], list(i=v))))
      }
   }
   # x and m may have different time moments
   if (is.null(m)) {
      tim=ti
      inna=c()
   } else {
      tim=as.numeric(colnames(m))
      inna=which(!is.na(m))
   }
   plot(range(ti, tim), range(c(x,m[inna])), t="n", ylab="Label", xlab="Time", ...)
   if (!is.null(x))
      matplot(ti, t(x), t="l", lty=seq_len(nb_curve), col=seq_len(nb_curve), lwd=2, add=TRUE, ...)
   if (!is.null(m)) {
      # plot measured points
      for (i in seq_len(nrow(m))) {
         inna=which(!is.na(m[i,]))
         if (length(inna) == 0)
            next
         points(tim[inna], m[i,inna], col=i, cex=0.5, t="b", lwd=0.5, ...)
         if (nrow(m) == nb_curve && !is.null(x)) {
            # draw filled polygons between simulation and data
            tmax=max(tim[inna])
            iti=which(ti <= tmax)
            polygon(c(ti[iti],rev(tim[inna])), c(x[i,iti], rev(m[i,inna])), col=rgb(red=t(col2rgb(i)), alpha=31, max=255), bord=FALSE, ...)
         }
      }
   }
   legend("topright", legend=nm_leg, lty=1:nb_curve, col=1:nb_curve, lwd=2, cex=0.75, bg=rgb(0.97,0.97,0.97, 0.75))
}
#browser()
cat("***Warning: 'plot_imass.R' is deprecated. Use 'plot_ilab.R' instead.\n", file=fclog)
for (iexp in seq_len(nb_exp)) {
   usmf=jx_f$usmf[[iexp]] # unscaled simulated measurements
   me=measurements$vec$kin[[iexp]] # measured dynamic labeling data
   if (!is.null(measurements$outlier[[iexp]])) {
      iout=measurements$outlier[[iexp]]
      iout=iout[iout <= prod(dim(me))] # only outliers of label kinetics
      me[iout]=NA # measured dynamic labeling data
   }

   # get unique fragment names
   nm_sel=grep("^m:", if (is.null(rownames(me))) rownames(usmf) else rownames(me), v=TRUE)
   nm_sel=sort(nm_sel)
   pdf(sprintf("%s/%s.pdf", dirres, nm_exp[iexp]))
   if (length(nm_sel) > 0) {
      plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
      text(0.5, 0.05, lab="MS measurements", cex=2)
      nmf=unique(apply(sapply(strsplit(nm_sel, ":", fixed=TRUE), "[", 1:4)[2:3,], 2, paste0, sep="", collapse=":"))
      for (metf in nmf) {
         i=grep(sprintf("m:%s:", metf), nm_sel, fix=TRUE, v=TRUE)
         #isim=pmatch(sapply(strsplit(i, ":", fixed=TRUE), function(v) paste0(v[-length(v)], collapse=":")), rownames(usmf))
         isim=grep(sprintf("m:%s:", metf), rownames(usmf), fix=TRUE, v=TRUE)
         plot_ti(tifull[[iexp]][-1L], usmf[isim,,drop=FALSE], me[i,,drop=FALSE], main=strsplit(metf, ":")[[1]][1], ylim=0:1)
      }
   }
   # plot non measured metabs from mid
   nm_sim=rownames(mid[[iexp]])
   nmm=if (length(nm_sel)) unique(sapply(strsplit(nm_sel, ":", fixed=TRUE), "[", 1:4)[2,]) else character(0L)
   nmmid=unique(sapply(strsplit(nm_sim, "+", fixed=TRUE), "[", 1L))
   if (emu) {
      nmmid=sapply(strsplit(nmmid, ":", fixed=TRUE), "[", 1L)
   }
   nmp=sort(setdiff(nmmid, nmm))
   if (length(nmp)) {
      plot(0:1, c(0, 0.1), type="n", axes=FALSE, xlab="", ylab="")
      text(0.5, 0.05, lab="MS simulations", cex=2)
   }
   for (met in nmp) {
      if (emu) {
         i=grep(sprintf("^%s:", met), nm_sim, v=TRUE)
         # take fragments
         fr=unique(sapply(strsplit(i, "[+:]"), "[", 2L))
         for (f in fr) {
            i=grep(sprintf("^%s:%s\\+", met, f), nm_sim, v=TRUE)
            fi=as.integer(f)
            mainlab=if (fi == 2**clen[met]-1) met else sprintf("%s #%s", met, int2bit(fi, clen[met]))
            plot_ti(tifull[[iexp]][-1L], mid[[iexp]][i,,drop=FALSE], NULL, main=mainlab, ylim=0:1)
         }
      } else {
         i=grep(sprintf("^%s\\+", met), nm_sim, v=TRUE)
         plot_ti(tifull[[iexp]][-1L], mid[[iexp]][i,,drop=FALSE], NULL, main=met, ylim=0:1)
      }
   }
   dev.off()
}

# test for psoptim_ic
dirR="/home/sokol/dev/sysbio/ftbl2sys/influx_si/R"
source(file.path(dirR, "nlsic.R"))
source(file.path(dirR, "opt_cumo_tools.R"))
source(file.path(dirR, "psoptim_ic.R"))
fn=function(x) {
#browser()
   sum(x**2)+10*sum(sin(x)**2)+10
}

# scalar case
x=seq(-5, 5, length.out=201)
plot(x, sapply(x, fn), t="l")

fit=psoptim_ic(NA, fn)

# 2D case
n=2L
z=outer(x, x, function(x,y) sapply(seq_along(x), function(i) fn(c(x[i],y[i]))))
plot3D::persp3D(z=z)
fit=psoptim_ic(c(NA,NA), fn, mean=10, control=list(trace=1, maxit=30))

# 2D box case x in [-4,-1], y in [2; 6]
n=2L
ui=rbind(diag(n), -diag(n))
ci=c(-4, 2, 1, -6)
x=seq(ci[1L], -ci[1L+n], length.out=101)
y=seq(ci[2L], -ci[2L+n], length.out=101)
z=outer(x, y, function(x,y) sapply(seq_along(x), function(i) fn(c(x[i],y[i]))))
plot3D::persp3D(x, y, z=z)
# the mean+-magnitude is completely outside of the feasibility domain
#set.seed(7)
fit=psoptim_ic(c(NA,NA), fn, mean=100*c(-2.5, 4), magnitude=10, control=list(trace=1, maxit=30, REPORT=5, maxit.stagnate=3, reltol=1.e-2), ui=ui, ci=ci)

#!/bin/bash
# clean files after runing influx_s[i] in the current (default) or a directory given in first and next parameters

if [ $# != 0 ]; then
   dirs="$@"
else
   dirs="."
fi

for d in $dirs; do
   [ -e "$d" ] || continue
   ( cd "$d" &&
   for f in *.ftbl; do
      #echo fb="${f/.ftbl/}"
      #echo "f="$f
      fb="${f/.ftbl/}"
      rm -f "$fb"{.R,.err,.log,.pres.csv,.RData,.Rprof,_res.kvh,_ires.kvh,.netan,.sif,_netan.kvh,_rev.txt,_net.txt,_fwd.txt,.xml,.pdf} *.$fb.attrs {edge,node}.*.$fb*\(.V+\([0-9]\)\) "$fb".mc*.err parallel.R
   done )
done
